# coding: utf-8

"""
    Advanced Bot Protection API

    This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation.   # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IpLookupModeV1Lookup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'header_name': 'HeaderNameV1',
        'reverse_index': 'int'
    }

    attribute_map = {
        'header_name': 'header_name',
        'reverse_index': 'reverse_index'
    }

    def __init__(self, header_name=None, reverse_index=None):  # noqa: E501
        """IpLookupModeV1Lookup - a model defined in Swagger"""  # noqa: E501
        self._header_name = None
        self._reverse_index = None
        self.discriminator = None
        self.header_name = header_name
        self.reverse_index = reverse_index

    @property
    def header_name(self):
        """Gets the header_name of this IpLookupModeV1Lookup.  # noqa: E501


        :return: The header_name of this IpLookupModeV1Lookup.  # noqa: E501
        :rtype: HeaderNameV1
        """
        return self._header_name

    @header_name.setter
    def header_name(self, header_name):
        """Sets the header_name of this IpLookupModeV1Lookup.


        :param header_name: The header_name of this IpLookupModeV1Lookup.  # noqa: E501
        :type: HeaderNameV1
        """
        if header_name is None:
            raise ValueError("Invalid value for `header_name`, must not be `None`")  # noqa: E501

        self._header_name = header_name

    @property
    def reverse_index(self):
        """Gets the reverse_index of this IpLookupModeV1Lookup.  # noqa: E501

        If the header contains multiple comma-separated IP addresses, this controls which IP will be used.  # noqa: E501

        :return: The reverse_index of this IpLookupModeV1Lookup.  # noqa: E501
        :rtype: int
        """
        return self._reverse_index

    @reverse_index.setter
    def reverse_index(self, reverse_index):
        """Sets the reverse_index of this IpLookupModeV1Lookup.

        If the header contains multiple comma-separated IP addresses, this controls which IP will be used.  # noqa: E501

        :param reverse_index: The reverse_index of this IpLookupModeV1Lookup.  # noqa: E501
        :type: int
        """
        if reverse_index is None:
            raise ValueError("Invalid value for `reverse_index`, must not be `None`")  # noqa: E501

        self._reverse_index = reverse_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpLookupModeV1Lookup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpLookupModeV1Lookup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
