# swagger-client
This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation. 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-api-id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountApi(swagger_client.ApiClient(configuration))
account_id = swagger_client.AccountId() # AccountId | Identifies an Account to operate on.
caid = 56 # int | Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID.  (optional)

try:
    # Retrieve the default encryption key for an Account
    api_response = api_instance.v1_account_account_id_default_encryption_key_get(account_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountApi->v1_account_account_id_default_encryption_key_get: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-api-id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountApi(swagger_client.ApiClient(configuration))
account_id = swagger_client.AccountId() # AccountId | Identifies an Account to operate on.
caid = 56 # int | Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID.  (optional)

try:
    # Retrieve an Account
    api_response = api_instance.v1_account_account_id_get(account_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountApi->v1_account_account_id_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/botmanagement*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountApi* | [**v1_account_account_id_default_encryption_key_get**](docs/AccountApi.md#v1_account_account_id_default_encryption_key_get) | **GET** /v1/account/{accountId}/default_encryption_key | Retrieve the default encryption key for an Account
*AccountApi* | [**v1_account_account_id_get**](docs/AccountApi.md#v1_account_account_id_get) | **GET** /v1/account/{accountId} | Retrieve an Account
*ConditionApi* | [**v1_account_account_id_condition_get**](docs/ConditionApi.md#v1_account_account_id_condition_get) | **GET** /v1/account/{accountId}/condition | Retrieve the list of all Conditions belonging to the Account
*ConditionApi* | [**v1_account_account_id_condition_post**](docs/ConditionApi.md#v1_account_account_id_condition_post) | **POST** /v1/account/{accountId}/condition | Create a new Condition
*ConditionApi* | [**v1_account_account_id_condition_search_get**](docs/ConditionApi.md#v1_account_account_id_condition_search_get) | **GET** /v1/account/{accountId}/condition/search | Search for Conditions
*ConditionApi* | [**v1_condition_condition_id_children_get**](docs/ConditionApi.md#v1_condition_condition_id_children_get) | **GET** /v1/condition/{conditionId}/children | Retrieve children of a Condition List
*ConditionApi* | [**v1_condition_condition_id_delete**](docs/ConditionApi.md#v1_condition_condition_id_delete) | **DELETE** /v1/condition/{conditionId} | Delete a Condition
*ConditionApi* | [**v1_condition_condition_id_get**](docs/ConditionApi.md#v1_condition_condition_id_get) | **GET** /v1/condition/{conditionId} | Retrieve a Condition
*ConditionApi* | [**v1_condition_condition_id_put**](docs/ConditionApi.md#v1_condition_condition_id_put) | **PUT** /v1/condition/{conditionId} | Update a Condition
*ConditionApi* | [**v1_condition_validate_post**](docs/ConditionApi.md#v1_condition_validate_post) | **POST** /v1/condition/validate | Validate a Condition literal
*CredentialApi* | [**v1_account_account_id_credential_get**](docs/CredentialApi.md#v1_account_account_id_credential_get) | **GET** /v1/account/{accountId}/credential | Retrieve access keys for the analysis host API
*CredentialApi* | [**v1_account_account_id_credential_post**](docs/CredentialApi.md#v1_account_account_id_credential_post) | **POST** /v1/account/{accountId}/credential | Create new Account credentials
*CredentialApi* | [**v1_credential_credential_id_delete**](docs/CredentialApi.md#v1_credential_credential_id_delete) | **DELETE** /v1/credential/{credentialId} | Delete credentials
*CredentialApi* | [**v1_credential_credential_id_get**](docs/CredentialApi.md#v1_credential_credential_id_get) | **GET** /v1/credential/{credentialId} | Retrieve credentials
*DomainApi* | [**v1_account_account_id_domain_get**](docs/DomainApi.md#v1_account_account_id_domain_get) | **GET** /v1/account/{accountId}/domain | Retrieve the list of Domains belonging to the Account
*DomainApi* | [**v1_account_account_id_domain_post**](docs/DomainApi.md#v1_account_account_id_domain_post) | **POST** /v1/account/{accountId}/domain | Create a new Domain
*DomainApi* | [**v1_domain_domain_id_delete**](docs/DomainApi.md#v1_domain_domain_id_delete) | **DELETE** /v1/domain/{domainId} | Delete a domain
*DomainApi* | [**v1_domain_domain_id_get**](docs/DomainApi.md#v1_domain_domain_id_get) | **GET** /v1/domain/{domainId} | Retrieve a Domain
*DomainApi* | [**v1_domain_domain_id_put**](docs/DomainApi.md#v1_domain_domain_id_put) | **PUT** /v1/domain/{domainId} | Update a Domain
*DomainApi* | [**v1_site_site_id_domain_get**](docs/DomainApi.md#v1_site_site_id_domain_get) | **GET** /v1/site/{siteId}/domain | Retrieve the list of Domains belonging to the Site
*DomainApi* | [**v1_site_site_id_domain_priority_get**](docs/DomainApi.md#v1_site_site_id_domain_priority_get) | **GET** /v1/site/{siteId}/domain_priority | Retrieve the Site&#x27;s Domain priority order
*DomainApi* | [**v1_site_site_id_domain_priority_put**](docs/DomainApi.md#v1_site_site_id_domain_priority_put) | **PUT** /v1/site/{siteId}/domain_priority | Update the Site&#x27;s Domain priority order.
*EncryptionkeyApi* | [**v1_domain_domain_id_encryptionkey_get**](docs/EncryptionkeyApi.md#v1_domain_domain_id_encryptionkey_get) | **GET** /v1/domain/{domainId}/encryptionkey | Retrieve the token encryption keys for a Domain
*EncryptionkeyApi* | [**v1_domain_domain_id_encryptionkey_post**](docs/EncryptionkeyApi.md#v1_domain_domain_id_encryptionkey_post) | **POST** /v1/domain/{domainId}/encryptionkey | Create a new encryption key for a Domain
*EncryptionkeyApi* | [**v1_encryptionkey_encryptionkey_id_delete**](docs/EncryptionkeyApi.md#v1_encryptionkey_encryptionkey_id_delete) | **DELETE** /v1/encryptionkey/{encryptionkeyId} | Delete an encryption key.
*PolicyApi* | [**v1_account_account_id_policy_get**](docs/PolicyApi.md#v1_account_account_id_policy_get) | **GET** /v1/account/{accountId}/policy | Retrieve the list of Policies belonging to the Account
*PolicyApi* | [**v1_account_account_id_policy_post**](docs/PolicyApi.md#v1_account_account_id_policy_post) | **POST** /v1/account/{accountId}/policy | Create a new Policy
*PolicyApi* | [**v1_policy_policy_id_delete**](docs/PolicyApi.md#v1_policy_policy_id_delete) | **DELETE** /v1/policy/{policyId} | Delete a Policy
*PolicyApi* | [**v1_policy_policy_id_environmental_parameters_get**](docs/PolicyApi.md#v1_policy_policy_id_environmental_parameters_get) | **GET** /v1/policy/{policyId}/environmental_parameters | Retrieve all environmental parameters used in a Policy
*PolicyApi* | [**v1_policy_policy_id_get**](docs/PolicyApi.md#v1_policy_policy_id_get) | **GET** /v1/policy/{policyId} | Retrieve a Policy
*PolicyApi* | [**v1_policy_policy_id_put**](docs/PolicyApi.md#v1_policy_policy_id_put) | **PUT** /v1/policy/{policyId} | Update a Policy
*PreflightApi* | [**v1_account_account_id_preflight_post**](docs/PreflightApi.md#v1_account_account_id_preflight_post) | **POST** /v1/account/{accountId}/preflight | Create a preflight used to publish the configuration to the analysis host
*PreflightApi* | [**v1_preflight_preflight_id_get**](docs/PreflightApi.md#v1_preflight_preflight_id_get) | **GET** /v1/preflight/{preflightId} | Retrieve a preflight
*PreflightApi* | [**v1_preflight_preflight_id_publish_post**](docs/PreflightApi.md#v1_preflight_preflight_id_publish_post) | **POST** /v1/preflight/{preflightId}/publish | Publishes a preflight
*PublishApi* | [**v1_account_account_id_publish_latest_successful_get**](docs/PublishApi.md#v1_account_account_id_publish_latest_successful_get) | **GET** /v1/account/{accountId}/publish/latest_successful | Gets the latest successful Publish for the Account
*PublishApi* | [**v1_preflight_preflight_id_publish_post**](docs/PublishApi.md#v1_preflight_preflight_id_publish_post) | **POST** /v1/preflight/{preflightId}/publish | Publishes a preflight
*PublishApi* | [**v1_publish_publish_id_get**](docs/PublishApi.md#v1_publish_publish_id_get) | **GET** /v1/publish/{publishId} | Retrieve publish information
*RootApi* | [**v1_get**](docs/RootApi.md#v1_get) | **GET** /v1/ | Retrieve the authenticated Account&#x27;s ID
*SiteApi* | [**v1_account_account_id_site_get**](docs/SiteApi.md#v1_account_account_id_site_get) | **GET** /v1/account/{accountId}/site | Retrieve the list of Sites belonging to an Account
*SiteApi* | [**v1_account_account_id_site_post**](docs/SiteApi.md#v1_account_account_id_site_post) | **POST** /v1/account/{accountId}/site | Create a new Site
*SiteApi* | [**v1_account_account_id_site_priority_get**](docs/SiteApi.md#v1_account_account_id_site_priority_get) | **GET** /v1/account/{accountId}/site_priority | Retrieve the Account&#x27;s Site priority order
*SiteApi* | [**v1_account_account_id_site_priority_put**](docs/SiteApi.md#v1_account_account_id_site_priority_put) | **PUT** /v1/account/{accountId}/site_priority | Set site priority in this Account
*SiteApi* | [**v1_site_site_id_delete**](docs/SiteApi.md#v1_site_site_id_delete) | **DELETE** /v1/site/{siteId} | Delete a Site
*SiteApi* | [**v1_site_site_id_environmental_parameters_get**](docs/SiteApi.md#v1_site_site_id_environmental_parameters_get) | **GET** /v1/site/{siteId}/environmental_parameters | Retrieve all environmental parameters used in a Site
*SiteApi* | [**v1_site_site_id_get**](docs/SiteApi.md#v1_site_site_id_get) | **GET** /v1/site/{siteId} | Retrieve a Site
*SiteApi* | [**v1_site_site_id_put**](docs/SiteApi.md#v1_site_site_id_put) | **PUT** /v1/site/{siteId} | Update a Site
*SnapshotApi* | [**v1_account_account_id_snapshot_get**](docs/SnapshotApi.md#v1_account_account_id_snapshot_get) | **GET** /v1/account/{accountId}/snapshot | Retrieve the list of snapshots belonging to an Account
*SnapshotApi* | [**v1_account_account_id_snapshot_post**](docs/SnapshotApi.md#v1_account_account_id_snapshot_post) | **POST** /v1/account/{accountId}/snapshot | Create a snapshot to allow a configuration rollback
*SnapshotApi* | [**v1_snapshot_snapshot_id_delete**](docs/SnapshotApi.md#v1_snapshot_snapshot_id_delete) | **DELETE** /v1/snapshot/{snapshotId} | Delete a snapshot
*SnapshotApi* | [**v1_snapshot_snapshot_id_get**](docs/SnapshotApi.md#v1_snapshot_snapshot_id_get) | **GET** /v1/snapshot/{snapshotId} | Retrieve a snapshot
*SnapshotApi* | [**v1_snapshot_snapshot_id_restore_post**](docs/SnapshotApi.md#v1_snapshot_snapshot_id_restore_post) | **POST** /v1/snapshot/{snapshotId}/restore | Restore the account configuration to the state in the provided snapshot.

## Documentation For Models

 - [AccountDefaultEncryptionKeyV1](docs/AccountDefaultEncryptionKeyV1.md)
 - [AccountId](docs/AccountId.md)
 - [AccountV1](docs/AccountV1.md)
 - [AnalysisSettingsV1](docs/AnalysisSettingsV1.md)
 - [CaptchaSettingsPassword](docs/CaptchaSettingsPassword.md)
 - [CaptchaSettingsV1](docs/CaptchaSettingsV1.md)
 - [CaptchaSettingsV1Geetest](docs/CaptchaSettingsV1Geetest.md)
 - [CaptchaSettingsV1ManagedGeetest](docs/CaptchaSettingsV1ManagedGeetest.md)
 - [CaptchaSettingsV1Recaptcha](docs/CaptchaSettingsV1Recaptcha.md)
 - [CaptchaSettingsValue](docs/CaptchaSettingsValue.md)
 - [CloudWafId](docs/CloudWafId.md)
 - [CloudWafWebsiteId](docs/CloudWafWebsiteId.md)
 - [ConditionId](docs/ConditionId.md)
 - [ConditionOwnerV1](docs/ConditionOwnerV1.md)
 - [ConditionRefV1](docs/ConditionRefV1.md)
 - [ConditionStateV1](docs/ConditionStateV1.md)
 - [ConditionV1](docs/ConditionV1.md)
 - [CookieModeV1](docs/CookieModeV1.md)
 - [Cookiescope](docs/Cookiescope.md)
 - [CreateConditionV1](docs/CreateConditionV1.md)
 - [CreateDirectiveV1](docs/CreateDirectiveV1.md)
 - [CreateDomainCriteriaV1](docs/CreateDomainCriteriaV1.md)
 - [CreateDomainV1](docs/CreateDomainV1.md)
 - [CreateEncryptionKeyV1](docs/CreateEncryptionKeyV1.md)
 - [CreatePolicyV1](docs/CreatePolicyV1.md)
 - [CreateSelectorV1](docs/CreateSelectorV1.md)
 - [CreateSiteV1](docs/CreateSiteV1.md)
 - [CreateSiteV1Selectors](docs/CreateSiteV1Selectors.md)
 - [CreateSnapshotV1](docs/CreateSnapshotV1.md)
 - [CredentialId](docs/CredentialId.md)
 - [CredentialV1](docs/CredentialV1.md)
 - [DerivedId](docs/DerivedId.md)
 - [DirectiveAction](docs/DirectiveAction.md)
 - [DirectiveV1](docs/DirectiveV1.md)
 - [DomainCriteriaV1](docs/DomainCriteriaV1.md)
 - [DomainId](docs/DomainId.md)
 - [DomainNamePart](docs/DomainNamePart.md)
 - [DomainPriorityV1](docs/DomainPriorityV1.md)
 - [DomainV1](docs/DomainV1.md)
 - [EncryptionKeyId](docs/EncryptionKeyId.md)
 - [EncryptionKeyMaterial](docs/EncryptionKeyMaterial.md)
 - [EncryptionKeyV1](docs/EncryptionKeyV1.md)
 - [EnvironmentalParameterV1](docs/EnvironmentalParameterV1.md)
 - [ErrorV1](docs/ErrorV1.md)
 - [GeetestDifficultyV1](docs/GeetestDifficultyV1.md)
 - [HeaderNameV1](docs/HeaderNameV1.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse20015](docs/InlineResponse20015.md)
 - [InlineResponse20016](docs/InlineResponse20016.md)
 - [InlineResponse20017](docs/InlineResponse20017.md)
 - [InlineResponse20018](docs/InlineResponse20018.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [InlineResponse201](docs/InlineResponse201.md)
 - [InlineResponse2011](docs/InlineResponse2011.md)
 - [InlineResponse2012](docs/InlineResponse2012.md)
 - [InlineResponse2013](docs/InlineResponse2013.md)
 - [InlineResponse2014](docs/InlineResponse2014.md)
 - [InlineResponse2015](docs/InlineResponse2015.md)
 - [InlineResponse2016](docs/InlineResponse2016.md)
 - [InlineResponse2017](docs/InlineResponse2017.md)
 - [InlineResponse2018](docs/InlineResponse2018.md)
 - [IpLookupModeV1](docs/IpLookupModeV1.md)
 - [IpLookupModeV1Lookup](docs/IpLookupModeV1Lookup.md)
 - [LatestSuccessfulPublishV1](docs/LatestSuccessfulPublishV1.md)
 - [Link](docs/Link.md)
 - [Links](docs/Links.md)
 - [LogRegionV1](docs/LogRegionV1.md)
 - [MaxRequestsPerMinute](docs/MaxRequestsPerMinute.md)
 - [MaxRequestsPerSession](docs/MaxRequestsPerSession.md)
 - [MaxSessionLength](docs/MaxSessionLength.md)
 - [MoiCode](docs/MoiCode.md)
 - [MoiValidationResultV1](docs/MoiValidationResultV1.md)
 - [MxHostnameId](docs/MxHostnameId.md)
 - [Name](docs/Name.md)
 - [NoJsInjectionPathV1](docs/NoJsInjectionPathV1.md)
 - [OneOfAccountV1CreatedAt](docs/OneOfAccountV1CreatedAt.md)
 - [OneOfAccountV1ModifiedAt](docs/OneOfAccountV1ModifiedAt.md)
 - [OneOfCreateDomainV1AnalysisIpLookupMode](docs/OneOfCreateDomainV1AnalysisIpLookupMode.md)
 - [OneOfCreateDomainV1CaptchaSettings](docs/OneOfCreateDomainV1CaptchaSettings.md)
 - [OneOfCreateDomainV1ChallengeIpLookupMode](docs/OneOfCreateDomainV1ChallengeIpLookupMode.md)
 - [OneOfCreateDomainV1CookieMode](docs/OneOfCreateDomainV1CookieMode.md)
 - [OneOfCreateDomainV1EncryptionKeyId](docs/OneOfCreateDomainV1EncryptionKeyId.md)
 - [OneOfCreateDomainV1LogRegion](docs/OneOfCreateDomainV1LogRegion.md)
 - [OneOfCreateDomainV1ProxyFlags](docs/OneOfCreateDomainV1ProxyFlags.md)
 - [OneOfCreateDomainV1UnmaskedHeaders](docs/OneOfCreateDomainV1UnmaskedHeaders.md)
 - [OneOfCreateSelectorV1PolicyId](docs/OneOfCreateSelectorV1PolicyId.md)
 - [OneOfCreateSiteV1MxHostnameId](docs/OneOfCreateSiteV1MxHostnameId.md)
 - [OneOfCreateSiteV1SelectorsPolicyId](docs/OneOfCreateSiteV1SelectorsPolicyId.md)
 - [OneOfCredentialV1ModifiedAt](docs/OneOfCredentialV1ModifiedAt.md)
 - [OneOfDomainV1CreatedAt](docs/OneOfDomainV1CreatedAt.md)
 - [OneOfDomainV1ModifiedAt](docs/OneOfDomainV1ModifiedAt.md)
 - [OneOfDomainV1ObfuscatePath](docs/OneOfDomainV1ObfuscatePath.md)
 - [OneOfLinksAccount](docs/OneOfLinksAccount.md)
 - [OneOfLinksAnalysisHost](docs/OneOfLinksAnalysisHost.md)
 - [OneOfLinksCondition](docs/OneOfLinksCondition.md)
 - [OneOfLinksCreateCondition](docs/OneOfLinksCreateCondition.md)
 - [OneOfLinksCreateDomain](docs/OneOfLinksCreateDomain.md)
 - [OneOfLinksCreatePolicy](docs/OneOfLinksCreatePolicy.md)
 - [OneOfLinksCreatePreflight](docs/OneOfLinksCreatePreflight.md)
 - [OneOfLinksCreatePublish](docs/OneOfLinksCreatePublish.md)
 - [OneOfLinksCreateSite](docs/OneOfLinksCreateSite.md)
 - [OneOfLinksCredential](docs/OneOfLinksCredential.md)
 - [OneOfLinksDefaultEncryptionKey](docs/OneOfLinksDefaultEncryptionKey.md)
 - [OneOfLinksDeleteCondition](docs/OneOfLinksDeleteCondition.md)
 - [OneOfLinksDeleteDomain](docs/OneOfLinksDeleteDomain.md)
 - [OneOfLinksDeleteEncryptionkey](docs/OneOfLinksDeleteEncryptionkey.md)
 - [OneOfLinksDeletePolicy](docs/OneOfLinksDeletePolicy.md)
 - [OneOfLinksDeleteSite](docs/OneOfLinksDeleteSite.md)
 - [OneOfLinksDeleteSnapshot](docs/OneOfLinksDeleteSnapshot.md)
 - [OneOfLinksDomain](docs/OneOfLinksDomain.md)
 - [OneOfLinksDomainPriority](docs/OneOfLinksDomainPriority.md)
 - [OneOfLinksEncryptionkey](docs/OneOfLinksEncryptionkey.md)
 - [OneOfLinksListConditionChildren](docs/OneOfLinksListConditionChildren.md)
 - [OneOfLinksListConditions](docs/OneOfLinksListConditions.md)
 - [OneOfLinksListCredentials](docs/OneOfLinksListCredentials.md)
 - [OneOfLinksListDomains](docs/OneOfLinksListDomains.md)
 - [OneOfLinksListEncryptionkeys](docs/OneOfLinksListEncryptionkeys.md)
 - [OneOfLinksListPolicies](docs/OneOfLinksListPolicies.md)
 - [OneOfLinksListSites](docs/OneOfLinksListSites.md)
 - [OneOfLinksListSnapshots](docs/OneOfLinksListSnapshots.md)
 - [OneOfLinksNext](docs/OneOfLinksNext.md)
 - [OneOfLinksPolicy](docs/OneOfLinksPolicy.md)
 - [OneOfLinksPreflight](docs/OneOfLinksPreflight.md)
 - [OneOfLinksPrev](docs/OneOfLinksPrev.md)
 - [OneOfLinksPublish](docs/OneOfLinksPublish.md)
 - [OneOfLinksRestoreSnapshot](docs/OneOfLinksRestoreSnapshot.md)
 - [OneOfLinksSearchConditions](docs/OneOfLinksSearchConditions.md)
 - [OneOfLinksSite](docs/OneOfLinksSite.md)
 - [OneOfLinksSitePriority](docs/OneOfLinksSitePriority.md)
 - [OneOfLinksSnapshot](docs/OneOfLinksSnapshot.md)
 - [OneOfLinksUpdateCondition](docs/OneOfLinksUpdateCondition.md)
 - [OneOfLinksUpdateDomain](docs/OneOfLinksUpdateDomain.md)
 - [OneOfLinksUpdateDomainPriority](docs/OneOfLinksUpdateDomainPriority.md)
 - [OneOfLinksUpdatePolicy](docs/OneOfLinksUpdatePolicy.md)
 - [OneOfLinksUpdateSite](docs/OneOfLinksUpdateSite.md)
 - [OneOfLinksUpdateSitePriority](docs/OneOfLinksUpdateSitePriority.md)
 - [OneOfPolicyV1CreatedAt](docs/OneOfPolicyV1CreatedAt.md)
 - [OneOfPolicyV1ModifiedAt](docs/OneOfPolicyV1ModifiedAt.md)
 - [OneOfPreflightV1Warnings](docs/OneOfPreflightV1Warnings.md)
 - [OneOfSelectorV1DerivedId](docs/OneOfSelectorV1DerivedId.md)
 - [OneOfSelectorV1PolicyId](docs/OneOfSelectorV1PolicyId.md)
 - [OneOfSiteV1CreatedAt](docs/OneOfSiteV1CreatedAt.md)
 - [OneOfSiteV1ModifiedAt](docs/OneOfSiteV1ModifiedAt.md)
 - [OneOfSiteV1MxHostnameId](docs/OneOfSiteV1MxHostnameId.md)
 - [OneOfUpdateDirectiveV1ConditionId](docs/OneOfUpdateDirectiveV1ConditionId.md)
 - [OneOfUpdateSelectorV1Id](docs/OneOfUpdateSelectorV1Id.md)
 - [OneOfUpdateSelectorV1PolicyId](docs/OneOfUpdateSelectorV1PolicyId.md)
 - [Path](docs/Path.md)
 - [PathPrefix](docs/PathPrefix.md)
 - [PolicyEnvironmentalParametersV1](docs/PolicyEnvironmentalParametersV1.md)
 - [PolicyId](docs/PolicyId.md)
 - [PolicyV1](docs/PolicyV1.md)
 - [PreflightId](docs/PreflightId.md)
 - [PreflightV1](docs/PreflightV1.md)
 - [PreflightWarningV1](docs/PreflightWarningV1.md)
 - [ProxyFlagV1](docs/ProxyFlagV1.md)
 - [ProxyFlagsV1](docs/ProxyFlagsV1.md)
 - [PublishId](docs/PublishId.md)
 - [PublishProgressPercentV1](docs/PublishProgressPercentV1.md)
 - [PublishStatusV1](docs/PublishStatusV1.md)
 - [PublishV1](docs/PublishV1.md)
 - [RateLimitingCustomScope](docs/RateLimitingCustomScope.md)
 - [RateLimitingV1](docs/RateLimitingV1.md)
 - [Regex](docs/Regex.md)
 - [RootV1](docs/RootV1.md)
 - [SelectorCriteriaPostbackV1](docs/SelectorCriteriaPostbackV1.md)
 - [SelectorCriteriaV1](docs/SelectorCriteriaV1.md)
 - [SelectorId](docs/SelectorId.md)
 - [SelectorV1](docs/SelectorV1.md)
 - [SiteEnvironmentalParametersV1](docs/SiteEnvironmentalParametersV1.md)
 - [SiteId](docs/SiteId.md)
 - [SitePriorityV1](docs/SitePriorityV1.md)
 - [SiteV1](docs/SiteV1.md)
 - [SnapshotId](docs/SnapshotId.md)
 - [SnapshotV1](docs/SnapshotV1.md)
 - [TagV1](docs/TagV1.md)
 - [Template](docs/Template.md)
 - [UnmaskedHeadersV1](docs/UnmaskedHeadersV1.md)
 - [UpdateConditionV1](docs/UpdateConditionV1.md)
 - [UpdateDirectiveV1](docs/UpdateDirectiveV1.md)
 - [UpdateDomainV1](docs/UpdateDomainV1.md)
 - [UpdatePolicyV1](docs/UpdatePolicyV1.md)
 - [UpdateSelectorV1](docs/UpdateSelectorV1.md)
 - [UpdateSiteV1](docs/UpdateSiteV1.md)
 - [UtcDateTimeV1](docs/UtcDateTimeV1.md)
 - [ValidateLiteralV1](docs/ValidateLiteralV1.md)
 - [WithLinks](docs/WithLinks.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-api-id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author


