# coding: utf-8

# flake8: noqa

"""
    Advanced Bot Protection API

    This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation.   # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import apis into sdk package
from swagger_client.api.account_api import AccountApi
from swagger_client.api.condition_api import ConditionApi
from swagger_client.api.credential_api import CredentialApi
from swagger_client.api.domain_api import DomainApi
from swagger_client.api.encryptionkey_api import EncryptionkeyApi
from swagger_client.api.policy_api import PolicyApi
from swagger_client.api.preflight_api import PreflightApi
from swagger_client.api.publish_api import PublishApi
from swagger_client.api.root_api import RootApi
from swagger_client.api.site_api import SiteApi
from swagger_client.api.snapshot_api import SnapshotApi
# import ApiClient
from swagger_client.api_client import ApiClient
from swagger_client.configuration import Configuration
# import models into sdk package
from swagger_client.models.account_default_encryption_key_v1 import AccountDefaultEncryptionKeyV1
from swagger_client.models.account_id import AccountId
from swagger_client.models.account_v1 import AccountV1
from swagger_client.models.analysis_settings_v1 import AnalysisSettingsV1
from swagger_client.models.captcha_settings_password import CaptchaSettingsPassword
from swagger_client.models.captcha_settings_v1 import CaptchaSettingsV1
from swagger_client.models.captcha_settings_v1_geetest import CaptchaSettingsV1Geetest
from swagger_client.models.captcha_settings_v1_managed_geetest import CaptchaSettingsV1ManagedGeetest
from swagger_client.models.captcha_settings_v1_recaptcha import CaptchaSettingsV1Recaptcha
from swagger_client.models.captcha_settings_value import CaptchaSettingsValue
from swagger_client.models.cloud_waf_id import CloudWafId
from swagger_client.models.cloud_waf_website_id import CloudWafWebsiteId
from swagger_client.models.condition_id import ConditionId
from swagger_client.models.condition_owner_v1 import ConditionOwnerV1
from swagger_client.models.condition_ref_v1 import ConditionRefV1
from swagger_client.models.condition_state_v1 import ConditionStateV1
from swagger_client.models.condition_v1 import ConditionV1
from swagger_client.models.cookie_mode_v1 import CookieModeV1
from swagger_client.models.cookiescope import Cookiescope
from swagger_client.models.create_condition_v1 import CreateConditionV1
from swagger_client.models.create_directive_v1 import CreateDirectiveV1
from swagger_client.models.create_domain_criteria_v1 import CreateDomainCriteriaV1
from swagger_client.models.create_domain_v1 import CreateDomainV1
from swagger_client.models.create_encryption_key_v1 import CreateEncryptionKeyV1
from swagger_client.models.create_policy_v1 import CreatePolicyV1
from swagger_client.models.create_selector_v1 import CreateSelectorV1
from swagger_client.models.create_site_v1 import CreateSiteV1
from swagger_client.models.create_site_v1_selectors import CreateSiteV1Selectors
from swagger_client.models.create_snapshot_v1 import CreateSnapshotV1
from swagger_client.models.credential_id import CredentialId
from swagger_client.models.credential_v1 import CredentialV1
from swagger_client.models.derived_id import DerivedId
from swagger_client.models.directive_action import DirectiveAction
from swagger_client.models.directive_v1 import DirectiveV1
from swagger_client.models.domain_criteria_v1 import DomainCriteriaV1
from swagger_client.models.domain_id import DomainId
from swagger_client.models.domain_name_part import DomainNamePart
from swagger_client.models.domain_priority_v1 import DomainPriorityV1
from swagger_client.models.domain_v1 import DomainV1
from swagger_client.models.encryption_key_id import EncryptionKeyId
from swagger_client.models.encryption_key_material import EncryptionKeyMaterial
from swagger_client.models.encryption_key_v1 import EncryptionKeyV1
from swagger_client.models.environmental_parameter_v1 import EnvironmentalParameterV1
from swagger_client.models.error_v1 import ErrorV1
from swagger_client.models.geetest_difficulty_v1 import GeetestDifficultyV1
from swagger_client.models.header_name_v1 import HeaderNameV1
from swagger_client.models.inline_response200 import InlineResponse200
from swagger_client.models.inline_response2001 import InlineResponse2001
from swagger_client.models.inline_response20010 import InlineResponse20010
from swagger_client.models.inline_response20011 import InlineResponse20011
from swagger_client.models.inline_response20012 import InlineResponse20012
from swagger_client.models.inline_response20013 import InlineResponse20013
from swagger_client.models.inline_response20014 import InlineResponse20014
from swagger_client.models.inline_response20015 import InlineResponse20015
from swagger_client.models.inline_response20016 import InlineResponse20016
from swagger_client.models.inline_response20017 import InlineResponse20017
from swagger_client.models.inline_response20018 import InlineResponse20018
from swagger_client.models.inline_response2002 import InlineResponse2002
from swagger_client.models.inline_response2003 import InlineResponse2003
from swagger_client.models.inline_response2004 import InlineResponse2004
from swagger_client.models.inline_response2005 import InlineResponse2005
from swagger_client.models.inline_response2006 import InlineResponse2006
from swagger_client.models.inline_response2007 import InlineResponse2007
from swagger_client.models.inline_response2008 import InlineResponse2008
from swagger_client.models.inline_response2009 import InlineResponse2009
from swagger_client.models.inline_response201 import InlineResponse201
from swagger_client.models.inline_response2011 import InlineResponse2011
from swagger_client.models.inline_response2012 import InlineResponse2012
from swagger_client.models.inline_response2013 import InlineResponse2013
from swagger_client.models.inline_response2014 import InlineResponse2014
from swagger_client.models.inline_response2015 import InlineResponse2015
from swagger_client.models.inline_response2016 import InlineResponse2016
from swagger_client.models.inline_response2017 import InlineResponse2017
from swagger_client.models.inline_response2018 import InlineResponse2018
from swagger_client.models.ip_lookup_mode_v1 import IpLookupModeV1
from swagger_client.models.ip_lookup_mode_v1_lookup import IpLookupModeV1Lookup
from swagger_client.models.latest_successful_publish_v1 import LatestSuccessfulPublishV1
from swagger_client.models.link import Link
from swagger_client.models.links import Links
from swagger_client.models.log_region_v1 import LogRegionV1
from swagger_client.models.max_requests_per_minute import MaxRequestsPerMinute
from swagger_client.models.max_requests_per_session import MaxRequestsPerSession
from swagger_client.models.max_session_length import MaxSessionLength
from swagger_client.models.moi_code import MoiCode
from swagger_client.models.moi_validation_result_v1 import MoiValidationResultV1
from swagger_client.models.mx_hostname_id import MxHostnameId
from swagger_client.models.name import Name
from swagger_client.models.no_js_injection_path_v1 import NoJsInjectionPathV1
from swagger_client.models.one_of_account_v1_created_at import OneOfAccountV1CreatedAt
from swagger_client.models.one_of_account_v1_modified_at import OneOfAccountV1ModifiedAt
from swagger_client.models.one_of_create_domain_v1_analysis_ip_lookup_mode import OneOfCreateDomainV1AnalysisIpLookupMode
from swagger_client.models.one_of_create_domain_v1_captcha_settings import OneOfCreateDomainV1CaptchaSettings
from swagger_client.models.one_of_create_domain_v1_challenge_ip_lookup_mode import OneOfCreateDomainV1ChallengeIpLookupMode
from swagger_client.models.one_of_create_domain_v1_cookie_mode import OneOfCreateDomainV1CookieMode
from swagger_client.models.one_of_create_domain_v1_encryption_key_id import OneOfCreateDomainV1EncryptionKeyId
from swagger_client.models.one_of_create_domain_v1_log_region import OneOfCreateDomainV1LogRegion
from swagger_client.models.one_of_create_domain_v1_proxy_flags import OneOfCreateDomainV1ProxyFlags
from swagger_client.models.one_of_create_domain_v1_unmasked_headers import OneOfCreateDomainV1UnmaskedHeaders
from swagger_client.models.one_of_create_selector_v1_policy_id import OneOfCreateSelectorV1PolicyId
from swagger_client.models.one_of_create_site_v1_mx_hostname_id import OneOfCreateSiteV1MxHostnameId
from swagger_client.models.one_of_create_site_v1_selectors_policy_id import OneOfCreateSiteV1SelectorsPolicyId
from swagger_client.models.one_of_credential_v1_modified_at import OneOfCredentialV1ModifiedAt
from swagger_client.models.one_of_domain_v1_created_at import OneOfDomainV1CreatedAt
from swagger_client.models.one_of_domain_v1_modified_at import OneOfDomainV1ModifiedAt
from swagger_client.models.one_of_domain_v1_obfuscate_path import OneOfDomainV1ObfuscatePath
from swagger_client.models.one_of_links_account import OneOfLinksAccount
from swagger_client.models.one_of_links_analysis_host import OneOfLinksAnalysisHost
from swagger_client.models.one_of_links_condition import OneOfLinksCondition
from swagger_client.models.one_of_links_create_condition import OneOfLinksCreateCondition
from swagger_client.models.one_of_links_create_domain import OneOfLinksCreateDomain
from swagger_client.models.one_of_links_create_policy import OneOfLinksCreatePolicy
from swagger_client.models.one_of_links_create_preflight import OneOfLinksCreatePreflight
from swagger_client.models.one_of_links_create_publish import OneOfLinksCreatePublish
from swagger_client.models.one_of_links_create_site import OneOfLinksCreateSite
from swagger_client.models.one_of_links_credential import OneOfLinksCredential
from swagger_client.models.one_of_links_default_encryption_key import OneOfLinksDefaultEncryptionKey
from swagger_client.models.one_of_links_delete_condition import OneOfLinksDeleteCondition
from swagger_client.models.one_of_links_delete_domain import OneOfLinksDeleteDomain
from swagger_client.models.one_of_links_delete_encryptionkey import OneOfLinksDeleteEncryptionkey
from swagger_client.models.one_of_links_delete_policy import OneOfLinksDeletePolicy
from swagger_client.models.one_of_links_delete_site import OneOfLinksDeleteSite
from swagger_client.models.one_of_links_delete_snapshot import OneOfLinksDeleteSnapshot
from swagger_client.models.one_of_links_domain import OneOfLinksDomain
from swagger_client.models.one_of_links_domain_priority import OneOfLinksDomainPriority
from swagger_client.models.one_of_links_encryptionkey import OneOfLinksEncryptionkey
from swagger_client.models.one_of_links_list_condition_children import OneOfLinksListConditionChildren
from swagger_client.models.one_of_links_list_conditions import OneOfLinksListConditions
from swagger_client.models.one_of_links_list_credentials import OneOfLinksListCredentials
from swagger_client.models.one_of_links_list_domains import OneOfLinksListDomains
from swagger_client.models.one_of_links_list_encryptionkeys import OneOfLinksListEncryptionkeys
from swagger_client.models.one_of_links_list_policies import OneOfLinksListPolicies
from swagger_client.models.one_of_links_list_sites import OneOfLinksListSites
from swagger_client.models.one_of_links_list_snapshots import OneOfLinksListSnapshots
from swagger_client.models.one_of_links_next import OneOfLinksNext
from swagger_client.models.one_of_links_policy import OneOfLinksPolicy
from swagger_client.models.one_of_links_preflight import OneOfLinksPreflight
from swagger_client.models.one_of_links_prev import OneOfLinksPrev
from swagger_client.models.one_of_links_publish import OneOfLinksPublish
from swagger_client.models.one_of_links_restore_snapshot import OneOfLinksRestoreSnapshot
from swagger_client.models.one_of_links_search_conditions import OneOfLinksSearchConditions
from swagger_client.models.one_of_links_site import OneOfLinksSite
from swagger_client.models.one_of_links_site_priority import OneOfLinksSitePriority
from swagger_client.models.one_of_links_snapshot import OneOfLinksSnapshot
from swagger_client.models.one_of_links_update_condition import OneOfLinksUpdateCondition
from swagger_client.models.one_of_links_update_domain import OneOfLinksUpdateDomain
from swagger_client.models.one_of_links_update_domain_priority import OneOfLinksUpdateDomainPriority
from swagger_client.models.one_of_links_update_policy import OneOfLinksUpdatePolicy
from swagger_client.models.one_of_links_update_site import OneOfLinksUpdateSite
from swagger_client.models.one_of_links_update_site_priority import OneOfLinksUpdateSitePriority
from swagger_client.models.one_of_policy_v1_created_at import OneOfPolicyV1CreatedAt
from swagger_client.models.one_of_policy_v1_modified_at import OneOfPolicyV1ModifiedAt
from swagger_client.models.one_of_preflight_v1_warnings import OneOfPreflightV1Warnings
from swagger_client.models.one_of_selector_v1_derived_id import OneOfSelectorV1DerivedId
from swagger_client.models.one_of_selector_v1_policy_id import OneOfSelectorV1PolicyId
from swagger_client.models.one_of_site_v1_created_at import OneOfSiteV1CreatedAt
from swagger_client.models.one_of_site_v1_modified_at import OneOfSiteV1ModifiedAt
from swagger_client.models.one_of_site_v1_mx_hostname_id import OneOfSiteV1MxHostnameId
from swagger_client.models.one_of_update_directive_v1_condition_id import OneOfUpdateDirectiveV1ConditionId
from swagger_client.models.one_of_update_selector_v1_id import OneOfUpdateSelectorV1Id
from swagger_client.models.one_of_update_selector_v1_policy_id import OneOfUpdateSelectorV1PolicyId
from swagger_client.models.path import Path
from swagger_client.models.path_prefix import PathPrefix
from swagger_client.models.policy_environmental_parameters_v1 import PolicyEnvironmentalParametersV1
from swagger_client.models.policy_id import PolicyId
from swagger_client.models.policy_v1 import PolicyV1
from swagger_client.models.preflight_id import PreflightId
from swagger_client.models.preflight_v1 import PreflightV1
from swagger_client.models.preflight_warning_v1 import PreflightWarningV1
from swagger_client.models.proxy_flag_v1 import ProxyFlagV1
from swagger_client.models.proxy_flags_v1 import ProxyFlagsV1
from swagger_client.models.publish_id import PublishId
from swagger_client.models.publish_progress_percent_v1 import PublishProgressPercentV1
from swagger_client.models.publish_status_v1 import PublishStatusV1
from swagger_client.models.publish_v1 import PublishV1
from swagger_client.models.rate_limiting_custom_scope import RateLimitingCustomScope
from swagger_client.models.rate_limiting_v1 import RateLimitingV1
from swagger_client.models.regex import Regex
from swagger_client.models.root_v1 import RootV1
from swagger_client.models.selector_criteria_postback_v1 import SelectorCriteriaPostbackV1
from swagger_client.models.selector_criteria_v1 import SelectorCriteriaV1
from swagger_client.models.selector_id import SelectorId
from swagger_client.models.selector_v1 import SelectorV1
from swagger_client.models.site_environmental_parameters_v1 import SiteEnvironmentalParametersV1
from swagger_client.models.site_id import SiteId
from swagger_client.models.site_priority_v1 import SitePriorityV1
from swagger_client.models.site_v1 import SiteV1
from swagger_client.models.snapshot_id import SnapshotId
from swagger_client.models.snapshot_v1 import SnapshotV1
from swagger_client.models.tag_v1 import TagV1
from swagger_client.models.template import Template
from swagger_client.models.unmasked_headers_v1 import UnmaskedHeadersV1
from swagger_client.models.update_condition_v1 import UpdateConditionV1
from swagger_client.models.update_directive_v1 import UpdateDirectiveV1
from swagger_client.models.update_domain_v1 import UpdateDomainV1
from swagger_client.models.update_policy_v1 import UpdatePolicyV1
from swagger_client.models.update_selector_v1 import UpdateSelectorV1
from swagger_client.models.update_site_v1 import UpdateSiteV1
from swagger_client.models.utc_date_time_v1 import UtcDateTimeV1
from swagger_client.models.validate_literal_v1 import ValidateLiteralV1
from swagger_client.models.with_links import WithLinks
