# coding: utf-8

"""
    Advanced Bot Protection API

    This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation.   # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class EncryptionkeyApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def v1_domain_domain_id_encryptionkey_get(self, domain_id, **kwargs):  # noqa: E501
        """Retrieve the token encryption keys for a Domain  # noqa: E501

        The response is sorted in ascending order of time of creation. It is recommended to try the last (newest) key first and then proceeding backwards in the array, as the latest key is most likely to be active. The account configuration needs to be published for the analysis host to accept new keys.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_domain_domain_id_encryptionkey_get(domain_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DomainId domain_id: Identifies a Domain to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.v1_domain_domain_id_encryptionkey_get_with_http_info(domain_id, **kwargs)  # noqa: E501
        else:
            (data) = self.v1_domain_domain_id_encryptionkey_get_with_http_info(domain_id, **kwargs)  # noqa: E501
            return data

    def v1_domain_domain_id_encryptionkey_get_with_http_info(self, domain_id, **kwargs):  # noqa: E501
        """Retrieve the token encryption keys for a Domain  # noqa: E501

        The response is sorted in ascending order of time of creation. It is recommended to try the last (newest) key first and then proceeding backwards in the array, as the latest key is most likely to be active. The account configuration needs to be published for the analysis host to accept new keys.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_domain_domain_id_encryptionkey_get_with_http_info(domain_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DomainId domain_id: Identifies a Domain to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['domain_id', 'caid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method v1_domain_domain_id_encryptionkey_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'domain_id' is set
        if ('domain_id' not in params or
                params['domain_id'] is None):
            raise ValueError("Missing the required parameter `domain_id` when calling `v1_domain_domain_id_encryptionkey_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'domain_id' in params:
            path_params['domainId'] = params['domain_id']  # noqa: E501

        query_params = []
        if 'caid' in params:
            query_params.append(('caid', params['caid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v1/domain/{domainId}/encryptionkey', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def v1_domain_domain_id_encryptionkey_post(self, body, domain_id, **kwargs):  # noqa: E501
        """Create a new encryption key for a Domain  # noqa: E501

        A new encryption key will be created even if the same encryption key material is used by another Domain.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_domain_domain_id_encryptionkey_post(body, domain_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateEncryptionKeyV1 body: (required)
        :param DomainId domain_id: Identifies a Domain to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse2017
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.v1_domain_domain_id_encryptionkey_post_with_http_info(body, domain_id, **kwargs)  # noqa: E501
        else:
            (data) = self.v1_domain_domain_id_encryptionkey_post_with_http_info(body, domain_id, **kwargs)  # noqa: E501
            return data

    def v1_domain_domain_id_encryptionkey_post_with_http_info(self, body, domain_id, **kwargs):  # noqa: E501
        """Create a new encryption key for a Domain  # noqa: E501

        A new encryption key will be created even if the same encryption key material is used by another Domain.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_domain_domain_id_encryptionkey_post_with_http_info(body, domain_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateEncryptionKeyV1 body: (required)
        :param DomainId domain_id: Identifies a Domain to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse2017
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'domain_id', 'caid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method v1_domain_domain_id_encryptionkey_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `v1_domain_domain_id_encryptionkey_post`")  # noqa: E501
        # verify the required parameter 'domain_id' is set
        if ('domain_id' not in params or
                params['domain_id'] is None):
            raise ValueError("Missing the required parameter `domain_id` when calling `v1_domain_domain_id_encryptionkey_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'domain_id' in params:
            path_params['domainId'] = params['domain_id']  # noqa: E501

        query_params = []
        if 'caid' in params:
            query_params.append(('caid', params['caid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v1/domain/{domainId}/encryptionkey', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2017',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def v1_encryptionkey_encryptionkey_id_delete(self, encryptionkey_id, **kwargs):  # noqa: E501
        """Delete an encryption key.  # noqa: E501

        Delete an encryption key for a Domain. Other domains are unaffected.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_encryptionkey_encryptionkey_id_delete(encryptionkey_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EncryptionKeyId encryptionkey_id: Identifies the Encryption Key to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse2017
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.v1_encryptionkey_encryptionkey_id_delete_with_http_info(encryptionkey_id, **kwargs)  # noqa: E501
        else:
            (data) = self.v1_encryptionkey_encryptionkey_id_delete_with_http_info(encryptionkey_id, **kwargs)  # noqa: E501
            return data

    def v1_encryptionkey_encryptionkey_id_delete_with_http_info(self, encryptionkey_id, **kwargs):  # noqa: E501
        """Delete an encryption key.  # noqa: E501

        Delete an encryption key for a Domain. Other domains are unaffected.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.v1_encryptionkey_encryptionkey_id_delete_with_http_info(encryptionkey_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EncryptionKeyId encryptionkey_id: Identifies the Encryption Key to operate on. (required)
        :param int caid: Current Account ID. API keys are valid for an account and all of its sub accounts. When working with sub-accounts, this needs to be set to the corresponding Imperva account ID. Not specifying the parameter will default it to the main account's ID. 
        :return: InlineResponse2017
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['encryptionkey_id', 'caid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method v1_encryptionkey_encryptionkey_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'encryptionkey_id' is set
        if ('encryptionkey_id' not in params or
                params['encryptionkey_id'] is None):
            raise ValueError("Missing the required parameter `encryptionkey_id` when calling `v1_encryptionkey_encryptionkey_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'encryptionkey_id' in params:
            path_params['encryptionkeyId'] = params['encryptionkey_id']  # noqa: E501

        query_params = []
        if 'caid' in params:
            query_params.append(('caid', params['caid']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v1/encryptionkey/{encryptionkeyId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2017',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
