# coding: utf-8

"""
    Advanced Bot Protection API

    This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation.   # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AnalysisSettingsV1(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'rate_limiting': 'RateLimitingV1',
        'max_requests_per_minute': 'MaxRequestsPerMinute',
        'max_requests_per_session': 'MaxRequestsPerSession',
        'max_session_length': 'MaxSessionLength',
        'use_site_rate_limiting_parameters': 'bool'
    }

    attribute_map = {
        'rate_limiting': 'rate_limiting',
        'max_requests_per_minute': 'max_requests_per_minute',
        'max_requests_per_session': 'max_requests_per_session',
        'max_session_length': 'max_session_length',
        'use_site_rate_limiting_parameters': 'use_site_rate_limiting_parameters'
    }

    def __init__(self, rate_limiting=None, max_requests_per_minute=None, max_requests_per_session=None, max_session_length=None, use_site_rate_limiting_parameters=True):  # noqa: E501
        """AnalysisSettingsV1 - a model defined in Swagger"""  # noqa: E501
        self._rate_limiting = None
        self._max_requests_per_minute = None
        self._max_requests_per_session = None
        self._max_session_length = None
        self._use_site_rate_limiting_parameters = None
        self.discriminator = None
        self.rate_limiting = rate_limiting
        if max_requests_per_minute is not None:
            self.max_requests_per_minute = max_requests_per_minute
        if max_requests_per_session is not None:
            self.max_requests_per_session = max_requests_per_session
        if max_session_length is not None:
            self.max_session_length = max_session_length
        if use_site_rate_limiting_parameters is not None:
            self.use_site_rate_limiting_parameters = use_site_rate_limiting_parameters

    @property
    def rate_limiting(self):
        """Gets the rate_limiting of this AnalysisSettingsV1.  # noqa: E501


        :return: The rate_limiting of this AnalysisSettingsV1.  # noqa: E501
        :rtype: RateLimitingV1
        """
        return self._rate_limiting

    @rate_limiting.setter
    def rate_limiting(self, rate_limiting):
        """Sets the rate_limiting of this AnalysisSettingsV1.


        :param rate_limiting: The rate_limiting of this AnalysisSettingsV1.  # noqa: E501
        :type: RateLimitingV1
        """
        if rate_limiting is None:
            raise ValueError("Invalid value for `rate_limiting`, must not be `None`")  # noqa: E501

        self._rate_limiting = rate_limiting

    @property
    def max_requests_per_minute(self):
        """Gets the max_requests_per_minute of this AnalysisSettingsV1.  # noqa: E501


        :return: The max_requests_per_minute of this AnalysisSettingsV1.  # noqa: E501
        :rtype: MaxRequestsPerMinute
        """
        return self._max_requests_per_minute

    @max_requests_per_minute.setter
    def max_requests_per_minute(self, max_requests_per_minute):
        """Sets the max_requests_per_minute of this AnalysisSettingsV1.


        :param max_requests_per_minute: The max_requests_per_minute of this AnalysisSettingsV1.  # noqa: E501
        :type: MaxRequestsPerMinute
        """

        self._max_requests_per_minute = max_requests_per_minute

    @property
    def max_requests_per_session(self):
        """Gets the max_requests_per_session of this AnalysisSettingsV1.  # noqa: E501


        :return: The max_requests_per_session of this AnalysisSettingsV1.  # noqa: E501
        :rtype: MaxRequestsPerSession
        """
        return self._max_requests_per_session

    @max_requests_per_session.setter
    def max_requests_per_session(self, max_requests_per_session):
        """Sets the max_requests_per_session of this AnalysisSettingsV1.


        :param max_requests_per_session: The max_requests_per_session of this AnalysisSettingsV1.  # noqa: E501
        :type: MaxRequestsPerSession
        """

        self._max_requests_per_session = max_requests_per_session

    @property
    def max_session_length(self):
        """Gets the max_session_length of this AnalysisSettingsV1.  # noqa: E501


        :return: The max_session_length of this AnalysisSettingsV1.  # noqa: E501
        :rtype: MaxSessionLength
        """
        return self._max_session_length

    @max_session_length.setter
    def max_session_length(self, max_session_length):
        """Sets the max_session_length of this AnalysisSettingsV1.


        :param max_session_length: The max_session_length of this AnalysisSettingsV1.  # noqa: E501
        :type: MaxSessionLength
        """

        self._max_session_length = max_session_length

    @property
    def use_site_rate_limiting_parameters(self):
        """Gets the use_site_rate_limiting_parameters of this AnalysisSettingsV1.  # noqa: E501

        Apply default values from the website group  # noqa: E501

        :return: The use_site_rate_limiting_parameters of this AnalysisSettingsV1.  # noqa: E501
        :rtype: bool
        """
        return self._use_site_rate_limiting_parameters

    @use_site_rate_limiting_parameters.setter
    def use_site_rate_limiting_parameters(self, use_site_rate_limiting_parameters):
        """Sets the use_site_rate_limiting_parameters of this AnalysisSettingsV1.

        Apply default values from the website group  # noqa: E501

        :param use_site_rate_limiting_parameters: The use_site_rate_limiting_parameters of this AnalysisSettingsV1.  # noqa: E501
        :type: bool
        """

        self._use_site_rate_limiting_parameters = use_site_rate_limiting_parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AnalysisSettingsV1, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AnalysisSettingsV1):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
