# coding: utf-8

"""
    Advanced Bot Protection API

    This is the API for onboarding websites into Advanced Bot Protection. For full feature documentation, see [Advanced Bot Protection](https://docs.imperva.com/bundle/advanced-bot-protection/page/74791.htm)  ## Terminology differences  The API term *Domain* corresponds to, and is interchangeable with, a *Website* as used in the UI and web based documentation.  The API term *Site* corresponds to and is interchangeable with a *Website Group* as used in the UI and web based documentation.  The API term *Selector* corresponds to and is interchangeable with a *per-Path* *Policy* as used in the UI and web based documentation.  Besides the Imperva *account*, there is also an Advanced Bot Protection *account*. The are connected but have their own identifiers that cannot be mixed. In the API, *account* always refers to an ABP account unless otherwise specified.  ## Updates  When using PUT to update a resource, the entire resource will be replaced and any omitted fields may be deleted. To prevent data loss when performing an update you must GET the resource, update the returned response, and then send the result as the PUT request body.  ## API compatibility  Previous versions of the API are deprecated when a new version is released. Previous versions will be supported until further notice.  For a client to stay compatible with non breaking changes they need to take the following into account:  * New optional properties and properties with default values may   be added to JSON objects used as API request bodies.  * New properties may be added to JSON objects in API response bodies.  * Certain sum types (e.g. `enum` and `oneOf`) are documented as *open*   which means new alternatives can be added. The new values will only   be present if configured using the API or UI.  ## Authentication  See [API Key Management](https://docs.imperva.com/bundle/cloud-application-security/page/settings/api-keys.htm) for instructions on how to authenticate to this API.  ## Pagination  Resources may be paginated. This is indicated by the inclusion of the 'next' and/or the 'prev' relations in the '_links' property. See the Links schema documentation.   # noqa: E501

    OpenAPI spec version: 0.1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SiteV1(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'SiteId',
        'account_id': 'AccountId',
        'mx_hostname_id': 'OneOfSiteV1MxHostnameId',
        'name': 'Name',
        'selectors': 'list[SelectorV1]',
        'created_at': 'OneOfSiteV1CreatedAt',
        'modified_at': 'OneOfSiteV1ModifiedAt',
        'default_max_requests_per_minute': 'MaxRequestsPerMinute',
        'default_max_requests_per_session': 'MaxRequestsPerSession',
        'default_max_session_length': 'MaxSessionLength'
    }

    attribute_map = {
        'id': 'id',
        'account_id': 'account_id',
        'mx_hostname_id': 'mx_hostname_id',
        'name': 'name',
        'selectors': 'selectors',
        'created_at': 'created_at',
        'modified_at': 'modified_at',
        'default_max_requests_per_minute': 'default_max_requests_per_minute',
        'default_max_requests_per_session': 'default_max_requests_per_session',
        'default_max_session_length': 'default_max_session_length'
    }

    def __init__(self, id=None, account_id=None, mx_hostname_id=None, name=None, selectors=None, created_at=None, modified_at=None, default_max_requests_per_minute=None, default_max_requests_per_session=None, default_max_session_length=None):  # noqa: E501
        """SiteV1 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._account_id = None
        self._mx_hostname_id = None
        self._name = None
        self._selectors = None
        self._created_at = None
        self._modified_at = None
        self._default_max_requests_per_minute = None
        self._default_max_requests_per_session = None
        self._default_max_session_length = None
        self.discriminator = None
        self.id = id
        self.account_id = account_id
        if mx_hostname_id is not None:
            self.mx_hostname_id = mx_hostname_id
        self.name = name
        self.selectors = selectors
        if created_at is not None:
            self.created_at = created_at
        if modified_at is not None:
            self.modified_at = modified_at
        if default_max_requests_per_minute is not None:
            self.default_max_requests_per_minute = default_max_requests_per_minute
        if default_max_requests_per_session is not None:
            self.default_max_requests_per_session = default_max_requests_per_session
        if default_max_session_length is not None:
            self.default_max_session_length = default_max_session_length

    @property
    def id(self):
        """Gets the id of this SiteV1.  # noqa: E501


        :return: The id of this SiteV1.  # noqa: E501
        :rtype: SiteId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SiteV1.


        :param id: The id of this SiteV1.  # noqa: E501
        :type: SiteId
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def account_id(self):
        """Gets the account_id of this SiteV1.  # noqa: E501


        :return: The account_id of this SiteV1.  # noqa: E501
        :rtype: AccountId
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this SiteV1.


        :param account_id: The account_id of this SiteV1.  # noqa: E501
        :type: AccountId
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def mx_hostname_id(self):
        """Gets the mx_hostname_id of this SiteV1.  # noqa: E501


        :return: The mx_hostname_id of this SiteV1.  # noqa: E501
        :rtype: OneOfSiteV1MxHostnameId
        """
        return self._mx_hostname_id

    @mx_hostname_id.setter
    def mx_hostname_id(self, mx_hostname_id):
        """Sets the mx_hostname_id of this SiteV1.


        :param mx_hostname_id: The mx_hostname_id of this SiteV1.  # noqa: E501
        :type: OneOfSiteV1MxHostnameId
        """

        self._mx_hostname_id = mx_hostname_id

    @property
    def name(self):
        """Gets the name of this SiteV1.  # noqa: E501


        :return: The name of this SiteV1.  # noqa: E501
        :rtype: Name
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SiteV1.


        :param name: The name of this SiteV1.  # noqa: E501
        :type: Name
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def selectors(self):
        """Gets the selectors of this SiteV1.  # noqa: E501

        A list of Selectors in priority order, such that the first Selector that matches the incoming request will decide the Policy that will be applied.  # noqa: E501

        :return: The selectors of this SiteV1.  # noqa: E501
        :rtype: list[SelectorV1]
        """
        return self._selectors

    @selectors.setter
    def selectors(self, selectors):
        """Sets the selectors of this SiteV1.

        A list of Selectors in priority order, such that the first Selector that matches the incoming request will decide the Policy that will be applied.  # noqa: E501

        :param selectors: The selectors of this SiteV1.  # noqa: E501
        :type: list[SelectorV1]
        """
        if selectors is None:
            raise ValueError("Invalid value for `selectors`, must not be `None`")  # noqa: E501

        self._selectors = selectors

    @property
    def created_at(self):
        """Gets the created_at of this SiteV1.  # noqa: E501


        :return: The created_at of this SiteV1.  # noqa: E501
        :rtype: OneOfSiteV1CreatedAt
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this SiteV1.


        :param created_at: The created_at of this SiteV1.  # noqa: E501
        :type: OneOfSiteV1CreatedAt
        """

        self._created_at = created_at

    @property
    def modified_at(self):
        """Gets the modified_at of this SiteV1.  # noqa: E501


        :return: The modified_at of this SiteV1.  # noqa: E501
        :rtype: OneOfSiteV1ModifiedAt
        """
        return self._modified_at

    @modified_at.setter
    def modified_at(self, modified_at):
        """Sets the modified_at of this SiteV1.


        :param modified_at: The modified_at of this SiteV1.  # noqa: E501
        :type: OneOfSiteV1ModifiedAt
        """

        self._modified_at = modified_at

    @property
    def default_max_requests_per_minute(self):
        """Gets the default_max_requests_per_minute of this SiteV1.  # noqa: E501


        :return: The default_max_requests_per_minute of this SiteV1.  # noqa: E501
        :rtype: MaxRequestsPerMinute
        """
        return self._default_max_requests_per_minute

    @default_max_requests_per_minute.setter
    def default_max_requests_per_minute(self, default_max_requests_per_minute):
        """Sets the default_max_requests_per_minute of this SiteV1.


        :param default_max_requests_per_minute: The default_max_requests_per_minute of this SiteV1.  # noqa: E501
        :type: MaxRequestsPerMinute
        """

        self._default_max_requests_per_minute = default_max_requests_per_minute

    @property
    def default_max_requests_per_session(self):
        """Gets the default_max_requests_per_session of this SiteV1.  # noqa: E501


        :return: The default_max_requests_per_session of this SiteV1.  # noqa: E501
        :rtype: MaxRequestsPerSession
        """
        return self._default_max_requests_per_session

    @default_max_requests_per_session.setter
    def default_max_requests_per_session(self, default_max_requests_per_session):
        """Sets the default_max_requests_per_session of this SiteV1.


        :param default_max_requests_per_session: The default_max_requests_per_session of this SiteV1.  # noqa: E501
        :type: MaxRequestsPerSession
        """

        self._default_max_requests_per_session = default_max_requests_per_session

    @property
    def default_max_session_length(self):
        """Gets the default_max_session_length of this SiteV1.  # noqa: E501


        :return: The default_max_session_length of this SiteV1.  # noqa: E501
        :rtype: MaxSessionLength
        """
        return self._default_max_session_length

    @default_max_session_length.setter
    def default_max_session_length(self, default_max_session_length):
        """Sets the default_max_session_length of this SiteV1.


        :param default_max_session_length: The default_max_session_length of this SiteV1.  # noqa: E501
        :type: MaxSessionLength
        """

        self._default_max_session_length = default_max_session_length

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SiteV1, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SiteV1):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
