# swagger-client
This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
api_specification = 'api_specification_example' # str | 
base_path = 'base_path_example' # str | 
description = 'description_example' # str | 
oas_file_name = 'oas_file_name_example' # str | 
specification_violation_action = 'specification_violation_action_example' # str | 
validate_host = true # bool | 
violation_actions = 'violation_actions_example' # str | 
site_id = 789 # int | The site ID

try:
    # Add an API
    api_response = api_instance.add_api(api_specification, base_path, description, oas_file_name, specification_violation_action, validate_host, violation_actions, site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->add_api: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
api_id = 789 # int | The API ID
site_id = 789 # int | The site ID

try:
    # Delete an API
    api_response = api_instance.delete_api(api_id, site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->delete_api: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))

try:
    # Retrieve all APIs for the account
    api_response = api_instance.get_all_apis()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->get_all_apis: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The site ID

try:
    # Retrieve all APIs for a site
    api_response = api_instance.get_all_site_apis(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->get_all_site_apis: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The site ID

try:
    # Retrieve all APIs and endpoints for a site
    api_response = api_instance.get_all_site_apis_with_endpoints(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->get_all_site_apis_with_endpoints: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
api_id = 789 # int | The API ID
site_id = 789 # int | The site ID

try:
    # Retrieve an API
    api_response = api_instance.get_api(api_id, site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->get_api: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
api_id = 789 # int | The API ID
site_id = 789 # int | The site ID

try:
    # Download the API OAS file
    api_response = api_instance.get_api_file(api_id, site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->get_api_file: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIApi(swagger_client.ApiClient(configuration))
api_id = 789 # int | The API ID
site_id = 789 # int | The site ID
api_specification = 'api_specification_example' # str |  (optional)
description = 'description_example' # str |  (optional)
oas_file_name = 'oas_file_name_example' # str |  (optional)
specification_violation_action = 'specification_violation_action_example' # str |  (optional)
validate_host = true # bool |  (optional)
violation_actions = 'violation_actions_example' # str |  (optional)

try:
    # Update an API
    api_response = api_instance.update_api(api_id, site_id, api_specification=api_specification, description=description, oas_file_name=oas_file_name, specification_violation_action=specification_violation_action, validate_host=validate_host, violation_actions=violation_actions)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIApi->update_api: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/api-security*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIApi* | [**add_api**](docs/APIApi.md#add_api) | **POST** /api/{siteId} | Add an API
*APIApi* | [**delete_api**](docs/APIApi.md#delete_api) | **DELETE** /api/{siteId}/{apiId} | Delete an API
*APIApi* | [**get_all_apis**](docs/APIApi.md#get_all_apis) | **GET** /api | Retrieve all APIs for the account
*APIApi* | [**get_all_site_apis**](docs/APIApi.md#get_all_site_apis) | **GET** /api/{siteId} | Retrieve all APIs for a site
*APIApi* | [**get_all_site_apis_with_endpoints**](docs/APIApi.md#get_all_site_apis_with_endpoints) | **GET** /api/{siteId}/all | Retrieve all APIs and endpoints for a site
*APIApi* | [**get_api**](docs/APIApi.md#get_api) | **GET** /api/{siteId}/{apiId} | Retrieve an API
*APIApi* | [**get_api_file**](docs/APIApi.md#get_api_file) | **GET** /api/file/{siteId}/{apiId} | Download the API OAS file
*APIApi* | [**update_api**](docs/APIApi.md#update_api) | **POST** /api/{siteId}/{apiId} | Update an API
*DiscoveryAccountSettingsApi* | [**add_auth_location**](docs/DiscoveryAccountSettingsApi.md#add_auth_location) | **POST** /v2/discovery/account/settings/auth-parameter-location | Add Authentication Location
*DiscoveryAccountSettingsApi* | [**delete_discovery_account_settings**](docs/DiscoveryAccountSettingsApi.md#delete_discovery_account_settings) | **DELETE** /v2/discovery/account/settings | Deletes the Discovery account settings
*DiscoveryAccountSettingsApi* | [**get_discovery_account_settings**](docs/DiscoveryAccountSettingsApi.md#get_discovery_account_settings) | **GET** /v2/discovery/account/settings | Retrieve the Discovery account settings
*DiscoveryAccountSettingsApi* | [**update_discovery_account_settings**](docs/DiscoveryAccountSettingsApi.md#update_discovery_account_settings) | **POST** /v2/discovery/account/settings | Update only the changed Discovery account settings
*DiscoveryHostsApi* | [**get_hosts**](docs/DiscoveryHostsApi.md#get_hosts) | **GET** /v2/discovery/hosts | Retrieves the account&#x27;s discovered hosts
*DiscoveryInventoryApi* | [**get_discovered_api_files**](docs/DiscoveryInventoryApi.md#get_discovered_api_files) | **GET** /v2/discovery/inventory/endpoints/files | Download all OAS files of the discovered APIs to a compressed ZIP file
*DiscoveryInventoryApi* | [**get_discovered_endpoints**](docs/DiscoveryInventoryApi.md#get_discovered_endpoints) | **GET** /v2/discovery/inventory/endpoints | Retrieve all discovered endpoints
*DiscoveryInventoryApi* | [**get_endpoint_drill_down**](docs/DiscoveryInventoryApi.md#get_endpoint_drill_down) | **GET** /v2/discovery/inventory/endpoints/{endpointId} | Retrieve detailed information for the endpoint
*DiscoveryInventoryApi* | [**relearn_risk**](docs/DiscoveryInventoryApi.md#relearn_risk) | **DELETE** /v2/discovery/inventory/endpoints/risks | Relearn risk data
*DiscoverySiteSettingsApi* | [**get_site_discovery_settings**](docs/DiscoverySiteSettingsApi.md#get_site_discovery_settings) | **GET** /v2/discovery/sites/{siteId}/settings | Retrieve discovery settings for a site
*DiscoverySiteSettingsApi* | [**get_sites_discovery_settings**](docs/DiscoverySiteSettingsApi.md#get_sites_discovery_settings) | **GET** /v2/discovery/sites/settings | Retrieve the discovery settings for all sites in the account
*DiscoverySiteSettingsApi* | [**update_one_site_discovery_settings**](docs/DiscoverySiteSettingsApi.md#update_one_site_discovery_settings) | **POST** /v2/discovery/sites/{siteId}/settings | Update the site&#x27;s discovery settings
*DiscoverySiteSettingsApi* | [**update_sites_discovery_settings**](docs/DiscoverySiteSettingsApi.md#update_sites_discovery_settings) | **POST** /v2/discovery/sites/settings | Update the site&#x27;s discovery settings
*DiscoveryStatisticsApi* | [**get_dashboard_classification_statistics**](docs/DiscoveryStatisticsApi.md#get_dashboard_classification_statistics) | **GET** /v2/discovery/statistics/classification/from/{from-timestamp}/to/{to-timestamp} | Retrieve account level baselined endpoints&#x27; classification statistics
*DiscoveryStatisticsApi* | [**get_dashboard_general_statistics**](docs/DiscoveryStatisticsApi.md#get_dashboard_general_statistics) | **GET** /v2/discovery/statistics/usage/from/{from-timestamp}/to/{to-timestamp} | Retrieve account level baselined endpoints&#x27; usage statistics
*DiscoveryStatisticsApi* | [**get_dashboard_geolocation_statistics**](docs/DiscoveryStatisticsApi.md#get_dashboard_geolocation_statistics) | **GET** /v2/discovery/statistics/geolocation/from/{from-timestamp}/to/{to-timestamp} | Retrieve account level baselined endpoints&#x27; geolocation statistics
*DiscoveryStatisticsApi* | [**get_dashboard_volume_stats**](docs/DiscoveryStatisticsApi.md#get_dashboard_volume_stats) | **GET** /v2/discovery/statistics/volume/from/{from-timestamp}/to/{to-timestamp} | Retrieve account level baselined endpoints&#x27; volume statistics
*EndpointApi* | [**get_all_user_facing_endpoints**](docs/EndpointApi.md#get_all_user_facing_endpoints) | **GET** /endpoint/{apiId} | Retrieve all endpoints
*EndpointApi* | [**get_user_facing_endpoint**](docs/EndpointApi.md#get_user_facing_endpoint) | **GET** /endpoint/{apiId}/{endpointId} | Retrieve an endpoint
*EndpointApi* | [**update_endpoint**](docs/EndpointApi.md#update_endpoint) | **POST** /endpoint/{apiId}/{endpointId} | Update an endpoint
*SiteConfigurationApi* | [**get_site_configuration_for_account**](docs/SiteConfigurationApi.md#get_site_configuration_for_account) | **GET** /config/site | Retrieves all site configurations
*SiteConfigurationApi* | [**get_site_configuration_for_site**](docs/SiteConfigurationApi.md#get_site_configuration_for_site) | **GET** /config/site/{siteId} | Retrieves a site configuration
*SiteConfigurationApi* | [**update_site_configuration**](docs/SiteConfigurationApi.md#update_site_configuration) | **POST** /config/site/{siteId} | Updates site configuration
*VerificationApi* | [**delete_action**](docs/VerificationApi.md#delete_action) | **DELETE** /v2/shift-left/actions/{actionId} | Delete an action
*VerificationApi* | [**download_results**](docs/VerificationApi.md#download_results) | **GET** /v2/shift-left/actions/{actionId}/actionType/{actionTypeId} | Download reports
*VerificationApi* | [**get_action_types**](docs/VerificationApi.md#get_action_types) | **GET** /v2/shift-left/actions/action-types | Retrieve all action types for an account
*VerificationApi* | [**get_actions**](docs/VerificationApi.md#get_actions) | **GET** /v2/shift-left/actions | Retrieve all actions for an account
*VerificationApi* | [**upload_discovered_hosts_spec_files**](docs/VerificationApi.md#upload_discovered_hosts_spec_files) | **POST** /v2/shift-left/files/discovery | Uploads discovered APIs
*VerificationApi* | [**upload_file**](docs/VerificationApi.md#upload_file) | **POST** /v2/shift-left/files/oas | Upload an OAS file

## Documentation For Models

 - [Action](docs/Action.md)
 - [ActionType](docs/ActionType.md)
 - [ActionTypeMap](docs/ActionTypeMap.md)
 - [AddApiResponse](docs/AddApiResponse.md)
 - [AddApiResponseValue](docs/AddApiResponseValue.md)
 - [ApiFailureResponse](docs/ApiFailureResponse.md)
 - [ApiIdEndpointIdBody](docs/ApiIdEndpointIdBody.md)
 - [ApiResponse](docs/ApiResponse.md)
 - [ApiSiteIdBody](docs/ApiSiteIdBody.md)
 - [ApiSuccessResponse](docs/ApiSuccessResponse.md)
 - [ApiViolationActions](docs/ApiViolationActions.md)
 - [ApiWithEndpointResponse](docs/ApiWithEndpointResponse.md)
 - [AuthParameterLocationDto](docs/AuthParameterLocationDto.md)
 - [AuthParameterLocationResponse](docs/AuthParameterLocationResponse.md)
 - [AuthParameterSettings](docs/AuthParameterSettings.md)
 - [AuthenticationInfo](docs/AuthenticationInfo.md)
 - [ClassificationRiskVolumeStatistics](docs/ClassificationRiskVolumeStatistics.md)
 - [ClassificationStatistics](docs/ClassificationStatistics.md)
 - [ClassificationVolumeStatistics](docs/ClassificationVolumeStatistics.md)
 - [DataExposureInfo](docs/DataExposureInfo.md)
 - [DataLabelSettings](docs/DataLabelSettings.md)
 - [DataTypeDto](docs/DataTypeDto.md)
 - [DeprecatedApiSettings](docs/DeprecatedApiSettings.md)
 - [DiscoveredApisSummary](docs/DiscoveredApisSummary.md)
 - [DiscoveredEndpoint](docs/DiscoveredEndpoint.md)
 - [DiscoveryAccountSettings](docs/DiscoveryAccountSettings.md)
 - [DownloadApiSpecificationDtoResponse](docs/DownloadApiSpecificationDtoResponse.md)
 - [DuplicateEndpointResponse](docs/DuplicateEndpointResponse.md)
 - [EndpointClassificationStatistics](docs/EndpointClassificationStatistics.md)
 - [EndpointDetails](docs/EndpointDetails.md)
 - [EndpointDrillDown](docs/EndpointDrillDown.md)
 - [EndpointResponse](docs/EndpointResponse.md)
 - [EndpointSettingsDto](docs/EndpointSettingsDto.md)
 - [EndpointStatisticsSummary](docs/EndpointStatisticsSummary.md)
 - [EndpointStatusDrillDownDto](docs/EndpointStatusDrillDownDto.md)
 - [EndpointViolationActions](docs/EndpointViolationActions.md)
 - [EndpointVolumeStatistics](docs/EndpointVolumeStatistics.md)
 - [EndpointsPerHost](docs/EndpointsPerHost.md)
 - [EndpointsPerLabel](docs/EndpointsPerLabel.md)
 - [ExcessiveDataExposureSettings](docs/ExcessiveDataExposureSettings.md)
 - [FilesOasBody](docs/FilesOasBody.md)
 - [GeolocationCountryStatistics](docs/GeolocationCountryStatistics.md)
 - [GeolocationStatistics](docs/GeolocationStatistics.md)
 - [GetActionTypesResponse](docs/GetActionTypesResponse.md)
 - [GetActionsResponse](docs/GetActionsResponse.md)
 - [GetApiResponse](docs/GetApiResponse.md)
 - [GetApisResponse](docs/GetApisResponse.md)
 - [GetApisWithEndpointsResponse](docs/GetApisWithEndpointsResponse.md)
 - [GetDashboardClassificationStatisticsSuccessfulResponse](docs/GetDashboardClassificationStatisticsSuccessfulResponse.md)
 - [GetDashboardGeneralStatisticsSuccessfulResponse](docs/GetDashboardGeneralStatisticsSuccessfulResponse.md)
 - [GetDashboardGeolocationStatisticsSuccessfulResponse](docs/GetDashboardGeolocationStatisticsSuccessfulResponse.md)
 - [GetDashboardVolumeStatisticsSuccessfulResponse](docs/GetDashboardVolumeStatisticsSuccessfulResponse.md)
 - [GetDiscoveredEndpointsResponse](docs/GetDiscoveredEndpointsResponse.md)
 - [GetDiscoveryAccountSettingsResponse](docs/GetDiscoveryAccountSettingsResponse.md)
 - [GetEndpointDrillDownResponse](docs/GetEndpointDrillDownResponse.md)
 - [GetEndpointResponse](docs/GetEndpointResponse.md)
 - [GetEndpointsResponse](docs/GetEndpointsResponse.md)
 - [GetHostsResponse](docs/GetHostsResponse.md)
 - [GetSiteConfigurationResponse](docs/GetSiteConfigurationResponse.md)
 - [GetSiteConfigurationsResponse](docs/GetSiteConfigurationsResponse.md)
 - [GetSiteDiscoverySettingsListResponse](docs/GetSiteDiscoverySettingsListResponse.md)
 - [GetSiteDiscoverySettingsResponse](docs/GetSiteDiscoverySettingsResponse.md)
 - [Host](docs/Host.md)
 - [HostClassificationStatistics](docs/HostClassificationStatistics.md)
 - [HostDetails](docs/HostDetails.md)
 - [HostVolumeStatistics](docs/HostVolumeStatistics.md)
 - [InventoryDiscoveryData](docs/InventoryDiscoveryData.md)
 - [Label](docs/Label.md)
 - [NumberOfEndpointsByRisks](docs/NumberOfEndpointsByRisks.md)
 - [ParameterDrillDown](docs/ParameterDrillDown.md)
 - [ParserErrorResponse](docs/ParserErrorResponse.md)
 - [PathParamSegments](docs/PathParamSegments.md)
 - [RequestDrillDown](docs/RequestDrillDown.md)
 - [ResourceClassificationStatistics](docs/ResourceClassificationStatistics.md)
 - [ResourceDetails](docs/ResourceDetails.md)
 - [ResourceStatTrend](docs/ResourceStatTrend.md)
 - [ResourceVolumeStatistics](docs/ResourceVolumeStatistics.md)
 - [ResponseDrillDown](docs/ResponseDrillDown.md)
 - [RiskInfo](docs/RiskInfo.md)
 - [SegmentDetails](docs/SegmentDetails.md)
 - [SensitiveDataClassification](docs/SensitiveDataClassification.md)
 - [SimpleTextErrorResponse](docs/SimpleTextErrorResponse.md)
 - [SimpleTextSuccessResponse](docs/SimpleTextSuccessResponse.md)
 - [SiteConfigurationResponse](docs/SiteConfigurationResponse.md)
 - [SiteDiscoverySettings](docs/SiteDiscoverySettings.md)
 - [SiteIdApiIdBody](docs/SiteIdApiIdBody.md)
 - [UpdateEndpointResponse](docs/UpdateEndpointResponse.md)
 - [UpdateEndpointResponseValue](docs/UpdateEndpointResponseValue.md)
 - [UpdateSiteConfigurationResponse](docs/UpdateSiteConfigurationResponse.md)
 - [UpdateSiteConfigurationResponseValue](docs/UpdateSiteConfigurationResponseValue.md)
 - [UploadFileSuccessResponse](docs/UploadFileSuccessResponse.md)
 - [UsageStatistics](docs/UsageStatistics.md)
 - [VolumeStatistics](docs/VolumeStatistics.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


