# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class DiscoveryInventoryApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_discovered_api_files(self, **kwargs):  # noqa: E501
        """Download all OAS files of the discovered APIs to a compressed ZIP file  # noqa: E501

        Download all OAS files of the discovered APIs, for all hosts or selected hosts in the query, to a compressed ZIP file. The ZIP file format is account-<account_id>-api-files.zip and the ZIP file name format is <host_name>-<base_path>-discovery.json. Underscore is used as the delimiter for the basePath.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_discovered_api_files(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str host_ids: Comma separated list of host ids
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_discovered_api_files_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_discovered_api_files_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_discovered_api_files_with_http_info(self, **kwargs):  # noqa: E501
        """Download all OAS files of the discovered APIs to a compressed ZIP file  # noqa: E501

        Download all OAS files of the discovered APIs, for all hosts or selected hosts in the query, to a compressed ZIP file. The ZIP file format is account-<account_id>-api-files.zip and the ZIP file name format is <host_name>-<base_path>-discovery.json. Underscore is used as the delimiter for the basePath.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_discovered_api_files_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str host_ids: Comma separated list of host ids
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_discovered_api_files" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/zip'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/inventory/endpoints/files', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_discovered_endpoints(self, **kwargs):  # noqa: E501
        """Retrieve all discovered endpoints  # noqa: E501

        Retrieve all discovered endpoints for the account or for the specified hosts. If no host id is provided - retrieve all discovered endpoints for all hosts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_discovered_endpoints(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str host_ids: Comma separated list of host ids
        :return: GetDiscoveredEndpointsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_discovered_endpoints_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_discovered_endpoints_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_discovered_endpoints_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieve all discovered endpoints  # noqa: E501

        Retrieve all discovered endpoints for the account or for the specified hosts. If no host id is provided - retrieve all discovered endpoints for all hosts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_discovered_endpoints_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str host_ids: Comma separated list of host ids
        :return: GetDiscoveredEndpointsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_discovered_endpoints" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/inventory/endpoints', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDiscoveredEndpointsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_endpoint_drill_down(self, endpoint_id, **kwargs):  # noqa: E501
        """Retrieve detailed information for the endpoint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_endpoint_drill_down(endpoint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int endpoint_id: endpoint ID (required)
        :return: GetEndpointDrillDownResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_endpoint_drill_down_with_http_info(endpoint_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_endpoint_drill_down_with_http_info(endpoint_id, **kwargs)  # noqa: E501
            return data

    def get_endpoint_drill_down_with_http_info(self, endpoint_id, **kwargs):  # noqa: E501
        """Retrieve detailed information for the endpoint  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_endpoint_drill_down_with_http_info(endpoint_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int endpoint_id: endpoint ID (required)
        :return: GetEndpointDrillDownResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_endpoint_drill_down" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_id' is set
        if ('endpoint_id' not in params or
                params['endpoint_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_id` when calling `get_endpoint_drill_down`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_id' in params:
            path_params['endpointId'] = params['endpoint_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/inventory/endpoints/{endpointId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetEndpointDrillDownResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def relearn_risk(self, **kwargs):  # noqa: E501
        """Relearn risk data  # noqa: E501

        Deletes the current risk data and adds new risk data by relearning  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.relearn_risk(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_ids: endpointIds
        :return: ApiSuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.relearn_risk_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.relearn_risk_with_http_info(**kwargs)  # noqa: E501
            return data

    def relearn_risk_with_http_info(self, **kwargs):  # noqa: E501
        """Relearn risk data  # noqa: E501

        Deletes the current risk data and adds new risk data by relearning  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.relearn_risk_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_ids: endpointIds
        :return: ApiSuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method relearn_risk" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'endpoint_ids' in params:
            query_params.append(('endpointIds', params['endpoint_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/inventory/endpoints/risks', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiSuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
