# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class DiscoveryStatisticsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_dashboard_classification_statistics(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' classification statistics  # noqa: E501

        Retrieve account level baselined endpoints' classification statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_classification_statistics(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardClassificationStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dashboard_classification_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dashboard_classification_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
            return data

    def get_dashboard_classification_statistics_with_http_info(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' classification statistics  # noqa: E501

        Retrieve account level baselined endpoints' classification statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_classification_statistics_with_http_info(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardClassificationStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['from_timestamp', 'to_timestamp', 'host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dashboard_classification_statistics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'from_timestamp' is set
        if ('from_timestamp' not in params or
                params['from_timestamp'] is None):
            raise ValueError("Missing the required parameter `from_timestamp` when calling `get_dashboard_classification_statistics`")  # noqa: E501
        # verify the required parameter 'to_timestamp' is set
        if ('to_timestamp' not in params or
                params['to_timestamp'] is None):
            raise ValueError("Missing the required parameter `to_timestamp` when calling `get_dashboard_classification_statistics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'from_timestamp' in params:
            path_params['from-timestamp'] = params['from_timestamp']  # noqa: E501
        if 'to_timestamp' in params:
            path_params['to-timestamp'] = params['to_timestamp']  # noqa: E501

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/statistics/classification/from/{from-timestamp}/to/{to-timestamp}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDashboardClassificationStatisticsSuccessfulResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dashboard_general_statistics(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' usage statistics  # noqa: E501

        Retrieve account level baselined endpoints' usage statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_general_statistics(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host IDs
        :return: GetDashboardGeneralStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dashboard_general_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dashboard_general_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
            return data

    def get_dashboard_general_statistics_with_http_info(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' usage statistics  # noqa: E501

        Retrieve account level baselined endpoints' usage statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_general_statistics_with_http_info(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host IDs
        :return: GetDashboardGeneralStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['from_timestamp', 'to_timestamp', 'host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dashboard_general_statistics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'from_timestamp' is set
        if ('from_timestamp' not in params or
                params['from_timestamp'] is None):
            raise ValueError("Missing the required parameter `from_timestamp` when calling `get_dashboard_general_statistics`")  # noqa: E501
        # verify the required parameter 'to_timestamp' is set
        if ('to_timestamp' not in params or
                params['to_timestamp'] is None):
            raise ValueError("Missing the required parameter `to_timestamp` when calling `get_dashboard_general_statistics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'from_timestamp' in params:
            path_params['from-timestamp'] = params['from_timestamp']  # noqa: E501
        if 'to_timestamp' in params:
            path_params['to-timestamp'] = params['to_timestamp']  # noqa: E501

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/statistics/usage/from/{from-timestamp}/to/{to-timestamp}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDashboardGeneralStatisticsSuccessfulResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dashboard_geolocation_statistics(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' geolocation statistics  # noqa: E501

        Retrieve account level baselined endpoints' geolocation statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_geolocation_statistics(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardGeolocationStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dashboard_geolocation_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dashboard_geolocation_statistics_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
            return data

    def get_dashboard_geolocation_statistics_with_http_info(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' geolocation statistics  # noqa: E501

        Retrieve account level baselined endpoints' geolocation statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_geolocation_statistics_with_http_info(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardGeolocationStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['from_timestamp', 'to_timestamp', 'host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dashboard_geolocation_statistics" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'from_timestamp' is set
        if ('from_timestamp' not in params or
                params['from_timestamp'] is None):
            raise ValueError("Missing the required parameter `from_timestamp` when calling `get_dashboard_geolocation_statistics`")  # noqa: E501
        # verify the required parameter 'to_timestamp' is set
        if ('to_timestamp' not in params or
                params['to_timestamp'] is None):
            raise ValueError("Missing the required parameter `to_timestamp` when calling `get_dashboard_geolocation_statistics`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'from_timestamp' in params:
            path_params['from-timestamp'] = params['from_timestamp']  # noqa: E501
        if 'to_timestamp' in params:
            path_params['to-timestamp'] = params['to_timestamp']  # noqa: E501

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/statistics/geolocation/from/{from-timestamp}/to/{to-timestamp}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDashboardGeolocationStatisticsSuccessfulResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dashboard_volume_stats(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' volume statistics  # noqa: E501

        Retrieve account level baselined endpoints' volume statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_volume_stats(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardVolumeStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dashboard_volume_stats_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dashboard_volume_stats_with_http_info(from_timestamp, to_timestamp, **kwargs)  # noqa: E501
            return data

    def get_dashboard_volume_stats_with_http_info(self, from_timestamp, to_timestamp, **kwargs):  # noqa: E501
        """Retrieve account level baselined endpoints' volume statistics  # noqa: E501

        Retrieve account level baselined endpoints' volume statistics  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dashboard_volume_stats_with_http_info(from_timestamp, to_timestamp, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int from_timestamp: Start Date or Start Time of the statistics  in milliseconds (epoch time). (required)
        :param int to_timestamp: End Date or End Time of the statistics  in milliseconds (epoch time). (required)
        :param str host_ids: Comma separated list of host ids
        :return: GetDashboardVolumeStatisticsSuccessfulResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['from_timestamp', 'to_timestamp', 'host_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dashboard_volume_stats" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'from_timestamp' is set
        if ('from_timestamp' not in params or
                params['from_timestamp'] is None):
            raise ValueError("Missing the required parameter `from_timestamp` when calling `get_dashboard_volume_stats`")  # noqa: E501
        # verify the required parameter 'to_timestamp' is set
        if ('to_timestamp' not in params or
                params['to_timestamp'] is None):
            raise ValueError("Missing the required parameter `to_timestamp` when calling `get_dashboard_volume_stats`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'from_timestamp' in params:
            path_params['from-timestamp'] = params['from_timestamp']  # noqa: E501
        if 'to_timestamp' in params:
            path_params['to-timestamp'] = params['to_timestamp']  # noqa: E501

        query_params = []
        if 'host_ids' in params:
            query_params.append(('hostIds', params['host_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v2/discovery/statistics/volume/from/{from-timestamp}/to/{to-timestamp}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDashboardVolumeStatisticsSuccessfulResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
