# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeprecatedApiSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'deprecated_api_enabled': 'bool',
        'inactive_for_days': 'int',
        'last_modified': 'int',
        'last_modified_user': 'str'
    }

    attribute_map = {
        'deprecated_api_enabled': 'deprecatedApiEnabled',
        'inactive_for_days': 'inactiveForDays',
        'last_modified': 'lastModified',
        'last_modified_user': 'lastModifiedUser'
    }

    def __init__(self, deprecated_api_enabled=None, inactive_for_days=None, last_modified=None, last_modified_user=None):  # noqa: E501
        """DeprecatedApiSettings - a model defined in Swagger"""  # noqa: E501
        self._deprecated_api_enabled = None
        self._inactive_for_days = None
        self._last_modified = None
        self._last_modified_user = None
        self.discriminator = None
        if deprecated_api_enabled is not None:
            self.deprecated_api_enabled = deprecated_api_enabled
        if inactive_for_days is not None:
            self.inactive_for_days = inactive_for_days
        if last_modified is not None:
            self.last_modified = last_modified
        if last_modified_user is not None:
            self.last_modified_user = last_modified_user

    @property
    def deprecated_api_enabled(self):
        """Gets the deprecated_api_enabled of this DeprecatedApiSettings.  # noqa: E501


        :return: The deprecated_api_enabled of this DeprecatedApiSettings.  # noqa: E501
        :rtype: bool
        """
        return self._deprecated_api_enabled

    @deprecated_api_enabled.setter
    def deprecated_api_enabled(self, deprecated_api_enabled):
        """Sets the deprecated_api_enabled of this DeprecatedApiSettings.


        :param deprecated_api_enabled: The deprecated_api_enabled of this DeprecatedApiSettings.  # noqa: E501
        :type: bool
        """

        self._deprecated_api_enabled = deprecated_api_enabled

    @property
    def inactive_for_days(self):
        """Gets the inactive_for_days of this DeprecatedApiSettings.  # noqa: E501

        number of days for which API is inactive  # noqa: E501

        :return: The inactive_for_days of this DeprecatedApiSettings.  # noqa: E501
        :rtype: int
        """
        return self._inactive_for_days

    @inactive_for_days.setter
    def inactive_for_days(self, inactive_for_days):
        """Sets the inactive_for_days of this DeprecatedApiSettings.

        number of days for which API is inactive  # noqa: E501

        :param inactive_for_days: The inactive_for_days of this DeprecatedApiSettings.  # noqa: E501
        :type: int
        """

        self._inactive_for_days = inactive_for_days

    @property
    def last_modified(self):
        """Gets the last_modified of this DeprecatedApiSettings.  # noqa: E501

        The last modified timestamp  # noqa: E501

        :return: The last_modified of this DeprecatedApiSettings.  # noqa: E501
        :rtype: int
        """
        return self._last_modified

    @last_modified.setter
    def last_modified(self, last_modified):
        """Sets the last_modified of this DeprecatedApiSettings.

        The last modified timestamp  # noqa: E501

        :param last_modified: The last_modified of this DeprecatedApiSettings.  # noqa: E501
        :type: int
        """

        self._last_modified = last_modified

    @property
    def last_modified_user(self):
        """Gets the last_modified_user of this DeprecatedApiSettings.  # noqa: E501

        The last modified user  # noqa: E501

        :return: The last_modified_user of this DeprecatedApiSettings.  # noqa: E501
        :rtype: str
        """
        return self._last_modified_user

    @last_modified_user.setter
    def last_modified_user(self, last_modified_user):
        """Sets the last_modified_user of this DeprecatedApiSettings.

        The last modified user  # noqa: E501

        :param last_modified_user: The last_modified_user of this DeprecatedApiSettings.  # noqa: E501
        :type: str
        """

        self._last_modified_user = last_modified_user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeprecatedApiSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeprecatedApiSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
