# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DiscoveredApisSummary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number_of_hosts': 'int',
        'number_of_resources': 'int',
        'number_of_endpoints': 'int',
        'number_of_labels': 'int',
        'number_of_api_discovery_statuses': 'dict(str, int)',
        'number_of_endpoints_with_risks': 'dict(str, int)',
        'number_of_endpoints_with_data_labels': 'dict(str, int)'
    }

    attribute_map = {
        'number_of_hosts': 'numberOfHosts',
        'number_of_resources': 'numberOfResources',
        'number_of_endpoints': 'numberOfEndpoints',
        'number_of_labels': 'numberOfLabels',
        'number_of_api_discovery_statuses': 'numberOfApiDiscoveryStatuses',
        'number_of_endpoints_with_risks': 'numberOfEndpointsWithRisks',
        'number_of_endpoints_with_data_labels': 'numberOfEndpointsWithDataLabels'
    }

    def __init__(self, number_of_hosts=None, number_of_resources=None, number_of_endpoints=None, number_of_labels=None, number_of_api_discovery_statuses=None, number_of_endpoints_with_risks=None, number_of_endpoints_with_data_labels=None):  # noqa: E501
        """DiscoveredApisSummary - a model defined in Swagger"""  # noqa: E501
        self._number_of_hosts = None
        self._number_of_resources = None
        self._number_of_endpoints = None
        self._number_of_labels = None
        self._number_of_api_discovery_statuses = None
        self._number_of_endpoints_with_risks = None
        self._number_of_endpoints_with_data_labels = None
        self.discriminator = None
        if number_of_hosts is not None:
            self.number_of_hosts = number_of_hosts
        if number_of_resources is not None:
            self.number_of_resources = number_of_resources
        if number_of_endpoints is not None:
            self.number_of_endpoints = number_of_endpoints
        if number_of_labels is not None:
            self.number_of_labels = number_of_labels
        if number_of_api_discovery_statuses is not None:
            self.number_of_api_discovery_statuses = number_of_api_discovery_statuses
        if number_of_endpoints_with_risks is not None:
            self.number_of_endpoints_with_risks = number_of_endpoints_with_risks
        if number_of_endpoints_with_data_labels is not None:
            self.number_of_endpoints_with_data_labels = number_of_endpoints_with_data_labels

    @property
    def number_of_hosts(self):
        """Gets the number_of_hosts of this DiscoveredApisSummary.  # noqa: E501

        The total number of hosts for all endpoints  # noqa: E501

        :return: The number_of_hosts of this DiscoveredApisSummary.  # noqa: E501
        :rtype: int
        """
        return self._number_of_hosts

    @number_of_hosts.setter
    def number_of_hosts(self, number_of_hosts):
        """Sets the number_of_hosts of this DiscoveredApisSummary.

        The total number of hosts for all endpoints  # noqa: E501

        :param number_of_hosts: The number_of_hosts of this DiscoveredApisSummary.  # noqa: E501
        :type: int
        """

        self._number_of_hosts = number_of_hosts

    @property
    def number_of_resources(self):
        """Gets the number_of_resources of this DiscoveredApisSummary.  # noqa: E501

        The total number of resources for all endpoints  # noqa: E501

        :return: The number_of_resources of this DiscoveredApisSummary.  # noqa: E501
        :rtype: int
        """
        return self._number_of_resources

    @number_of_resources.setter
    def number_of_resources(self, number_of_resources):
        """Sets the number_of_resources of this DiscoveredApisSummary.

        The total number of resources for all endpoints  # noqa: E501

        :param number_of_resources: The number_of_resources of this DiscoveredApisSummary.  # noqa: E501
        :type: int
        """

        self._number_of_resources = number_of_resources

    @property
    def number_of_endpoints(self):
        """Gets the number_of_endpoints of this DiscoveredApisSummary.  # noqa: E501

        The total number of endpoints for the account  # noqa: E501

        :return: The number_of_endpoints of this DiscoveredApisSummary.  # noqa: E501
        :rtype: int
        """
        return self._number_of_endpoints

    @number_of_endpoints.setter
    def number_of_endpoints(self, number_of_endpoints):
        """Sets the number_of_endpoints of this DiscoveredApisSummary.

        The total number of endpoints for the account  # noqa: E501

        :param number_of_endpoints: The number_of_endpoints of this DiscoveredApisSummary.  # noqa: E501
        :type: int
        """

        self._number_of_endpoints = number_of_endpoints

    @property
    def number_of_labels(self):
        """Gets the number_of_labels of this DiscoveredApisSummary.  # noqa: E501

        The total number of labels for all endpoints  # noqa: E501

        :return: The number_of_labels of this DiscoveredApisSummary.  # noqa: E501
        :rtype: int
        """
        return self._number_of_labels

    @number_of_labels.setter
    def number_of_labels(self, number_of_labels):
        """Sets the number_of_labels of this DiscoveredApisSummary.

        The total number of labels for all endpoints  # noqa: E501

        :param number_of_labels: The number_of_labels of this DiscoveredApisSummary.  # noqa: E501
        :type: int
        """

        self._number_of_labels = number_of_labels

    @property
    def number_of_api_discovery_statuses(self):
        """Gets the number_of_api_discovery_statuses of this DiscoveredApisSummary.  # noqa: E501

        The number of endpoints per discovery status  # noqa: E501

        :return: The number_of_api_discovery_statuses of this DiscoveredApisSummary.  # noqa: E501
        :rtype: dict(str, int)
        """
        return self._number_of_api_discovery_statuses

    @number_of_api_discovery_statuses.setter
    def number_of_api_discovery_statuses(self, number_of_api_discovery_statuses):
        """Sets the number_of_api_discovery_statuses of this DiscoveredApisSummary.

        The number of endpoints per discovery status  # noqa: E501

        :param number_of_api_discovery_statuses: The number_of_api_discovery_statuses of this DiscoveredApisSummary.  # noqa: E501
        :type: dict(str, int)
        """

        self._number_of_api_discovery_statuses = number_of_api_discovery_statuses

    @property
    def number_of_endpoints_with_risks(self):
        """Gets the number_of_endpoints_with_risks of this DiscoveredApisSummary.  # noqa: E501

        The discovered API risks  # noqa: E501

        :return: The number_of_endpoints_with_risks of this DiscoveredApisSummary.  # noqa: E501
        :rtype: dict(str, int)
        """
        return self._number_of_endpoints_with_risks

    @number_of_endpoints_with_risks.setter
    def number_of_endpoints_with_risks(self, number_of_endpoints_with_risks):
        """Sets the number_of_endpoints_with_risks of this DiscoveredApisSummary.

        The discovered API risks  # noqa: E501

        :param number_of_endpoints_with_risks: The number_of_endpoints_with_risks of this DiscoveredApisSummary.  # noqa: E501
        :type: dict(str, int)
        """

        self._number_of_endpoints_with_risks = number_of_endpoints_with_risks

    @property
    def number_of_endpoints_with_data_labels(self):
        """Gets the number_of_endpoints_with_data_labels of this DiscoveredApisSummary.  # noqa: E501

        Number of sensitive and non-sensitive data labels  # noqa: E501

        :return: The number_of_endpoints_with_data_labels of this DiscoveredApisSummary.  # noqa: E501
        :rtype: dict(str, int)
        """
        return self._number_of_endpoints_with_data_labels

    @number_of_endpoints_with_data_labels.setter
    def number_of_endpoints_with_data_labels(self, number_of_endpoints_with_data_labels):
        """Sets the number_of_endpoints_with_data_labels of this DiscoveredApisSummary.

        Number of sensitive and non-sensitive data labels  # noqa: E501

        :param number_of_endpoints_with_data_labels: The number_of_endpoints_with_data_labels of this DiscoveredApisSummary.  # noqa: E501
        :type: dict(str, int)
        """

        self._number_of_endpoints_with_data_labels = number_of_endpoints_with_data_labels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DiscoveredApisSummary, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DiscoveredApisSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
