# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResourceClassificationStatistics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_details': 'ResourceDetails',
        'labels': 'list[Label]',
        'resource_stat_trend': 'ResourceStatTrend',
        'is_first_time_seen_in_current_time_period': 'bool'
    }

    attribute_map = {
        'resource_details': 'resourceDetails',
        'labels': 'labels',
        'resource_stat_trend': 'resourceStatTrend',
        'is_first_time_seen_in_current_time_period': 'isFirstTimeSeenInCurrentTimePeriod'
    }

    def __init__(self, resource_details=None, labels=None, resource_stat_trend=None, is_first_time_seen_in_current_time_period=None):  # noqa: E501
        """ResourceClassificationStatistics - a model defined in Swagger"""  # noqa: E501
        self._resource_details = None
        self._labels = None
        self._resource_stat_trend = None
        self._is_first_time_seen_in_current_time_period = None
        self.discriminator = None
        if resource_details is not None:
            self.resource_details = resource_details
        if labels is not None:
            self.labels = labels
        if resource_stat_trend is not None:
            self.resource_stat_trend = resource_stat_trend
        if is_first_time_seen_in_current_time_period is not None:
            self.is_first_time_seen_in_current_time_period = is_first_time_seen_in_current_time_period

    @property
    def resource_details(self):
        """Gets the resource_details of this ResourceClassificationStatistics.  # noqa: E501


        :return: The resource_details of this ResourceClassificationStatistics.  # noqa: E501
        :rtype: ResourceDetails
        """
        return self._resource_details

    @resource_details.setter
    def resource_details(self, resource_details):
        """Sets the resource_details of this ResourceClassificationStatistics.


        :param resource_details: The resource_details of this ResourceClassificationStatistics.  # noqa: E501
        :type: ResourceDetails
        """

        self._resource_details = resource_details

    @property
    def labels(self):
        """Gets the labels of this ResourceClassificationStatistics.  # noqa: E501


        :return: The labels of this ResourceClassificationStatistics.  # noqa: E501
        :rtype: list[Label]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this ResourceClassificationStatistics.


        :param labels: The labels of this ResourceClassificationStatistics.  # noqa: E501
        :type: list[Label]
        """

        self._labels = labels

    @property
    def resource_stat_trend(self):
        """Gets the resource_stat_trend of this ResourceClassificationStatistics.  # noqa: E501


        :return: The resource_stat_trend of this ResourceClassificationStatistics.  # noqa: E501
        :rtype: ResourceStatTrend
        """
        return self._resource_stat_trend

    @resource_stat_trend.setter
    def resource_stat_trend(self, resource_stat_trend):
        """Sets the resource_stat_trend of this ResourceClassificationStatistics.


        :param resource_stat_trend: The resource_stat_trend of this ResourceClassificationStatistics.  # noqa: E501
        :type: ResourceStatTrend
        """

        self._resource_stat_trend = resource_stat_trend

    @property
    def is_first_time_seen_in_current_time_period(self):
        """Gets the is_first_time_seen_in_current_time_period of this ResourceClassificationStatistics.  # noqa: E501


        :return: The is_first_time_seen_in_current_time_period of this ResourceClassificationStatistics.  # noqa: E501
        :rtype: bool
        """
        return self._is_first_time_seen_in_current_time_period

    @is_first_time_seen_in_current_time_period.setter
    def is_first_time_seen_in_current_time_period(self, is_first_time_seen_in_current_time_period):
        """Sets the is_first_time_seen_in_current_time_period of this ResourceClassificationStatistics.


        :param is_first_time_seen_in_current_time_period: The is_first_time_seen_in_current_time_period of this ResourceClassificationStatistics.  # noqa: E501
        :type: bool
        """

        self._is_first_time_seen_in_current_time_period = is_first_time_seen_in_current_time_period

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceClassificationStatistics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceClassificationStatistics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
