# coding: utf-8

"""
    Imperva Advanced API Security

    This topic describes the API for Imperva Advanced API Security. For full feature documentation, see [Imperva API Security](https://docs.imperva.com/bundle/api-security/page/72248.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RiskInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'risk': 'str',
        'risk_type': 'str',
        'owasp_tag': 'str'
    }

    attribute_map = {
        'risk': 'risk',
        'risk_type': 'riskType',
        'owasp_tag': 'owaspTag'
    }

    def __init__(self, risk=None, risk_type=None, owasp_tag=None):  # noqa: E501
        """RiskInfo - a model defined in Swagger"""  # noqa: E501
        self._risk = None
        self._risk_type = None
        self._owasp_tag = None
        self.discriminator = None
        if risk is not None:
            self.risk = risk
        if risk_type is not None:
            self.risk_type = risk_type
        if owasp_tag is not None:
            self.owasp_tag = owasp_tag

    @property
    def risk(self):
        """Gets the risk of this RiskInfo.  # noqa: E501

        The discovered API risk  # noqa: E501

        :return: The risk of this RiskInfo.  # noqa: E501
        :rtype: str
        """
        return self._risk

    @risk.setter
    def risk(self, risk):
        """Sets the risk of this RiskInfo.

        The discovered API risk  # noqa: E501

        :param risk: The risk of this RiskInfo.  # noqa: E501
        :type: str
        """

        self._risk = risk

    @property
    def risk_type(self):
        """Gets the risk_type of this RiskInfo.  # noqa: E501

        The discovered API risk type  # noqa: E501

        :return: The risk_type of this RiskInfo.  # noqa: E501
        :rtype: str
        """
        return self._risk_type

    @risk_type.setter
    def risk_type(self, risk_type):
        """Sets the risk_type of this RiskInfo.

        The discovered API risk type  # noqa: E501

        :param risk_type: The risk_type of this RiskInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["OWASP", "OTHER"]  # noqa: E501
        if risk_type not in allowed_values:
            raise ValueError(
                "Invalid value for `risk_type` ({0}), must be one of {1}"  # noqa: E501
                .format(risk_type, allowed_values)
            )

        self._risk_type = risk_type

    @property
    def owasp_tag(self):
        """Gets the owasp_tag of this RiskInfo.  # noqa: E501

        The OWASP tag associated with the risk  # noqa: E501

        :return: The owasp_tag of this RiskInfo.  # noqa: E501
        :rtype: str
        """
        return self._owasp_tag

    @owasp_tag.setter
    def owasp_tag(self, owasp_tag):
        """Sets the owasp_tag of this RiskInfo.

        The OWASP tag associated with the risk  # noqa: E501

        :param owasp_tag: The owasp_tag of this RiskInfo.  # noqa: E501
        :type: str
        """

        self._owasp_tag = owasp_tag

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RiskInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RiskInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
