# swagger-client
Access the Attack Analytics data for your account using the API. For full feature documentation, see [Imperva Attack Analytics](https://docs.imperva.com/bundle/Attack-Analytics/page/Content/attack_analytics/attack_analytics.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AttackAnalyticsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Account ID. Unique identifier of the account to operate on.
incident_id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The incident identifier.

try:
    # Retrieve incident details
    api_response = api_instance.get_incident_stats_by_account(caid, incident_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AttackAnalyticsApi->get_incident_stats_by_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AttackAnalyticsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Account ID. Unique identifier of the account to operate on.
from_timestamp = 789 # int | Earliest time boundary, specified as number of milliseconds since midnight 1970 (UNIX time * 1000). (optional)
to_timestamp = 789 # int | Latest time boundary, specified as number of milliseconds since midnight 1970 (UNIX time * 1000). (optional)

try:
    # Retrieve a list of incidents
    api_response = api_instance.get_incidents_by_account(caid, from_timestamp=from_timestamp, to_timestamp=to_timestamp)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AttackAnalyticsApi->get_incidents_by_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AttackAnalyticsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Unique account id

try:
    # Retrieve insights
    api_response = api_instance.get_insights_per_account(caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AttackAnalyticsApi->get_insights_per_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AttackAnalyticsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Unique identifier of the account to operate on
incident_id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The incident identifier

try:
    # Retrieve event sample
    api_response = api_instance.get_sample_events_by_incident(caid, incident_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AttackAnalyticsApi->get_sample_events_by_incident: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/analytics*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AttackAnalyticsApi* | [**get_incident_stats_by_account**](docs/AttackAnalyticsApi.md#get_incident_stats_by_account) | **GET** /v1/incidents/{incidentId}/stats | Retrieve incident details
*AttackAnalyticsApi* | [**get_incidents_by_account**](docs/AttackAnalyticsApi.md#get_incidents_by_account) | **GET** /v1/incidents | Retrieve a list of incidents
*AttackAnalyticsApi* | [**get_insights_per_account**](docs/AttackAnalyticsApi.md#get_insights_per_account) | **GET** /v1/insights | Retrieve insights
*AttackAnalyticsApi* | [**get_sample_events_by_incident**](docs/AttackAnalyticsApi.md#get_sample_events_by_incident) | **GET** /v1/incidents/{incidentId}/sample-events | Retrieve event sample

## Documentation For Models

 - [AttackedSiteInfo](docs/AttackedSiteInfo.md)
 - [Cookie](docs/Cookie.md)
 - [CountryDominance](docs/CountryDominance.md)
 - [DdosData](docs/DdosData.md)
 - [ErrorResponseWrapper](docs/ErrorResponseWrapper.md)
 - [Event](docs/Event.md)
 - [GeneralInsightData](docs/GeneralInsightData.md)
 - [Incident](docs/Incident.md)
 - [IncidentStats](docs/IncidentStats.md)
 - [Insight](docs/Insight.md)
 - [InsightSummaryVOApi](docs/InsightSummaryVOApi.md)
 - [InsightsDataApi](docs/InsightsDataApi.md)
 - [IpDominance](docs/IpDominance.md)
 - [IpObject](docs/IpObject.md)
 - [KeyValue](docs/KeyValue.md)
 - [KeyValueIpObjectLong](docs/KeyValueIpObjectLong.md)
 - [KeyValueLongInteger](docs/KeyValueLongInteger.md)
 - [KeyValueStringLong](docs/KeyValueStringLong.md)
 - [KeyValueStringString](docs/KeyValueStringString.md)
 - [NetworkTrafficData](docs/NetworkTrafficData.md)
 - [ShinyObject](docs/ShinyObject.md)
 - [Site](docs/Site.md)
 - [SiteViolation](docs/SiteViolation.md)
 - [ToolDominance](docs/ToolDominance.md)
 - [Violation](docs/Violation.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


