# coding: utf-8

"""
    Attack Analytics API

    Access the Attack Analytics data for your account using the API. For full feature documentation, see [Imperva Attack Analytics](https://docs.imperva.com/bundle/Attack-Analytics/page/Content/attack_analytics/attack_analytics.htm).  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DdosData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'max_bps_passed': 'float',
        'max_bps_blocked': 'float',
        'network_traffic_data_list': 'list[NetworkTrafficData]'
    }

    attribute_map = {
        'max_bps_passed': 'max_BPS_passed',
        'max_bps_blocked': 'max_BPS_blocked',
        'network_traffic_data_list': 'network_traffic_data_list'
    }

    def __init__(self, max_bps_passed=None, max_bps_blocked=None, network_traffic_data_list=None):  # noqa: E501
        """DdosData - a model defined in Swagger"""  # noqa: E501
        self._max_bps_passed = None
        self._max_bps_blocked = None
        self._network_traffic_data_list = None
        self.discriminator = None
        if max_bps_passed is not None:
            self.max_bps_passed = max_bps_passed
        if max_bps_blocked is not None:
            self.max_bps_blocked = max_bps_blocked
        if network_traffic_data_list is not None:
            self.network_traffic_data_list = network_traffic_data_list

    @property
    def max_bps_passed(self):
        """Gets the max_bps_passed of this DdosData.  # noqa: E501

        Peak clean traffic values during the DDoS attack  # noqa: E501

        :return: The max_bps_passed of this DdosData.  # noqa: E501
        :rtype: float
        """
        return self._max_bps_passed

    @max_bps_passed.setter
    def max_bps_passed(self, max_bps_passed):
        """Sets the max_bps_passed of this DdosData.

        Peak clean traffic values during the DDoS attack  # noqa: E501

        :param max_bps_passed: The max_bps_passed of this DdosData.  # noqa: E501
        :type: float
        """

        self._max_bps_passed = max_bps_passed

    @property
    def max_bps_blocked(self):
        """Gets the max_bps_blocked of this DdosData.  # noqa: E501

        Peak blocked traffic values during the DDoS attack-  # noqa: E501

        :return: The max_bps_blocked of this DdosData.  # noqa: E501
        :rtype: float
        """
        return self._max_bps_blocked

    @max_bps_blocked.setter
    def max_bps_blocked(self, max_bps_blocked):
        """Sets the max_bps_blocked of this DdosData.

        Peak blocked traffic values during the DDoS attack-  # noqa: E501

        :param max_bps_blocked: The max_bps_blocked of this DdosData.  # noqa: E501
        :type: float
        """

        self._max_bps_blocked = max_bps_blocked

    @property
    def network_traffic_data_list(self):
        """Gets the network_traffic_data_list of this DdosData.  # noqa: E501

        Peak passed and blocked traffic values by protocol during the DDoS attack (e.g. TCP, UDP, SYN).  # noqa: E501

        :return: The network_traffic_data_list of this DdosData.  # noqa: E501
        :rtype: list[NetworkTrafficData]
        """
        return self._network_traffic_data_list

    @network_traffic_data_list.setter
    def network_traffic_data_list(self, network_traffic_data_list):
        """Sets the network_traffic_data_list of this DdosData.

        Peak passed and blocked traffic values by protocol during the DDoS attack (e.g. TCP, UDP, SYN).  # noqa: E501

        :param network_traffic_data_list: The network_traffic_data_list of this DdosData.  # noqa: E501
        :type: list[NetworkTrafficData]
        """

        self._network_traffic_data_list = network_traffic_data_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DdosData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DdosData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
