# swagger-client
View a log of actions performed in your account by account users, system processes, and Imperva system administrators and support. For full feature documentation, see [Audit Trail](https://docs.imperva.com/bundle/cloud-application-security/page/audit-trail.htm)

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AuditTrailApi(swagger_client.ApiClient(configuration))
start = 789 # int | Earliest time boundary (in milliseconds)
assume = true # bool | Is the action performed by Imperva Support logged in as an account user (optional)
caid = 789 # int | Numeric identifier of the account to operate on. If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
end = 789 # int | Latest time boundary (in milliseconds) (optional)
limit = 56 # int | The number of objects to return in the response. Defaults to 50. Maximum is 100 (optional)
offset = 56 # int | Offset is the position of a particular record in the dataset. You can retrieve a subset of records starting with the offset value. The offset and limit parameters work together. Valid values for the offset parameter are multiples of the limit. For example, if you define limit as 50, you can define offset as either 0, 50, 100, 150, or any multiple of 50. (optional)
type = 'type_example' # str | The action that was performed in the account, such as ACCOUNT_LOGIN (optional)

try:
    # Get account audit events
    api_response = api_instance.get_audit_events_v2(start, assume=assume, caid=caid, end=end, limit=limit, offset=offset, type=type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AuditTrailApi->get_audit_events_v2: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/audit-trail*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuditTrailApi* | [**get_audit_events_v2**](docs/AuditTrailApi.md#get_audit_events_v2) | **GET** /v2/events | Get account audit events
*AuditTrailV1RetiredApi* | [**get_audit_events**](docs/AuditTrailV1RetiredApi.md#get_audit_events) | **GET** /v1/events | Get account audit events

## Documentation For Models

 - [AuditRecord](docs/AuditRecord.md)
 - [AuditRecordResponse](docs/AuditRecordResponse.md)
 - [ErrorResponseWrapper](docs/ErrorResponseWrapper.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


