# coding: utf-8

"""
    Certificate Manager API

    Configure client certificate support for your websites or web applications. <br/>Manage and upload a Certificate Revocation List (CRL) file to verify whether certificates are valid and trustworthy. <br/>For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/more/client-certificate-support.htm\">Client Certificate Support</a>.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ClientCACertificateDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'name': 'str',
        'serial_number': 'str',
        'issuer': 'str',
        'valid_from': 'datetime',
        'valid_to': 'datetime',
        'creation_date': 'str',
        'hash': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'serial_number': 'serialNumber',
        'issuer': 'issuer',
        'valid_from': 'validFrom',
        'valid_to': 'validTo',
        'creation_date': 'creationDate',
        'hash': 'hash'
    }

    def __init__(self, id=None, name=None, serial_number=None, issuer=None, valid_from=None, valid_to=None, creation_date=None, hash=None):  # noqa: E501
        """ClientCACertificateDetails - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._serial_number = None
        self._issuer = None
        self._valid_from = None
        self._valid_to = None
        self._creation_date = None
        self._hash = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if serial_number is not None:
            self.serial_number = serial_number
        if issuer is not None:
            self.issuer = issuer
        if valid_from is not None:
            self.valid_from = valid_from
        if valid_to is not None:
            self.valid_to = valid_to
        if creation_date is not None:
            self.creation_date = creation_date
        if hash is not None:
            self.hash = hash

    @property
    def id(self):
        """Gets the id of this ClientCACertificateDetails.  # noqa: E501


        :return: The id of this ClientCACertificateDetails.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ClientCACertificateDetails.


        :param id: The id of this ClientCACertificateDetails.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ClientCACertificateDetails.  # noqa: E501


        :return: The name of this ClientCACertificateDetails.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ClientCACertificateDetails.


        :param name: The name of this ClientCACertificateDetails.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def serial_number(self):
        """Gets the serial_number of this ClientCACertificateDetails.  # noqa: E501


        :return: The serial_number of this ClientCACertificateDetails.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this ClientCACertificateDetails.


        :param serial_number: The serial_number of this ClientCACertificateDetails.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def issuer(self):
        """Gets the issuer of this ClientCACertificateDetails.  # noqa: E501


        :return: The issuer of this ClientCACertificateDetails.  # noqa: E501
        :rtype: str
        """
        return self._issuer

    @issuer.setter
    def issuer(self, issuer):
        """Sets the issuer of this ClientCACertificateDetails.


        :param issuer: The issuer of this ClientCACertificateDetails.  # noqa: E501
        :type: str
        """

        self._issuer = issuer

    @property
    def valid_from(self):
        """Gets the valid_from of this ClientCACertificateDetails.  # noqa: E501


        :return: The valid_from of this ClientCACertificateDetails.  # noqa: E501
        :rtype: datetime
        """
        return self._valid_from

    @valid_from.setter
    def valid_from(self, valid_from):
        """Sets the valid_from of this ClientCACertificateDetails.


        :param valid_from: The valid_from of this ClientCACertificateDetails.  # noqa: E501
        :type: datetime
        """

        self._valid_from = valid_from

    @property
    def valid_to(self):
        """Gets the valid_to of this ClientCACertificateDetails.  # noqa: E501


        :return: The valid_to of this ClientCACertificateDetails.  # noqa: E501
        :rtype: datetime
        """
        return self._valid_to

    @valid_to.setter
    def valid_to(self, valid_to):
        """Sets the valid_to of this ClientCACertificateDetails.


        :param valid_to: The valid_to of this ClientCACertificateDetails.  # noqa: E501
        :type: datetime
        """

        self._valid_to = valid_to

    @property
    def creation_date(self):
        """Gets the creation_date of this ClientCACertificateDetails.  # noqa: E501


        :return: The creation_date of this ClientCACertificateDetails.  # noqa: E501
        :rtype: str
        """
        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """Sets the creation_date of this ClientCACertificateDetails.


        :param creation_date: The creation_date of this ClientCACertificateDetails.  # noqa: E501
        :type: str
        """

        self._creation_date = creation_date

    @property
    def hash(self):
        """Gets the hash of this ClientCACertificateDetails.  # noqa: E501


        :return: The hash of this ClientCACertificateDetails.  # noqa: E501
        :rtype: str
        """
        return self._hash

    @hash.setter
    def hash(self, hash):
        """Sets the hash of this ClientCACertificateDetails.


        :param hash: The hash of this ClientCACertificateDetails.  # noqa: E501
        :type: str
        """

        self._hash = hash

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClientCACertificateDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClientCACertificateDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
