# swagger-client
View and manage certificates for all websites in your account.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.HSMCertificatesApi(swagger_client.ApiClient(configuration))
pop = 'pop_example' # str | The code of the Imperva data center (PoP) to check latency for.<br/>For the full list of PoPs and codes, see <a href='https://docs.imperva.com/bundle/cloud-application-security/page/more/pops.htm'>Imperva Data Centers</a>.
hsm_host_name = 'hsm_host_name_example' # str | The URI (host name) of the Fortanix region.<br/>Possible values: amer, uk, eu, apac, au in the required format, e.g. api.amer.smartkey.io

try:
    # Get HSM latency
    api_response = api_instance.get_latency(pop, hsm_host_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HSMCertificatesApi->get_latency: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/certificates-ui*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*HSMCertificatesApi* | [**get_latency**](docs/HSMCertificatesApi.md#get_latency) | **GET** /v3/certificates/hsm/latency | Get HSM latency
*SSLCertificatesApi* | [**change_san_validation_method**](docs/SSLCertificatesApi.md#change_san_validation_method) | **PUT** /v3/certificates/{certificateId}/sans/{sanId}/validationMethod | Change SAN validation method
*SSLCertificatesApi* | [**get_certificates1**](docs/SSLCertificatesApi.md#get_certificates1) | **GET** /v3/certificates | Get certificate details
*SSLCertificatesApi* | [**san_instructions_for_account**](docs/SSLCertificatesApi.md#san_instructions_for_account) | **GET** /v3/instructions | Get domain validation instructions
*SSLSettingsApi* | [**add_domain_to_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#add_domain_to_ssl_validation_delegation_settings) | **POST** /v3/account/ssl-settings/delegation/domain/{domain} | Add domain to the SSL validation delegation settings
*SSLSettingsApi* | [**delete_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#delete_ssl_validation_delegation_settings) | **DELETE** /v3/account/ssl-settings | Reset SSL settings to default
*SSLSettingsApi* | [**get_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#get_ssl_validation_delegation_settings) | **GET** /v3/account/ssl-settings | Get account SSL settings
*SSLSettingsApi* | [**patch_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#patch_ssl_validation_delegation_settings) | **PATCH** /v3/account/ssl-settings | Modify SSL settings (partial update)
*SSLSettingsApi* | [**removed_domain_to_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#removed_domain_to_ssl_validation_delegation_settings) | **DELETE** /v3/account/ssl-settings/delegation/domain/{domainId} | Remove domain from the SSL validation delegation settings
*SSLSettingsApi* | [**update_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#update_ssl_validation_delegation_settings) | **POST** /v3/account/ssl-settings | Overwrite SSL settings (full update)
*SSLSettingsApi* | [**verify_domain_to_ssl_validation_delegation_settings**](docs/SSLSettingsApi.md#verify_domain_to_ssl_validation_delegation_settings) | **POST** /v3/account/ssl-settings/delegation/domain/{domainId}/status | Check the configuration status of a domain that appears in the domain delegation list

## Documentation For Models

 - [APIError](docs/APIError.md)
 - [APIErrors](docs/APIErrors.md)
 - [AccountDtoSSLDelegationSettingsDto](docs/AccountDtoSSLDelegationSettingsDto.md)
 - [AccountSSLSettingsResponseDto](docs/AccountSSLSettingsResponseDto.md)
 - [AccountSettingsDto](docs/AccountSettingsDto.md)
 - [AllowDelegationDomainWithInheritanceResponseDto](docs/AllowDelegationDomainWithInheritanceResponseDto.md)
 - [AllowDomainDelegationWithInheritance](docs/AllowDomainDelegationWithInheritance.md)
 - [Certificate](docs/Certificate.md)
 - [CertificateSanDetails](docs/CertificateSanDetails.md)
 - [ChangeValidationMethodDTO](docs/ChangeValidationMethodDTO.md)
 - [ChangeValidationMethodExternalResponse](docs/ChangeValidationMethodExternalResponse.md)
 - [ChangeValidationMethodRequest](docs/ChangeValidationMethodRequest.md)
 - [CustomCertificateDetails](docs/CustomCertificateDetails.md)
 - [HsmLatencyDetailsResponse](docs/HsmLatencyDetailsResponse.md)
 - [HsmLatencyDto](docs/HsmLatencyDto.md)
 - [ImpervaGeneratedCertificateSettingsDto](docs/ImpervaGeneratedCertificateSettingsDto.md)
 - [RelatedSansDetails](docs/RelatedSansDetails.md)
 - [SanInstructionsDto](docs/SanInstructionsDto.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


