# swagger-client
This is the API documentation for Imperva Account Takeover Protection. ATO detects and mitigates account takeover attempts, protecting your web applications against volumetric and low and slow ATO attacks. For the full feature documentation, see https://docs.imperva.com/bundle/account-takeover.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConfigurationApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The Imperva ID of the \"source\" website (the website we copy from)
target_site_id = 789 # int | The Imperva ID of the \"target\" website (the website we want to copy the endpoint config to)
caid = -1 # int | The Imperva account ID. By default, the API operates on account (A) associated with the API credentials used for authentication. To operate on a different account (an account under the account (A)), specify the account ID. (optional) (default to -1)
endpoint_id = 'endpoint_id_example' # str | Optional: pass an endpoint ID to copy, if none passed all endpoints will be copied (optional)

try:
    # Copy a single login endpoint, or all of them, from the \"source\" website to the \"target\" website under the same account ID
    api_instance.copy_endpoint_configuration_from_site_to_another_site(site_id, target_site_id, caid=caid, endpoint_id=endpoint_id)
except ApiException as e:
    print("Exception when calling ConfigurationApi->copy_endpoint_configuration_from_site_to_another_site: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConfigurationApi(swagger_client.ApiClient(configuration))
endpoint_id = 'endpoint_id_example' # str | The endpoint ID to delete
site_id = 789 # int | The Imperva ID of the website
caid = -1 # int | The Imperva account ID. By default, the API operates on account (A) associated with the API credentials used for authentication. To operate on a different account (an account under the account (A)), specify the account ID. (optional) (default to -1)

try:
    # Delete an endpoint for this website
    api_instance.delete_endpoint(endpoint_id, site_id, caid=caid)
except ApiException as e:
    print("Exception when calling ConfigurationApi->delete_endpoint: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConfigurationApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The Imperva ID of the website
caid = -1 # int | The Imperva account ID. By default, the API operates on account (A) associated with the API credentials used for authentication. To operate on a different account (an account under the account (A)), specify the account ID. (optional) (default to -1)

try:
    # Retrieve all the onboarded login endpoints for this website
    api_response = api_instance.get_endpoints(site_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConfigurationApi->get_endpoints: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConfigurationApi(swagger_client.ApiClient(configuration))
caid = -1 # int | The Imperva account ID. By default, the API operates on account (A) associated with the API credentials used for authentication. To operate on a different account (an account under the account (A)), specify the account ID. (optional) (default to -1)

try:
    # Retrieve all onboarded sites with their mitigation status.
    api_response = api_instance.get_onboarded_sites_with_mitigation_status(caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConfigurationApi->get_onboarded_sites_with_mitigation_status: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/ato*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ConfigurationApi* | [**copy_endpoint_configuration_from_site_to_another_site**](docs/ConfigurationApi.md#copy_endpoint_configuration_from_site_to_another_site) | **POST** /v2/sites/{siteId}/onboard/copy-to/{target-site-id} | Copy a single login endpoint, or all of them, from the \&quot;source\&quot; website to the \&quot;target\&quot; website under the same account ID
*ConfigurationApi* | [**delete_endpoint**](docs/ConfigurationApi.md#delete_endpoint) | **DELETE** /v2/sites/{siteId}/endpoint/{endpointId} | Delete an endpoint for this website
*ConfigurationApi* | [**get_endpoints**](docs/ConfigurationApi.md#get_endpoints) | **GET** /v2/sites/{siteId}/endpoints | Retrieve all the onboarded login endpoints for this website
*ConfigurationApi* | [**get_onboarded_sites_with_mitigation_status**](docs/ConfigurationApi.md#get_onboarded_sites_with_mitigation_status) | **GET** /v2/sites | Retrieve all onboarded sites with their mitigation status.
*EvidenceApi* | [**get_aggregators_evidence**](docs/EvidenceApi.md#get_aggregators_evidence) | **POST** /v2/sites/{siteId}/report/evidence/aggregators | Retrieve aggregated login report
*EvidenceApi* | [**get_all_evidence**](docs/EvidenceApi.md#get_all_evidence) | **POST** /v2/sites/{siteId}/report/evidence | Retrieve report of all user logins
*EvidenceApi* | [**get_compromised_evidence**](docs/EvidenceApi.md#get_compromised_evidence) | **POST** /v2/sites/{siteId}/report/evidence/suspicious-successful | Retrieve the compromised users login report
*EvidenceApi* | [**get_leaked_evidence**](docs/EvidenceApi.md#get_leaked_evidence) | **POST** /v2/sites/{siteId}/report/evidence/leaked-creds | Retrieve the leaked users login report
*EvidenceApi* | [**get_likely_leaked_evidence**](docs/EvidenceApi.md#get_likely_leaked_evidence) | **POST** /v2/sites/{siteId}/report/evidence/likely-leaked | Retrieve the likely leaked users login report
*EvidenceApi* | [**get_mitigated_evidence**](docs/EvidenceApi.md#get_mitigated_evidence) | **POST** /v2/sites/{siteId}/report/evidence/mitigated-request | Retrieve the mitigated (CAPTCHA, BLOCK, TARPIT) users login report
*GeneralApi* | [**add_to_allow_list**](docs/GeneralApi.md#add_to_allow_list) | **POST** /v2/sites/{siteId}/allowlist | Update the allowlist for a specific site
*GeneralApi* | [**get_allow_list**](docs/GeneralApi.md#get_allow_list) | **GET** /v2/sites/{siteId}/allowlist | Retrieve the allowlist for a specific site
*GeneralApi* | [**get_leaked_report**](docs/GeneralApi.md#get_leaked_report) | **POST** /v2/sites/{siteId}/report/evidence/leaked | Retrieve the leaked users login report
*GeneralApi* | [**get_mitigated_report**](docs/GeneralApi.md#get_mitigated_report) | **POST** /v2/sites/{siteId}/report/evidence/mitigated | Retrieve the mitigated (CAPTCHA, BLOCK) users login report
*GeneralApi* | [**get_successful_and_suspicious_report**](docs/GeneralApi.md#get_successful_and_suspicious_report) | **POST** /v2/sites/{siteId}/report/evidence/suspicious/successful | Retrieve the compromised users login report
*GeneralApi* | [**remove_from_allow_list**](docs/GeneralApi.md#remove_from_allow_list) | **DELETE** /v2/sites/{siteId}/allowlist | Remove IPs from the allowlist for a specific site
*GeneralApi* | [**reset_risk**](docs/GeneralApi.md#reset_risk) | **POST** /v2/sites/{siteId}/reset-risk | Reset the risk level of IPs for a specific site
*GeneralApi* | [**set_allow_list**](docs/GeneralApi.md#set_allow_list) | **PUT** /v2/sites/{siteId}/allowlist | Overwrite the allowlist for a specific site
*MitigationApi* | [**get_mitigation_config**](docs/MitigationApi.md#get_mitigation_config) | **GET** /v2/sites/{siteId}/mitigation | Get the mitigation configuration for a specific site.
*MitigationApi* | [**set_mitigation_config_for_endpoints**](docs/MitigationApi.md#set_mitigation_config_for_endpoints) | **POST** /v2/sites/{siteId}/mitigation | Change the mitigation configuration for a specific site and endpoint. The actions (low, medium, high) should all be in UPPER CASE.
*PiiPasswordApi* | [**delete_pii_password**](docs/PiiPasswordApi.md#delete_pii_password) | **DELETE** /v2/sites/{siteId}/pii-password | Reset the PII password
*PiiPasswordApi* | [**set_pii_password**](docs/PiiPasswordApi.md#set_pii_password) | **POST** /v2/sites/{siteId}/pii-password | Update the PII password
*StatisticsApi* | [**get_all_stats**](docs/StatisticsApi.md#get_all_stats) | **POST** /v2/sites/{siteId}/stats | Get all stats - top stats and unique users stats.
*TimelineApi* | [**get_logins_timeline**](docs/TimelineApi.md#get_logins_timeline) | **POST** /v2/sites/{siteId}/timeline | Get the login timeline for a site.
*TopSourcesApi* | [**get_all_top_sources_stats**](docs/TopSourcesApi.md#get_all_top_sources_stats) | **POST** /v2/sites/{siteId}/stats/top | Get all the top stats (country, client, reputation, successful user, ip, ip+fingerprint).
*TopSourcesApi* | [**get_top_clients**](docs/TopSourcesApi.md#get_top_clients) | **POST** /v2/sites/{siteId}/stats/top/client | Get top number of requests by client of unique users for the current time period compared to previous time period
*TopSourcesApi* | [**get_top_countries**](docs/TopSourcesApi.md#get_top_countries) | **POST** /v2/sites/{siteId}/stats/top/country | Get top number of requests by country of unique users for the current time period compared to previous time period
*TopSourcesApi* | [**get_top_ips**](docs/TopSourcesApi.md#get_top_ips) | **POST** /v2/sites/{siteId}/stats/top/ip | Get top number of requests by IP of unique users for the current time period compared to previous time period
*TopSourcesApi* | [**get_top_ips_fps**](docs/TopSourcesApi.md#get_top_ips_fps) | **POST** /v2/sites/{siteId}/stats/top/ip-fingerprint | Get top number of requests by IP + Fingerprint of unique users for the current time period compared to previous time period
*TopSourcesApi* | [**get_top_reputation**](docs/TopSourcesApi.md#get_top_reputation) | **POST** /v2/sites/{siteId}/stats/top/reputation | Get top number of requests by reputation of unique users for the current time period compared to previous time period
*UsersApi* | [**get_aggregators_stats**](docs/UsersApi.md#get_aggregators_stats) | **POST** /v2/sites/{siteId}/stats/users/aggregators | Get aggregators successful requests of unique users for the current time period compared to previous time period
*UsersApi* | [**get_all_unique_users_stats**](docs/UsersApi.md#get_all_unique_users_stats) | **POST** /v2/sites/{siteId}/stats/users | Get all the unique users stats (leaked, aggregator, likely-leaked, suspicious-successful).
*UsersApi* | [**get_leaked_stats**](docs/UsersApi.md#get_leaked_stats) | **POST** /v2/sites/{siteId}/stats/users/leaked | Get leaked successful requests of unique users for the current time period compared to previous time period
*UsersApi* | [**get_likely_leaked_credentials_stats**](docs/UsersApi.md#get_likely_leaked_credentials_stats) | **POST** /v2/sites/{siteId}/stats/users/likely-leaked | Get likely leaked successful requests of unique users for the current time period compared to previous time period
*UsersApi* | [**get_suspicious_successful_stats**](docs/UsersApi.md#get_suspicious_successful_stats) | **POST** /v2/sites/{siteId}/stats/users/suspicious-successful | Get suspicious successful requests of unique users for the current time period compared to previous time period

## Documentation For Models

 - [AllStats](docs/AllStats.md)
 - [AllUserStats](docs/AllUserStats.md)
 - [AllowlistIp](docs/AllowlistIp.md)
 - [DeviceStats](docs/DeviceStats.md)
 - [Endpoints](docs/Endpoints.md)
 - [Evaluation](docs/Evaluation.md)
 - [Evidence](docs/Evidence.md)
 - [EvidenceRequest](docs/EvidenceRequest.md)
 - [LikelyLeakedEvidence](docs/LikelyLeakedEvidence.md)
 - [LoginEvent](docs/LoginEvent.md)
 - [LoginsTimeline](docs/LoginsTimeline.md)
 - [MitigationRequest](docs/MitigationRequest.md)
 - [PiiConfigPassword](docs/PiiConfigPassword.md)
 - [ReportRequest](docs/ReportRequest.md)
 - [Request](docs/Request.md)
 - [RequestTimeline](docs/RequestTimeline.md)
 - [SiteStatus](docs/SiteStatus.md)
 - [StatsRequest](docs/StatsRequest.md)
 - [StreamingOutput](docs/StreamingOutput.md)
 - [SuspiciousSuccessfulEvidence](docs/SuspiciousSuccessfulEvidence.md)
 - [TopSource](docs/TopSource.md)
 - [TopStats](docs/TopStats.md)
 - [UsersStats](docs/UsersStats.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


