# coding: utf-8

"""
    Account Takeover Protection API

    This is the API documentation for Imperva Account Takeover Protection. ATO detects and mitigates account takeover attempts, protecting your web applications against volumetric and low and slow ATO attacks. For the full feature documentation, see https://docs.imperva.com/bundle/account-takeover.  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ReportRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'start_time': 'int',
        'limit': 'int',
        'pii_password': 'str',
        'endpoint_id': 'str'
    }

    attribute_map = {
        'start_time': 'startTime',
        'limit': 'limit',
        'pii_password': 'piiPassword',
        'endpoint_id': 'endpointId'
    }

    def __init__(self, start_time=None, limit=None, pii_password=None, endpoint_id=None):  # noqa: E501
        """ReportRequest - a model defined in Swagger"""  # noqa: E501
        self._start_time = None
        self._limit = None
        self._pii_password = None
        self._endpoint_id = None
        self.discriminator = None
        if start_time is not None:
            self.start_time = start_time
        if limit is not None:
            self.limit = limit
        if pii_password is not None:
            self.pii_password = pii_password
        if endpoint_id is not None:
            self.endpoint_id = endpoint_id

    @property
    def start_time(self):
        """Gets the start_time of this ReportRequest.  # noqa: E501

        Specify the timestamp, in UNIX Epoch milliseconds, from which events are retrieved.  # noqa: E501

        :return: The start_time of this ReportRequest.  # noqa: E501
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this ReportRequest.

        Specify the timestamp, in UNIX Epoch milliseconds, from which events are retrieved.  # noqa: E501

        :param start_time: The start_time of this ReportRequest.  # noqa: E501
        :type: int
        """

        self._start_time = start_time

    @property
    def limit(self):
        """Gets the limit of this ReportRequest.  # noqa: E501

        Specify the maximum number of events in the report (maximum 10000, default 10000).  # noqa: E501

        :return: The limit of this ReportRequest.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this ReportRequest.

        Specify the maximum number of events in the report (maximum 10000, default 10000).  # noqa: E501

        :param limit: The limit of this ReportRequest.  # noqa: E501
        :type: int
        """

        self._limit = limit

    @property
    def pii_password(self):
        """Gets the pii_password of this ReportRequest.  # noqa: E501

        Specify the PII password used to encrypt login information. If not specified, the user names will be hashed or encrypted in the response.  # noqa: E501

        :return: The pii_password of this ReportRequest.  # noqa: E501
        :rtype: str
        """
        return self._pii_password

    @pii_password.setter
    def pii_password(self, pii_password):
        """Sets the pii_password of this ReportRequest.

        Specify the PII password used to encrypt login information. If not specified, the user names will be hashed or encrypted in the response.  # noqa: E501

        :param pii_password: The pii_password of this ReportRequest.  # noqa: E501
        :type: str
        """

        self._pii_password = pii_password

    @property
    def endpoint_id(self):
        """Gets the endpoint_id of this ReportRequest.  # noqa: E501

        Optional: Specify the endpoint ID to fetch information for. If no endpoint ID is specified, details of all endpoints defined for the website are returned.  # noqa: E501

        :return: The endpoint_id of this ReportRequest.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_id

    @endpoint_id.setter
    def endpoint_id(self, endpoint_id):
        """Sets the endpoint_id of this ReportRequest.

        Optional: Specify the endpoint ID to fetch information for. If no endpoint ID is specified, details of all endpoints defined for the website are returned.  # noqa: E501

        :param endpoint_id: The endpoint_id of this ReportRequest.  # noqa: E501
        :type: str
        """

        self._endpoint_id = endpoint_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ReportRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReportRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
