# coding: utf-8

"""
    Account Takeover Protection API

    This is the API documentation for Imperva Account Takeover Protection. ATO detects and mitigates account takeover attempts, protecting your web applications against volumetric and low and slow ATO attacks. For the full feature documentation, see https://docs.imperva.com/bundle/account-takeover.  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class StatsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'start_time': 'int',
        'end_time': 'int',
        'range_hours': 'int'
    }

    attribute_map = {
        'start_time': 'startTime',
        'end_time': 'endTime',
        'range_hours': 'rangeHours'
    }

    def __init__(self, start_time=None, end_time=None, range_hours=None):  # noqa: E501
        """StatsRequest - a model defined in Swagger"""  # noqa: E501
        self._start_time = None
        self._end_time = None
        self._range_hours = None
        self.discriminator = None
        if start_time is not None:
            self.start_time = start_time
        if end_time is not None:
            self.end_time = end_time
        if range_hours is not None:
            self.range_hours = range_hours

    @property
    def start_time(self):
        """Gets the start_time of this StatsRequest.  # noqa: E501

        Specify the timestamp, in UNIX Epoch milliseconds, from which events are retrieved.  # noqa: E501

        :return: The start_time of this StatsRequest.  # noqa: E501
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this StatsRequest.

        Specify the timestamp, in UNIX Epoch milliseconds, from which events are retrieved.  # noqa: E501

        :param start_time: The start_time of this StatsRequest.  # noqa: E501
        :type: int
        """

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this StatsRequest.  # noqa: E501

        Specify the timestamp, in UNIX Epoch milliseconds, to which events are retrieved.  # noqa: E501

        :return: The end_time of this StatsRequest.  # noqa: E501
        :rtype: int
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this StatsRequest.

        Specify the timestamp, in UNIX Epoch milliseconds, to which events are retrieved.  # noqa: E501

        :param end_time: The end_time of this StatsRequest.  # noqa: E501
        :type: int
        """

        self._end_time = end_time

    @property
    def range_hours(self):
        """Gets the range_hours of this StatsRequest.  # noqa: E501

        Specify the range, in hours, for which events are retrieved. If specified, range will be used. If not specified, startTime and endTime will be used instead.  # noqa: E501

        :return: The range_hours of this StatsRequest.  # noqa: E501
        :rtype: int
        """
        return self._range_hours

    @range_hours.setter
    def range_hours(self, range_hours):
        """Sets the range_hours of this StatsRequest.

        Specify the range, in hours, for which events are retrieved. If specified, range will be used. If not specified, startTime and endTime will be used instead.  # noqa: E501

        :param range_hours: The range_hours of this StatsRequest.  # noqa: E501
        :type: int
        """

        self._range_hours = range_hours

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StatsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StatsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
