# swagger-client
Imperva provides customers and partners with the ability to manage accounts and sites via an API. For more information, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/csh?context=my_api\">Cloud Application Security API Reference</a>.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
email = 'email_example' # str | Email address. For example: \"joe@example.com\".
parent_id = 789 # int | The newly created account's parent id. If not specified, the invoking account will be assigned as the parent. (optional)
name = 'name_example' # str | The account owner's name. For example: \"John Doe\". (optional)
plan_id = 'plan_id_example' # str | An identifier of the plan to assign to the new account. For example, ent100 for the Enterprise 100 plan.<br/>Example values:<br/>ent100 | ent50 | ent20 (optional)
ref_id = 'ref_id_example' # str | Customer specific identifier for this operation. (optional)
account_name = 'account_name_example' # str | Account name. (optional)
account_description = 'account_description_example' # str | The account description (optional)
user_name = 'user_name_example' # str | The account owner's name. For example: \"John Doe\". (optional)
log_level = 'log_level_example' # str | Sets the log reporting level for the site.<br/>Possible values: full | security | none | default<br/>Default value is <b>none</b><br/>Available only for customers that purchased the Logs Integration SKU. (optional)
logs_account_id = 'logs_account_id_example' # str | Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. Available only for customers that purchased the Logs Integration SKU. (optional)

try:
    # Add a new managed account
    api_response = api_instance.add_account(email, parent_id=parent_id, name=name, plan_id=plan_id, ref_id=ref_id, account_name=account_name, account_description=account_description, user_name=user_name, log_level=log_level, logs_account_id=logs_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->add_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
sub_account_name = 'sub_account_name_example' # str | The name of the sub account.
parent_id = 789 # int | The newly created account's parent id. If not specified, the invoking account will be assigned as the parent account. (optional)
ref_id = 'ref_id_example' # str | Customer specific identifier for this operation. (optional)
log_level = 'log_level_example' # str | Sets the log reporting level for the site.<br/>Possible values: full, security, none, default<br/>Available only for customers that purchased the Logs Integration SKU. (optional)
logs_account_id = 'logs_account_id_example' # str | Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.<br/>If not specified, operation will be performed on the account identified by the authentication parameters.<br/>Available only for customers that purchased the Logs Integration SKU. (optional)

try:
    # Add a new sub account
    api_response = api_instance.add_sub_account(sub_account_name, parent_id=parent_id, ref_id=ref_id, log_level=log_level, logs_account_id=logs_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->add_sub_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.

try:
    # Delete managed account
    api_response = api_instance.delete_account(account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->delete_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
sub_account_id = 789 # int | Numeric identifier of the sub account to operate on.

try:
    # Delete sub account
    api_response = api_instance.delete_sub_account(sub_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->delete_sub_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)

try:
    # Get account status
    api_response = api_instance.get_account_status(account_id=account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->get_account_status: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)

try:
    # Get default data storage region
    api_response = api_instance.get_default_region(account_id=account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->get_default_region: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
partner_id = 'partner_id_example' # str | Numeric identifier of the parent id to operate on (optional)

try:
    # Get account login token
    api_response = api_instance.get_token(account_id=account_id, partner_id=partner_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->get_token: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
page_size = 'page_size_example' # str | The number of objects to return in the response.<br/>Default: 50<br/>Maximum: 100 (optional)
page_num = 'page_num_example' # str | The page to return starting from 0. Default: '0 (optional)

try:
    # List managed accounts
    api_response = api_instance.list_accounts(account_id=account_id, page_size=page_size, page_num=page_num)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->list_accounts: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
page_size = 'page_size_example' # str | The number of objects to return in the response.<br/>Default: 50<br/>Maximum: 100 (optional)
page_num = 'page_num_example' # str | The page to return starting from 0. Default: 0 (optional)

try:
    # List account's sub accounts
    api_response = api_instance.list_sub_accounts(account_id=account_id, page_size=page_size, page_num=page_num)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->list_sub_accounts: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
param = 'param_example' # str | Name of configuration parameter to set.<br/>Possible values for param and value parameters:<br/><ul><li><b>name</b> the updated name.</li><li><b>email</b> the updated e-mail address</li><li><b>plan_id</b> a plan id</li><li><b>error_page_template</b> a Base64 encoded template for an error page.</li><li><b>support_all_tls_versions</b> Use this operation to allow sites in the account to support all TLS versions for connectivity between clients (visitors) and the Imperva service. When this option is set, you can then enable the option per site to support all TLS versions. Possible values: true, false. Note: To remain PCI-compliant, do not enable this option.</li><li><b>naked_domain_san_for_new_www_sites</b> Use this option to determine if the naked domain SAN will be added to the SSL certificate for new www sites. Default value: true.</li><li><b>wildcard_san_for_new_sites</b> Use this option to determine if the wildcard SAN or the full domain SAN is added to the Imperva SSL certificate for new sites. Possible values: true, false, default (determined by plan) Default value: default.</li><li><b>ref_id</b> Sets the Reference ID, a free-text field that enables you to add a unique identifier to correlate an object in our service, such as a protected website, with an object on the customer side.</li><li><b>enable_http2_for_new_sites</b> Use this option to enable HTTP/2 for newly created SSL sites.</li><li><b>enable_http2_to_origin_for_new_sites</b> Use this option to enable HTTP/2 to Origin for newly created SSL sites. This option can only be enabled once HTTP/2 is enabled for newly created sites.</li><li><b>consent_required</b> Blocks Imperva from performing sensitive operations on your behalf. You can then activate consent via the Cloud Security Console UI. Possible values: true, false..</li></ul>
value = 'value_example' # str | According to the configuration paramater used.
body = 'body_example' # str |  (optional)

try:
    # Modify account configuration
    api_response = api_instance.modify_account_configuration(param, value, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->modify_account_configuration: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
log_level = 'log_level_example' # str | Sets the log reporting level for the site.<br/> Possible values: full | security | none | default<br/>Available only for customers that purchased the Log Integration SKU.
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)

try:
    # Modify account log level
    api_response = api_instance.modify_account_log_level(log_level, account_id=account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->modify_account_log_level: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
data_storage_region = 'data_storage_region_example' # str | The data region to use.<br/>Possible values: US | EU | APAC | AU (optional)

try:
    # Set default data storage region
    api_response = api_instance.set_default_region(account_id=account_id, data_storage_region=data_storage_region)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->set_default_region: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on

try:
    # Set Imperva servers for log storage
    api_response = api_instance.set_default_siem_storage(account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->set_default_siem_storage: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on
bucket_name = 'bucket_name_example' # str | S3 bucket name
access_key = 'access_key_example' # str | S3 access key
secret_key = 'secret_key_example' # str | S3 secret key

try:
    # Set S3 configuration for log storage
    api_response = api_instance.set_storage_to_s3(account_id, bucket_name, access_key, secret_key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->set_storage_to_s3: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on
host = 'host_example' # str | The IP address of your SFTP server
user_name = 'user_name_example' # str | A user name that will be used to log in to the SFTP server
password = 'password_example' # str | A corresponding password for the user account used to log in to the SFTP server
destination_folder = 'destination_folder_example' # str | The path to the directory on the SFTP server

try:
    # Set SFTP server configuration for log storage
    api_response = api_instance.set_storage_to_sftp(account_id, host, user_name, password, destination_folder)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->set_storage_to_sftp: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 789 # int | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)

try:
    # Get account subscription details
    api_response = api_instance.subscription(account_id=account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->subscription: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on
bucket_name = 'bucket_name_example' # str | S3 bucket name
access_key = 'access_key_example' # str | S3 access key
secret_key = 'secret_key_example' # str | S3 secret key
save_on_success = true # bool | Save this configuration if the test connection was successful. Default value:false (optional)

try:
    # Test connection with S3 bucket
    api_response = api_instance.test_connection_s3(account_id, bucket_name, access_key, secret_key, save_on_success=save_on_success)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->test_connection_s3: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AccountManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.
host = 'host_example' # str | The IP address of your SFTP server
user_name = 'user_name_example' # str | A user name that will be used to log in to the SFTP server
password = 'password_example' # str | A corresponding password for the user account used to log in to the SFTP server
destination_folder = 'destination_folder_example' # str | The path to the directory on the SFTP server
save_on_success = true # bool | Save this configuration if the test connection was successful. Default value: false (optional)

try:
    # Test connection with SFTP server
    api_response = api_instance.test_connection_sftp(account_id, host, user_name, password, destination_folder, save_on_success=save_on_success)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AccountManagementApi->test_connection_sftp: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://my.imperva.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountManagementApi* | [**add_account**](docs/AccountManagementApi.md#add_account) | **POST** /api/prov/v1/accounts/add | Add a new managed account
*AccountManagementApi* | [**add_sub_account**](docs/AccountManagementApi.md#add_sub_account) | **POST** /api/prov/v1/subaccounts/add | Add a new sub account
*AccountManagementApi* | [**delete_account**](docs/AccountManagementApi.md#delete_account) | **POST** /api/prov/v1/accounts/delete | Delete managed account
*AccountManagementApi* | [**delete_sub_account**](docs/AccountManagementApi.md#delete_sub_account) | **POST** /api/prov/v1/subaccounts/delete | Delete sub account
*AccountManagementApi* | [**get_account_status**](docs/AccountManagementApi.md#get_account_status) | **POST** /api/prov/v1/account | Get account status
*AccountManagementApi* | [**get_default_region**](docs/AccountManagementApi.md#get_default_region) | **POST** /api/prov/v1/accounts/data-privacy/show | Get default data storage region
*AccountManagementApi* | [**get_token**](docs/AccountManagementApi.md#get_token) | **POST** /api/prov/v1/accounts/gettoken | Get account login token
*AccountManagementApi* | [**list_accounts**](docs/AccountManagementApi.md#list_accounts) | **POST** /api/prov/v1/accounts/list | List managed accounts
*AccountManagementApi* | [**list_sub_accounts**](docs/AccountManagementApi.md#list_sub_accounts) | **POST** /api/prov/v1/accounts/listSubAccounts | List account&#x27;s sub accounts
*AccountManagementApi* | [**modify_account_configuration**](docs/AccountManagementApi.md#modify_account_configuration) | **POST** /api/prov/v1/accounts/configure | Modify account configuration
*AccountManagementApi* | [**modify_account_log_level**](docs/AccountManagementApi.md#modify_account_log_level) | **POST** /api/prov/v1/accounts/setlog | Modify account log level
*AccountManagementApi* | [**set_default_region**](docs/AccountManagementApi.md#set_default_region) | **POST** /api/prov/v1/accounts/data-privacy/set-region-default | Set default data storage region
*AccountManagementApi* | [**set_default_siem_storage**](docs/AccountManagementApi.md#set_default_siem_storage) | **POST** /api/prov/v1/accounts/setDefaultSiemStorage | Set Imperva servers for log storage
*AccountManagementApi* | [**set_storage_to_s3**](docs/AccountManagementApi.md#set_storage_to_s3) | **POST** /api/prov/v1/accounts/setAmazonSiemStorage | Set S3 configuration for log storage
*AccountManagementApi* | [**set_storage_to_sftp**](docs/AccountManagementApi.md#set_storage_to_sftp) | **POST** /api/prov/v1/accounts/setSftpSiemStorage | Set SFTP server configuration for log storage
*AccountManagementApi* | [**subscription**](docs/AccountManagementApi.md#subscription) | **POST** /api/prov/v1/accounts/subscription | Get account subscription details
*AccountManagementApi* | [**test_connection_s3**](docs/AccountManagementApi.md#test_connection_s3) | **POST** /api/prov/v1/accounts/testS3Connection | Test connection with S3 bucket
*AccountManagementApi* | [**test_connection_sftp**](docs/AccountManagementApi.md#test_connection_sftp) | **POST** /api/prov/v1/accounts/testSftpConnection | Test connection with SFTP server
*DDoSProtectionForIndividualIPsApi* | [**add_sip_by_cname**](docs/DDoSProtectionForIndividualIPsApi.md#add_sip_by_cname) | **POST** /api/prov/v1/ddos-protection/edge-ip/add/cname | Protected IP over TCP - add by origin IP
*DDoSProtectionForIndividualIPsApi* | [**add_sip_by_dns_and_cname**](docs/DDoSProtectionForIndividualIPsApi.md#add_sip_by_dns_and_cname) | **POST** /api/prov/v1/ddos-protection/edge-ip/add/dns-with-cname | Protected IP over TCP - add by DNS and CNAME
*DDoSProtectionForIndividualIPsApi* | [**add_sip_by_dns_and_ip**](docs/DDoSProtectionForIndividualIPsApi.md#add_sip_by_dns_and_ip) | **POST** /api/prov/v1/ddos-protection/edge-ip/add/dns-with-ip | Protected IP over TCP - add by DNS and origin IP
*DDoSProtectionForIndividualIPsApi* | [**add_sip_by_ip**](docs/DDoSProtectionForIndividualIPsApi.md#add_sip_by_ip) | **POST** /api/prov/v1/ddos-protection/edge-ip/add/ip | Protected IP over TCP - add by CNAME
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_by_cname**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_by_cname) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/cname | Protected IP over TCP - edit by CNAME
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_by_dns_and_cname**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_by_dns_and_cname) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/dns-with-cname | Protected IP over TCP - edit by DNS and origin IP
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_by_dns_and_ip**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_by_dns_and_ip) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/dns-with-ip | Protected IP over TCP - edit by DNS and origin IP
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_by_ip**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_by_ip) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/ip | Protected IP over TCP - edit by origin IP
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_ha_protocol**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_ha_protocol) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/ha-protocol | Protected IP over TCP - edit HA protocol setting
*DDoSProtectionForIndividualIPsApi* | [**edit_sip_monitoring_settings**](docs/DDoSProtectionForIndividualIPsApi.md#edit_sip_monitoring_settings) | **POST** /api/prov/v1/ddos-protection/edge-ip/edit/monitoring-settings | Protected IP over TCP - edit monitoring settings
*DDoSProtectionForIndividualIPsApi* | [**remove_sip**](docs/DDoSProtectionForIndividualIPsApi.md#remove_sip) | **POST** /api/prov/v1/ddos-protection/edge-ip/remove | Protected IP over TCP - remove
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_ddos_start**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_ddos_start) | **POST** /api/v1/infra-protect/test-alerts/ddos/start | DDoS start
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_ddos_stop**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_ddos_stop) | **POST** /api/v1/infra-protect/test-alerts/ddos/stop | DDoS stop
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_monitoring_attack_start_critical_alert**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_monitoring_attack_start_critical_alert) | **POST** /api/v1/infra-protect/test-alerts/monitoring/attack-start | Monitoring attack start
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_net_flow_bad_data**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_net_flow_bad_data) | **POST** /api/v1/infra-protect/test-alerts/monitoring/bad-data | Monitoring bad data
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_net_flow_start**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_net_flow_start) | **POST** /api/v1/infra-protect/test-alerts/monitoring/start | Monitoring start
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_net_flow_stop**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_net_flow_stop) | **POST** /api/v1/infra-protect/test-alerts/monitoring/stop | Monitoring stop
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_tunnel_down**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_tunnel_down) | **POST** /api/v1/infra-protect/test-alerts/connection/down | Connection down
*DDoSForNetworksTestAlertsApi* | [**post_infra_protect_tunnel_up**](docs/DDoSForNetworksTestAlertsApi.md#post_infra_protect_tunnel_up) | **POST** /api/v1/infra-protect/test-alerts/connection/up | Connection up
*DDoSForNetworksTestAlertsApi* | [**post_protected_ip_status_down**](docs/DDoSForNetworksTestAlertsApi.md#post_protected_ip_status_down) | **POST** /api/v1/infra-protect/test-alerts/ip-protection-status/down | IP protection status down
*DDoSForNetworksTestAlertsApi* | [**post_protected_ip_status_up**](docs/DDoSForNetworksTestAlertsApi.md#post_protected_ip_status_up) | **POST** /api/v1/infra-protect/test-alerts/ip-protection-status/up | IP protection status up
*IntegrationsApi* | [**get_clapps_info**](docs/IntegrationsApi.md#get_clapps_info) | **POST** /api/integration/v1/clapps | Get client applications info
*IntegrationsApi* | [**get_geo_info**](docs/IntegrationsApi.md#get_geo_info) | **POST** /api/integration/v1/geo | Get geographical info
*IntegrationsApi* | [**get_ip_ranges**](docs/IntegrationsApi.md#get_ip_ranges) | **POST** /api/integration/v1/ips | Get Imperva IP ranges
*IntegrationsApi* | [**get_texts**](docs/IntegrationsApi.md#get_texts) | **POST** /api/integration/v1/texts | Get texts
*LoginProtectApi* | [**add_lp_user**](docs/LoginProtectApi.md#add_lp_user) | **POST** /api/prov/v1/sites/lp/add-user | Add login protect user
*LoginProtectApi* | [**configure_protected_app_by_lp**](docs/LoginProtectApi.md#configure_protected_app_by_lp) | **POST** /api/prov/v1/sites/lp/configure-app | Configure login protect on admin areas
*LoginProtectApi* | [**edit_lp_user**](docs/LoginProtectApi.md#edit_lp_user) | **POST** /api/prov/v1/sites/lp/edit-user | Edit login protect user
*LoginProtectApi* | [**get_lp_users**](docs/LoginProtectApi.md#get_lp_users) | **POST** /api/prov/v1/sites/lp/users | Get login protect users
*LoginProtectApi* | [**modify_lp_site_configuration**](docs/LoginProtectApi.md#modify_lp_site_configuration) | **POST** /api/prov/v1/sites/lp/configure | Modify Site Login Protect Configuration
*LoginProtectApi* | [**remove_lp_user**](docs/LoginProtectApi.md#remove_lp_user) | **POST** /api/prov/v1/sites/lp/remove | Remove login protect user
*LoginProtectApi* | [**send_sms**](docs/LoginProtectApi.md#send_sms) | **POST** /api/prov/v1/sites/lp/send-sms | Send SMS to user
*SiteManagementApi* | [**add_cache_rule**](docs/SiteManagementApi.md#add_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/add | Add a cache rule
*SiteManagementApi* | [**add_custom_rule**](docs/SiteManagementApi.md#add_custom_rule) | **POST** /api/prov/v1/sites/incapRules/add | Add rule
*SiteManagementApi* | [**add_data_center**](docs/SiteManagementApi.md#add_data_center) | **POST** /api/prov/v1/sites/dataCenters/add | Add data center
*SiteManagementApi* | [**add_dc_server**](docs/SiteManagementApi.md#add_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/add | Add server
*SiteManagementApi* | [**add_site**](docs/SiteManagementApi.md#add_site) | **POST** /api/prov/v1/sites/add | Add a site
*SiteManagementApi* | [**check_caa_compliance**](docs/SiteManagementApi.md#check_caa_compliance) | **POST** /api/prov/v1/caa/check-compliance | Check CAA compliance
*SiteManagementApi* | [**create_new_csr**](docs/SiteManagementApi.md#create_new_csr) | **POST** /api/prov/v1/sites/customCertificate/csr | Create new CSR
*SiteManagementApi* | [**delete_cache_rule**](docs/SiteManagementApi.md#delete_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/delete | Delete a cache rule
*SiteManagementApi* | [**delete_custom_rule**](docs/SiteManagementApi.md#delete_custom_rule) | **POST** /api/prov/v1/sites/incapRules/delete | Delete rule
*SiteManagementApi* | [**delete_data_center**](docs/SiteManagementApi.md#delete_data_center) | **POST** /api/prov/v1/sites/dataCenters/delete | Delete data center
*SiteManagementApi* | [**delete_dc_server**](docs/SiteManagementApi.md#delete_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/delete | Delete server
*SiteManagementApi* | [**delete_site**](docs/SiteManagementApi.md#delete_site) | **POST** /api/prov/v1/sites/delete | Delete site
*SiteManagementApi* | [**domain_emails**](docs/SiteManagementApi.md#domain_emails) | **POST** /api/prov/v1/domain/emails | Get domain approver e-mail addresses
*SiteManagementApi* | [**edit_bots_configuration**](docs/SiteManagementApi.md#edit_bots_configuration) | **POST** /api/prov/v3/sites/{extSiteId}/settings/botConfiguration | Update website bot configuration
*SiteManagementApi* | [**edit_cache_rule**](docs/SiteManagementApi.md#edit_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/edit | Edit a cache rule
*SiteManagementApi* | [**edit_custom_rule**](docs/SiteManagementApi.md#edit_custom_rule) | **POST** /api/prov/v1/sites/incapRules/edit | Edit rule
*SiteManagementApi* | [**edit_data_center**](docs/SiteManagementApi.md#edit_data_center) | **POST** /api/prov/v1/sites/dataCenters/edit | Edit data center
*SiteManagementApi* | [**edit_dc_server**](docs/SiteManagementApi.md#edit_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/edit | Edit server
*SiteManagementApi* | [**enable_cache_shield**](docs/SiteManagementApi.md#enable_cache_shield) | **POST** /api/prov/v1/sites/performance/cache-shield/enable | Enable cache shield
*SiteManagementApi* | [**enable_disable_cache_rule**](docs/SiteManagementApi.md#enable_disable_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/enable | Enable or disable cache rule
*SiteManagementApi* | [**enable_disable_custom_rule**](docs/SiteManagementApi.md#enable_disable_custom_rule) | **POST** /api/prov/v1/sites/incapRules/enableDisable | Enable or disable rule
*SiteManagementApi* | [**get_advanced_caching_settings**](docs/SiteManagementApi.md#get_advanced_caching_settings) | **POST** /api/prov/v1/sites/performance/advanced/get | Get advanced caching settings
*SiteManagementApi* | [**get_bots_configuration**](docs/SiteManagementApi.md#get_bots_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/settings/botConfiguration | Get website bot configuration
*SiteManagementApi* | [**get_cache404_settings**](docs/SiteManagementApi.md#get_cache404_settings) | **POST** /api/prov/v1/sites/performance/cache404 | Get cache 404 settings
*SiteManagementApi* | [**get_caching_mode**](docs/SiteManagementApi.md#get_caching_mode) | **POST** /api/prov/v1/sites/performance/cache-mode/get | Get caching mode
*SiteManagementApi* | [**get_data_region**](docs/SiteManagementApi.md#get_data_region) | **POST** /api/prov/v1/sites/data-privacy/show | Get site data storage region
*SiteManagementApi* | [**get_html_injection_rules**](docs/SiteManagementApi.md#get_html_injection_rules) | **POST** /api/prov/v1/sites/htmlinjections | Get HTML injection rules
*SiteManagementApi* | [**get_override_site_regions_by_geo**](docs/SiteManagementApi.md#get_override_site_regions_by_geo) | **POST** /api/prov/v1/sites/data-privacy/show-override-by-geo | Check site regions by origin geolocation
*SiteManagementApi* | [**get_recommended_data_center_origin_po_ps**](docs/SiteManagementApi.md#get_recommended_data_center_origin_po_ps) | **POST** /api/prov/v1/sites/datacenter/origin-pop/recommend | Get data center recommended origin PoPs
*SiteManagementApi* | [**get_response_header_settings**](docs/SiteManagementApi.md#get_response_header_settings) | **POST** /api/prov/v1/sites/performance/response-headers/get | Get cached response headers
*SiteManagementApi* | [**get_rewrite_ports**](docs/SiteManagementApi.md#get_rewrite_ports) | **POST** /api/prov/v1/sites/performance/rewrite-port | Get rewrite port
*SiteManagementApi* | [**get_secure_resources_mode**](docs/SiteManagementApi.md#get_secure_resources_mode) | **POST** /api/prov/v1/sites/performance/secure-resources/get | Get secure resources mode
*SiteManagementApi* | [**get_site_error_page_template**](docs/SiteManagementApi.md#get_site_error_page_template) | **POST** /api/prov/v1/sites/performance/error-page | Get error page
*SiteManagementApi* | [**get_site_report**](docs/SiteManagementApi.md#get_site_report) | **POST** /api/prov/v1/sites/report | Get site report
*SiteManagementApi* | [**get_stale_content**](docs/SiteManagementApi.md#get_stale_content) | **POST** /api/prov/v1/sites/performance/stale-content/get | Get stale content settings
*SiteManagementApi* | [**get_tag_response_header**](docs/SiteManagementApi.md#get_tag_response_header) | **POST** /api/prov/v1/sites/performance/tag-response/get | Get header to tag responses by
*SiteManagementApi* | [**get_tls_configuration**](docs/SiteManagementApi.md#get_tls_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/settings/TLSConfiguration | Get website TLS configuration
*SiteManagementApi* | [**get_xray_link**](docs/SiteManagementApi.md#get_xray_link) | **POST** /api/prov/v1/sites/xray/get-link | Get XRay access link
*SiteManagementApi* | [**is_cache_shield_enabled**](docs/SiteManagementApi.md#is_cache_shield_enabled) | **POST** /api/prov/v1/sites/performance/cache-shield | Is cache shield enabled
*SiteManagementApi* | [**list_account_custom_rules**](docs/SiteManagementApi.md#list_account_custom_rules) | **POST** /api/prov/v1/sites/incapRules/account/list | List account rules
*SiteManagementApi* | [**list_cache_rules**](docs/SiteManagementApi.md#list_cache_rules) | **POST** /api/prov/v1/sites/performance/caching-rules/list | List cache rules for a given site
*SiteManagementApi* | [**list_custom_rules**](docs/SiteManagementApi.md#list_custom_rules) | **POST** /api/prov/v1/sites/incapRules/list | List rules
*SiteManagementApi* | [**list_data_centers**](docs/SiteManagementApi.md#list_data_centers) | **POST** /api/prov/v1/sites/dataCenters/list | List data centers
*SiteManagementApi* | [**list_data_centers_configuration**](docs/SiteManagementApi.md#list_data_centers_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/data-centers-configuration | get site&#x27;s data centers&#x27; configuration
*SiteManagementApi* | [**list_sites**](docs/SiteManagementApi.md#list_sites) | **POST** /api/prov/v1/sites/list | List sites
*SiteManagementApi* | [**modify_advanced_caching_settings**](docs/SiteManagementApi.md#modify_advanced_caching_settings) | **POST** /api/prov/v1/sites/performance/advanced | Advanced caching settings
*SiteManagementApi* | [**modify_cache404_settings**](docs/SiteManagementApi.md#modify_cache404_settings) | **POST** /api/prov/v1/sites/performance/cache404/modify | Modify cache 404 settings
*SiteManagementApi* | [**modify_purge_settings**](docs/SiteManagementApi.md#modify_purge_settings) | **POST** /api/prov/v1/sites/performance/purge | Purge resources
*SiteManagementApi* | [**modify_response_header_settings**](docs/SiteManagementApi.md#modify_response_header_settings) | **POST** /api/prov/v1/sites/performance/response-headers | Modify cached response headers
*SiteManagementApi* | [**modify_rewrite_ports**](docs/SiteManagementApi.md#modify_rewrite_ports) | **POST** /api/prov/v1/sites/performance/rewrite-port/modify | Modify rewrite port
*SiteManagementApi* | [**modify_site_configuration**](docs/SiteManagementApi.md#modify_site_configuration) | **POST** /api/prov/v1/sites/configure | Modify site configuration
*SiteManagementApi* | [**modify_site_error_page_template**](docs/SiteManagementApi.md#modify_site_error_page_template) | **POST** /api/prov/v1/sites/performance/error-page/modify | Modify error page
*SiteManagementApi* | [**modify_site_log_level**](docs/SiteManagementApi.md#modify_site_log_level) | **POST** /api/prov/v1/sites/setlog | Modify site logs level
*SiteManagementApi* | [**modify_site_security_configuration**](docs/SiteManagementApi.md#modify_site_security_configuration) | **POST** /api/prov/v1/sites/configure/security | Modify site security configuration
*SiteManagementApi* | [**modify_site_support_deprecated_tls**](docs/SiteManagementApi.md#modify_site_support_deprecated_tls) | **POST** /api/prov/v1/sites/tls | Set support for all TLS versions
*SiteManagementApi* | [**modify_stale_content**](docs/SiteManagementApi.md#modify_stale_content) | **POST** /api/prov/v1/sites/performance/stale-content | Modify stale content settings
*SiteManagementApi* | [**modify_tag_response_header**](docs/SiteManagementApi.md#modify_tag_response_header) | **POST** /api/prov/v1/sites/performance/tag-response | Tag the response according to the value of a header
*SiteManagementApi* | [**move_site**](docs/SiteManagementApi.md#move_site) | **POST** /api/prov/v1/sites/moveSite | Move site
*SiteManagementApi* | [**purge_hostname**](docs/SiteManagementApi.md#purge_hostname) | **POST** /api/prov/v1/sites/hostname/purge | Purge hostname from cache
*SiteManagementApi* | [**purge_site_cache**](docs/SiteManagementApi.md#purge_site_cache) | **POST** /api/prov/v1/sites/cache/purge | Purge site cache
*SiteManagementApi* | [**put_data_centers_configuration**](docs/SiteManagementApi.md#put_data_centers_configuration) | **PUT** /api/prov/v3/sites/{extSiteId}/data-centers-configuration | set site&#x27;s data centers&#x27; configuration
*SiteManagementApi* | [**remove_custom_certificate**](docs/SiteManagementApi.md#remove_custom_certificate) | **POST** /api/prov/v1/sites/customCertificate/remove | Remove custom certificate
*SiteManagementApi* | [**resume_traffic_to_active_dcs**](docs/SiteManagementApi.md#resume_traffic_to_active_dcs) | **POST** /api/prov/v1/sites/dataCenters/resume | Resume traffic to your active data centers
*SiteManagementApi* | [**set_caching_mode**](docs/SiteManagementApi.md#set_caching_mode) | **POST** /api/prov/v1/sites/performance/cache-mode | Modify caching mode
*SiteManagementApi* | [**set_data_center_origin_po_p**](docs/SiteManagementApi.md#set_data_center_origin_po_p) | **POST** /api/prov/v1/sites/datacenter/origin-pop/modify | Set data center origin PoP
*SiteManagementApi* | [**set_data_region**](docs/SiteManagementApi.md#set_data_region) | **POST** /api/prov/v1/sites/data-privacy/region-change | Set site data storage region
*SiteManagementApi* | [**set_html_injection_rule**](docs/SiteManagementApi.md#set_html_injection_rule) | **POST** /api/prov/v1/sites/configure/htmlInjections | Add, replace or remove a HTML injection rule
*SiteManagementApi* | [**set_override_site_regions_by_geo**](docs/SiteManagementApi.md#set_override_site_regions_by_geo) | **POST** /api/prov/v1/sites/data-privacy/override-by-geo | Set site regions by origin geolocation
*SiteManagementApi* | [**set_priority**](docs/SiteManagementApi.md#set_priority) | **POST** /api/prov/v1/sites/incapRules/priority/set | Set rule priority
*SiteManagementApi* | [**set_secure_resources_mode**](docs/SiteManagementApi.md#set_secure_resources_mode) | **POST** /api/prov/v1/sites/performance/secure-resources | Modify secure resources mode
*SiteManagementApi* | [**site_status**](docs/SiteManagementApi.md#site_status) | **POST** /api/prov/v1/sites/status | Get site status
*SiteManagementApi* | [**update_tls_configuration**](docs/SiteManagementApi.md#update_tls_configuration) | **POST** /api/prov/v3/sites/{extSiteId}/settings/TLSConfiguration | Update website TLS configuration
*SiteManagementApi* | [**upload_custom_certificate**](docs/SiteManagementApi.md#upload_custom_certificate) | **POST** /api/prov/v1/sites/customCertificate/upload | Upload custom certificate
*TrafficStatisticsAndLogsApi* | [**change_logs_collectors_config_status**](docs/TrafficStatisticsAndLogsApi.md#change_logs_collectors_config_status) | **POST** /api/logscollector/change/status | Change logs collector configuration status
*TrafficStatisticsAndLogsApi* | [**get_infra_events**](docs/TrafficStatisticsAndLogsApi.md#get_infra_events) | **POST** /api/v1/infra/events | Get infrastructure protection events
*TrafficStatisticsAndLogsApi* | [**get_infra_protect_histogram**](docs/TrafficStatisticsAndLogsApi.md#get_infra_protect_histogram) | **POST** /api/v1/infra/histogram | Get infrastructure protection histogram
*TrafficStatisticsAndLogsApi* | [**get_infra_protect_top_data**](docs/TrafficStatisticsAndLogsApi.md#get_infra_protect_top_data) | **POST** /api/v1/infra/top-graph | Get infrastructure protection top items (graph view)
*TrafficStatisticsAndLogsApi* | [**get_infra_protect_top_table**](docs/TrafficStatisticsAndLogsApi.md#get_infra_protect_top_table) | **POST** /api/v1/infra/top-table | Get infrastructure protection top items (table view)
*TrafficStatisticsAndLogsApi* | [**get_infra_stats**](docs/TrafficStatisticsAndLogsApi.md#get_infra_stats) | **POST** /api/v1/infra/stats | Get infrastructure protection statistics
*TrafficStatisticsAndLogsApi* | [**get_stats**](docs/TrafficStatisticsAndLogsApi.md#get_stats) | **POST** /api/stats/v1 | Get statistics
*TrafficStatisticsAndLogsApi* | [**get_visits**](docs/TrafficStatisticsAndLogsApi.md#get_visits) | **POST** /api/visits/v1 | Get visits
*TrafficStatisticsAndLogsApi* | [**upload_lc_public_key**](docs/TrafficStatisticsAndLogsApi.md#upload_lc_public_key) | **POST** /api/logscollector/upload/publickey | Upload public key
*WAFLogSetupApi* | [**activate**](docs/WAFLogSetupApi.md#activate) | **POST** /api/prov/v1/waf-log-setup/activate | Activate WAF Logs
*WAFLogSetupApi* | [**change_status**](docs/WAFLogSetupApi.md#change_status) | **POST** /api/prov/v1/waf-log-setup/change/status | Change logs collector configuration status

## Documentation For Models

 - [ADRule](docs/ADRule.md)
 - [ADRuleSeries](docs/ADRuleSeries.md)
 - [Account](docs/Account.md)
 - [AccountBandwidth](docs/AccountBandwidth.md)
 - [AccountPlanStatus](docs/AccountPlanStatus.md)
 - [AccountPlanStatusWebsiteProtection](docs/AccountPlanStatusWebsiteProtection.md)
 - [Accounts](docs/Accounts.md)
 - [ActionItem](docs/ActionItem.md)
 - [AnalyticsHistogramApiResponse](docs/AnalyticsHistogramApiResponse.md)
 - [AnalyticsTopGraphDataResponse](docs/AnalyticsTopGraphDataResponse.md)
 - [AnalyticsTopTableApiResponse](docs/AnalyticsTopTableApiResponse.md)
 - [AnalyticsTopTableData](docs/AnalyticsTopTableData.md)
 - [ApiError](docs/ApiError.md)
 - [ApiErrorResponse](docs/ApiErrorResponse.md)
 - [ApiErrorSource](docs/ApiErrorSource.md)
 - [ApiResult](docs/ApiResult.md)
 - [ApiResultAccountStatus](docs/ApiResultAccountStatus.md)
 - [ApiResultAccountSubscription](docs/ApiResultAccountSubscription.md)
 - [ApiResultAddCacheRule](docs/ApiResultAddCacheRule.md)
 - [ApiResultDomainEmails](docs/ApiResultDomainEmails.md)
 - [ApiResultGetCacheMode](docs/ApiResultGetCacheMode.md)
 - [ApiResultGetClappsInfo](docs/ApiResultGetClappsInfo.md)
 - [ApiResultGetResponseHeaderSettings](docs/ApiResultGetResponseHeaderSettings.md)
 - [ApiResultGetRewritePorts](docs/ApiResultGetRewritePorts.md)
 - [ApiResultGetSecureResources](docs/ApiResultGetSecureResources.md)
 - [ApiResultGetSiteXrayLink](docs/ApiResultGetSiteXrayLink.md)
 - [ApiResultGetSsoToken](docs/ApiResultGetSsoToken.md)
 - [ApiResultGetTagResponseHeader](docs/ApiResultGetTagResponseHeader.md)
 - [ApiResultGetTexts](docs/ApiResultGetTexts.md)
 - [ApiResultHtmlInjections](docs/ApiResultHtmlInjections.md)
 - [ApiResultIncapsulaRanges](docs/ApiResultIncapsulaRanges.md)
 - [ApiResultInfraProtectSipCname](docs/ApiResultInfraProtectSipCname.md)
 - [ApiResultInfraProtectSipDnsWithCname](docs/ApiResultInfraProtectSipDnsWithCname.md)
 - [ApiResultInfraProtectSipDnsWithIp](docs/ApiResultInfraProtectSipDnsWithIp.md)
 - [ApiResultInfraProtectSipIp](docs/ApiResultInfraProtectSipIp.md)
 - [ApiResultLCPublicKey](docs/ApiResultLCPublicKey.md)
 - [ApiResultListSites](docs/ApiResultListSites.md)
 - [ApiResultListUsers](docs/ApiResultListUsers.md)
 - [ApiResultMoveSite](docs/ApiResultMoveSite.md)
 - [ApiResultReport](docs/ApiResultReport.md)
 - [ApiResultSessions](docs/ApiResultSessions.md)
 - [ApiResultSetDataRegion](docs/ApiResultSetDataRegion.md)
 - [ApiResultSetSupportDeprecatedTLSForSite](docs/ApiResultSetSupportDeprecatedTLSForSite.md)
 - [ApiResultSiteStats](docs/ApiResultSiteStats.md)
 - [ApiResultSiteStatus](docs/ApiResultSiteStatus.md)
 - [ApiResultSubAccountStatus](docs/ApiResultSubAccountStatus.md)
 - [ApiResultTestAlert](docs/ApiResultTestAlert.md)
 - [ApiResultTestAlertConnectionStatus](docs/ApiResultTestAlertConnectionStatus.md)
 - [ApiResultTestAlertExporterStatus](docs/ApiResultTestAlertExporterStatus.md)
 - [ApiResultTestAlertProtectedIPStatus](docs/ApiResultTestAlertProtectedIPStatus.md)
 - [ApiResultWAFLogSetupActivate](docs/ApiResultWAFLogSetupActivate.md)
 - [BotConfiguration](docs/BotConfiguration.md)
 - [BotsConfiguration](docs/BotsConfiguration.md)
 - [BotsConfigurationDTO](docs/BotsConfigurationDTO.md)
 - [CaaComplianceCheckResult](docs/CaaComplianceCheckResult.md)
 - [Caching](docs/Caching.md)
 - [CreateNewCSRResponse](docs/CreateNewCSRResponse.md)
 - [CustomAreas](docs/CustomAreas.md)
 - [CustomAreasExceptions](docs/CustomAreasExceptions.md)
 - [CustomRuleResponse](docs/CustomRuleResponse.md)
 - [DataCenterConfiguration](docs/DataCenterConfiguration.md)
 - [DataCenterResponse](docs/DataCenterResponse.md)
 - [DataCenterServerConfiguration](docs/DataCenterServerConfiguration.md)
 - [DataCentersConfiguration](docs/DataCentersConfiguration.md)
 - [DataCentersConfigurationDTO](docs/DataCentersConfigurationDTO.md)
 - [DeleteCustomRuleResponse](docs/DeleteCustomRuleResponse.md)
 - [DnsInstructionItem](docs/DnsInstructionItem.md)
 - [GeoInfo](docs/GeoInfo.md)
 - [GetAdvancedCachingSettingsApiResult](docs/GetAdvancedCachingSettingsApiResult.md)
 - [GetCache404SettingsApiResult](docs/GetCache404SettingsApiResult.md)
 - [GetStaleContentApiResult](docs/GetStaleContentApiResult.md)
 - [HSTSConfiguration](docs/HSTSConfiguration.md)
 - [HtmlInjectionItem](docs/HtmlInjectionItem.md)
 - [IncapRule](docs/IncapRule.md)
 - [IncapRuleApiResult](docs/IncapRuleApiResult.md)
 - [IncapRuleSeries](docs/IncapRuleSeries.md)
 - [InfraEventsApiResponse](docs/InfraEventsApiResponse.md)
 - [InfraProtectEvent](docs/InfraProtectEvent.md)
 - [InfraStatsApiResponse](docs/InfraStatsApiResponse.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse20015](docs/InlineResponse20015.md)
 - [InlineResponse20016](docs/InlineResponse20016.md)
 - [InlineResponse20017](docs/InlineResponse20017.md)
 - [InlineResponse20018](docs/InlineResponse20018.md)
 - [InlineResponse20019](docs/InlineResponse20019.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse20020](docs/InlineResponse20020.md)
 - [InlineResponse20021](docs/InlineResponse20021.md)
 - [InlineResponse20022](docs/InlineResponse20022.md)
 - [InlineResponse20023](docs/InlineResponse20023.md)
 - [InlineResponse20024](docs/InlineResponse20024.md)
 - [InlineResponse20025](docs/InlineResponse20025.md)
 - [InlineResponse20026](docs/InlineResponse20026.md)
 - [InlineResponse20027](docs/InlineResponse20027.md)
 - [InlineResponse20028](docs/InlineResponse20028.md)
 - [InlineResponse20029](docs/InlineResponse20029.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse20030](docs/InlineResponse20030.md)
 - [InlineResponse20031](docs/InlineResponse20031.md)
 - [InlineResponse20032](docs/InlineResponse20032.md)
 - [InlineResponse20033](docs/InlineResponse20033.md)
 - [InlineResponse20034](docs/InlineResponse20034.md)
 - [InlineResponse20035](docs/InlineResponse20035.md)
 - [InlineResponse20036](docs/InlineResponse20036.md)
 - [InlineResponse20037](docs/InlineResponse20037.md)
 - [InlineResponse20038](docs/InlineResponse20038.md)
 - [InlineResponse20039](docs/InlineResponse20039.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse20040](docs/InlineResponse20040.md)
 - [InlineResponse20041](docs/InlineResponse20041.md)
 - [InlineResponse20042](docs/InlineResponse20042.md)
 - [InlineResponse20043](docs/InlineResponse20043.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [IsCacheShieldEnabledApiResult](docs/IsCacheShieldEnabledApiResult.md)
 - [ListCustomRulesResponse](docs/ListCustomRulesResponse.md)
 - [ListDataCenterResponse](docs/ListDataCenterResponse.md)
 - [Login](docs/Login.md)
 - [LoginProtectApiResult](docs/LoginProtectApiResult.md)
 - [LoginProtectUsersApiResults](docs/LoginProtectUsersApiResults.md)
 - [LpExtendedUser](docs/LpExtendedUser.md)
 - [PerformanceConfigurationApiResult](docs/PerformanceConfigurationApiResult.md)
 - [PlanSection](docs/PlanSection.md)
 - [PlanSectionRow](docs/PlanSectionRow.md)
 - [PopRttResponse](docs/PopRttResponse.md)
 - [RecommendedPopsApiResult](docs/RecommendedPopsApiResult.md)
 - [RequestBodyTimeoutDTO](docs/RequestBodyTimeoutDTO.md)
 - [RequestsGeo](docs/RequestsGeo.md)
 - [RewritePort](docs/RewritePort.md)
 - [ServerOperationResponse](docs/ServerOperationResponse.md)
 - [SessionItem](docs/SessionItem.md)
 - [SetPriorityResponse](docs/SetPriorityResponse.md)
 - [SiteCacheRuleResponse](docs/SiteCacheRuleResponse.md)
 - [SiteConfigurationWarning](docs/SiteConfigurationWarning.md)
 - [SiteDualFactorSettings](docs/SiteDualFactorSettings.md)
 - [SpecificUsersList](docs/SpecificUsersList.md)
 - [Stats](docs/Stats.md)
 - [SubAccountStatus](docs/SubAccountStatus.md)
 - [TLSConfiguration](docs/TLSConfiguration.md)
 - [TLSConfigurationDto](docs/TLSConfigurationDto.md)
 - [Threat](docs/Threat.md)
 - [ThreatItem](docs/ThreatItem.md)
 - [TimeSeriesItem](docs/TimeSeriesItem.md)
 - [TopGraphPayloads](docs/TopGraphPayloads.md)
 - [VisitsItem](docs/VisitsItem.md)
 - [VisitsSummary](docs/VisitsSummary.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


