# swagger-client
To better align with REST API standards and best practices, Imperva is gradually rolling out a new version of APIs, available for your use in managing your Cloud Application Security account and websites. These APIs provide either an alternative to existing APIs, or provide APIs with new functionality. For more details about Imperva APIs, see <a href=https://docs.imperva.com/bundle/api-docs/page/api/api-overview.htm>Imperva API Documentation</a>.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.CustomCertificateApi(swagger_client.ApiClient(configuration))
ext_site_id = 56 # int | The Imperva ID of your website.
auth_type = 'auth_type_example' # str | 

try:
    # Remove custom certificate
    api_instance.sites_ext_site_id_custom_certificate_delete(ext_site_id, auth_type)
except ApiException as e:
    print("Exception when calling CustomCertificateApi->sites_ext_site_id_custom_certificate_delete: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.CustomCertificateApi(swagger_client.ApiClient(configuration))
body = swagger_client.CustomCertificateBody() # CustomCertificateBody | 
ext_site_id = 56 # int | The Imperva ID of your website.

try:
    # Upload custom certificate
    api_instance.sites_ext_site_id_custom_certificate_put(body, ext_site_id)
except ApiException as e:
    print("Exception when calling CustomCertificateApi->sites_ext_site_id_custom_certificate_put: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://my.imperva.com/api/prov/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CustomCertificateApi* | [**sites_ext_site_id_custom_certificate_delete**](docs/CustomCertificateApi.md#sites_ext_site_id_custom_certificate_delete) | **DELETE** /sites/{extSiteId}/customCertificate | Remove custom certificate
*CustomCertificateApi* | [**sites_ext_site_id_custom_certificate_put**](docs/CustomCertificateApi.md#sites_ext_site_id_custom_certificate_put) | **PUT** /sites/{extSiteId}/customCertificate | Upload custom certificate
*CustomCertificateWithHSMSupportApi* | [**sites_ext_site_id_hsm_certificate_connectivity_test_get**](docs/CustomCertificateWithHSMSupportApi.md#sites_ext_site_id_hsm_certificate_connectivity_test_get) | **GET** /sites/{extSiteId}/hsmCertificate/connectivityTest | Test connectivity between Imperva and HSM provider
*CustomCertificateWithHSMSupportApi* | [**sites_ext_site_id_hsm_certificate_delete**](docs/CustomCertificateWithHSMSupportApi.md#sites_ext_site_id_hsm_certificate_delete) | **DELETE** /sites/{extSiteId}/hsmCertificate | Remove custom certificate and HSM credentials
*CustomCertificateWithHSMSupportApi* | [**sites_ext_site_id_hsm_certificate_put**](docs/CustomCertificateWithHSMSupportApi.md#sites_ext_site_id_hsm_certificate_put) | **PUT** /sites/{extSiteId}/hsmCertificate | Upload custom certificate and HSM credentials
*RulesApi* | [**sites_site_id_rules_post**](docs/RulesApi.md#sites_site_id_rules_post) | **POST** /sites/{siteId}/rules | Create rule
*RulesApi* | [**sites_site_id_rules_rule_id_delete**](docs/RulesApi.md#sites_site_id_rules_rule_id_delete) | **DELETE** /sites/{siteId}/rules/{ruleId} | Delete rule - must contain valid rule id
*RulesApi* | [**sites_site_id_rules_rule_id_get**](docs/RulesApi.md#sites_site_id_rules_rule_id_get) | **GET** /sites/{siteId}/rules/{ruleId} | Read rule - must contain valid rule id
*RulesApi* | [**sites_site_id_rules_rule_id_post**](docs/RulesApi.md#sites_site_id_rules_rule_id_post) | **POST** /sites/{siteId}/rules/{ruleId} | Update rule - must contain valid rule id
*RulesApi* | [**sites_site_id_rules_rule_id_put**](docs/RulesApi.md#sites_site_id_rules_rule_id_put) | **PUT** /sites/{siteId}/rules/{ruleId} | Overwrite rule - must contain valid rule id
*SettingsApi* | [**sites_ext_site_id_settings_general_additional_txt_records_delete**](docs/SettingsApi.md#sites_ext_site_id_settings_general_additional_txt_records_delete) | **DELETE** /sites/{extSiteId}/settings/general/additionalTxtRecords | Delete a specific TXT record that is defined for the site in Cloud WAF
*SettingsApi* | [**sites_ext_site_id_settings_general_additional_txt_records_delete_all_delete**](docs/SettingsApi.md#sites_ext_site_id_settings_general_additional_txt_records_delete_all_delete) | **DELETE** /sites/{extSiteId}/settings/general/additionalTxtRecords/delete-all | Delete all TXT records that are defined for the site in Cloud WAF
*SettingsApi* | [**sites_ext_site_id_settings_general_additional_txt_records_get**](docs/SettingsApi.md#sites_ext_site_id_settings_general_additional_txt_records_get) | **GET** /sites/{extSiteId}/settings/general/additionalTxtRecords | Return all TXT records defined for the site in Cloud WAF
*SettingsApi* | [**sites_ext_site_id_settings_general_additional_txt_records_post**](docs/SettingsApi.md#sites_ext_site_id_settings_general_additional_txt_records_post) | **POST** /sites/{extSiteId}/settings/general/additionalTxtRecords | Create or modify one or more of the TXT records defined for the site in Cloud WAF  (partial update)
*SettingsApi* | [**sites_ext_site_id_settings_general_additional_txt_records_put**](docs/SettingsApi.md#sites_ext_site_id_settings_general_additional_txt_records_put) | **PUT** /sites/{extSiteId}/settings/general/additionalTxtRecords | Overwrite a specific TXT record that is defined for the site in Cloud WAF  (full update)
*SettingsApi* | [**sites_site_id_settings_masking_get**](docs/SettingsApi.md#sites_site_id_settings_masking_get) | **GET** /sites/{siteId}/settings/masking | Returns a masking setting for the given site.
*SettingsApi* | [**sites_site_id_settings_masking_post**](docs/SettingsApi.md#sites_site_id_settings_masking_post) | **POST** /sites/{siteId}/settings/masking | Update masking settings for site

## Documentation For Models

 - [ApiResult](docs/ApiResult.md)
 - [CustomCertificateBody](docs/CustomCertificateBody.md)
 - [HsmBody](docs/HsmBody.md)
 - [HsmBodyData](docs/HsmBodyData.md)
 - [HsmBodyDataHsmDetails](docs/HsmBodyDataHsmDetails.md)
 - [MaskingSettings](docs/MaskingSettings.md)
 - [Rule](docs/Rule.md)
 - [RuleBlockDurationDetails](docs/RuleBlockDurationDetails.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


