# Rule

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**rule_id** | **int** | Numeric identifier of the rule to operate on | [optional] 
**name** | **str** | Rule name | 
**action** | **str** | Rule action.  * RULE_ACTION_REDIRECT - Redirect rule. Redirect the client to a different URL, responding with a 30X response.  * RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL using restricted redirect settings.  * RULE_ACTION_REWRITE_URL - Redirect rule. Modify the path to which a specific request is targeted.  * RULE_ACTION_REWRITE_HEADER - Redirect rule. Modify or add a request header before passing traffic to the origin server.  * RULE_ACTION_REWRITE_COOKIE - Redirect rule. Allows the modification and addition of cookies that are sent by the client to the origin server. The cookie name and value should be indicated.  * RULE_ACTION_DELETE_HEADER - Redirect rule. Remove a specific request header, which means that it won’t be sent to the origin server.  * RULE_ACTION_DELETE_COOKIE - Redirect rule. Allows the removal a specific cookie set on the client, which means that it won’t be sent to the origin server.  * RULE_ACTION_RESPONSE_REWRITE_HEADER - Redirect rule. Modify or add a response header before passing traffic by the origin server to the client.  * RULE_ACTION_RESPONSE_DELETE_HEADER - Redirect rule. Remove a specific response header, which means that it won’t be sent to the client.  * RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE - Redirect rule. Modify the response status code before passing traffic by the origin server to the client.  * RULE_ACTION_FORWARD_TO_DC - Redirect rule. Used to define the data center to which a specific request will be sent.  * RULE_ACTION_FORWARD_TO_PORT - Redirect rule. Used to define the port to which a specific request will be sent.  * RULE_ACTION_ALERT - Security rule. Generate a non blocking alert for this event.  * RULE_ACTION_BLOCK - Security rule. Block the current request and generate an alert for this event.  * RULE_ACTION_BLOCK_USER - Security rule. Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.  * RULE_ACTION_BLOCK_IP - Security rule. Block the current IP and generate an alert for this event. Any subsequent request from the same IP will be blocked for a period of 10 minutes.  * RULE_ACTION_RETRY - Security rule. Require any client matching the rule filters to support cookies in order to complete the request.  * RULE_ACTION_INTRUSIVE_HTML - Security rule. Require any client matching the rule filters to support javascript in order to complete the request. Since the Javascript test is embedded in an HTML page, this action should only be enabled for HTML resources.  * RULE_ACTION_CAPTCHA - Security rule. Require any client matching the rule filters to pass a CAPTCHA test in order to complete the request. Since the CAPTCHA test is embedded in an HTML page, this action should only be enabled for HTML resources.  * RULE_ACTION_RATE - Count the number of requests received that match the rule filter.  * RULE_ACTION_CUSTOM_ERROR_RESPONSE - Replace default error response &amp; error code with custom ones. Once blocked a rule that matches the provided filter &amp; error type will return a custom error &amp; error code.  * RULE_ACTION_WAF_OVERRIDE - Overrides the global WAF setting for a specific threat type.  | 
**filter** | **str** | The filter defines the conditions that trigger the rule action. For action RULE_ACTION_SIMPLIFIED_REDIRECT filter is not relevant. For other actions, if left empty, the rule is always run. | [optional] 
**response_code** | **int** | For RULE_ACTION_REDIRECT or RULE_ACTION_SIMPLIFIED_REDIRECT rule&#x27;s response code, valid values are 302, 301, 303, 307, 308. For RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE rule&#x27;s response code, valid values are all 3-digits numbers. For RULE_ACTION_CUSTOM_ERROR_RESPONSE, valid values are [ 200, 400, 401, 402, 403, 404, 405, 406, 407, 408, 409, 410, 411, 412, 413, 414, 415, 416, 417, 419, 420, 422, 423, 424, 429, 500, 501, 502, 503, 504, 505, 507 ] | [optional] 
**add_missing** | **bool** | Add cookie or header if it doesn&#x27;t exist (Rewrite cookie rule only) | [optional] 
**rewrite_existing** | **bool** | Rewrite cookie or header if it exists | [optional] 
**_from** | **str** | Pattern to rewrite. For RULE_ACTION_REWRITE_URL - Url to rewrite. For RULE_ACTION_REWRITE_HEADER/RULE_ACTION_RESPONSE_REWRITE_HEADER - Header value to rewrite. For RULE_ACTION_REWRITE_COOKIE - Cookie value to rewrite | [optional] 
**to** | **str** | Pattern to change to. RULE_ACTION_REWRITE_URL - Url to change to. RULE_ACTION_REWRITE_HEADER/RULE_ACTION_RESPONSE_REWRITE_HEADER - Header value to change to. RULE_ACTION_REWRITE_COOKIE - Cookie value to change to | [optional] 
**rewrite_name** | **str** | Name of cookie or header to rewrite. Applies only for RULE_ACTION_REWRITE_COOKIE, RULE_ACTION_REWRITE_HEADER and RULE_ACTION_RESPONSE_REWRITE_HEADER | [optional] 
**dc_id** | **int** | Data center to forward request to. Applies only for RULE_ACTION_FORWARD_TO_DC | [optional] 
**port_forwarding_context** | **str** | Context for port forwarding. \&quot;Use Port Value\&quot; or \&quot;Use Header Name\&quot;. Applies only for RULE_ACTION_FORWARD_TO_PORT | [optional] 
**port_forwarding_value** | **str** | Port number or header name for port forwarding. Applies only for RULE_ACTION_FORWARD_TO_PORT | [optional] 
**rate_context** | **str** | The context of the rate counter. Possible values IP or Session. Applies only to rules using RULE_ACTION_RATE. | [optional] 
**rate_interval** | **int** | The interval in seconds of the rate counter. Possible values is a multiple of 10 minimum 10 maximum 300. Applies only to rules using RULE_ACTION_RATE. | [optional] 
**error_type** | **str** | The error that triggers the rule. error.type.all triggers the rule regardless of the error type. Applies only for RULE_ACTION_CUSTOM_ERROR_RESPONSE | [optional] 
**error_response_format** | **str** | The format of the given error response in the error_response_data field. Applies only for RULE_ACTION_CUSTOM_ERROR_RESPONSE | [optional] 
**error_response_data** | **str** | The response returned when the request matches the filter and is blocked. Applies only for RULE_ACTION_CUSTOM_ERROR_RESPONSE | [optional] 
**multiple_deletions** | **bool** | Delete multiple header occurrences. Applies only to rules using RULE_ACTION_DELETE_HEADER and RULE_ACTION_RESPONSE_DELETE_HEADER | [optional] 
**override_waf_rule** | **str** | The setting to override. Possible values: SQL Injection, Remote File Inclusion, Cross Site Scripting, Illegal Resource Access | [optional] 
**override_waf_action** | **str** | The action for the override rule. Possible values: Alert Only, Block Request, Block User, Block IP, Ignore | [optional] 
**enabled** | **bool** | The setting enables or disables the rule. | [optional] 
**block_duration_details** | [**RuleBlockDurationDetails**](RuleBlockDurationDetails.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

