# swagger-client
Get a detailed list of your account users, including name, ID, email, and assigned roles. For more details, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/accountusers-idm.htm\">Manage Account Users</a>.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = swagger_client.UserManagementApi(swagger_client.ApiClient(configuration))

try:
    # Retrieve the list of users for a given account
    api_response = api_instance.get_current_account_users()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling UserManagementApi->get_current_account_users: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/identity-management*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*UserManagementApi* | [**get_current_account_users**](docs/UserManagementApi.md#get_current_account_users) | **GET** /v3/users/list | Retrieve the list of users for a given account

## Documentation For Models

 - [Role](docs/Role.md)
 - [User](docs/User.md)
 - [UsersExternalResponse](docs/UsersExternalResponse.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header

## caid

- **Type**: API key
- **API key parameter name**: caid
- **Location**: URL query string


## Author


