# swagger-client
Create and manage notification settings for your account using the API. For full feature documentation, see <a href='https://docs.imperva.com/bundle/cloud-application-security/page/settings/notification-settings.htm'> Notification Settings </a>

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
body = swagger_client.ImpervaApiDtoNotificationPolicyFull() # ImpervaApiDtoNotificationPolicyFull | 
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Create a notification policy
    api_response = api_instance.create(body, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->create: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
policy_id = 789 # int | The Imperva ID of the policy. To retrieve the policy ID, run the GET /v3/policies/lite API.
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Delete a notification policy
    api_response = api_instance.delete(policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->delete: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
policy_id = 789 # int | The Imperva ID of the policy. To retrieve the policy ID, run the GET /v3/policies/lite API.
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Retrieve a notification policy
    api_response = api_instance.get(policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->get: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Get account notification policies
    api_response = api_instance.get_notification_policy_lite_list(caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->get_notification_policy_lite_list: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
body = swagger_client.ImpervaApiDtoNotificationPolicyFull() # ImpervaApiDtoNotificationPolicyFull | 
policy_id = 789 # int | The Imperva ID of the policy. To retrieve the policy ID, run the GET /v3/policies/lite API.
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Update a notification policy
    api_response = api_instance.update(body, policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->update: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.NotificationPoliciesApi(swagger_client.ApiClient(configuration))
body = swagger_client.ImpervaApiDtoNotificationPolicyUpdates() # ImpervaApiDtoNotificationPolicyUpdates | 
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Update notification policy status
    api_response = api_instance.update_non_crud_policy(body, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NotificationPoliciesApi->update_non_crud_policy: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/notification-settings*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*NotificationPoliciesApi* | [**create**](docs/NotificationPoliciesApi.md#create) | **POST** /v3/policies | Create a notification policy
*NotificationPoliciesApi* | [**delete**](docs/NotificationPoliciesApi.md#delete) | **DELETE** /v3/policies/{policyId} | Delete a notification policy
*NotificationPoliciesApi* | [**get**](docs/NotificationPoliciesApi.md#get) | **GET** /v3/policies/{policyId} | Retrieve a notification policy
*NotificationPoliciesApi* | [**get_notification_policy_lite_list**](docs/NotificationPoliciesApi.md#get_notification_policy_lite_list) | **GET** /v3/policies/lite | Get account notification policies
*NotificationPoliciesApi* | [**update**](docs/NotificationPoliciesApi.md#update) | **PUT** /v3/policies/{policyId} | Update a notification policy
*NotificationPoliciesApi* | [**update_non_crud_policy**](docs/NotificationPoliciesApi.md#update_non_crud_policy) | **PUT** /v3/policy/update | Update notification policy status

## Documentation For Models

 - [Asset](docs/Asset.md)
 - [ChannelType](docs/ChannelType.md)
 - [ExternalRecipient](docs/ExternalRecipient.md)
 - [ImpervaApiDtoListNotificationPolicyLite](docs/ImpervaApiDtoListNotificationPolicyLite.md)
 - [ImpervaApiDtoNotificationPolicyFull](docs/ImpervaApiDtoNotificationPolicyFull.md)
 - [ImpervaApiDtoNotificationPolicyUpdates](docs/ImpervaApiDtoNotificationPolicyUpdates.md)
 - [NotificationChannelEmail](docs/NotificationChannelEmail.md)
 - [NotificationChannelInterface](docs/NotificationChannelInterface.md)
 - [NotificationPolicyFull](docs/NotificationPolicyFull.md)
 - [NotificationPolicyLite](docs/NotificationPolicyLite.md)
 - [NotificationPolicyUpdates](docs/NotificationPolicyUpdates.md)
 - [OneOfNotificationPolicyFullNotificationChannelListItems](docs/OneOfNotificationPolicyFullNotificationChannelListItems.md)
 - [Recipient](docs/Recipient.md)
 - [SubAccount](docs/SubAccount.md)
 - [SubAccountPolicyInfo](docs/SubAccountPolicyInfo.md)
 - [UserRecipient](docs/UserRecipient.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


