# coding: utf-8

"""
    Notification Settings API

    Create and manage notification settings for your account using the API. For full feature documentation, see <a href='https://docs.imperva.com/bundle/cloud-application-security/page/settings/notification-settings.htm'> Notification Settings </a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Asset(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'asset_type': 'str',
        'asset_id': 'int',
        'display_name': 'str'
    }

    attribute_map = {
        'asset_type': 'assetType',
        'asset_id': 'assetId',
        'display_name': 'displayName'
    }

    def __init__(self, asset_type=None, asset_id=None, display_name=None):  # noqa: E501
        """Asset - a model defined in Swagger"""  # noqa: E501
        self._asset_type = None
        self._asset_id = None
        self._display_name = None
        self.discriminator = None
        self.asset_type = asset_type
        self.asset_id = asset_id
        if display_name is not None:
            self.display_name = display_name

    @property
    def asset_type(self):
        """Gets the asset_type of this Asset.  # noqa: E501

        Indicates the type of asset that triggers the notification, such as websites, router connections, network prefixes, individual IPs, Flow exporters, and DNS zones. Example values include: “SITE”  # noqa: E501

        :return: The asset_type of this Asset.  # noqa: E501
        :rtype: str
        """
        return self._asset_type

    @asset_type.setter
    def asset_type(self, asset_type):
        """Sets the asset_type of this Asset.

        Indicates the type of asset that triggers the notification, such as websites, router connections, network prefixes, individual IPs, Flow exporters, and DNS zones. Example values include: “SITE”  # noqa: E501

        :param asset_type: The asset_type of this Asset.  # noqa: E501
        :type: str
        """
        if asset_type is None:
            raise ValueError("Invalid value for `asset_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SITE", "IP_RANGE", "EDGE_IP", "ORIGIN_CONNECTIVITY", "NETFLOW_EXPORTER", "DOMAIN"]  # noqa: E501
        if asset_type not in allowed_values:
            raise ValueError(
                "Invalid value for `asset_type` ({0}), must be one of {1}"  # noqa: E501
                .format(asset_type, allowed_values)
            )

        self._asset_type = asset_type

    @property
    def asset_id(self):
        """Gets the asset_id of this Asset.  # noqa: E501

        Indicates a numeric value of the asset.  # noqa: E501

        :return: The asset_id of this Asset.  # noqa: E501
        :rtype: int
        """
        return self._asset_id

    @asset_id.setter
    def asset_id(self, asset_id):
        """Sets the asset_id of this Asset.

        Indicates a numeric value of the asset.  # noqa: E501

        :param asset_id: The asset_id of this Asset.  # noqa: E501
        :type: int
        """
        if asset_id is None:
            raise ValueError("Invalid value for `asset_id`, must not be `None`")  # noqa: E501

        self._asset_id = asset_id

    @property
    def display_name(self):
        """Gets the display_name of this Asset.  # noqa: E501

        Indicates name of recipient of the notification.  # noqa: E501

        :return: The display_name of this Asset.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this Asset.

        Indicates name of recipient of the notification.  # noqa: E501

        :param display_name: The display_name of this Asset.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Asset, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Asset):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
