# coding: utf-8

"""
    Notification Settings API

    Create and manage notification settings for your account using the API. For full feature documentation, see <a href='https://docs.imperva.com/bundle/cloud-application-security/page/settings/notification-settings.htm'> Notification Settings </a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from swagger_client.models.notification_channel_interface import NotificationChannelInterface  # noqa: F401,E501

class NotificationChannelEmail(NotificationChannelInterface):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'recipient_to_list': 'list[object]'
    }
    if hasattr(NotificationChannelInterface, "swagger_types"):
        swagger_types.update(NotificationChannelInterface.swagger_types)

    attribute_map = {
        'recipient_to_list': 'recipientToList'
    }
    if hasattr(NotificationChannelInterface, "attribute_map"):
        attribute_map.update(NotificationChannelInterface.attribute_map)

    def __init__(self, recipient_to_list=None, *args, **kwargs):  # noqa: E501
        """NotificationChannelEmail - a model defined in Swagger"""  # noqa: E501
        self._recipient_to_list = None
        self.discriminator = None
        self.recipient_to_list = recipient_to_list
        NotificationChannelInterface.__init__(self, *args, **kwargs)

    @property
    def recipient_to_list(self):
        """Gets the recipient_to_list of this NotificationChannelEmail.  # noqa: E501

        List of recipients  # noqa: E501

        :return: The recipient_to_list of this NotificationChannelEmail.  # noqa: E501
        :rtype: list[object]
        """
        return self._recipient_to_list

    @recipient_to_list.setter
    def recipient_to_list(self, recipient_to_list):
        """Sets the recipient_to_list of this NotificationChannelEmail.

        List of recipients  # noqa: E501

        :param recipient_to_list: The recipient_to_list of this NotificationChannelEmail.  # noqa: E501
        :type: list[object]
        """
        if recipient_to_list is None:
            raise ValueError("Invalid value for `recipient_to_list`, must not be `None`")  # noqa: E501

        self._recipient_to_list = recipient_to_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NotificationChannelEmail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotificationChannelEmail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
