# coding: utf-8

"""
    Notification Settings API

    Create and manage notification settings for your account using the API. For full feature documentation, see <a href='https://docs.imperva.com/bundle/cloud-application-security/page/settings/notification-settings.htm'> Notification Settings </a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NotificationPolicyUpdates(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'int',
        'policy_id': 'int',
        'status': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'policy_id': 'policyId',
        'status': 'status'
    }

    def __init__(self, account_id=None, policy_id=None, status=None):  # noqa: E501
        """NotificationPolicyUpdates - a model defined in Swagger"""  # noqa: E501
        self._account_id = None
        self._policy_id = None
        self._status = None
        self.discriminator = None
        if account_id is not None:
            self.account_id = account_id
        self.policy_id = policy_id
        self.status = status

    @property
    def account_id(self):
        """Gets the account_id of this NotificationPolicyUpdates.  # noqa: E501

        Numerical value obtained by retrieving from PolicyDetails.  # noqa: E501

        :return: The account_id of this NotificationPolicyUpdates.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this NotificationPolicyUpdates.

        Numerical value obtained by retrieving from PolicyDetails.  # noqa: E501

        :param account_id: The account_id of this NotificationPolicyUpdates.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def policy_id(self):
        """Gets the policy_id of this NotificationPolicyUpdates.  # noqa: E501

        Numerical value obtained by retrieving from PolicyDetails.  # noqa: E501

        :return: The policy_id of this NotificationPolicyUpdates.  # noqa: E501
        :rtype: int
        """
        return self._policy_id

    @policy_id.setter
    def policy_id(self, policy_id):
        """Sets the policy_id of this NotificationPolicyUpdates.

        Numerical value obtained by retrieving from PolicyDetails.  # noqa: E501

        :param policy_id: The policy_id of this NotificationPolicyUpdates.  # noqa: E501
        :type: int
        """
        if policy_id is None:
            raise ValueError("Invalid value for `policy_id`, must not be `None`")  # noqa: E501

        self._policy_id = policy_id

    @property
    def status(self):
        """Gets the status of this NotificationPolicyUpdates.  # noqa: E501

        Indicates whether policy is enabled or disabled.  # noqa: E501

        :return: The status of this NotificationPolicyUpdates.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NotificationPolicyUpdates.

        Indicates whether policy is enabled or disabled.  # noqa: E501

        :param status: The status of this NotificationPolicyUpdates.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["ENABLE", "DISABLE"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NotificationPolicyUpdates, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotificationPolicyUpdates):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
