# swagger-client
Create policies to centrally configure settings and apply them to multiple websites in your account. For full feature documentation, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/csh?context=policies\">Create and Manage Policies</a>.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
asset_id = 789 # int | Asset ID
asset_type = 'asset_type_example' # str | The type of asset on which the policy is applied
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the check is performed for an asset that belongs to the account (A) associated with the API credentials used for authentication. To check for an asset that belongs to a different account (an account under the account (A)), specify the account ID. (optional)

try:
    # Check whether the policy is applied on the asset
    api_response = api_instance.check_if_policy_is_applied_on_asset(asset_id, asset_type, policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->check_if_policy_is_applied_on_asset: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.PolicyDto() # PolicyDto | Policy to save. The supported format JSON
caid = 789 # int | By default, the policy is created for the account (A) associated with the API credentials used for authentication. To create the policy for a different account (an account under the account (A)), specify the account ID. (optional)
source_policy_id = 789 # int | Optional to clone full policy data (optional)

try:
    # Add a new policy or copy an existing policy
    api_response = api_instance.create_new_policy(body, caid=caid, source_policy_id=source_policy_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->create_new_policy: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the policy is deleted for the account (A) associated with the API credentials used for authentication. To delete the policy for a different account (an account under the account (A)), specify the account ID. (optional)

try:
    # Delete an existing policy
    api_response = api_instance.delete_policy(policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->delete_policy: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
caid = 789 # int | By default, the policies are retrieved for the account (A) associated with the API credentials used for authentication. To retrieve the policies for a different account (an account under the account (A)), specify the account ID. (optional)
extended = true # bool | Optional to get full policy data. Default is false. When set to false, the response returns basic policy details such as name, ID, and policy type, according to GetLeanPoliciesResponse. This is the default value. If set to true, the response returns full policy details, including current configuration and settings, according to GetPoliciesResponse. (optional)

try:
    # Retrieve all policies in account
    api_response = api_instance.get_all_policies_by_account(caid=caid, extended=extended)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->get_all_policies_by_account: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the policy is retrieved for the account (A) associated with the API credentials used for authentication. To retrieve the policy for a different account (an account under the account (A)), specify the account ID. (optional)
extended = true # bool | Optional to get full policy data. Default is false. When set to false, the response returns basic policy details such as name, ID, and policy type, according to GetLeanPoliciesResponse. This is the default value. If set to true, the response returns full policy details, including current configuration and settings, according to GetPoliciesResponse. (optional)

try:
    # Retrieve policy details
    api_response = api_instance.get_policy_by_id(policy_id, caid=caid, extended=extended)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->get_policy_by_id: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.UpdatePolicyDto() # UpdatePolicyDto | Policy to save. The supported format JSON
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the policy is updated for the account (A) associated with the API credentials used for authentication. To update the policy for a different account (an account under the account (A)), specify the account ID. (optional)

try:
    # Modify an existing policy (partial update)
    api_response = api_instance.modify_policy(body, policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->modify_policy: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.PolicyDto() # PolicyDto | Policy to save. The supported format JSON
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the policy is saved for the account (A) associated with the API credentials used for authentication. To save the policy for a different account (an account under the account (A)), specify the account ID. (optional)

try:
    # Overwrite an existing policy (full update)
    api_response = api_instance.update_policy(body, policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->update_policy: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.PolicyManagementApi(swagger_client.ApiClient(configuration))
asset_id = 789 # int | Asset ID
asset_type = 'asset_type_example' # str | The type of asset on which the policy is applied
policy_id = 789 # int | The Policy ID
caid = 789 # int | By default, the policy is applied for an asset that belongs to the account (A) associated with the API credentials used for authentication. To apply the policy for an asset that belongs to a different account (an account under the account (A)), specify the account ID. (optional)

try:
    # Overwrite applied assets in a policy
    api_response = api_instance.update_policy_to_single_asset(asset_id, asset_type, policy_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PolicyManagementApi->update_policy_to_single_asset: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/policies*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*PolicyManagementApi* | [**check_if_policy_is_applied_on_asset**](docs/PolicyManagementApi.md#check_if_policy_is_applied_on_asset) | **GET** /v2/policies/{policyId}/assets/{assetType}/{assetId} | Check whether the policy is applied on the asset
*PolicyManagementApi* | [**create_new_policy**](docs/PolicyManagementApi.md#create_new_policy) | **POST** /v2/policies | Add a new policy or copy an existing policy
*PolicyManagementApi* | [**delete_policy**](docs/PolicyManagementApi.md#delete_policy) | **DELETE** /v2/policies/{policyId} | Delete an existing policy
*PolicyManagementApi* | [**get_all_policies_by_account**](docs/PolicyManagementApi.md#get_all_policies_by_account) | **GET** /v2/policies | Retrieve all policies in account
*PolicyManagementApi* | [**get_policy_by_id**](docs/PolicyManagementApi.md#get_policy_by_id) | **GET** /v2/policies/{policyId} | Retrieve policy details
*PolicyManagementApi* | [**modify_policy**](docs/PolicyManagementApi.md#modify_policy) | **POST** /v2/policies/{policyId} | Modify an existing policy (partial update)
*PolicyManagementApi* | [**update_policy**](docs/PolicyManagementApi.md#update_policy) | **PUT** /v2/policies/{policyId} | Overwrite an existing policy (full update)
*PolicyManagementApi* | [**update_policy_to_single_asset**](docs/PolicyManagementApi.md#update_policy_to_single_asset) | **PATCH** /v2/policies/{policyId}/{assetType}/{assetId} | Overwrite applied assets in a policy
*PolicyManagementAccountApplicationApi* | [**add_available_account_to_policy**](docs/PolicyManagementAccountApplicationApi.md#add_available_account_to_policy) | **POST** /v2/accounts/{subAccountId}/policies/{policyId} | Enables an account to access a policy
*PolicyManagementAccountApplicationApi* | [**get_account_policy_association**](docs/PolicyManagementAccountApplicationApi.md#get_account_policy_association) | **GET** /v3/accounts/associated-policies | Retrieve the list of default and available policies of the account
*PolicyManagementAccountApplicationApi* | [**get_all_available_accounts_of_policy**](docs/PolicyManagementAccountApplicationApi.md#get_all_available_accounts_of_policy) | **GET** /v2/accounts/policies/{policyId} | Retrieves the list of accounts that can access a policy
*PolicyManagementAccountApplicationApi* | [**patch_account_policy_association**](docs/PolicyManagementAccountApplicationApi.md#patch_account_policy_association) | **PATCH** /v3/accounts/associated-policies | Update the list of default and available policies of the account
*PolicyManagementAccountApplicationApi* | [**put_account_policy_association**](docs/PolicyManagementAccountApplicationApi.md#put_account_policy_association) | **PUT** /v3/accounts/associated-policies | Set the list of default and available policies of the account (full overwrite)
*PolicyManagementAccountApplicationApi* | [**remove_available_account_from_policy**](docs/PolicyManagementAccountApplicationApi.md#remove_available_account_from_policy) | **DELETE** /v2/accounts/{subAccountId}/policies/{policyId} | Removes access to a policy by an account
*PolicyManagementAccountApplicationApi* | [**set_available_account_to_policy**](docs/PolicyManagementAccountApplicationApi.md#set_available_account_to_policy) | **PUT** /v2/accounts/policies/{policyId} | Defines the list of accounts that can access a policy
*PolicyManagementAssetApplicationApi* | [**apply_asset_to_policy**](docs/PolicyManagementAssetApplicationApi.md#apply_asset_to_policy) | **POST** /v2/assets/{assetType}/{assetId}/policies/{policyId} | Apply a single policy to a single asset
*PolicyManagementAssetApplicationApi* | [**get_all_asset_of_policy**](docs/PolicyManagementAssetApplicationApi.md#get_all_asset_of_policy) | **GET** /v2/assets/policies/{policyId} | Retrieve assets to which policy is applied
*PolicyManagementAssetApplicationApi* | [**get_all_policies_of_asset**](docs/PolicyManagementAssetApplicationApi.md#get_all_policies_of_asset) | **GET** /v2/assets/{assetType}/{assetId}/policies | Retrieve all policies applied to an asset
*PolicyManagementAssetApplicationApi* | [**un_apply_policy_on_asset**](docs/PolicyManagementAssetApplicationApi.md#un_apply_policy_on_asset) | **DELETE** /v2/assets/{assetType}/{assetId}/policies/{policyId} | Remove policy from asset
*PolicyManagementAssetApplicationApi* | [**update_asset_with_single_policy**](docs/PolicyManagementAssetApplicationApi.md#update_asset_with_single_policy) | **PUT** /v2/assets/{assetType}/{assetId}/policies/{policyId} | Overwrite policies assigned to a single asset

## Documentation For Models

 - [APIError](docs/APIError.md)
 - [AccountPolicyAssociationDto](docs/AccountPolicyAssociationDto.md)
 - [AccountPolicyAssociationV3RequestResponse](docs/AccountPolicyAssociationV3RequestResponse.md)
 - [AssetResult](docs/AssetResult.md)
 - [DefaultPolicyConfigDto](docs/DefaultPolicyConfigDto.md)
 - [ExceptionsDataDto](docs/ExceptionsDataDto.md)
 - [GeoDto](docs/GeoDto.md)
 - [GetAssetsResponse](docs/GetAssetsResponse.md)
 - [GetLeanPoliciesResponse](docs/GetLeanPoliciesResponse.md)
 - [GetLeanPolicyResponse](docs/GetLeanPolicyResponse.md)
 - [GetPoliciesResponse](docs/GetPoliciesResponse.md)
 - [GetPolicyAssetResponse](docs/GetPolicyAssetResponse.md)
 - [GetPolicyResponse](docs/GetPolicyResponse.md)
 - [LeanPolicyDto](docs/LeanPolicyDto.md)
 - [PolicyAccountsResult](docs/PolicyAccountsResult.md)
 - [PolicyAssetMappingResult](docs/PolicyAssetMappingResult.md)
 - [PolicyBaseFailureResponse](docs/PolicyBaseFailureResponse.md)
 - [PolicyDataExceptionDto](docs/PolicyDataExceptionDto.md)
 - [PolicyDto](docs/PolicyDto.md)
 - [PolicyDtoResult](docs/PolicyDtoResult.md)
 - [PolicyResult](docs/PolicyResult.md)
 - [PolicySettingsDto](docs/PolicySettingsDto.md)
 - [SettingsDataDto](docs/SettingsDataDto.md)
 - [SimpleTextErrorResponse](docs/SimpleTextErrorResponse.md)
 - [UpdatePolicyDto](docs/UpdatePolicyDto.md)
 - [UrlsDto](docs/UrlsDto.md)
 - [Value](docs/Value.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


