# coding: utf-8

"""
    Imperva Policy Management

    Create policies to centrally configure settings and apply them to multiple websites in your account. For full feature documentation, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/csh?context=policies\">Create and Manage Policies</a>.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DefaultPolicyConfigDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'account_id': 'int',
        'asset_type': 'str',
        'policy_id': 'int'
    }

    attribute_map = {
        'id': 'id',
        'account_id': 'accountId',
        'asset_type': 'assetType',
        'policy_id': 'policyId'
    }

    def __init__(self, id=None, account_id=None, asset_type=None, policy_id=None):  # noqa: E501
        """DefaultPolicyConfigDto - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._account_id = None
        self._asset_type = None
        self._policy_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if account_id is not None:
            self.account_id = account_id
        if asset_type is not None:
            self.asset_type = asset_type
        if policy_id is not None:
            self.policy_id = policy_id

    @property
    def id(self):
        """Gets the id of this DefaultPolicyConfigDto.  # noqa: E501

        The ID of this default policy configuration.  # noqa: E501

        :return: The id of this DefaultPolicyConfigDto.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DefaultPolicyConfigDto.

        The ID of this default policy configuration.  # noqa: E501

        :param id: The id of this DefaultPolicyConfigDto.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def account_id(self):
        """Gets the account_id of this DefaultPolicyConfigDto.  # noqa: E501

        The account ID  # noqa: E501

        :return: The account_id of this DefaultPolicyConfigDto.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this DefaultPolicyConfigDto.

        The account ID  # noqa: E501

        :param account_id: The account_id of this DefaultPolicyConfigDto.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def asset_type(self):
        """Gets the asset_type of this DefaultPolicyConfigDto.  # noqa: E501

        The type of asset on which the policy is applied  # noqa: E501

        :return: The asset_type of this DefaultPolicyConfigDto.  # noqa: E501
        :rtype: str
        """
        return self._asset_type

    @asset_type.setter
    def asset_type(self, asset_type):
        """Sets the asset_type of this DefaultPolicyConfigDto.

        The type of asset on which the policy is applied  # noqa: E501

        :param asset_type: The asset_type of this DefaultPolicyConfigDto.  # noqa: E501
        :type: str
        """
        allowed_values = ["WEBSITE"]  # noqa: E501
        if asset_type not in allowed_values:
            raise ValueError(
                "Invalid value for `asset_type` ({0}), must be one of {1}"  # noqa: E501
                .format(asset_type, allowed_values)
            )

        self._asset_type = asset_type

    @property
    def policy_id(self):
        """Gets the policy_id of this DefaultPolicyConfigDto.  # noqa: E501

        The ID of this policy  # noqa: E501

        :return: The policy_id of this DefaultPolicyConfigDto.  # noqa: E501
        :rtype: int
        """
        return self._policy_id

    @policy_id.setter
    def policy_id(self, policy_id):
        """Sets the policy_id of this DefaultPolicyConfigDto.

        The ID of this policy  # noqa: E501

        :param policy_id: The policy_id of this DefaultPolicyConfigDto.  # noqa: E501
        :type: int
        """

        self._policy_id = policy_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DefaultPolicyConfigDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DefaultPolicyConfigDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
