# coding: utf-8

"""
    Imperva Policy Management

    Create policies to centrally configure settings and apply them to multiple websites in your account. For full feature documentation, see <a style=\"text-decoration:none\" href=\"https://docs.imperva.com/csh?context=policies\">Create and Manage Policies</a>.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ExceptionsDataDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'exception_type': 'str',
        'values': 'list[str]'
    }

    attribute_map = {
        'exception_type': 'exceptionType',
        'values': 'values'
    }

    def __init__(self, exception_type=None, values=None):  # noqa: E501
        """ExceptionsDataDto - a model defined in Swagger"""  # noqa: E501
        self._exception_type = None
        self._values = None
        self.discriminator = None
        if exception_type is not None:
            self.exception_type = exception_type
        if values is not None:
            self.values = values

    @property
    def exception_type(self):
        """Gets the exception_type of this ExceptionsDataDto.  # noqa: E501

        The element that the exception is based on.  # noqa: E501

        :return: The exception_type of this ExceptionsDataDto.  # noqa: E501
        :rtype: str
        """
        return self._exception_type

    @exception_type.setter
    def exception_type(self, exception_type):
        """Sets the exception_type of this ExceptionsDataDto.

        The element that the exception is based on.  # noqa: E501

        :param exception_type: The exception_type of this ExceptionsDataDto.  # noqa: E501
        :type: str
        """
        allowed_values = ["GEO", "IP", "URL", "URL_NOT_EQUALS", "URL_NOT_CONTAINS", "URL_PREFIX", "URL_SUFFIX", "URL_NOT_PREFIX", "URL_NOT_SUFFIX", "URL_CONTAINS", "CLIENT_ID", "SITE_ID", "HTTP_PARAM", "USER_AGENT"]  # noqa: E501
        if exception_type not in allowed_values:
            raise ValueError(
                "Invalid value for `exception_type` ({0}), must be one of {1}"  # noqa: E501
                .format(exception_type, allowed_values)
            )

        self._exception_type = exception_type

    @property
    def values(self):
        """Gets the values of this ExceptionsDataDto.  # noqa: E501

        Values of the exception vary based on the exceptionType parameter  # noqa: E501

        :return: The values of this ExceptionsDataDto.  # noqa: E501
        :rtype: list[str]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this ExceptionsDataDto.

        Values of the exception vary based on the exceptionType parameter  # noqa: E501

        :param values: The values of this ExceptionsDataDto.  # noqa: E501
        :type: list[str]
        """

        self._values = values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExceptionsDataDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExceptionsDataDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
