# swagger-client
This is an API for Imperva Reputation Intelligence. Gain visibility into the reputation of the IPs attacking your sites to make more informed, data-driven decisions. Leverage reputation data from across the Imperva customer base and 3rd party providers to help in incident response. Reputation Intelligence is for informational purposes only and does not perform any actions. Limit: 10 requests per minute. For full feature documentation, see [Reputation Intelligence](https://docs.imperva.com/bundle/ip-reputation/page/reputation-intelligence.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
ip = 'ip_example' # str | Unique IP address. Only IPv4 addresses are supported.

try:
    # Retrieve reputation intelligence data for a specified IP.
    api_response = api_instance.get_ip_reputation(ip)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_ip_reputation: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/ip-reputation*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*V1Api* | [**get_ip_reputation**](docs/V1Api.md#get_ip_reputation) | **GET** /v1/reputation | Retrieve reputation intelligence data for a specified IP.

## Documentation For Models

 - [AsnData](docs/AsnData.md)
 - [ErrorResponseWrapper](docs/ErrorResponseWrapper.md)
 - [IPDataApi](docs/IPDataApi.md)
 - [IPGeoData](docs/IPGeoData.md)
 - [RiskData](docs/RiskData.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


