# swagger-client
This is an API for Imperva User Management

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
body = swagger_client.CreateRole() # CreateRole | The details required for creating the role.

try:
    # Create New Role
    api_response = api_instance.create_role(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->create_role: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
body = swagger_client.CreateUser() # CreateUser | The details required to create new user.

try:
    # Create New User
    api_response = api_instance.create_user(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->create_user: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
role_id = 789 # int | The role ID of the required role.

try:
    # Delete Role By Role ID
    api_response = api_instance.delete_role_by_role_id(role_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->delete_role_by_role_id: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
user_email = 'user_email_example' # str | The email of the required user
account_id = 789 # int | Unique ID of the required account

try:
    # Delete User Details By User Email
    api_response = api_instance.delete_user_by_user_email(user_email, account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->delete_user_by_user_email: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
account_id = 789 # int | Unique ID of the required account.

try:
    # Get Account Abilities By Account ID
    api_response = api_instance.get_all_available_account_abilities_by_account_id(account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_all_available_account_abilities_by_account_id: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
role_id = 789 # int | The role ID of the required role.

try:
    # Get Role Details By Role ID
    api_response = api_instance.get_role_details_by_role_id(role_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_role_details_by_role_id: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
account_id = 789 # int | Unique ID of the required account
user_email = 'user_email_example' # str | The email of the required user (optional)
role_name = 'role_name_example' # str | The name of the required role (optional)

try:
    # Get Role Details By Account ID, User Email, or Role Name
    api_response = api_instance.get_roles_details(account_id, user_email=user_email, role_name=role_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_roles_details: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
user_email = 'user_email_example' # str | The email of the required user
account_id = 789 # int | Unique ID of the required account

try:
    # Get role assignments By User Email And Account ID
    api_response = api_instance.get_user_assignment_by_user_email(user_email, account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_user_assignment_by_user_email: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
user_email = 'user_email_example' # str | The email of the required user
account_id = 789 # int | Unique ID of the required account

try:
    # Get User Details By User Email and Account ID
    api_response = api_instance.get_user_by_user_email(user_email, account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->get_user_by_user_email: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
body = [swagger_client.RequestedAssignment()] # list[RequestedAssignment] | The details required for the new assignments.

try:
    # Assign Users To Roles or Delete Existing Assignment
    api_response = api_instance.update_assignments(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->update_assignments: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.V1Api(swagger_client.ApiClient(configuration))
body = swagger_client.UpdateRole() # UpdateRole | The details required for updating the role.
role_id = 789 # int | The role ID of the required role.

try:
    # Update Role Details By Role ID
    api_response = api_instance.update_role(body, role_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling V1Api->update_role: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/user-management*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*V1Api* | [**create_role**](docs/V1Api.md#create_role) | **POST** /v1/roles | Create New Role
*V1Api* | [**create_user**](docs/V1Api.md#create_user) | **POST** /v1/users | Create New User
*V1Api* | [**delete_role_by_role_id**](docs/V1Api.md#delete_role_by_role_id) | **DELETE** /v1/roles/{roleId} | Delete Role By Role ID
*V1Api* | [**delete_user_by_user_email**](docs/V1Api.md#delete_user_by_user_email) | **DELETE** /v1/users | Delete User Details By User Email
*V1Api* | [**get_all_available_account_abilities_by_account_id**](docs/V1Api.md#get_all_available_account_abilities_by_account_id) | **GET** /v1/abilities/accounts/{accountId} | Get Account Abilities By Account ID
*V1Api* | [**get_role_details_by_role_id**](docs/V1Api.md#get_role_details_by_role_id) | **GET** /v1/roles/{roleId} | Get Role Details By Role ID
*V1Api* | [**get_roles_details**](docs/V1Api.md#get_roles_details) | **GET** /v1/roles | Get Role Details By Account ID, User Email, or Role Name
*V1Api* | [**get_user_assignment_by_user_email**](docs/V1Api.md#get_user_assignment_by_user_email) | **GET** /v1/assignments | Get role assignments By User Email And Account ID
*V1Api* | [**get_user_by_user_email**](docs/V1Api.md#get_user_by_user_email) | **GET** /v1/users | Get User Details By User Email and Account ID
*V1Api* | [**update_assignments**](docs/V1Api.md#update_assignments) | **POST** /v1/assignments | Assign Users To Roles or Delete Existing Assignment
*V1Api* | [**update_role**](docs/V1Api.md#update_role) | **POST** /v1/roles/{roleId} | Update Role Details By Role ID

## Documentation For Models

 - [Ability](docs/Ability.md)
 - [ApiSuccessResponse](docs/ApiSuccessResponse.md)
 - [CreateRole](docs/CreateRole.md)
 - [CreateUser](docs/CreateUser.md)
 - [RequestedAssignment](docs/RequestedAssignment.md)
 - [RoleDetails](docs/RoleDetails.md)
 - [RoleShortDetails](docs/RoleShortDetails.md)
 - [StackTraceElement](docs/StackTraceElement.md)
 - [Throwable](docs/Throwable.md)
 - [UpdateRole](docs/UpdateRole.md)
 - [User](docs/User.md)
 - [UserAssignment](docs/UserAssignment.md)
 - [UserManagementApiException](docs/UserManagementApiException.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


