# coding: utf-8

"""
    User Management API

    This is an API for Imperva User Management  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RoleDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'role_id': 'int',
        'role_name': 'str',
        'role_description': 'str',
        'account_id': 'int',
        'account_name': 'str',
        'role_abilities': 'list[Ability]',
        'user_assignment': 'list[UserAssignment]',
        'update_date': 'str',
        'is_editable': 'bool'
    }

    attribute_map = {
        'role_id': 'roleId',
        'role_name': 'roleName',
        'role_description': 'roleDescription',
        'account_id': 'accountId',
        'account_name': 'accountName',
        'role_abilities': 'roleAbilities',
        'user_assignment': 'userAssignment',
        'update_date': 'updateDate',
        'is_editable': 'isEditable'
    }

    def __init__(self, role_id=None, role_name=None, role_description=None, account_id=None, account_name=None, role_abilities=None, user_assignment=None, update_date=None, is_editable=None):  # noqa: E501
        """RoleDetails - a model defined in Swagger"""  # noqa: E501
        self._role_id = None
        self._role_name = None
        self._role_description = None
        self._account_id = None
        self._account_name = None
        self._role_abilities = None
        self._user_assignment = None
        self._update_date = None
        self._is_editable = None
        self.discriminator = None
        if role_id is not None:
            self.role_id = role_id
        if role_name is not None:
            self.role_name = role_name
        if role_description is not None:
            self.role_description = role_description
        if account_id is not None:
            self.account_id = account_id
        if account_name is not None:
            self.account_name = account_name
        if role_abilities is not None:
            self.role_abilities = role_abilities
        if user_assignment is not None:
            self.user_assignment = user_assignment
        if update_date is not None:
            self.update_date = update_date
        if is_editable is not None:
            self.is_editable = is_editable

    @property
    def role_id(self):
        """Gets the role_id of this RoleDetails.  # noqa: E501

        ID of the role that was acted on.  # noqa: E501

        :return: The role_id of this RoleDetails.  # noqa: E501
        :rtype: int
        """
        return self._role_id

    @role_id.setter
    def role_id(self, role_id):
        """Sets the role_id of this RoleDetails.

        ID of the role that was acted on.  # noqa: E501

        :param role_id: The role_id of this RoleDetails.  # noqa: E501
        :type: int
        """

        self._role_id = role_id

    @property
    def role_name(self):
        """Gets the role_name of this RoleDetails.  # noqa: E501

        The name of the role that was acted on.  # noqa: E501

        :return: The role_name of this RoleDetails.  # noqa: E501
        :rtype: str
        """
        return self._role_name

    @role_name.setter
    def role_name(self, role_name):
        """Sets the role_name of this RoleDetails.

        The name of the role that was acted on.  # noqa: E501

        :param role_name: The role_name of this RoleDetails.  # noqa: E501
        :type: str
        """

        self._role_name = role_name

    @property
    def role_description(self):
        """Gets the role_description of this RoleDetails.  # noqa: E501

        Description of the role.  # noqa: E501

        :return: The role_description of this RoleDetails.  # noqa: E501
        :rtype: str
        """
        return self._role_description

    @role_description.setter
    def role_description(self, role_description):
        """Sets the role_description of this RoleDetails.

        Description of the role.  # noqa: E501

        :param role_description: The role_description of this RoleDetails.  # noqa: E501
        :type: str
        """

        self._role_description = role_description

    @property
    def account_id(self):
        """Gets the account_id of this RoleDetails.  # noqa: E501

        ID of the account that was acted on.  # noqa: E501

        :return: The account_id of this RoleDetails.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this RoleDetails.

        ID of the account that was acted on.  # noqa: E501

        :param account_id: The account_id of this RoleDetails.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def account_name(self):
        """Gets the account_name of this RoleDetails.  # noqa: E501

        The name of the account that was acted on.  # noqa: E501

        :return: The account_name of this RoleDetails.  # noqa: E501
        :rtype: str
        """
        return self._account_name

    @account_name.setter
    def account_name(self, account_name):
        """Sets the account_name of this RoleDetails.

        The name of the account that was acted on.  # noqa: E501

        :param account_name: The account_name of this RoleDetails.  # noqa: E501
        :type: str
        """

        self._account_name = account_name

    @property
    def role_abilities(self):
        """Gets the role_abilities of this RoleDetails.  # noqa: E501

        The abilities that the role contains.  # noqa: E501

        :return: The role_abilities of this RoleDetails.  # noqa: E501
        :rtype: list[Ability]
        """
        return self._role_abilities

    @role_abilities.setter
    def role_abilities(self, role_abilities):
        """Sets the role_abilities of this RoleDetails.

        The abilities that the role contains.  # noqa: E501

        :param role_abilities: The role_abilities of this RoleDetails.  # noqa: E501
        :type: list[Ability]
        """

        self._role_abilities = role_abilities

    @property
    def user_assignment(self):
        """Gets the user_assignment of this RoleDetails.  # noqa: E501

        The emails and account ids of users assigned to the role.  # noqa: E501

        :return: The user_assignment of this RoleDetails.  # noqa: E501
        :rtype: list[UserAssignment]
        """
        return self._user_assignment

    @user_assignment.setter
    def user_assignment(self, user_assignment):
        """Sets the user_assignment of this RoleDetails.

        The emails and account ids of users assigned to the role.  # noqa: E501

        :param user_assignment: The user_assignment of this RoleDetails.  # noqa: E501
        :type: list[UserAssignment]
        """

        self._user_assignment = user_assignment

    @property
    def update_date(self):
        """Gets the update_date of this RoleDetails.  # noqa: E501

        The last update date of this role.  # noqa: E501

        :return: The update_date of this RoleDetails.  # noqa: E501
        :rtype: str
        """
        return self._update_date

    @update_date.setter
    def update_date(self, update_date):
        """Sets the update_date of this RoleDetails.

        The last update date of this role.  # noqa: E501

        :param update_date: The update_date of this RoleDetails.  # noqa: E501
        :type: str
        """

        self._update_date = update_date

    @property
    def is_editable(self):
        """Gets the is_editable of this RoleDetails.  # noqa: E501

        Whether or not the role can be modified.  # noqa: E501

        :return: The is_editable of this RoleDetails.  # noqa: E501
        :rtype: bool
        """
        return self._is_editable

    @is_editable.setter
    def is_editable(self, is_editable):
        """Sets the is_editable of this RoleDetails.

        Whether or not the role can be modified.  # noqa: E501

        :param is_editable: The is_editable of this RoleDetails.  # noqa: E501
        :type: bool
        """

        self._is_editable = is_editable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RoleDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
