# coding: utf-8

"""
    User Management API

    This is an API for Imperva User Management  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class User(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_id': 'int',
        'account_id': 'int',
        'first_name': 'str',
        'last_name': 'str',
        'user_email': 'str',
        'roles_details': 'list[RoleShortDetails]'
    }

    attribute_map = {
        'user_id': 'userId',
        'account_id': 'accountId',
        'first_name': 'firstName',
        'last_name': 'lastName',
        'user_email': 'userEmail',
        'roles_details': 'rolesDetails'
    }

    def __init__(self, user_id=None, account_id=None, first_name=None, last_name=None, user_email=None, roles_details=None):  # noqa: E501
        """User - a model defined in Swagger"""  # noqa: E501
        self._user_id = None
        self._account_id = None
        self._first_name = None
        self._last_name = None
        self._user_email = None
        self._roles_details = None
        self.discriminator = None
        if user_id is not None:
            self.user_id = user_id
        if account_id is not None:
            self.account_id = account_id
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if user_email is not None:
            self.user_email = user_email
        self.roles_details = roles_details

    @property
    def user_id(self):
        """Gets the user_id of this User.  # noqa: E501

        The ID of the user that the action was done in.  # noqa: E501

        :return: The user_id of this User.  # noqa: E501
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this User.

        The ID of the user that the action was done in.  # noqa: E501

        :param user_id: The user_id of this User.  # noqa: E501
        :type: int
        """

        self._user_id = user_id

    @property
    def account_id(self):
        """Gets the account_id of this User.  # noqa: E501

        ID of the account that was acted on.  # noqa: E501

        :return: The account_id of this User.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this User.

        ID of the account that was acted on.  # noqa: E501

        :param account_id: The account_id of this User.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def first_name(self):
        """Gets the first_name of this User.  # noqa: E501

        The first name of the user.  # noqa: E501

        :return: The first_name of this User.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this User.

        The first name of the user.  # noqa: E501

        :param first_name: The first_name of this User.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this User.  # noqa: E501

        The last name of the user.  # noqa: E501

        :return: The last_name of this User.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this User.

        The last name of the user.  # noqa: E501

        :param last_name: The last_name of this User.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def user_email(self):
        """Gets the user_email of this User.  # noqa: E501

        The userEmail of the user that was acted on.  # noqa: E501

        :return: The user_email of this User.  # noqa: E501
        :rtype: str
        """
        return self._user_email

    @user_email.setter
    def user_email(self, user_email):
        """Sets the user_email of this User.

        The userEmail of the user that was acted on.  # noqa: E501

        :param user_email: The user_email of this User.  # noqa: E501
        :type: str
        """

        self._user_email = user_email

    @property
    def roles_details(self):
        """Gets the roles_details of this User.  # noqa: E501


        :return: The roles_details of this User.  # noqa: E501
        :rtype: list[RoleShortDetails]
        """
        return self._roles_details

    @roles_details.setter
    def roles_details(self, roles_details):
        """Sets the roles_details of this User.


        :param roles_details: The roles_details of this User.  # noqa: E501
        :type: list[RoleShortDetails]
        """
        if roles_details is None:
            raise ValueError("Invalid value for `roles_details`, must not be `None`")  # noqa: E501

        self._roles_details = roles_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(User, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, User):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
