# swagger-client
Set up and manage the Imperva SIEM log integration.  - Create, view, and edit connections to your log storage repository.  - Configure which logs you want to receive from Imperva, and where to receive them.  For full feature documentation, see  [Near Real-Time SIEM Log Integration](https://docs.imperva.com/bundle/cloud-application-security/page/siem-log-configuration.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectionsApi(swagger_client.ApiClient(configuration))
body = swagger_client.ConnectionDtoResponse() # ConnectionDtoResponse | JSON body. Schema is identical to the response.

try:
    # Create connection
    api_response = api_instance.create1(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConnectionsApi->create1: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectionsApi(swagger_client.ApiClient(configuration))
connection_id = 'connection_id_example' # str | The unique ID for the connection, assigned by Imperva. To find the connection ID, run GET /v3/connections

try:
    # Delete connection
    api_instance.delete1(connection_id)
except ApiException as e:
    print("Exception when calling ConnectionsApi->delete1: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectionsApi(swagger_client.ApiClient(configuration))
connection_id = 'connection_id_example' # str | The unique ID for the connection, assigned by Imperva. To find the connection ID, run GET /v3/connections

try:
    # Retrieve connection
    api_response = api_instance.get1(connection_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConnectionsApi->get1: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectionsApi(swagger_client.ApiClient(configuration))

try:
    # Retrieve all connections
    api_response = api_instance.get_all1()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConnectionsApi->get_all1: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectionsApi(swagger_client.ApiClient(configuration))
body = swagger_client.ConnectionDtoResponse() # ConnectionDtoResponse | JSON body. Schema is identical to the response.
connection_id = 'connection_id_example' # str | The unique ID for the connection, assigned by Imperva. To find the connection ID, run GET /v3/connections

try:
    # Overwrite connection
    api_response = api_instance.update1(body, connection_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConnectionsApi->update1: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/siem-config-service*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ConnectionsApi* | [**create1**](docs/ConnectionsApi.md#create1) | **POST** /v3/connections/ | Create connection
*ConnectionsApi* | [**delete1**](docs/ConnectionsApi.md#delete1) | **DELETE** /v3/connections/{connectionId} | Delete connection
*ConnectionsApi* | [**get1**](docs/ConnectionsApi.md#get1) | **GET** /v3/connections/{connectionId} | Retrieve connection
*ConnectionsApi* | [**get_all1**](docs/ConnectionsApi.md#get_all1) | **GET** /v3/connections/ | Retrieve all connections
*ConnectionsApi* | [**update1**](docs/ConnectionsApi.md#update1) | **PUT** /v3/connections/{connectionId} | Overwrite connection
*LogConfigurationsApi* | [**create**](docs/LogConfigurationsApi.md#create) | **POST** /v3/log-configurations/ | Create log configuration
*LogConfigurationsApi* | [**delete**](docs/LogConfigurationsApi.md#delete) | **DELETE** /v3/log-configurations/{configurationId} | Delete log configuration
*LogConfigurationsApi* | [**get**](docs/LogConfigurationsApi.md#get) | **GET** /v3/log-configurations/{configurationId} | Retrieve log configuration
*LogConfigurationsApi* | [**get_all**](docs/LogConfigurationsApi.md#get_all) | **GET** /v3/log-configurations/ | Retrieve all log configurations
*LogConfigurationsApi* | [**update**](docs/LogConfigurationsApi.md#update) | **PUT** /v3/log-configurations/{configurationId} | Overwrite log configuration

## Documentation For Models

 - [ApiError](docs/ApiError.md)
 - [ApiErrorResponse](docs/ApiErrorResponse.md)
 - [ArnConnectionInfoDto](docs/ArnConnectionInfoDto.md)
 - [ConnectionDto](docs/ConnectionDto.md)
 - [ConnectionDtoResponse](docs/ConnectionDtoResponse.md)
 - [CustomerS3ArnConnectionDto](docs/CustomerS3ArnConnectionDto.md)
 - [CustomerS3BasicAuthDto](docs/CustomerS3BasicAuthDto.md)
 - [LogConfigurationDto](docs/LogConfigurationDto.md)
 - [LogConfigurationDtoResponse](docs/LogConfigurationDtoResponse.md)
 - [OneOfConnectionDto](docs/OneOfConnectionDto.md)
 - [S3ConnectionInfoDto](docs/S3ConnectionInfoDto.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


