# coding: utf-8

"""
    Imperva SIEM Configurations API 3.0

    Set up and manage the Imperva SIEM log integration.  - Create, view, and edit connections to your log storage repository.  - Configure which logs you want to receive from Imperva, and where to receive them.  For full feature documentation, see  [Near Real-Time SIEM Log Integration](https://docs.imperva.com/bundle/cloud-application-security/page/siem-log-configuration.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ConnectionDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'connection_name': 'str',
        'storage_type': 'str'
    }

    attribute_map = {
        'connection_name': 'connectionName',
        'storage_type': 'storageType'
    }

    discriminator_value_class_map = {
          'CustomerS3BasicAuthDto': 'CustomerS3BasicAuthDto',
'CustomerS3ArnConnectionDto': 'CustomerS3ArnConnectionDto'    }

    def __init__(self, connection_name=None, storage_type=None):  # noqa: E501
        """ConnectionDto - a model defined in Swagger"""  # noqa: E501
        self._connection_name = None
        self._storage_type = None
        self.discriminator = 'storage_type'
        self.connection_name = connection_name
        self.storage_type = storage_type

    @property
    def connection_name(self):
        """Gets the connection_name of this ConnectionDto.  # noqa: E501

        Connection name.  # noqa: E501

        :return: The connection_name of this ConnectionDto.  # noqa: E501
        :rtype: str
        """
        return self._connection_name

    @connection_name.setter
    def connection_name(self, connection_name):
        """Sets the connection_name of this ConnectionDto.

        Connection name.  # noqa: E501

        :param connection_name: The connection_name of this ConnectionDto.  # noqa: E501
        :type: str
        """
        if connection_name is None:
            raise ValueError("Invalid value for `connection_name`, must not be `None`")  # noqa: E501

        self._connection_name = connection_name

    @property
    def storage_type(self):
        """Gets the storage_type of this ConnectionDto.  # noqa: E501

        Storage type.  # noqa: E501

        :return: The storage_type of this ConnectionDto.  # noqa: E501
        :rtype: str
        """
        return self._storage_type

    @storage_type.setter
    def storage_type(self, storage_type):
        """Sets the storage_type of this ConnectionDto.

        Storage type.  # noqa: E501

        :param storage_type: The storage_type of this ConnectionDto.  # noqa: E501
        :type: str
        """
        if storage_type is None:
            raise ValueError("Invalid value for `storage_type`, must not be `None`")  # noqa: E501
        allowed_values = ["CUSTOMER_S3", "CUSTOMER_S3_ARN"]  # noqa: E501
        if storage_type not in allowed_values:
            raise ValueError(
                "Invalid value for `storage_type` ({0}), must be one of {1}"  # noqa: E501
                .format(storage_type, allowed_values)
            )

        self._storage_type = storage_type

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_value = data[self.discriminator].lower()
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ConnectionDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConnectionDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
