# coding: utf-8

"""
    Imperva SIEM Configurations API 3.0

    Set up and manage the Imperva SIEM log integration.  - Create, view, and edit connections to your log storage repository.  - Configure which logs you want to receive from Imperva, and where to receive them.  For full feature documentation, see  [Near Real-Time SIEM Log Integration](https://docs.imperva.com/bundle/cloud-application-security/page/siem-log-configuration.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from swagger_client.models.connection_dto import ConnectionDto  # noqa: F401,E501

class CustomerS3ArnConnectionDto(ConnectionDto):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'connection_info': 'ArnConnectionInfoDto'
    }
    if hasattr(ConnectionDto, "swagger_types"):
        swagger_types.update(ConnectionDto.swagger_types)

    attribute_map = {
        'connection_info': 'connectionInfo'
    }
    if hasattr(ConnectionDto, "attribute_map"):
        attribute_map.update(ConnectionDto.attribute_map)

    def __init__(self, connection_info=None, *args, **kwargs):  # noqa: E501
        """CustomerS3ArnConnectionDto - a model defined in Swagger"""  # noqa: E501
        self._connection_info = None
        self.discriminator = None
        self.connection_info = connection_info
        ConnectionDto.__init__(self, *args, **kwargs)

    @property
    def connection_info(self):
        """Gets the connection_info of this CustomerS3ArnConnectionDto.  # noqa: E501


        :return: The connection_info of this CustomerS3ArnConnectionDto.  # noqa: E501
        :rtype: ArnConnectionInfoDto
        """
        return self._connection_info

    @connection_info.setter
    def connection_info(self, connection_info):
        """Sets the connection_info of this CustomerS3ArnConnectionDto.


        :param connection_info: The connection_info of this CustomerS3ArnConnectionDto.  # noqa: E501
        :type: ArnConnectionInfoDto
        """
        if connection_info is None:
            raise ValueError("Invalid value for `connection_info`, must not be `None`")  # noqa: E501

        self._connection_info = connection_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomerS3ArnConnectionDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomerS3ArnConnectionDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
