# coding: utf-8

"""
    Imperva SIEM Configurations API 3.0

    Set up and manage the Imperva SIEM log integration.  - Create, view, and edit connections to your log storage repository.  - Configure which logs you want to receive from Imperva, and where to receive them.  For full feature documentation, see  [Near Real-Time SIEM Log Integration](https://docs.imperva.com/bundle/cloud-application-security/page/siem-log-configuration.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class S3ConnectionInfoDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'access_key': 'str',
        'secret_key': 'str',
        'path': 'str'
    }

    attribute_map = {
        'access_key': 'accessKey',
        'secret_key': 'secretKey',
        'path': 'path'
    }

    def __init__(self, access_key=None, secret_key=None, path=None):  # noqa: E501
        """S3ConnectionInfoDto - a model defined in Swagger"""  # noqa: E501
        self._access_key = None
        self._secret_key = None
        self._path = None
        self.discriminator = None
        self.access_key = access_key
        self.secret_key = secret_key
        self.path = path

    @property
    def access_key(self):
        """Gets the access_key of this S3ConnectionInfoDto.  # noqa: E501

        The access key for S3.  # noqa: E501

        :return: The access_key of this S3ConnectionInfoDto.  # noqa: E501
        :rtype: str
        """
        return self._access_key

    @access_key.setter
    def access_key(self, access_key):
        """Sets the access_key of this S3ConnectionInfoDto.

        The access key for S3.  # noqa: E501

        :param access_key: The access_key of this S3ConnectionInfoDto.  # noqa: E501
        :type: str
        """
        if access_key is None:
            raise ValueError("Invalid value for `access_key`, must not be `None`")  # noqa: E501

        self._access_key = access_key

    @property
    def secret_key(self):
        """Gets the secret_key of this S3ConnectionInfoDto.  # noqa: E501

        The secret key for S3.  # noqa: E501

        :return: The secret_key of this S3ConnectionInfoDto.  # noqa: E501
        :rtype: str
        """
        return self._secret_key

    @secret_key.setter
    def secret_key(self, secret_key):
        """Sets the secret_key of this S3ConnectionInfoDto.

        The secret key for S3.  # noqa: E501

        :param secret_key: The secret_key of this S3ConnectionInfoDto.  # noqa: E501
        :type: str
        """
        if secret_key is None:
            raise ValueError("Invalid value for `secret_key`, must not be `None`")  # noqa: E501

        self._secret_key = secret_key

    @property
    def path(self):
        """Gets the path of this S3ConnectionInfoDto.  # noqa: E501

        The secret key for S3.  # noqa: E501

        :return: The path of this S3ConnectionInfoDto.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this S3ConnectionInfoDto.

        The secret key for S3.  # noqa: E501

        :param path: The path of this S3ConnectionInfoDto.  # noqa: E501
        :type: str
        """
        if path is None:
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(S3ConnectionInfoDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, S3ConnectionInfoDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
