# swagger-client
Access the subscription data for your account using the API. For the full feature documentation, see [Subscription status](https://docs.imperva.com/bundle/cloud-application-security/page/settings/subscription.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SubscriptionResourcesApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Account ID. Unique identifier of the account to operate on.
subscription_id = 'subscription_id_example' # str | Subscription ID. Unique identifier of the subscription. Run the GET /v3/subscriptions API to locate the value of the ‘id’ parameter in the response.

try:
    # Retrieve a subscription's resources
    api_response = api_instance.get_subscription_resources(caid, subscription_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SubscriptionResourcesApi->get_subscription_resources: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/subscription-management*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SubscriptionResourcesApi* | [**get_subscription_resources**](docs/SubscriptionResourcesApi.md#get_subscription_resources) | **GET** /v3/subscriptions/{subscription-id}/resources | Retrieve a subscription&#x27;s resources
*SubscriptionsApi* | [**get**](docs/SubscriptionsApi.md#get) | **GET** /v3/subscriptions/{subscription-id} | Retrieve a subscription
*SubscriptionsApi* | [**get_all**](docs/SubscriptionsApi.md#get_all) | **GET** /v3/subscriptions | Retrieve all subscriptions

## Documentation For Models

 - [BooleanSubscriptionResourceValueDto](docs/BooleanSubscriptionResourceValueDto.md)
 - [EnumSubscriptionResourceValueDto](docs/EnumSubscriptionResourceValueDto.md)
 - [ImpervaApiBodyListSubscription](docs/ImpervaApiBodyListSubscription.md)
 - [ImpervaApiBodyListSubscriptionResourceDto](docs/ImpervaApiBodyListSubscriptionResourceDto.md)
 - [ImpervaApiBodySubscription](docs/ImpervaApiBodySubscription.md)
 - [NumberSubscriptionResourceValueDto](docs/NumberSubscriptionResourceValueDto.md)
 - [OneOfSubscriptionResourceDtoSubscriptionResourceValue](docs/OneOfSubscriptionResourceDtoSubscriptionResourceValue.md)
 - [Subscription](docs/Subscription.md)
 - [SubscriptionResourceDto](docs/SubscriptionResourceDto.md)
 - [SubscriptionResourceValueDto](docs/SubscriptionResourceValueDto.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


