# swagger-client
Gain more visibility into connectivity issues that occur when Imperva data centers cannot reach your origin web servers. For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/troubleshoot.htm\">Troubleshoot Website Errors.</a>

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.ConnectivityTestsApi(swagger_client.ApiClient(configuration))
body = swagger_client.ConnectivityTestSearch() # ConnectivityTestSearch | Filters
asset_type = 'asset_type_example' # str | 
asset_id = 789 # int | Numeric identifier of the site to retrieve.

try:
    # Retrieve connectivity tests for a given website.
    api_response = api_instance.get_connectivity_check_api_result(body, asset_type, asset_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ConnectivityTestsApi->get_connectivity_check_api_result: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/troubleshooting-center*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ConnectivityTestsApi* | [**get_connectivity_check_api_result**](docs/ConnectivityTestsApi.md#get_connectivity_check_api_result) | **POST** /v3/connectivityTests/{assetType}/{assetId} | Retrieve connectivity tests for a given website.

## Documentation For Models

 - [APIError](docs/APIError.md)
 - [ApiResult](docs/ApiResult.md)
 - [Check](docs/Check.md)
 - [ConnectivityTest](docs/ConnectivityTest.md)
 - [ConnectivityTestSearch](docs/ConnectivityTestSearch.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [Meta](docs/Meta.md)
 - [Pop](docs/Pop.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


