# coding: utf-8

"""
    Imperva Troubleshooting Page API

    Gain more visibility into connectivity issues that occur when Imperva data centers cannot reach your origin web servers. For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/troubleshoot.htm\">Troubleshoot Website Errors.</a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class ConnectivityTestsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_connectivity_check_api_result(self, body, asset_type, asset_id, **kwargs):  # noqa: E501
        """Retrieve connectivity tests for a given website.  # noqa: E501

        Retrieves details of connectivity tests of a given website.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_connectivity_check_api_result(body, asset_type, asset_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ConnectivityTestSearch body: Filters (required)
        :param str asset_type: (required)
        :param int asset_id: Numeric identifier of the site to retrieve. (required)
        :return: ApiResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_connectivity_check_api_result_with_http_info(body, asset_type, asset_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_connectivity_check_api_result_with_http_info(body, asset_type, asset_id, **kwargs)  # noqa: E501
            return data

    def get_connectivity_check_api_result_with_http_info(self, body, asset_type, asset_id, **kwargs):  # noqa: E501
        """Retrieve connectivity tests for a given website.  # noqa: E501

        Retrieves details of connectivity tests of a given website.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_connectivity_check_api_result_with_http_info(body, asset_type, asset_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ConnectivityTestSearch body: Filters (required)
        :param str asset_type: (required)
        :param int asset_id: Numeric identifier of the site to retrieve. (required)
        :return: ApiResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'asset_type', 'asset_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_connectivity_check_api_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_connectivity_check_api_result`")  # noqa: E501
        # verify the required parameter 'asset_type' is set
        if ('asset_type' not in params or
                params['asset_type'] is None):
            raise ValueError("Missing the required parameter `asset_type` when calling `get_connectivity_check_api_result`")  # noqa: E501
        # verify the required parameter 'asset_id' is set
        if ('asset_id' not in params or
                params['asset_id'] is None):
            raise ValueError("Missing the required parameter `asset_id` when calling `get_connectivity_check_api_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'asset_type' in params:
            path_params['assetType'] = params['asset_type']  # noqa: E501
        if 'asset_id' in params:
            path_params['assetId'] = params['asset_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_id', 'api_key']  # noqa: E501

        return self.api_client.call_api(
            '/v3/connectivityTests/{assetType}/{assetId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiResult',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
