# coding: utf-8

"""
    Imperva Troubleshooting Page API

    Gain more visibility into connectivity issues that occur when Imperva data centers cannot reach your origin web servers. For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/troubleshoot.htm\">Troubleshoot Website Errors.</a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Check(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'check_type': 'str',
        'check': 'str'
    }

    attribute_map = {
        'check_type': 'check_type',
        'check': 'check'
    }

    def __init__(self, check_type=None, check=None):  # noqa: E501
        """Check - a model defined in Swagger"""  # noqa: E501
        self._check_type = None
        self._check = None
        self.discriminator = None
        if check_type is not None:
            self.check_type = check_type
        if check is not None:
            self.check = check

    @property
    def check_type(self):
        """Gets the check_type of this Check.  # noqa: E501


        :return: The check_type of this Check.  # noqa: E501
        :rtype: str
        """
        return self._check_type

    @check_type.setter
    def check_type(self, check_type):
        """Sets the check_type of this Check.


        :param check_type: The check_type of this Check.  # noqa: E501
        :type: str
        """
        allowed_values = ["PING", "MTR", "MTR_TCP"]  # noqa: E501
        if check_type not in allowed_values:
            raise ValueError(
                "Invalid value for `check_type` ({0}), must be one of {1}"  # noqa: E501
                .format(check_type, allowed_values)
            )

        self._check_type = check_type

    @property
    def check(self):
        """Gets the check of this Check.  # noqa: E501


        :return: The check of this Check.  # noqa: E501
        :rtype: str
        """
        return self._check

    @check.setter
    def check(self, check):
        """Sets the check of this Check.


        :param check: The check of this Check.  # noqa: E501
        :type: str
        """

        self._check = check

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Check, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Check):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
