# coding: utf-8

"""
    Imperva Troubleshooting Page API

    Gain more visibility into connectivity issues that occur when Imperva data centers cannot reach your origin web servers. For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/troubleshoot.htm\">Troubleshoot Website Errors.</a>  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Meta(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'page': 'int',
        'limit': 'int',
        'total_pages': 'int'
    }

    attribute_map = {
        'page': 'page',
        'limit': 'limit',
        'total_pages': 'totalPages'
    }

    def __init__(self, page=None, limit=None, total_pages=None):  # noqa: E501
        """Meta - a model defined in Swagger"""  # noqa: E501
        self._page = None
        self._limit = None
        self._total_pages = None
        self.discriminator = None
        if page is not None:
            self.page = page
        if limit is not None:
            self.limit = limit
        if total_pages is not None:
            self.total_pages = total_pages

    @property
    def page(self):
        """Gets the page of this Meta.  # noqa: E501

        The page returned  # noqa: E501

        :return: The page of this Meta.  # noqa: E501
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this Meta.

        The page returned  # noqa: E501

        :param page: The page of this Meta.  # noqa: E501
        :type: int
        """

        self._page = page

    @property
    def limit(self):
        """Gets the limit of this Meta.  # noqa: E501

        The number of connectivity test returned per page  # noqa: E501

        :return: The limit of this Meta.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this Meta.

        The number of connectivity test returned per page  # noqa: E501

        :param limit: The limit of this Meta.  # noqa: E501
        :type: int
        """

        self._limit = limit

    @property
    def total_pages(self):
        """Gets the total_pages of this Meta.  # noqa: E501

        The total number of pages in search result  # noqa: E501

        :return: The total_pages of this Meta.  # noqa: E501
        :rtype: int
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this Meta.

        The total number of pages in search result  # noqa: E501

        :param total_pages: The total_pages of this Meta.  # noqa: E501
        :type: int
        """

        self._total_pages = total_pages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Meta, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Meta):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
