# swagger-client
Access the usage history for your account using the API. For the full feature documentation, see [View Account Usage](https://docs.imperva.com/bundle/cloud-application-security/page/usage-report.htm).

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.UsageRecordsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Account ID. Unique identifier of the account to operate on.
subscription_usage_record_id = 'subscription_usage_record_id_example' # str | Unique identifier of the subscription usage record. Run the GET /v3/subscription-usage-record API to locate the value of the ‘id’ parameter in the response.
resource = 'resource_example' # str | Resource ID.

try:
    # Retrieve a usage record's detailed information.
    api_response = api_instance.get_detailed_usage(caid, subscription_usage_record_id, resource)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling UsageRecordsApi->get_detailed_usage: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.UsageRecordsApi(swagger_client.ApiClient(configuration))
caid = 789 # int | Account ID. Unique identifier of the account to operate on.
_from = '2013-10-20' # date | Earliest time boundary, specified as an ISO Date Format yyyy-MM-dd. (optional)
to = '2013-10-20' # date | Latest time boundary, specified as an ISO Date Format yyyy-MM-dd. (optional)
resource = 'resource_example' # str | Resource ID. Possible values : advanced_bot_protection_connector, api_security_anywhere ,bot_management ,infra_protect_always_on_bandwidth, on_demand_throughput, throughput (optional)

try:
    # Retrieve a summary of usage records.
    api_response = api_instance.get_usage_summary(caid, _from=_from, to=to, resource=resource)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling UsageRecordsApi->get_usage_summary: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/usage-management*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*UsageRecordsApi* | [**get_detailed_usage**](docs/UsageRecordsApi.md#get_detailed_usage) | **GET** /v3/subscription-usage-records/{subscription-usage-record-id}/detailed-usage | Retrieve a usage record&#x27;s detailed information.
*UsageRecordsApi* | [**get_usage_summary**](docs/UsageRecordsApi.md#get_usage_summary) | **GET** /v3/subscription-usage-records | Retrieve a summary of usage records.

## Documentation For Models

 - [Bucket](docs/Bucket.md)
 - [DetailedResourceUsage](docs/DetailedResourceUsage.md)
 - [DetailedSubscriptionUsage](docs/DetailedSubscriptionUsage.md)
 - [ImpervaApiBodyListDetailedSubscriptionUsage](docs/ImpervaApiBodyListDetailedSubscriptionUsage.md)
 - [ImpervaApiBodyListSubscriptionUsageRecord](docs/ImpervaApiBodyListSubscriptionUsageRecord.md)
 - [ResourceUsageRecord](docs/ResourceUsageRecord.md)
 - [SubscriptionUsageRecord](docs/SubscriptionUsageRecord.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


