# coding: utf-8

"""
    Imperva Usage Management API

    Access the usage history for your account using the API. For the full feature documentation, see [View Account Usage](https://docs.imperva.com/bundle/cloud-application-security/page/usage-report.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DetailedResourceUsage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'resource_id': 'str',
        'data_unit': 'str',
        'bucket_list': 'list[Bucket]'
    }

    attribute_map = {
        'id': 'id',
        'resource_id': 'resource_id',
        'data_unit': 'data_unit',
        'bucket_list': 'bucket_list'
    }

    def __init__(self, id=None, resource_id=None, data_unit=None, bucket_list=None):  # noqa: E501
        """DetailedResourceUsage - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._resource_id = None
        self._data_unit = None
        self._bucket_list = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if resource_id is not None:
            self.resource_id = resource_id
        if data_unit is not None:
            self.data_unit = data_unit
        if bucket_list is not None:
            self.bucket_list = bucket_list

    @property
    def id(self):
        """Gets the id of this DetailedResourceUsage.  # noqa: E501

        Usage record ID of the resource.  # noqa: E501

        :return: The id of this DetailedResourceUsage.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DetailedResourceUsage.

        Usage record ID of the resource.  # noqa: E501

        :param id: The id of this DetailedResourceUsage.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def resource_id(self):
        """Gets the resource_id of this DetailedResourceUsage.  # noqa: E501

        The measured resource ID.  # noqa: E501

        :return: The resource_id of this DetailedResourceUsage.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this DetailedResourceUsage.

        The measured resource ID.  # noqa: E501

        :param resource_id: The resource_id of this DetailedResourceUsage.  # noqa: E501
        :type: str
        """

        self._resource_id = resource_id

    @property
    def data_unit(self):
        """Gets the data_unit of this DetailedResourceUsage.  # noqa: E501

        The measurement unit of the data. Possible values: Mbps, Gb, M Requests.  # noqa: E501

        :return: The data_unit of this DetailedResourceUsage.  # noqa: E501
        :rtype: str
        """
        return self._data_unit

    @data_unit.setter
    def data_unit(self, data_unit):
        """Sets the data_unit of this DetailedResourceUsage.

        The measurement unit of the data. Possible values: Mbps, Gb, M Requests.  # noqa: E501

        :param data_unit: The data_unit of this DetailedResourceUsage.  # noqa: E501
        :type: str
        """

        self._data_unit = data_unit

    @property
    def bucket_list(self):
        """Gets the bucket_list of this DetailedResourceUsage.  # noqa: E501

        List of usage values per a unit of time (bucket).  # noqa: E501

        :return: The bucket_list of this DetailedResourceUsage.  # noqa: E501
        :rtype: list[Bucket]
        """
        return self._bucket_list

    @bucket_list.setter
    def bucket_list(self, bucket_list):
        """Sets the bucket_list of this DetailedResourceUsage.

        List of usage values per a unit of time (bucket).  # noqa: E501

        :param bucket_list: The bucket_list of this DetailedResourceUsage.  # noqa: E501
        :type: list[Bucket]
        """

        self._bucket_list = bucket_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DetailedResourceUsage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DetailedResourceUsage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
