# coding: utf-8

"""
    Imperva Usage Management API

    Access the usage history for your account using the API. For the full feature documentation, see [View Account Usage](https://docs.imperva.com/bundle/cloud-application-security/page/usage-report.htm).  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DetailedSubscriptionUsage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'resource_usage_records': 'list[DetailedResourceUsage]'
    }

    attribute_map = {
        'id': 'id',
        'resource_usage_records': 'resource_usage_records'
    }

    def __init__(self, id=None, resource_usage_records=None):  # noqa: E501
        """DetailedSubscriptionUsage - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._resource_usage_records = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if resource_usage_records is not None:
            self.resource_usage_records = resource_usage_records

    @property
    def id(self):
        """Gets the id of this DetailedSubscriptionUsage.  # noqa: E501

        Usage record ID of the subscription  # noqa: E501

        :return: The id of this DetailedSubscriptionUsage.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DetailedSubscriptionUsage.

        Usage record ID of the subscription  # noqa: E501

        :param id: The id of this DetailedSubscriptionUsage.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def resource_usage_records(self):
        """Gets the resource_usage_records of this DetailedSubscriptionUsage.  # noqa: E501

        List of detailed resource usage records.  # noqa: E501

        :return: The resource_usage_records of this DetailedSubscriptionUsage.  # noqa: E501
        :rtype: list[DetailedResourceUsage]
        """
        return self._resource_usage_records

    @resource_usage_records.setter
    def resource_usage_records(self, resource_usage_records):
        """Sets the resource_usage_records of this DetailedSubscriptionUsage.

        List of detailed resource usage records.  # noqa: E501

        :param resource_usage_records: The resource_usage_records of this DetailedSubscriptionUsage.  # noqa: E501
        :type: list[DetailedResourceUsage]
        """

        self._resource_usage_records = resource_usage_records

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DetailedSubscriptionUsage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DetailedSubscriptionUsage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
