# swagger-client
Manage the domains that are sharing the CNAME of an onboarded website.<br/>All domains that are using the same CNAME share the website configuration settings and policies of the onboarded website.<br/>For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/website-general-settings.htm\">Website General Settings</a>.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.DomainsApi(swagger_client.ApiClient(configuration))
body = swagger_client.AddSiteDomainDetails() # AddSiteDomainDetails | 
site_id = 789 # int | The Imperva ID of the onboarded website.

try:
    # Add domain to a given website
    api_response = api_instance.add_site_domain(body, site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DomainsApi->add_site_domain: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.DomainsApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The Imperva ID of the onboarded website.
domain_id = 789 # int | The Imperva ID of the domain. You can retrieve the domain ID using the GET /domains call.

try:
    # Delete a domain from a website
    api_instance.delete_site_domain(site_id, domain_id)
except ApiException as e:
    print("Exception when calling DomainsApi->delete_site_domain: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.DomainsApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The Imperva ID of the onboarded website.
domain_id = 789 # int | The Imperva ID of the domain. You can retrieve the domain ID using the GET /domains call.

try:
    #  Retrieve details of a given domain
    api_response = api_instance.get_site_domain(site_id, domain_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DomainsApi->get_site_domain: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.DomainsApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | The Imperva ID of the onboarded website.
page_number = 56 # int | The page to return starting from 0.<br/><br/>In order to view the full results, run the API call with page_num set to 0,<br/>then again with page_num set to 1, and so forth.<br/><br/>Default: 0 (optional)
page_size = 56 # int | The number of objects to return in the response.<br/><br/>Default: 50<br/><br/>Maximum: 100 (optional)

try:
    # List domains for a given website
    api_response = api_instance.list_site_domains(site_id, page_number=page_number, page_size=page_size)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DomainsApi->list_site_domains: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/site-domain-manager*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DomainsApi* | [**add_site_domain**](docs/DomainsApi.md#add_site_domain) | **POST** /v2/sites/{siteId}/domains | Add domain to a given website
*DomainsApi* | [**delete_site_domain**](docs/DomainsApi.md#delete_site_domain) | **DELETE** /v2/sites/{siteId}/domains/{domainId} | Delete a domain from a website
*DomainsApi* | [**get_site_domain**](docs/DomainsApi.md#get_site_domain) | **GET** /v2/sites/{siteId}/domains/{domainId} |  Retrieve details of a given domain
*DomainsApi* | [**list_site_domains**](docs/DomainsApi.md#list_site_domains) | **GET** /v2/sites/{siteId}/domains | List domains for a given website

## Documentation For Models

 - [APIError](docs/APIError.md)
 - [APIErrors](docs/APIErrors.md)
 - [AddSiteDomainDetails](docs/AddSiteDomainDetails.md)
 - [GetEntitiesDetailsMeta](docs/GetEntitiesDetailsMeta.md)
 - [GetSiteDomainsDetails](docs/GetSiteDomainsDetails.md)
 - [SiteDomainDetails](docs/SiteDomainDetails.md)
 - [WildCardSubDomainDetails](docs/WildCardSubDomainDetails.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


