# coding: utf-8

"""
    Imperva Website Domain Management

    Manage the domains that are sharing the CNAME of an onboarded website.<br/>All domains that are using the same CNAME share the website configuration settings and policies of the onboarded website.<br/>For full feature documentation, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/website-general-settings.htm\">Website General Settings</a>.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetEntitiesDetailsMeta(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total_pages': 'int'
    }

    attribute_map = {
        'total_pages': 'totalPages'
    }

    def __init__(self, total_pages=None):  # noqa: E501
        """GetEntitiesDetailsMeta - a model defined in Swagger"""  # noqa: E501
        self._total_pages = None
        self.discriminator = None
        if total_pages is not None:
            self.total_pages = total_pages

    @property
    def total_pages(self):
        """Gets the total_pages of this GetEntitiesDetailsMeta.  # noqa: E501

        The total number of pages  # noqa: E501

        :return: The total_pages of this GetEntitiesDetailsMeta.  # noqa: E501
        :rtype: int
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this GetEntitiesDetailsMeta.

        The total number of pages  # noqa: E501

        :param total_pages: The total_pages of this GetEntitiesDetailsMeta.  # noqa: E501
        :type: int
        """

        self._total_pages = total_pages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetEntitiesDetailsMeta, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetEntitiesDetailsMeta):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
