# swagger-client
Get details of your websites configured in Imperva.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site.
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Get site
    api_response = api_instance.get_site(site_id, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_site: %s\n" % e)

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_ids = [56] # list[int] | A list of website ids. If this parameter is provided, only websites matching one of these IDs will be returned. (optional)
names = ['names_example'] # list[str] | A list of website names. If this parameter is provided, only websites matching one of these names will be returned. (optional)
site_types = ['site_types_example'] # list[str] | A list of website types. Indicates if the website is onboarded to Imperva Cloud WAF or configured for Imperva WAF Anywhere. If this parameter is provided, only websites with type matching one of these types will be returned. (optional)
page = 0 # int | The page to return starting from 0. (optional) (default to 0)
size = 10 # int | Page size used to determine the first object to be returned and the number of objects to be returned. (optional) (default to 10)
caid = 789 # int | The Imperva ID of the account or subaccount. By default, the account ID is the ID associated with the API credentials used for authentication. To run an API on a sub account, specify the sub account ID. (optional)

try:
    # Get sites
    api_response = api_instance.get_sites(site_ids=site_ids, names=names, site_types=site_types, page=page, size=size, caid=caid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_sites: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.imperva.com/sites-mgmt*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SiteManagementApi* | [**get_site**](docs/SiteManagementApi.md#get_site) | **GET** /v3/sites/{siteId} | Get site
*SiteManagementApi* | [**get_sites**](docs/SiteManagementApi.md#get_sites) | **GET** /v3/sites | Get sites

## Documentation For Models

 - [APIError](docs/APIError.md)
 - [CollectionSite](docs/CollectionSite.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [PaginatedCollectionSite](docs/PaginatedCollectionSite.md)
 - [PaginationMetadata](docs/PaginationMetadata.md)
 - [Site](docs/Site.md)

## Documentation For Authorization


## api_id

- **Type**: API key
- **API key parameter name**: x-API-Id
- **Location**: HTTP header

## api_key

- **Type**: API key
- **API key parameter name**: x-API-Key
- **Location**: HTTP header


## Author


