# swagger_client.SiteManagementApi

All URIs are relative to *https://my.imperva.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**add_cache_rule**](SiteManagementApi.md#add_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/add | Add a cache rule
[**add_custom_rule**](SiteManagementApi.md#add_custom_rule) | **POST** /api/prov/v1/sites/incapRules/add | Add rule
[**add_data_center**](SiteManagementApi.md#add_data_center) | **POST** /api/prov/v1/sites/dataCenters/add | Add data center
[**add_dc_server**](SiteManagementApi.md#add_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/add | Add server
[**add_site**](SiteManagementApi.md#add_site) | **POST** /api/prov/v1/sites/add | Add a site
[**check_caa_compliance**](SiteManagementApi.md#check_caa_compliance) | **POST** /api/prov/v1/caa/check-compliance | Check CAA compliance
[**create_new_csr**](SiteManagementApi.md#create_new_csr) | **POST** /api/prov/v1/sites/customCertificate/csr | Create new CSR
[**delete_cache_rule**](SiteManagementApi.md#delete_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/delete | Delete a cache rule
[**delete_custom_rule**](SiteManagementApi.md#delete_custom_rule) | **POST** /api/prov/v1/sites/incapRules/delete | Delete rule
[**delete_data_center**](SiteManagementApi.md#delete_data_center) | **POST** /api/prov/v1/sites/dataCenters/delete | Delete data center
[**delete_dc_server**](SiteManagementApi.md#delete_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/delete | Delete server
[**delete_site**](SiteManagementApi.md#delete_site) | **POST** /api/prov/v1/sites/delete | Delete site
[**domain_emails**](SiteManagementApi.md#domain_emails) | **POST** /api/prov/v1/domain/emails | Get domain approver e-mail addresses
[**edit_bots_configuration**](SiteManagementApi.md#edit_bots_configuration) | **POST** /api/prov/v3/sites/{extSiteId}/settings/botConfiguration | Update website bot configuration
[**edit_cache_rule**](SiteManagementApi.md#edit_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/edit | Edit a cache rule
[**edit_custom_rule**](SiteManagementApi.md#edit_custom_rule) | **POST** /api/prov/v1/sites/incapRules/edit | Edit rule
[**edit_data_center**](SiteManagementApi.md#edit_data_center) | **POST** /api/prov/v1/sites/dataCenters/edit | Edit data center
[**edit_dc_server**](SiteManagementApi.md#edit_dc_server) | **POST** /api/prov/v1/sites/dataCenters/servers/edit | Edit server
[**enable_cache_shield**](SiteManagementApi.md#enable_cache_shield) | **POST** /api/prov/v1/sites/performance/cache-shield/enable | Enable cache shield
[**enable_disable_cache_rule**](SiteManagementApi.md#enable_disable_cache_rule) | **POST** /api/prov/v1/sites/performance/caching-rules/enable | Enable or disable cache rule
[**enable_disable_custom_rule**](SiteManagementApi.md#enable_disable_custom_rule) | **POST** /api/prov/v1/sites/incapRules/enableDisable | Enable or disable rule
[**get_advanced_caching_settings**](SiteManagementApi.md#get_advanced_caching_settings) | **POST** /api/prov/v1/sites/performance/advanced/get | Get advanced caching settings
[**get_bots_configuration**](SiteManagementApi.md#get_bots_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/settings/botConfiguration | Get website bot configuration
[**get_cache404_settings**](SiteManagementApi.md#get_cache404_settings) | **POST** /api/prov/v1/sites/performance/cache404 | Get cache 404 settings
[**get_caching_mode**](SiteManagementApi.md#get_caching_mode) | **POST** /api/prov/v1/sites/performance/cache-mode/get | Get caching mode
[**get_data_region**](SiteManagementApi.md#get_data_region) | **POST** /api/prov/v1/sites/data-privacy/show | Get site data storage region
[**get_html_injection_rules**](SiteManagementApi.md#get_html_injection_rules) | **POST** /api/prov/v1/sites/htmlinjections | Get HTML injection rules
[**get_override_site_regions_by_geo**](SiteManagementApi.md#get_override_site_regions_by_geo) | **POST** /api/prov/v1/sites/data-privacy/show-override-by-geo | Check site regions by origin geolocation
[**get_recommended_data_center_origin_po_ps**](SiteManagementApi.md#get_recommended_data_center_origin_po_ps) | **POST** /api/prov/v1/sites/datacenter/origin-pop/recommend | Get data center recommended origin PoPs
[**get_response_header_settings**](SiteManagementApi.md#get_response_header_settings) | **POST** /api/prov/v1/sites/performance/response-headers/get | Get cached response headers
[**get_rewrite_ports**](SiteManagementApi.md#get_rewrite_ports) | **POST** /api/prov/v1/sites/performance/rewrite-port | Get rewrite port
[**get_secure_resources_mode**](SiteManagementApi.md#get_secure_resources_mode) | **POST** /api/prov/v1/sites/performance/secure-resources/get | Get secure resources mode
[**get_site_error_page_template**](SiteManagementApi.md#get_site_error_page_template) | **POST** /api/prov/v1/sites/performance/error-page | Get error page
[**get_site_report**](SiteManagementApi.md#get_site_report) | **POST** /api/prov/v1/sites/report | Get site report
[**get_stale_content**](SiteManagementApi.md#get_stale_content) | **POST** /api/prov/v1/sites/performance/stale-content/get | Get stale content settings
[**get_tag_response_header**](SiteManagementApi.md#get_tag_response_header) | **POST** /api/prov/v1/sites/performance/tag-response/get | Get header to tag responses by
[**get_tls_configuration**](SiteManagementApi.md#get_tls_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/settings/TLSConfiguration | Get website TLS configuration
[**get_xray_link**](SiteManagementApi.md#get_xray_link) | **POST** /api/prov/v1/sites/xray/get-link | Get XRay access link
[**is_cache_shield_enabled**](SiteManagementApi.md#is_cache_shield_enabled) | **POST** /api/prov/v1/sites/performance/cache-shield | Is cache shield enabled
[**list_account_custom_rules**](SiteManagementApi.md#list_account_custom_rules) | **POST** /api/prov/v1/sites/incapRules/account/list | List account rules
[**list_cache_rules**](SiteManagementApi.md#list_cache_rules) | **POST** /api/prov/v1/sites/performance/caching-rules/list | List cache rules for a given site
[**list_custom_rules**](SiteManagementApi.md#list_custom_rules) | **POST** /api/prov/v1/sites/incapRules/list | List rules
[**list_data_centers**](SiteManagementApi.md#list_data_centers) | **POST** /api/prov/v1/sites/dataCenters/list | List data centers
[**list_data_centers_configuration**](SiteManagementApi.md#list_data_centers_configuration) | **GET** /api/prov/v3/sites/{extSiteId}/data-centers-configuration | get site&#x27;s data centers&#x27; configuration
[**list_sites**](SiteManagementApi.md#list_sites) | **POST** /api/prov/v1/sites/list | List sites
[**modify_advanced_caching_settings**](SiteManagementApi.md#modify_advanced_caching_settings) | **POST** /api/prov/v1/sites/performance/advanced | Advanced caching settings
[**modify_cache404_settings**](SiteManagementApi.md#modify_cache404_settings) | **POST** /api/prov/v1/sites/performance/cache404/modify | Modify cache 404 settings
[**modify_purge_settings**](SiteManagementApi.md#modify_purge_settings) | **POST** /api/prov/v1/sites/performance/purge | Purge resources
[**modify_response_header_settings**](SiteManagementApi.md#modify_response_header_settings) | **POST** /api/prov/v1/sites/performance/response-headers | Modify cached response headers
[**modify_rewrite_ports**](SiteManagementApi.md#modify_rewrite_ports) | **POST** /api/prov/v1/sites/performance/rewrite-port/modify | Modify rewrite port
[**modify_site_configuration**](SiteManagementApi.md#modify_site_configuration) | **POST** /api/prov/v1/sites/configure | Modify site configuration
[**modify_site_error_page_template**](SiteManagementApi.md#modify_site_error_page_template) | **POST** /api/prov/v1/sites/performance/error-page/modify | Modify error page
[**modify_site_log_level**](SiteManagementApi.md#modify_site_log_level) | **POST** /api/prov/v1/sites/setlog | Modify site logs level
[**modify_site_security_configuration**](SiteManagementApi.md#modify_site_security_configuration) | **POST** /api/prov/v1/sites/configure/security | Modify site security configuration
[**modify_site_support_deprecated_tls**](SiteManagementApi.md#modify_site_support_deprecated_tls) | **POST** /api/prov/v1/sites/tls | Set support for all TLS versions
[**modify_stale_content**](SiteManagementApi.md#modify_stale_content) | **POST** /api/prov/v1/sites/performance/stale-content | Modify stale content settings
[**modify_tag_response_header**](SiteManagementApi.md#modify_tag_response_header) | **POST** /api/prov/v1/sites/performance/tag-response | Tag the response according to the value of a header
[**move_site**](SiteManagementApi.md#move_site) | **POST** /api/prov/v1/sites/moveSite | Move site
[**purge_hostname**](SiteManagementApi.md#purge_hostname) | **POST** /api/prov/v1/sites/hostname/purge | Purge hostname from cache
[**purge_site_cache**](SiteManagementApi.md#purge_site_cache) | **POST** /api/prov/v1/sites/cache/purge | Purge site cache
[**put_data_centers_configuration**](SiteManagementApi.md#put_data_centers_configuration) | **PUT** /api/prov/v3/sites/{extSiteId}/data-centers-configuration | set site&#x27;s data centers&#x27; configuration
[**remove_custom_certificate**](SiteManagementApi.md#remove_custom_certificate) | **POST** /api/prov/v1/sites/customCertificate/remove | Remove custom certificate
[**resume_traffic_to_active_dcs**](SiteManagementApi.md#resume_traffic_to_active_dcs) | **POST** /api/prov/v1/sites/dataCenters/resume | Resume traffic to your active data centers
[**set_caching_mode**](SiteManagementApi.md#set_caching_mode) | **POST** /api/prov/v1/sites/performance/cache-mode | Modify caching mode
[**set_data_center_origin_po_p**](SiteManagementApi.md#set_data_center_origin_po_p) | **POST** /api/prov/v1/sites/datacenter/origin-pop/modify | Set data center origin PoP
[**set_data_region**](SiteManagementApi.md#set_data_region) | **POST** /api/prov/v1/sites/data-privacy/region-change | Set site data storage region
[**set_html_injection_rule**](SiteManagementApi.md#set_html_injection_rule) | **POST** /api/prov/v1/sites/configure/htmlInjections | Add, replace or remove a HTML injection rule
[**set_override_site_regions_by_geo**](SiteManagementApi.md#set_override_site_regions_by_geo) | **POST** /api/prov/v1/sites/data-privacy/override-by-geo | Set site regions by origin geolocation
[**set_priority**](SiteManagementApi.md#set_priority) | **POST** /api/prov/v1/sites/incapRules/priority/set | Set rule priority
[**set_secure_resources_mode**](SiteManagementApi.md#set_secure_resources_mode) | **POST** /api/prov/v1/sites/performance/secure-resources | Modify secure resources mode
[**site_status**](SiteManagementApi.md#site_status) | **POST** /api/prov/v1/sites/status | Get site status
[**update_tls_configuration**](SiteManagementApi.md#update_tls_configuration) | **POST** /api/prov/v3/sites/{extSiteId}/settings/TLSConfiguration | Update website TLS configuration
[**upload_custom_certificate**](SiteManagementApi.md#upload_custom_certificate) | **POST** /api/prov/v1/sites/customCertificate/upload | Upload custom certificate

# **add_cache_rule**
> InlineResponse2003 add_cache_rule(action, site_id, name, filter=filter, ttl=ttl, ttl_unit=ttl_unit, differentiated_by_value=differentiated_by_value, params=params, _all_params=_all_params, tag_name=tag_name, text=text)

Add a cache rule

Use this operation for adding a cache rule

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
action = 'action_example' # str | Rule action. See Possible action parameter values.<br/>Possible action parameter values:<br/><ul><li><b>HTTP_CACHE_MAKE_STATIC</b> Cache Resource</li><li><b>HTTP_CACHE_CLIENT_CACHE_CTL</b> Cache Resource on Client</li><li><b>HTTP_CACHE_FORCE_UNCACHEABLE</b> Don't Cache Resource</li><li><b>HTTP_CACHE_DIFFERENTIATE_SSL</b> Differentiate Cache Key by HTTP/HTTPS Scheme</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_HEADER</b> Differentiate Cache Key by Header</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_COOKIE</b> Differentiate Cache Key by Cookie</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_GEO</b> Differentiate Cache Key by Geolocation</li><li><b>HTTP_CACHE_IGNORE_PARAMS</b> Ignore Parameters in Cache Key</li><li><b>HTTP_CACHE_IGNORE_AUTH_HEADER</b> Cache Authenticated Resources</li><li><b>HTTP_CACHE_FORCE_VALIDATION</b> Force User Authentication</li><li><b>HTTP_CACHE_ADD_TAG</b> Create Tag</li><li><b>HTTP_CACHE_ENRICH_CACHE_KEY</b> Enrich Cache Key</li></ul>
site_id = 789 # int | Numeric identifier of the site to operate on.
name = 'name_example' # str | Rule name.
filter = 'filter_example' # str | Rule will trigger only a request that matches this filter. For more details on filters, see <a href=\"https://docs.imperva.com/csh?context=rule_syntax\">Syntax Guide</a>. (optional)
ttl = 'ttl_example' # str | Rule TTL. Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL (optional)
ttl_unit = 'ttl_unit_example' # str | Rule TTL time unit.<br/>Must be one of SECONDS, MINUTES, HOURS, DAYS or WEEKS. If no time unit is provided, SECONDS is used.<br/>Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL (optional)
differentiated_by_value = 'differentiated_by_value_example' # str | Value to differentiate by. HTTP_CACHE_DIFFERENTIATE_BY_HEADER - header name, HTTP_CACHE_DIFFERENTIATE_BY_COOKIE - cookie name, HTTP_CACHE_DIFFERENTIATE_BY_GEO - geo location <br/>(ISO 3166-1 alpha-2 country codes ), otherwise irrelevant. (optional)
params = 'params_example' # str | Comma separated list of parameters to ignore. Parameters name must be alphanumeric. (optional)
_all_params = true # bool | When set to <b>true</b>: all parameters in cache key will be ignored.<br/>Default: false.<br/>Relevant for HTTP_CACHE_IGNORE_PARAMS action (optional)
tag_name = 'tag_name_example' # str | The name of the tag to add. (optional)
text = 'text_example' # str | Add text to the cache key as suffix. Relevant for the HTTP_CACHE_ENRICH_CACHE_KEY action (optional)

try:
    # Add a cache rule
    api_response = api_instance.add_cache_rule(action, site_id, name, filter=filter, ttl=ttl, ttl_unit=ttl_unit, differentiated_by_value=differentiated_by_value, params=params, _all_params=_all_params, tag_name=tag_name, text=text)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->add_cache_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**| Rule action. See Possible action parameter values.&lt;br/&gt;Possible action parameter values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_MAKE_STATIC&lt;/b&gt; Cache Resource&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_CLIENT_CACHE_CTL&lt;/b&gt; Cache Resource on Client&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_FORCE_UNCACHEABLE&lt;/b&gt; Don&#x27;t Cache Resource&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_SSL&lt;/b&gt; Differentiate Cache Key by HTTP/HTTPS Scheme&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_HEADER&lt;/b&gt; Differentiate Cache Key by Header&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_COOKIE&lt;/b&gt; Differentiate Cache Key by Cookie&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_GEO&lt;/b&gt; Differentiate Cache Key by Geolocation&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_IGNORE_PARAMS&lt;/b&gt; Ignore Parameters in Cache Key&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_IGNORE_AUTH_HEADER&lt;/b&gt; Cache Authenticated Resources&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_FORCE_VALIDATION&lt;/b&gt; Force User Authentication&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_ADD_TAG&lt;/b&gt; Create Tag&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_ENRICH_CACHE_KEY&lt;/b&gt; Enrich Cache Key&lt;/li&gt;&lt;/ul&gt; | 
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **name** | **str**| Rule name. | 
 **filter** | **str**| Rule will trigger only a request that matches this filter. For more details on filters, see &lt;a href&#x3D;\&quot;https://docs.imperva.com/csh?context&#x3D;rule_syntax\&quot;&gt;Syntax Guide&lt;/a&gt;. | [optional] 
 **ttl** | **str**| Rule TTL. Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL | [optional] 
 **ttl_unit** | **str**| Rule TTL time unit.&lt;br/&gt;Must be one of SECONDS, MINUTES, HOURS, DAYS or WEEKS. If no time unit is provided, SECONDS is used.&lt;br/&gt;Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL | [optional] 
 **differentiated_by_value** | **str**| Value to differentiate by. HTTP_CACHE_DIFFERENTIATE_BY_HEADER - header name, HTTP_CACHE_DIFFERENTIATE_BY_COOKIE - cookie name, HTTP_CACHE_DIFFERENTIATE_BY_GEO - geo location &lt;br/&gt;(ISO 3166-1 alpha-2 country codes ), otherwise irrelevant. | [optional] 
 **params** | **str**| Comma separated list of parameters to ignore. Parameters name must be alphanumeric. | [optional] 
 **_all_params** | **bool**| When set to &lt;b&gt;true&lt;/b&gt;: all parameters in cache key will be ignored.&lt;br/&gt;Default: false.&lt;br/&gt;Relevant for HTTP_CACHE_IGNORE_PARAMS action | [optional] 
 **tag_name** | **str**| The name of the tag to add. | [optional] 
 **text** | **str**| Add text to the cache key as suffix. Relevant for the HTTP_CACHE_ENRICH_CACHE_KEY action | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_custom_rule**
> CustomRuleResponse add_custom_rule(action, site_id, name, filter, response_code=response_code, protocol=protocol, add_missing=add_missing, _from=_from, to=to, rewrite_name=rewrite_name, dc_id=dc_id, allow_caching=allow_caching, is_test_mode=is_test_mode, rate_context=rate_context, rate_interval=rate_interval, port_forwarding_context=port_forwarding_context, port_forwarding_value=port_forwarding_value, multiple_deletions=multiple_deletions, rewrite_existing=rewrite_existing)

Add rule

Use this operation to add a rule (Delivery, Security or Rate).

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
action = 'action_example' # str | Rule action. See the possible values in the table below.<br/>Possible action parameter values for Delivery Rules:<br/><ul><li><b>RULE_ACTION_REDIRECT</b> Redirect the client to a different URL, responding with a 30X response.</li><li><b>RULE_ACTION_SIMPLIFIED_REDIRECT</b> Redirect the client to a different URL, responding with a 30X response.</li><li><b>RULE_ACTION_REWRITE_URL</b> Modify the path to which a specific request is targeted.</li><li><b>RULE_ACTION_REWRITE_HEADER</b> Modify or add a request header before passing traffic to the origin server.</li><li><b>RULE_ACTION_REWRITE_COOKIE</b> Modify or add cookies that are sent by the client to the origin server. The cookie name and value should be indicated.</li><li><b>RULE_ACTION_DELETE_HEADER</b> Remove a specific request header, which means that it won’t be sent to the origin server.</li><li><b>RULE_ACTION_DELETE_COOKIE</b> Remove a specific cookie set on the client, which means that it won’t be sent to the origin server.</li><li><b>RULE_ACTION_FORWARD_TO_DC</b> Define the data center to which a specific request will be sent.</li><li><b>RULE_ACTION_FORWARD_TO_PORT</b> Define the port to which a specific request will be sent.</li><li><b>RULE_ACTION_RESPONSE_REWRITE_HEADER</b> Modify or add a header to the response received from the origin server.</li><li><b>RULE_ACTION_RESPONSE_DELETE_HEADER</b> Remove a specific response header, which means that it won't be returned to the client.</li><li><b>RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE</b> Modify the response code received from the origin server.</li></ul><br/>Possible action parameter values for security rules:<br/><ul><li><b>RULE_ACTION_ALERT</b> Generate a non blocking alert for this event.</li><li><b>RULE_ACTION_BLOCK</b> Block the current request and generate an alert for this event.</li><li><b>RULE_ACTION_BLOCK_USER</b> Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.</li><li><b>RULE_ACTION_BLOCK_IP</b> Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.</li><li><b>RULE_ACTION_RETRY</b> Require any client matching the rule filters to support cookies in order to complete the request.</li><li><b>RULE_ACTION_INTRUSIVE_HTML</b> Require any client matching the rule filters to support javascript in order to complete the request. Since the Javascript test is embedded in an HTML page, this action should only be enabled for HTML resources.</li><li><b>RULE_ACTION_CAPTCHA</b> Require any client matching the rule filters to pass a CAPTCHA test in order to complete the request. Since the CAPTCHA test is embedded in an HTML page, this action should only be enabled for HTML resources.</li></ul><br/>Possible action parameter values for counter (rate) rules:<br/><ul><li><b>RULE_ACTION_RATE</b> Count the number of requests received that match the rule filter.</li></ul>
site_id = 789 # int | Numeric identifier of the site to operate on.
name = 'name_example' # str | Rule name.
filter = 'filter_example' # str | Rule will trigger only a request that matches this filter. For more details on filter guidelines, see <a href=\"https://docs.imperva.com/csh?context=rule_syntax\">Syntax Guide</a>.<br/>The filter may contain up to 400 characters.
response_code = 56 # int | Redirect rule's response code. Valid values are 302, 301, 303, 307, 308. (optional)
protocol = 'protocol_example' # str |  (optional)
add_missing = true # bool | Add cookie or header if it doesn't exist (Rewrite cookie rule only) (optional)
_from = '_from_example' # str | The pattern to rewrite.<br/>For RULE_ACTION_REWRITE_URL - The URL to rewrite.<br/>For RULE_ACTION_REWRITE_HEADER - The header value to rewrite.<br/>For RULE_ACTION_REWRITE_COOKIE - The cookie value to rewrite.<br/>For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. (optional)
to = 'to_example' # str | The pattern to change to.<br/>For RULE_ACTION_REWRITE_URL - The URL to change to.<br/>For RULE_ACTION_REWRITE_HEADER - The header value to change to.<br/>For RULE_ACTION_REWRITE_COOKIE - The cookie value to change to.<br/>For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. (optional)
rewrite_name = 'rewrite_name_example' # str | Name of cookie or header to rewrite. Applies only for RULE_ACTION_REWRITE_COOKIE and RULE_ACTION_REWRITE_HEADER. (optional)
dc_id = 789 # int | Data center to forward request to. Applies only for RULE_ACTION_FORWARD_TO_DC. (optional)
allow_caching = true # bool |  (optional)
is_test_mode = true # bool | Apply the rule only to the IP address the API request was sent from.<br/>This option is not available for Simplified Redirect rules. (optional)
rate_context = 'rate_context_example' # str | The context of the rate counter. Possible values: IP / Session. Applies only to rules using RULE_ACTION_RATE. (optional)
rate_interval = 56 # int | The interval (in seconds) of the rate counter. Possible values: A multiple of 10 from 10-300. Applies only to rules using RULE_ACTION_RATE. (optional)
port_forwarding_context = 'port_forwarding_context_example' # str | Context for port forwarding. \"Use Port Value\" or \"Use Header Name\". Applies only for RULE_ACTION_FORWARD_TO_PORT. (optional)
port_forwarding_value = 'port_forwarding_value_example' # str | Port number or header name for port forwarding. Applies only for RULE_ACTION_FORWARD_TO_PORT. (optional)
multiple_deletions = true # bool | Delete multiple header occurrences. Applies only to rules using RULE_ACTION_DELETE_HEADER and RULE_ACTION_RESPONSE_DELETE_HEADER. (optional)
rewrite_existing = true # bool | Rewrite cookie or header if it exists (optional)

try:
    # Add rule
    api_response = api_instance.add_custom_rule(action, site_id, name, filter, response_code=response_code, protocol=protocol, add_missing=add_missing, _from=_from, to=to, rewrite_name=rewrite_name, dc_id=dc_id, allow_caching=allow_caching, is_test_mode=is_test_mode, rate_context=rate_context, rate_interval=rate_interval, port_forwarding_context=port_forwarding_context, port_forwarding_value=port_forwarding_value, multiple_deletions=multiple_deletions, rewrite_existing=rewrite_existing)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->add_custom_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**| Rule action. See the possible values in the table below.&lt;br/&gt;Possible action parameter values for Delivery Rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REDIRECT&lt;/b&gt; Redirect the client to a different URL, responding with a 30X response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_SIMPLIFIED_REDIRECT&lt;/b&gt; Redirect the client to a different URL, responding with a 30X response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_URL&lt;/b&gt; Modify the path to which a specific request is targeted.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_HEADER&lt;/b&gt; Modify or add a request header before passing traffic to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_COOKIE&lt;/b&gt; Modify or add cookies that are sent by the client to the origin server. The cookie name and value should be indicated.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_DELETE_HEADER&lt;/b&gt; Remove a specific request header, which means that it won’t be sent to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_DELETE_COOKIE&lt;/b&gt; Remove a specific cookie set on the client, which means that it won’t be sent to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_FORWARD_TO_DC&lt;/b&gt; Define the data center to which a specific request will be sent.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_FORWARD_TO_PORT&lt;/b&gt; Define the port to which a specific request will be sent.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_REWRITE_HEADER&lt;/b&gt; Modify or add a header to the response received from the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_DELETE_HEADER&lt;/b&gt; Remove a specific response header, which means that it won&#x27;t be returned to the client.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE&lt;/b&gt; Modify the response code received from the origin server.&lt;/li&gt;&lt;/ul&gt;&lt;br/&gt;Possible action parameter values for security rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_ALERT&lt;/b&gt; Generate a non blocking alert for this event.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK&lt;/b&gt; Block the current request and generate an alert for this event.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK_USER&lt;/b&gt; Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK_IP&lt;/b&gt; Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RETRY&lt;/b&gt; Require any client matching the rule filters to support cookies in order to complete the request.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_INTRUSIVE_HTML&lt;/b&gt; Require any client matching the rule filters to support javascript in order to complete the request. Since the Javascript test is embedded in an HTML page, this action should only be enabled for HTML resources.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_CAPTCHA&lt;/b&gt; Require any client matching the rule filters to pass a CAPTCHA test in order to complete the request. Since the CAPTCHA test is embedded in an HTML page, this action should only be enabled for HTML resources.&lt;/li&gt;&lt;/ul&gt;&lt;br/&gt;Possible action parameter values for counter (rate) rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RATE&lt;/b&gt; Count the number of requests received that match the rule filter.&lt;/li&gt;&lt;/ul&gt; | 
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **name** | **str**| Rule name. | 
 **filter** | **str**| Rule will trigger only a request that matches this filter. For more details on filter guidelines, see &lt;a href&#x3D;\&quot;https://docs.imperva.com/csh?context&#x3D;rule_syntax\&quot;&gt;Syntax Guide&lt;/a&gt;.&lt;br/&gt;The filter may contain up to 400 characters. | 
 **response_code** | **int**| Redirect rule&#x27;s response code. Valid values are 302, 301, 303, 307, 308. | [optional] 
 **protocol** | **str**|  | [optional] 
 **add_missing** | **bool**| Add cookie or header if it doesn&#x27;t exist (Rewrite cookie rule only) | [optional] 
 **_from** | **str**| The pattern to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_URL - The URL to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_HEADER - The header value to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_COOKIE - The cookie value to rewrite.&lt;br/&gt;For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. | [optional] 
 **to** | **str**| The pattern to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_URL - The URL to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_HEADER - The header value to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_COOKIE - The cookie value to change to.&lt;br/&gt;For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. | [optional] 
 **rewrite_name** | **str**| Name of cookie or header to rewrite. Applies only for RULE_ACTION_REWRITE_COOKIE and RULE_ACTION_REWRITE_HEADER. | [optional] 
 **dc_id** | **int**| Data center to forward request to. Applies only for RULE_ACTION_FORWARD_TO_DC. | [optional] 
 **allow_caching** | **bool**|  | [optional] 
 **is_test_mode** | **bool**| Apply the rule only to the IP address the API request was sent from.&lt;br/&gt;This option is not available for Simplified Redirect rules. | [optional] 
 **rate_context** | **str**| The context of the rate counter. Possible values: IP / Session. Applies only to rules using RULE_ACTION_RATE. | [optional] 
 **rate_interval** | **int**| The interval (in seconds) of the rate counter. Possible values: A multiple of 10 from 10-300. Applies only to rules using RULE_ACTION_RATE. | [optional] 
 **port_forwarding_context** | **str**| Context for port forwarding. \&quot;Use Port Value\&quot; or \&quot;Use Header Name\&quot;. Applies only for RULE_ACTION_FORWARD_TO_PORT. | [optional] 
 **port_forwarding_value** | **str**| Port number or header name for port forwarding. Applies only for RULE_ACTION_FORWARD_TO_PORT. | [optional] 
 **multiple_deletions** | **bool**| Delete multiple header occurrences. Applies only to rules using RULE_ACTION_DELETE_HEADER and RULE_ACTION_RESPONSE_DELETE_HEADER. | [optional] 
 **rewrite_existing** | **bool**| Rewrite cookie or header if it exists | [optional] 

### Return type

[**CustomRuleResponse**](CustomRuleResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_data_center**
> InlineResponse20017 add_data_center(site_id, name, server_address, lb_algorithm=lb_algorithm, is_enabled=is_enabled, is_content=is_content)

Add data center

Use this operation for adding data center to site.<br/>You can configure up to 40 data centers per site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
name = 'name_example' # str | The new data center's name.
server_address = 'server_address_example' # str | The server's address. Possible values: IP, CNAME
lb_algorithm = 'lb_algorithm_example' # str | Data center load balancing algorithm. Possible values are:<br/>LB_LEAST_PENDING_REQUESTS - Server with least pending requests<br/>LB_LEAST_OPEN_CONNECTIONS - Server with least open connections<br/>LB_SOURCE_IP_HASH - Server by IP hash<br/>RANDOM - Random server<br/>WEIGHTED - Server by weight (optional)
is_enabled = true # bool | Enables the data center. (optional)
is_content = true # bool | The data center will be available for specific resources (<b>Forward</b> Delivery Rules). (optional)

try:
    # Add data center
    api_response = api_instance.add_data_center(site_id, name, server_address, lb_algorithm=lb_algorithm, is_enabled=is_enabled, is_content=is_content)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->add_data_center: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **name** | **str**| The new data center&#x27;s name. | 
 **server_address** | **str**| The server&#x27;s address. Possible values: IP, CNAME | 
 **lb_algorithm** | **str**| Data center load balancing algorithm. Possible values are:&lt;br/&gt;LB_LEAST_PENDING_REQUESTS - Server with least pending requests&lt;br/&gt;LB_LEAST_OPEN_CONNECTIONS - Server with least open connections&lt;br/&gt;LB_SOURCE_IP_HASH - Server by IP hash&lt;br/&gt;RANDOM - Random server&lt;br/&gt;WEIGHTED - Server by weight | [optional] 
 **is_enabled** | **bool**| Enables the data center. | [optional] 
 **is_content** | **bool**| The data center will be available for specific resources (&lt;b&gt;Forward&lt;/b&gt; Delivery Rules). | [optional] 

### Return type

[**InlineResponse20017**](InlineResponse20017.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_dc_server**
> InlineResponse20016 add_dc_server(dc_id, server_address, is_disabled=is_disabled, is_standby=is_standby)

Add server

Use this operation to add a server to a data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
dc_id = 789 # int | The data center's ID.
server_address = 'server_address_example' # str | Server IP address.
is_disabled = true # bool | Enables the data center (optional)
is_standby = true # bool | Set the server as Active (P0) or Standby (P1) (Boolean). (optional)

try:
    # Add server
    api_response = api_instance.add_dc_server(dc_id, server_address, is_disabled=is_disabled, is_standby=is_standby)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->add_dc_server: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dc_id** | **int**| The data center&#x27;s ID. | 
 **server_address** | **str**| Server IP address. | 
 **is_disabled** | **bool**| Enables the data center | [optional] 
 **is_standby** | **bool**| Set the server as Active (P0) or Standby (P1) (Boolean). | [optional] 

### Return type

[**InlineResponse20016**](InlineResponse20016.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_site**
> InlineResponse20014 add_site(domain, body=body, account_id=account_id, ref_id=ref_id, send_site_setup_emails=send_site_setup_emails, site_ip=site_ip, force_ssl=force_ssl, naked_domain_san=naked_domain_san, wildcard_san=wildcard_san, log_level=log_level, logs_account_id=logs_account_id)

Add a site

Add a new site to an account. If the site already exists, its status is returned.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
domain = 'domain_example' # str | The domain name of the site. For example: <a href=\"www.example.com\">www.example.com</a>, <a href=\"hello.example.com\">www.example.com</a>, <a href=\"example.com\">www.example.com</a>
body = 'body_example' # str |  (optional)
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters. (optional)
ref_id = 'ref_id_example' # str | Customer specific identifier for this operation (optional)
send_site_setup_emails = 'send_site_setup_emails_example' # str | If this value is false, end users will not get emails about the add site process such as DNS instructions and SSL setup. (optional)
site_ip = 'site_ip_example' # str | Manually set the web server IP/CNAME (optional)
force_ssl = 'force_ssl_example' # str | If this value is true, manually set the site to support SSL.<br/>This option is only available for sites with manually configured IP/CNAME and for specific accounts. (optional)
naked_domain_san = 'naked_domain_san_example' # str | Use “true” to add the naked domain SAN to a www site’s SSL certificate. Default value: true (optional)
wildcard_san = 'wildcard_san_example' # str | Use “true” to add the wildcard SAN or “false” to add the full domain SAN to the site’s SSL certificate. Default value: true (optional)
log_level = 'log_level_example' # str | Available only for customers that purchased the Logs Integration SKU.<br/>Sets the log reporting level for the site. Options are “full”, “security”, “none” and default (optional)
logs_account_id = 'logs_account_id_example' # str | Available only for customers that purchased the Logs Integration SKU.<br/>Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.<br/>If not specified, operation will be performed on the account identified by the authentication parameters (optional)

try:
    # Add a site
    api_response = api_instance.add_site(domain, body=body, account_id=account_id, ref_id=ref_id, send_site_setup_emails=send_site_setup_emails, site_ip=site_ip, force_ssl=force_ssl, naked_domain_san=naked_domain_san, wildcard_san=wildcard_san, log_level=log_level, logs_account_id=logs_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->add_site: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain** | **str**| The domain name of the site. For example: &lt;a href&#x3D;\&quot;www.example.com\&quot;&gt;www.example.com&lt;/a&gt;, &lt;a href&#x3D;\&quot;hello.example.com\&quot;&gt;www.example.com&lt;/a&gt;, &lt;a href&#x3D;\&quot;example.com\&quot;&gt;www.example.com&lt;/a&gt; | 
 **body** | [**str**](str.md)|  | [optional] 
 **account_id** | **str**| Numeric identifier of the account to operate on.&lt;br/&gt;If not specified, operation will be performed on the account identified by the authentication parameters. | [optional] 
 **ref_id** | **str**| Customer specific identifier for this operation | [optional] 
 **send_site_setup_emails** | **str**| If this value is false, end users will not get emails about the add site process such as DNS instructions and SSL setup. | [optional] 
 **site_ip** | **str**| Manually set the web server IP/CNAME | [optional] 
 **force_ssl** | **str**| If this value is true, manually set the site to support SSL.&lt;br/&gt;This option is only available for sites with manually configured IP/CNAME and for specific accounts. | [optional] 
 **naked_domain_san** | **str**| Use “true” to add the naked domain SAN to a www site’s SSL certificate. Default value: true | [optional] 
 **wildcard_san** | **str**| Use “true” to add the wildcard SAN or “false” to add the full domain SAN to the site’s SSL certificate. Default value: true | [optional] 
 **log_level** | **str**| Available only for customers that purchased the Logs Integration SKU.&lt;br/&gt;Sets the log reporting level for the site. Options are “full”, “security”, “none” and default | [optional] 
 **logs_account_id** | **str**| Available only for customers that purchased the Logs Integration SKU.&lt;br/&gt;Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.&lt;br/&gt;If not specified, operation will be performed on the account identified by the authentication parameters | [optional] 

### Return type

[**InlineResponse20014**](InlineResponse20014.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **check_caa_compliance**
> CaaComplianceCheckResult check_caa_compliance(site_id)

Check CAA compliance

Check site’s associated SANs for CAA compliance. If a given SAN is compliant, its SSL domain validation status is updated accordingly.This operation returns an updated list of the site’s associated SANs that are not compliant. An empty list indicates that all SANs are compliant.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.

try:
    # Check CAA compliance
    api_response = api_instance.check_caa_compliance(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->check_caa_compliance: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 

### Return type

[**CaaComplianceCheckResult**](CaaComplianceCheckResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_new_csr**
> CreateNewCSRResponse create_new_csr(site_id, domain=domain, email=email, country=country, state=state, city=city, organization=organization, organization_unit=organization_unit)

Create new CSR

Use this operation to create a certificate signing request (CSR) for your site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on
domain = 'domain_example' # str | common name. For example: example.com (optional)
email = 'email_example' # str | Email address. For example: joe@example.com (optional)
country = 'country_example' # str | The two-letter ISO code for the country where your organization is located (optional)
state = 'state_example' # str | The state/region where your organization is located. This should not be abbreviated (optional)
city = 'city_example' # str | The city where your organization is located (optional)
organization = 'organization_example' # str | The legal name of your organization. This should not be abbreviated or include suffixes such as Inc., Corp., or LLC (optional)
organization_unit = 'organization_unit_example' # str | The division of your organization handling the certificate. For example, IT Department (optional)

try:
    # Create new CSR
    api_response = api_instance.create_new_csr(site_id, domain=domain, email=email, country=country, state=state, city=city, organization=organization, organization_unit=organization_unit)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->create_new_csr: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on | 
 **domain** | **str**| common name. For example: example.com | [optional] 
 **email** | **str**| Email address. For example: joe@example.com | [optional] 
 **country** | **str**| The two-letter ISO code for the country where your organization is located | [optional] 
 **state** | **str**| The state/region where your organization is located. This should not be abbreviated | [optional] 
 **city** | **str**| The city where your organization is located | [optional] 
 **organization** | **str**| The legal name of your organization. This should not be abbreviated or include suffixes such as Inc., Corp., or LLC | [optional] 
 **organization_unit** | **str**| The division of your organization handling the certificate. For example, IT Department | [optional] 

### Return type

[**CreateNewCSRResponse**](CreateNewCSRResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_cache_rule**
> ApiResult delete_cache_rule(site_id, rule_id)

Delete a cache rule

Use this operation for deleting a cache rule

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
rule_id = 789 # int | ID of the rule to change.

try:
    # Delete a cache rule
    api_response = api_instance.delete_cache_rule(site_id, rule_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->delete_cache_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **rule_id** | **int**| ID of the rule to change. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_custom_rule**
> DeleteCustomRuleResponse delete_custom_rule(rule_id)

Delete rule

Use this operation to delete a rule (Delivery, Security or Rate).

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
rule_id = 789 # int | Rule id

try:
    # Delete rule
    api_response = api_instance.delete_custom_rule(rule_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->delete_custom_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rule_id** | **int**| Rule id | 

### Return type

[**DeleteCustomRuleResponse**](DeleteCustomRuleResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_data_center**
> InlineResponse20017 delete_data_center(dc_id)

Delete data center

Use this operation to delete a site's data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
dc_id = 789 # int | The data center's ID.

try:
    # Delete data center
    api_response = api_instance.delete_data_center(dc_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->delete_data_center: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dc_id** | **int**| The data center&#x27;s ID. | 

### Return type

[**InlineResponse20017**](InlineResponse20017.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_dc_server**
> InlineResponse20016 delete_dc_server(server_id)

Delete server

Use this operation to delete a data center's server.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
server_id = 789 # int | Server ID.

try:
    # Delete server
    api_response = api_instance.delete_dc_server(server_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->delete_dc_server: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **server_id** | **int**| Server ID. | 

### Return type

[**InlineResponse20016**](InlineResponse20016.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_site**
> ApiResult delete_site(site_id=site_id, ignore_grace_period=ignore_grace_period)

Delete site

Delete the site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on (optional)
ignore_grace_period = true # bool | The process ignores the site’s 24 hour grace period and immediately deletes the site. Default value: false (optional)

try:
    # Delete site
    api_response = api_instance.delete_site(site_id=site_id, ignore_grace_period=ignore_grace_period)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->delete_site: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | [optional] 
 **ignore_grace_period** | **bool**| The process ignores the site’s 24 hour grace period and immediately deletes the site. Default value: false | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **domain_emails**
> InlineResponse20030 domain_emails(domain)

Get domain approver e-mail addresses

Use this operation to get the list of email addresses that can be used when adding an SSL site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
domain = 'domain_example' # str | The domain name of the site. For example: <a href=\"www.example.com\">www.example.com</a>, <a href=\"hello.example.com\">www.example.com</a>, <a href=\"example.com\">www.example.com</a>

try:
    # Get domain approver e-mail addresses
    api_response = api_instance.domain_emails(domain)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->domain_emails: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain** | **str**| The domain name of the site. For example: &lt;a href&#x3D;\&quot;www.example.com\&quot;&gt;www.example.com&lt;/a&gt;, &lt;a href&#x3D;\&quot;hello.example.com\&quot;&gt;www.example.com&lt;/a&gt;, &lt;a href&#x3D;\&quot;example.com\&quot;&gt;www.example.com&lt;/a&gt; | 

### Return type

[**InlineResponse20030**](InlineResponse20030.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_bots_configuration**
> BotsConfigurationDTO edit_bots_configuration(body, ext_site_id)

Update website bot configuration

Update the Bot Access Control configuration for a given website. <br>For the full list of client applications and their associated IDs, see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/settings/client-classification.htm\">Client Classification</a>.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.BotsConfigurationDTO() # BotsConfigurationDTO | JSON body.  <br> Note: displayName is relevant for response only.
ext_site_id = 789 # int | 

try:
    # Update website bot configuration
    api_response = api_instance.edit_bots_configuration(body, ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->edit_bots_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BotsConfigurationDTO**](BotsConfigurationDTO.md)| JSON body.  &lt;br&gt; Note: displayName is relevant for response only. | 
 **ext_site_id** | **int**|  | 

### Return type

[**BotsConfigurationDTO**](BotsConfigurationDTO.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_cache_rule**
> ApiResult edit_cache_rule(action, site_id, rule_id, name, filter=filter, ttl=ttl, ttl_unit=ttl_unit, differentiated_by_value=differentiated_by_value, params=params, _all_params=_all_params, tag_name=tag_name, text=text)

Edit a cache rule

Use this operation for editing a cache rule

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
action = 'action_example' # str | Rule action. See Possible action parameter values.<br/>Possible action parameter values:<br/><ul><li><b>HTTP_CACHE_MAKE_STATIC</b> Cache Resource</li><li><b>HTTP_CACHE_CLIENT_CACHE_CTL</b> Cache Resource on Client</li><li><b>HTTP_CACHE_FORCE_UNCACHEABLE</b> Don't Cache Resource</li><li><b>HTTP_CACHE_DIFFERENTIATE_SSL</b> Differentiate Cache Key by HTTP/HTTPS Scheme</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_HEADER</b> Differentiate Cache Key by Header</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_COOKIE</b> Differentiate Cache Key by Cookie</li><li><b>HTTP_CACHE_DIFFERENTIATE_BY_GEO</b> Differentiate Cache Key by Geolocation</li><li><b>HTTP_CACHE_IGNORE_PARAMS</b> Ignore Parameters in Cache Key</li><li><b>HTTP_CACHE_IGNORE_AUTH_HEADER</b> Cache Authenticated Resources</li><li><b>HTTP_CACHE_FORCE_VALIDATION</b> Force User Authentication</li><li><b>HTTP_CACHE_ADD_TAG</b> Create Tag</li><li><b>HTTP_CACHE_ENRICH_CACHE_KEY</b> Enrich Cache Key</li></ul>
site_id = 789 # int | Numeric identifier of the site to operate on.
rule_id = 789 # int | ID of the rule to change.
name = 'name_example' # str | Rule name.
filter = 'filter_example' # str | Rule will trigger only a request that matches this filter. For more details on filters, see <a href=\"https://docs.imperva.com/csh?context=rule_syntax\">Syntax Guide</a>. (optional)
ttl = 'ttl_example' # str | Rule TTL. Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL (optional)
ttl_unit = 'ttl_unit_example' # str | Rule TTL time unit.<br/>Must be one of SECONDS, MINUTES, HOURS, DAYS or WEEKS. If no time unit is provided, SECONDS is used.<br/>Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL (optional)
differentiated_by_value = 'differentiated_by_value_example' # str | Value to differentiate by. HTTP_CACHE_DIFFERENTIATE_BY_HEADER - header name, HTTP_CACHE_DIFFERENTIATE_BY_COOKIE - cookie name, HTTP_CACHE_DIFFERENTIATE_BY_GEO - geo location<br/> (ISO 3166-1 alpha-2 country codes ), otherwise irrelevant. (optional)
params = 'params_example' # str | Comma separated list of parameters to ignore. Parameters name must be alphanumeric. (optional)
_all_params = true # bool | When set to <b>true</b>: all parameters in cache key will be ignored.<br/>Default: false.<br/>Relevant for HTTP_CACHE_IGNORE_PARAMS action (optional)
tag_name = 'tag_name_example' # str | The name of the tag to add. (optional)
text = 'text_example' # str | Add text to the cache key as suffix. Relevant for the HTTP_CACHE_ENRICH_CACHE_KEY action (optional)

try:
    # Edit a cache rule
    api_response = api_instance.edit_cache_rule(action, site_id, rule_id, name, filter=filter, ttl=ttl, ttl_unit=ttl_unit, differentiated_by_value=differentiated_by_value, params=params, _all_params=_all_params, tag_name=tag_name, text=text)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->edit_cache_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**| Rule action. See Possible action parameter values.&lt;br/&gt;Possible action parameter values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_MAKE_STATIC&lt;/b&gt; Cache Resource&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_CLIENT_CACHE_CTL&lt;/b&gt; Cache Resource on Client&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_FORCE_UNCACHEABLE&lt;/b&gt; Don&#x27;t Cache Resource&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_SSL&lt;/b&gt; Differentiate Cache Key by HTTP/HTTPS Scheme&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_HEADER&lt;/b&gt; Differentiate Cache Key by Header&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_COOKIE&lt;/b&gt; Differentiate Cache Key by Cookie&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_DIFFERENTIATE_BY_GEO&lt;/b&gt; Differentiate Cache Key by Geolocation&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_IGNORE_PARAMS&lt;/b&gt; Ignore Parameters in Cache Key&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_IGNORE_AUTH_HEADER&lt;/b&gt; Cache Authenticated Resources&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_FORCE_VALIDATION&lt;/b&gt; Force User Authentication&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_ADD_TAG&lt;/b&gt; Create Tag&lt;/li&gt;&lt;li&gt;&lt;b&gt;HTTP_CACHE_ENRICH_CACHE_KEY&lt;/b&gt; Enrich Cache Key&lt;/li&gt;&lt;/ul&gt; | 
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **rule_id** | **int**| ID of the rule to change. | 
 **name** | **str**| Rule name. | 
 **filter** | **str**| Rule will trigger only a request that matches this filter. For more details on filters, see &lt;a href&#x3D;\&quot;https://docs.imperva.com/csh?context&#x3D;rule_syntax\&quot;&gt;Syntax Guide&lt;/a&gt;. | [optional] 
 **ttl** | **str**| Rule TTL. Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL | [optional] 
 **ttl_unit** | **str**| Rule TTL time unit.&lt;br/&gt;Must be one of SECONDS, MINUTES, HOURS, DAYS or WEEKS. If no time unit is provided, SECONDS is used.&lt;br/&gt;Only relevant when action is HTTP_CACHE_MAKE_STATIC or HTTP_CACHE_CLIENT_CACHE_CTL | [optional] 
 **differentiated_by_value** | **str**| Value to differentiate by. HTTP_CACHE_DIFFERENTIATE_BY_HEADER - header name, HTTP_CACHE_DIFFERENTIATE_BY_COOKIE - cookie name, HTTP_CACHE_DIFFERENTIATE_BY_GEO - geo location&lt;br/&gt; (ISO 3166-1 alpha-2 country codes ), otherwise irrelevant. | [optional] 
 **params** | **str**| Comma separated list of parameters to ignore. Parameters name must be alphanumeric. | [optional] 
 **_all_params** | **bool**| When set to &lt;b&gt;true&lt;/b&gt;: all parameters in cache key will be ignored.&lt;br/&gt;Default: false.&lt;br/&gt;Relevant for HTTP_CACHE_IGNORE_PARAMS action | [optional] 
 **tag_name** | **str**| The name of the tag to add. | [optional] 
 **text** | **str**| Add text to the cache key as suffix. Relevant for the HTTP_CACHE_ENRICH_CACHE_KEY action | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_custom_rule**
> ApiResult edit_custom_rule(rule_id, action=action, name=name, filter=filter, response_code=response_code, protocol=protocol, add_missing=add_missing, _from=_from, to=to, rewrite_name=rewrite_name, dc_id=dc_id, allow_caching=allow_caching, rate_context=rate_context, rate_interval=rate_interval, is_test_mode=is_test_mode, port_forwarding_context=port_forwarding_context, port_forwarding_value=port_forwarding_value, multiple_deletions=multiple_deletions, rewrite_existing=rewrite_existing)

Edit rule

Use this operation to edit an existing rule (Delivery, Security or Rate).

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
rule_id = 789 # int | Rule ID.
action = 'action_example' # str | Rule action.<br/><br/>Possible action parameter values for Delivery Rules:<br/><ul><li><b>RULE_ACTION_REDIRECT</b> Redirect the client to a different URL, responding with a 30X response.</li><li><b>RULE_ACTION_SIMPLIFIED_REDIRECT</b> Redirect the client to a different URL, responding with a 30X response.</li><li><b>RULE_ACTION_REWRITE_URL</b> Modify the path to which a specific request is targeted.</li><li><b>RULE_ACTION_REWRITE_HEADER</b> Modify or add a request header before passing traffic to the origin server.</li><li><b>RULE_ACTION_REWRITE_COOKIE</b> Modify or add cookies that are sent by the client to the origin server. The cookie name and value should be indicated.</li><li><b>RULE_ACTION_DELETE_HEADER</b> Remove a specific request header, which means that it won’t be sent to the origin server.</li><li><b>RULE_ACTION_DELETE_COOKIE</b> Remove a specific cookie set on the client, which means that it won’t be sent to the origin server.</li><li><b>RULE_ACTION_FORWARD_TO_DC</b> Define the data center to which a specific request will be sent.</li><li><b>RULE_ACTION_FORWARD_TO_PORT</b> Define the port to which a specific request will be sent.</li><li><b>RULE_ACTION_RESPONSE_REWRITE_HEADER</b> Modify or add a header to the response received from the origin server.</li><li><b>RULE_ACTION_RESPONSE_DELETE_HEADER</b> Remove a specific response header, which means that it won't be returned to the client.</li><li><b>RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE</b> Modify the response code received from the origin server.</li></ul><br/>Possible action parameter values for security rules:<br/><ul><li><b>RULE_ACTION_ALERT</b> Generate a non blocking alert for this event.</li><li><b>RULE_ACTION_BLOCK</b> Block the current request and generate an alert for this event.</li><li><b>RULE_ACTION_BLOCK_USER</b> Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.</li><li><b>RULE_ACTION_BLOCK_IP</b> Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.</li><li><b>RULE_ACTION_RETRY</b> Require any client matching the rule filters to support cookies in order to complete the request.</li><li><b>RULE_ACTION_INTRUSIVE_HTML</b> Require any client matching the rule filters to support javascript in order to complete the request. Since the Javascript test is embedded in an HTML page, this action should only be enabled for HTML resources.</li><li><b>RULE_ACTION_CAPTCHA</b> Require any client matching the rule filters to pass a CAPTCHA test in order to complete the request. Since the CAPTCHA test is embedded in an HTML page, this action should only be enabled for HTML resources.</li></ul><br/>Possible action parameter values for counter (rate) rules:<br/><ul><li><b>RULE_ACTION_RATE</b> Count the number of requests received that match the rule filter.</li></ul> (optional)
name = 'name_example' # str | Rule name. (optional)
filter = 'filter_example' # str | Rule will trigger only a request that matches this filter. For more details on filter guidelines, see <a href=\"https://docs.imperva.com/csh?context=rule_syntax\">Syntax Guide</a>. (optional)
response_code = 56 # int | Redirect rule's response code. Valid values are 302, 301, 303, 307, 308. (optional)
protocol = 'protocol_example' # str |  (optional)
add_missing = true # bool | Add cookie or header if it doesn't exist (Rewrite cookie rule only) (optional)
_from = '_from_example' # str | The pattern to rewrite.<br/>For RULE_ACTION_REWRITE_URL - The URL to rewrite.<br/>For RULE_ACTION_REWRITE_HEADER - The header value to rewrite.<br/>For RULE_ACTION_REWRITE_COOKIE - The cookie value to rewrite.<br/>For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. (optional)
to = 'to_example' # str | The pattern to change to.<br/>For RULE_ACTION_REWRITE_URL - The URL to change to.<br/>For RULE_ACTION_REWRITE_HEADER - The header value to change to.<br/>For RULE_ACTION_REWRITE_COOKIE - The cookie value to change to.<br/>For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. (optional)
rewrite_name = 'rewrite_name_example' # str | Name of cookie or header to rewrite. Applies only for RULE_ACTION_REWRITE_COOKIE and RULE_ACTION_REWRITE_HEADER. (optional)
dc_id = 789 # int | Data center to forward request to. Applies only for RULE_ACTION_FORWARD_TO_DC. (optional)
allow_caching = true # bool |  (optional)
rate_context = 'rate_context_example' # str | The context of the rate counter. Possible values: IP / Session. Applies only to rules using RULE_ACTION_RATE. (optional)
rate_interval = 56 # int | The interval (in seconds) of the rate counter. Possible values: A multiple of 10 from 10-300. Applies only to rules using RULE_ACTION_RATE. (optional)
is_test_mode = true # bool | Make rule apply only for IP address the API request was sent from.<br/>This option is not available for Simplified Redirect rules. (optional)
port_forwarding_context = 'port_forwarding_context_example' # str | Context for port forwarding. \"Use Port Value\" or \"Use Header Name\". Applies only for RULE_ACTION_FORWARD_TO_PORT. (optional)
port_forwarding_value = 'port_forwarding_value_example' # str | Port number or header name for port forwarding. Applies only for RULE_ACTION_FORWARD_TO_PORT. (optional)
multiple_deletions = true # bool | Delete multiple header occurrences. Applies only to rules using RULE_ACTION_DELETE_HEADER and RULE_ACTION_RESPONSE_DELETE_HEADER. (optional)
rewrite_existing = true # bool | Rewrite cookie or header if it exists (optional)

try:
    # Edit rule
    api_response = api_instance.edit_custom_rule(rule_id, action=action, name=name, filter=filter, response_code=response_code, protocol=protocol, add_missing=add_missing, _from=_from, to=to, rewrite_name=rewrite_name, dc_id=dc_id, allow_caching=allow_caching, rate_context=rate_context, rate_interval=rate_interval, is_test_mode=is_test_mode, port_forwarding_context=port_forwarding_context, port_forwarding_value=port_forwarding_value, multiple_deletions=multiple_deletions, rewrite_existing=rewrite_existing)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->edit_custom_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rule_id** | **int**| Rule ID. | 
 **action** | **str**| Rule action.&lt;br/&gt;&lt;br/&gt;Possible action parameter values for Delivery Rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REDIRECT&lt;/b&gt; Redirect the client to a different URL, responding with a 30X response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_SIMPLIFIED_REDIRECT&lt;/b&gt; Redirect the client to a different URL, responding with a 30X response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_URL&lt;/b&gt; Modify the path to which a specific request is targeted.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_HEADER&lt;/b&gt; Modify or add a request header before passing traffic to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_REWRITE_COOKIE&lt;/b&gt; Modify or add cookies that are sent by the client to the origin server. The cookie name and value should be indicated.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_DELETE_HEADER&lt;/b&gt; Remove a specific request header, which means that it won’t be sent to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_DELETE_COOKIE&lt;/b&gt; Remove a specific cookie set on the client, which means that it won’t be sent to the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_FORWARD_TO_DC&lt;/b&gt; Define the data center to which a specific request will be sent.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_FORWARD_TO_PORT&lt;/b&gt; Define the port to which a specific request will be sent.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_REWRITE_HEADER&lt;/b&gt; Modify or add a header to the response received from the origin server.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_DELETE_HEADER&lt;/b&gt; Remove a specific response header, which means that it won&#x27;t be returned to the client.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RESPONSE_REWRITE_RESPONSE_CODE&lt;/b&gt; Modify the response code received from the origin server.&lt;/li&gt;&lt;/ul&gt;&lt;br/&gt;Possible action parameter values for security rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_ALERT&lt;/b&gt; Generate a non blocking alert for this event.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK&lt;/b&gt; Block the current request and generate an alert for this event.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK_USER&lt;/b&gt; Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_BLOCK_IP&lt;/b&gt; Block the current session and generate an alert for this event. Any subsequent request from the same Session will be blocked.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RETRY&lt;/b&gt; Require any client matching the rule filters to support cookies in order to complete the request.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_INTRUSIVE_HTML&lt;/b&gt; Require any client matching the rule filters to support javascript in order to complete the request. Since the Javascript test is embedded in an HTML page, this action should only be enabled for HTML resources.&lt;/li&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_CAPTCHA&lt;/b&gt; Require any client matching the rule filters to pass a CAPTCHA test in order to complete the request. Since the CAPTCHA test is embedded in an HTML page, this action should only be enabled for HTML resources.&lt;/li&gt;&lt;/ul&gt;&lt;br/&gt;Possible action parameter values for counter (rate) rules:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;RULE_ACTION_RATE&lt;/b&gt; Count the number of requests received that match the rule filter.&lt;/li&gt;&lt;/ul&gt; | [optional] 
 **name** | **str**| Rule name. | [optional] 
 **filter** | **str**| Rule will trigger only a request that matches this filter. For more details on filter guidelines, see &lt;a href&#x3D;\&quot;https://docs.imperva.com/csh?context&#x3D;rule_syntax\&quot;&gt;Syntax Guide&lt;/a&gt;. | [optional] 
 **response_code** | **int**| Redirect rule&#x27;s response code. Valid values are 302, 301, 303, 307, 308. | [optional] 
 **protocol** | **str**|  | [optional] 
 **add_missing** | **bool**| Add cookie or header if it doesn&#x27;t exist (Rewrite cookie rule only) | [optional] 
 **_from** | **str**| The pattern to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_URL - The URL to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_HEADER - The header value to rewrite.&lt;br/&gt;For RULE_ACTION_REWRITE_COOKIE - The cookie value to rewrite.&lt;br/&gt;For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. | [optional] 
 **to** | **str**| The pattern to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_URL - The URL to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_HEADER - The header value to change to.&lt;br/&gt;For RULE_ACTION_REWRITE_COOKIE - The cookie value to change to.&lt;br/&gt;For RULE_ACTION_SIMPLIFIED_REDIRECT - Redirect the client to a different URL, responding with a 30X response. | [optional] 
 **rewrite_name** | **str**| Name of cookie or header to rewrite. Applies only for RULE_ACTION_REWRITE_COOKIE and RULE_ACTION_REWRITE_HEADER. | [optional] 
 **dc_id** | **int**| Data center to forward request to. Applies only for RULE_ACTION_FORWARD_TO_DC. | [optional] 
 **allow_caching** | **bool**|  | [optional] 
 **rate_context** | **str**| The context of the rate counter. Possible values: IP / Session. Applies only to rules using RULE_ACTION_RATE. | [optional] 
 **rate_interval** | **int**| The interval (in seconds) of the rate counter. Possible values: A multiple of 10 from 10-300. Applies only to rules using RULE_ACTION_RATE. | [optional] 
 **is_test_mode** | **bool**| Make rule apply only for IP address the API request was sent from.&lt;br/&gt;This option is not available for Simplified Redirect rules. | [optional] 
 **port_forwarding_context** | **str**| Context for port forwarding. \&quot;Use Port Value\&quot; or \&quot;Use Header Name\&quot;. Applies only for RULE_ACTION_FORWARD_TO_PORT. | [optional] 
 **port_forwarding_value** | **str**| Port number or header name for port forwarding. Applies only for RULE_ACTION_FORWARD_TO_PORT. | [optional] 
 **multiple_deletions** | **bool**| Delete multiple header occurrences. Applies only to rules using RULE_ACTION_DELETE_HEADER and RULE_ACTION_RESPONSE_DELETE_HEADER. | [optional] 
 **rewrite_existing** | **bool**| Rewrite cookie or header if it exists | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_data_center**
> InlineResponse20017 edit_data_center(dc_id, name=name, is_enabled=is_enabled, is_standby=is_standby, is_content=is_content)

Edit data center

Use this operation to edit site's data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
dc_id = 789 # int | The data center's ID.
name = 'name_example' # str | The new data center's name. (optional)
is_enabled = true # bool | Enables the data center. (optional)
is_standby = true # bool | Defines the data center as <b>standby</b> for failover. (optional)
is_content = true # bool | The data center will be available for specific resources (<b>Forward</b> Delivery Rules). (optional)

try:
    # Edit data center
    api_response = api_instance.edit_data_center(dc_id, name=name, is_enabled=is_enabled, is_standby=is_standby, is_content=is_content)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->edit_data_center: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dc_id** | **int**| The data center&#x27;s ID. | 
 **name** | **str**| The new data center&#x27;s name. | [optional] 
 **is_enabled** | **bool**| Enables the data center. | [optional] 
 **is_standby** | **bool**| Defines the data center as &lt;b&gt;standby&lt;/b&gt; for failover. | [optional] 
 **is_content** | **bool**| The data center will be available for specific resources (&lt;b&gt;Forward&lt;/b&gt; Delivery Rules). | [optional] 

### Return type

[**InlineResponse20017**](InlineResponse20017.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_dc_server**
> InlineResponse20016 edit_dc_server(server_id, server_address=server_address, is_enabled=is_enabled, is_standby=is_standby)

Edit server

Use this operation to edit a server in a data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
server_id = 789 # int | Server ID.
server_address = 'server_address_example' # str | The IP address of the server to modify. (optional)
is_enabled = true # bool | Enable or disable the server (Boolean). (optional)
is_standby = true # bool | Set the server as Active (P0) or Standby (P1) (Boolean). (optional)

try:
    # Edit server
    api_response = api_instance.edit_dc_server(server_id, server_address=server_address, is_enabled=is_enabled, is_standby=is_standby)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->edit_dc_server: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **server_id** | **int**| Server ID. | 
 **server_address** | **str**| The IP address of the server to modify. | [optional] 
 **is_enabled** | **bool**| Enable or disable the server (Boolean). | [optional] 
 **is_standby** | **bool**| Set the server as Active (P0) or Standby (P1) (Boolean). | [optional] 

### Return type

[**InlineResponse20016**](InlineResponse20016.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **enable_cache_shield**
> ApiResult enable_cache_shield(site_id, enable)

Enable cache shield

Enable Cache Shield for a given site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
enable = true # bool | Use <b>true</b> to enable cache shield on the specified site, and <b>false</b> to disable it.

try:
    # Enable cache shield
    api_response = api_instance.enable_cache_shield(site_id, enable)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->enable_cache_shield: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **enable** | **bool**| Use &lt;b&gt;true&lt;/b&gt; to enable cache shield on the specified site, and &lt;b&gt;false&lt;/b&gt; to disable it. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **enable_disable_cache_rule**
> ApiResult enable_disable_cache_rule(site_id, rule_id, enable)

Enable or disable cache rule

Use this operation for enabling or disable cache rule

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
rule_id = 789 # int | Numeric identifier of the site to operate on.
enable = 'enable_example' # str | When true, the rule will be enabled. Set to false to disable.

try:
    # Enable or disable cache rule
    api_response = api_instance.enable_disable_cache_rule(site_id, rule_id, enable)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->enable_disable_cache_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **rule_id** | **int**| Numeric identifier of the site to operate on. | 
 **enable** | **str**| When true, the rule will be enabled. Set to false to disable. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **enable_disable_custom_rule**
> ApiResult enable_disable_custom_rule(rule_id, enable)

Enable or disable rule

Use this operation to enable or disable a rule (Delivery, Security or Rate).

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
rule_id = 789 # int | Rule id
enable = true # bool | When true, the rule will be enabled. Set to false to disable

try:
    # Enable or disable rule
    api_response = api_instance.enable_disable_custom_rule(rule_id, enable)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->enable_disable_custom_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rule_id** | **int**| Rule id | 
 **enable** | **bool**| When true, the rule will be enabled. Set to false to disable | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_advanced_caching_settings**
> InlineResponse20020 get_advanced_caching_settings(site_id, param)

Get advanced caching settings

Use this operation to get advanced caching settings.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
param = 'param_example' # str | Name of configuration parameter to set.<br/>Possible values for param and value parameters:<br/><ul><li><b>async_validation</b> Sets Async validation. Pass \"true\" or \"false\" in the value parameter.</li><li><b>minify_javascript</b> Sets the Minify JS. Pass \"true\" or \"false\" in the value parameter.</li><li><b>minify_css</b> Sets the Minify CSS. Pass \"true\" or \"false\" in the value parameter</li><li><b>minify_static_html</b> Sets Minify static HTML. Pass \"true\" or \"false\" in the value parameter</li><li><b>compress_jpeg</b> Sets the Compress JPEG. Pass \"true\" or \"false\" in the value parameter.</li><li><b>progressive_image_rendering</b> Sets the Progressive Image rendering flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>aggressive_compression</b> Sets the Aggressive compression rendering flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>compress_png</b> Sets the Compress PNG flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>on_the_fly_compression</b> \"On the fly\" Compression. Pass \"true\" or \"false\" in the value parameter.</li><li><b>tcp_pre_pooling</b> TCP Pre-Pooling. Pass \"true\" or \"false\" in the value parameter.</li><li><b>comply_no_cache</b> Comply with no-cache and max-age directives in client requests. Pass \"true\" or \"false\" in the value parameter.</li><li><b>comply_vary</b> Comply with the <b>Vary</b> header. Pass \"true\" or \"false\" in the value parameter.</li><li><b>use_shortest_caching</b> Use shortest caching duration in case of conflicts. Pass \"true\" or \"false\" in the value parameter.</li><li><b>prefer_last_modified</b> Prefer 'last modified' over eTag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>disable_client_side_caching</b> Disable client side caching. Pass \"true\" or \"false\" in the value parameter.</li><li><b>cache_300x</b> Cache 300X responses. Pass \"true\" or \"false\" in the value parameter.</li><li><b>unite_naked_full_cache</b> Use the same cache for full and naked domains. For example, use the same cached resource for <a href=\"https://www.example.com/a\"></a> and <a href=\"https://example.com/\"></a>a.</li><li><b>cache_empty_responses</b> Cache responses that don’t have a message body.</li><li><b>cache_http_10_responses</b> Cache HTTP 1.0 type responses that don’t include the Content-Length header or chunking. Pass \"true\" or \"false\" in the value parameter.</li><li><b>send_age_header</b> Send <b>Cache-Control: max-age</b> and <b>Age</b> headers. Pass \"true\" or \"false\" in the value parameter.</li><li><b>support_non_sni_clients</b> By default, non-SNI clients are supported. Disable this option to block non-SNI clients. Pass \"true\" or \"false\" in the value parameter.</li><li><b>origin_connection_reuse</b> By default, TCP connections that are opened for a client request remain open for a short time to handle additional requests that may arrive. This option disables that behavior.. Pass \"true\" or \"false\" in the value parameter.</li><li><b>redirect_http_to_https</b> Redirect HTTP requests to HTTPS requests by sending an HTTP 301 response.</li><li><b>redirect_naked_domain_to_full</b> Redirect requests from your website's naked domain to its full domain by sending and HTTP 301 response.</li><li><b>http_2</b> Enables supporting browsers to take advantage of the performance enhancements provided by HTTP/2 for your website. Non-supporting browsers can connect via HTTP/1.0 or HTTP/1.1. HTTP/2 support requires that SSL is configured for your website. Pass \"true\" or \"false\" in the value parameter</li></ul>

try:
    # Get advanced caching settings
    api_response = api_instance.get_advanced_caching_settings(site_id, param)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_advanced_caching_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **param** | **str**| Name of configuration parameter to set.&lt;br/&gt;Possible values for param and value parameters:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;async_validation&lt;/b&gt; Sets Async validation. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_javascript&lt;/b&gt; Sets the Minify JS. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_css&lt;/b&gt; Sets the Minify CSS. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_static_html&lt;/b&gt; Sets Minify static HTML. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;li&gt;&lt;b&gt;compress_jpeg&lt;/b&gt; Sets the Compress JPEG. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;progressive_image_rendering&lt;/b&gt; Sets the Progressive Image rendering flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;aggressive_compression&lt;/b&gt; Sets the Aggressive compression rendering flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;compress_png&lt;/b&gt; Sets the Compress PNG flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;on_the_fly_compression&lt;/b&gt; \&quot;On the fly\&quot; Compression. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;tcp_pre_pooling&lt;/b&gt; TCP Pre-Pooling. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;comply_no_cache&lt;/b&gt; Comply with no-cache and max-age directives in client requests. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;comply_vary&lt;/b&gt; Comply with the &lt;b&gt;Vary&lt;/b&gt; header. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;use_shortest_caching&lt;/b&gt; Use shortest caching duration in case of conflicts. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;prefer_last_modified&lt;/b&gt; Prefer &#x27;last modified&#x27; over eTag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;disable_client_side_caching&lt;/b&gt; Disable client side caching. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_300x&lt;/b&gt; Cache 300X responses. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;unite_naked_full_cache&lt;/b&gt; Use the same cache for full and naked domains. For example, use the same cached resource for &lt;a href&#x3D;\&quot;https://www.example.com/a\&quot;&gt;&lt;/a&gt; and &lt;a href&#x3D;\&quot;https://example.com/\&quot;&gt;&lt;/a&gt;a.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_empty_responses&lt;/b&gt; Cache responses that don’t have a message body.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_http_10_responses&lt;/b&gt; Cache HTTP 1.0 type responses that don’t include the Content-Length header or chunking. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;send_age_header&lt;/b&gt; Send &lt;b&gt;Cache-Control: max-age&lt;/b&gt; and &lt;b&gt;Age&lt;/b&gt; headers. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;support_non_sni_clients&lt;/b&gt; By default, non-SNI clients are supported. Disable this option to block non-SNI clients. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;origin_connection_reuse&lt;/b&gt; By default, TCP connections that are opened for a client request remain open for a short time to handle additional requests that may arrive. This option disables that behavior.. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;redirect_http_to_https&lt;/b&gt; Redirect HTTP requests to HTTPS requests by sending an HTTP 301 response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;redirect_naked_domain_to_full&lt;/b&gt; Redirect requests from your website&#x27;s naked domain to its full domain by sending and HTTP 301 response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;http_2&lt;/b&gt; Enables supporting browsers to take advantage of the performance enhancements provided by HTTP/2 for your website. Non-supporting browsers can connect via HTTP/1.0 or HTTP/1.1. HTTP/2 support requires that SSL is configured for your website. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;/ul&gt; | 

### Return type

[**InlineResponse20020**](InlineResponse20020.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_bots_configuration**
> BotsConfigurationDTO get_bots_configuration(ext_site_id)

Get website bot configuration

Retrieve the Bot Access Control configuration for a given website.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
ext_site_id = 789 # int | 

try:
    # Get website bot configuration
    api_response = api_instance.get_bots_configuration(ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_bots_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ext_site_id** | **int**|  | 

### Return type

[**BotsConfigurationDTO**](BotsConfigurationDTO.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cache404_settings**
> InlineResponse20021 get_cache404_settings(site_id)

Get cache 404 settings

Use this operation to get the caching settings of 404 responses for a site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get cache 404 settings
    api_response = api_instance.get_cache404_settings(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_cache404_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20021**](InlineResponse20021.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_caching_mode**
> InlineResponse20022 get_caching_mode(site_id)

Get caching mode

Use this operation to get a site's caching mode.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get caching mode
    api_response = api_instance.get_caching_mode(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_caching_mode: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20022**](InlineResponse20022.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_data_region**
> InlineResponse20031 get_data_region(site_id)

Get site data storage region

Use this operation to get the site data region.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.

try:
    # Get site data storage region
    api_response = api_instance.get_data_region(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_data_region: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20031**](InlineResponse20031.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_html_injection_rules**
> InlineResponse20032 get_html_injection_rules(site_id)

Get HTML injection rules

Use this operation to list all the HTML Injection rules

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on

try:
    # Get HTML injection rules
    api_response = api_instance.get_html_injection_rules(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_html_injection_rules: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 

### Return type

[**InlineResponse20032**](InlineResponse20032.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_override_site_regions_by_geo**
> ApiResult get_override_site_regions_by_geo()

Check site regions by origin geolocation

Use this operation to check if the data storage region for each new site is based on the geolocation of the origin server.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))

try:
    # Check site regions by origin geolocation
    api_response = api_instance.get_override_site_regions_by_geo()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_override_site_regions_by_geo: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recommended_data_center_origin_po_ps**
> InlineResponse20018 get_recommended_data_center_origin_po_ps(dc_id)

Get data center recommended origin PoPs

Get a list of recommended origin PoPs for a given data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
dc_id = 789 # int | Numeric identifier of the data center to operate on.

try:
    # Get data center recommended origin PoPs
    api_response = api_instance.get_recommended_data_center_origin_po_ps(dc_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_recommended_data_center_origin_po_ps: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dc_id** | **int**| Numeric identifier of the data center to operate on. | 

### Return type

[**InlineResponse20018**](InlineResponse20018.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_response_header_settings**
> InlineResponse20023 get_response_header_settings(site_id)

Get cached response headers

Use this operation to get a site's cached response headers.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get cached response headers
    api_response = api_instance.get_response_header_settings(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_response_header_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20023**](InlineResponse20023.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_rewrite_ports**
> InlineResponse20024 get_rewrite_ports(site_id)

Get rewrite port

Use this operation to get the rewritten port number used to access the origin server.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on

try:
    # Get rewrite port
    api_response = api_instance.get_rewrite_ports(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_rewrite_ports: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 

### Return type

[**InlineResponse20024**](InlineResponse20024.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_secure_resources_mode**
> InlineResponse20025 get_secure_resources_mode(site_id)

Get secure resources mode

Use this operation to get the Secure Resources mode for a site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on

try:
    # Get secure resources mode
    api_response = api_instance.get_secure_resources_mode(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_secure_resources_mode: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 

### Return type

[**InlineResponse20025**](InlineResponse20025.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_site_error_page_template**
> ApiResult get_site_error_page_template(site_id)

Get error page

Use this operation to get the custom error page for a given site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get error page
    api_response = api_instance.get_site_error_page_template(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_site_error_page_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_site_report**
> InlineResponse20033 get_site_report(site_id, report, format, time_range, start=start, end=end)

Get site report

Use this operation to get a report for a site. Reports are sent using Base64 encoding.The time_range parameter is ignored for accounts with the WAF Rules policy feature. For such accounts, the report returns the current status.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
report = 'report_example' # str | The report to get. One of: pci-compliance
format = 'format_example' # str | The format to get the report in. One of: pdf | html
time_range = 'time_range_example' # str | Time range to fetch data for.<br/>Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:<br/><ul><li><b>today</b> Retrieve data from midnight today until the current time.</li><li><b>last_7_days</b> Retrieve data from midnight of 7 days ago until the current time.</li><li><b>last_30_days</b> Retrieve data from midnight of 30 days ago until the current time.</li><li><b>last_90_days</b> Retrieve data from midnight of 90 days ago until the current time.</li><li><b>month_to_date</b> Retrieve data from midnight of the first day of the month until the current time.</li><li><b>custom</b> Specify a custom time range using two additional parameters: start and end.<br/>Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.<br/>For example:<ul><li>A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.</li><li>A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.</li> <li>A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.</li></ul></li></ul>
start = 'start_example' # str | Start date in milliseconds since 1970.<br/>Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:<br/><ul><li><b>today</b> Retrieve data from midnight today until the current time.</li><li><b>last_7_days</b> Retrieve data from midnight of 7 days ago until the current time.</li><li><b>last_30_days</b> Retrieve data from midnight of 30 days ago until the current time.</li><li><b>last_90_days</b> Retrieve data from midnight of 90 days ago until the current time.</li><li><b>month_to_date</b> Retrieve data from midnight of the first day of the month until the current time.</li><li><b>custom</b> Specify a custom time range using two additional parameters: start and end.<br/>Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.<br/>For example:<ul><li>A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.</li><li>A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.</li> <li>A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.</li></ul></li></ul> (optional)
end = 'end_example' # str | End date in milliseconds since 1970.<br/>Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:<br/><ul><li><b>today</b> Retrieve data from midnight today until the current time.</li><li><b>last_7_days</b> Retrieve data from midnight of 7 days ago until the current time.</li><li><b>last_30_days</b> Retrieve data from midnight of 30 days ago until the current time.</li><li><b>last_90_days</b> Retrieve data from midnight of 90 days ago until the current time.</li><li><b>month_to_date</b> Retrieve data from midnight of the first day of the month until the current time.</li><li><b>custom</b> Specify a custom time range using two additional parameters: start and end.<br/>Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.<br/>For example:<ul><li>A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.</li><li>A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.</li> <li>A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.</li></ul></li></ul> (optional)

try:
    # Get site report
    api_response = api_instance.get_site_report(site_id, report, format, time_range, start=start, end=end)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_site_report: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **report** | **str**| The report to get. One of: pci-compliance | 
 **format** | **str**| The format to get the report in. One of: pdf | html | 
 **time_range** | **str**| Time range to fetch data for.&lt;br/&gt;Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;today&lt;/b&gt; Retrieve data from midnight today until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_7_days&lt;/b&gt; Retrieve data from midnight of 7 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_30_days&lt;/b&gt; Retrieve data from midnight of 30 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_90_days&lt;/b&gt; Retrieve data from midnight of 90 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;month_to_date&lt;/b&gt; Retrieve data from midnight of the first day of the month until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;custom&lt;/b&gt; Specify a custom time range using two additional parameters: start and end.&lt;br/&gt;Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.&lt;br/&gt;For example:&lt;ul&gt;&lt;li&gt;A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.&lt;/li&gt;&lt;li&gt;A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.&lt;/li&gt; &lt;li&gt;A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;/ul&gt; | 
 **start** | **str**| Start date in milliseconds since 1970.&lt;br/&gt;Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;today&lt;/b&gt; Retrieve data from midnight today until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_7_days&lt;/b&gt; Retrieve data from midnight of 7 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_30_days&lt;/b&gt; Retrieve data from midnight of 30 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_90_days&lt;/b&gt; Retrieve data from midnight of 90 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;month_to_date&lt;/b&gt; Retrieve data from midnight of the first day of the month until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;custom&lt;/b&gt; Specify a custom time range using two additional parameters: start and end.&lt;br/&gt;Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.&lt;br/&gt;For example:&lt;ul&gt;&lt;li&gt;A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.&lt;/li&gt;&lt;li&gt;A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.&lt;/li&gt; &lt;li&gt;A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;/ul&gt; | [optional] 
 **end** | **str**| End date in milliseconds since 1970.&lt;br/&gt;Some operations require the user to specify a time range. This is done via the time_range parameter, which accepts the following values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;today&lt;/b&gt; Retrieve data from midnight today until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_7_days&lt;/b&gt; Retrieve data from midnight of 7 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_30_days&lt;/b&gt; Retrieve data from midnight of 30 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;last_90_days&lt;/b&gt; Retrieve data from midnight of 90 days ago until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;month_to_date&lt;/b&gt; Retrieve data from midnight of the first day of the month until the current time.&lt;/li&gt;&lt;li&gt;&lt;b&gt;custom&lt;/b&gt; Specify a custom time range using two additional parameters: start and end.&lt;br/&gt;Results are provided for full days only, starting from midnight. A time range of less than 24 hours gives results for the full day.&lt;br/&gt;For example:&lt;ul&gt;&lt;li&gt;A time range of 14:00 - 20:00 yesterday gives results for all of yesterday (midnight to midnight) - a full day.&lt;/li&gt;&lt;li&gt;A time range of 14:00 last Tuesday to 14:00 last Wednesday gives results for all of Tuesday and Wednesday - two full days.&lt;/li&gt; &lt;li&gt;A time range of 14:00 yesterday to 14:00 today gives results for all of yesterday starting from midnight until the current time today.&lt;/li&gt;&lt;/ul&gt;&lt;/li&gt;&lt;/ul&gt; | [optional] 

### Return type

[**InlineResponse20033**](InlineResponse20033.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_stale_content**
> InlineResponse20026 get_stale_content(site_id)

Get stale content settings

When Imperva can't connect to the origin server, serve stale content instead of displaying an error to end users for the specified amount of time. Expired resources are returned from cache, and refreshed asynchronously in the background.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get stale content settings
    api_response = api_instance.get_stale_content(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_stale_content: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20026**](InlineResponse20026.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_tag_response_header**
> InlineResponse20027 get_tag_response_header(site_id)

Get header to tag responses by

Get the origin response header containing the cache tags in your resources

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get header to tag responses by
    api_response = api_instance.get_tag_response_header(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_tag_response_header: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20027**](InlineResponse20027.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_tls_configuration**
> TLSConfigurationDto get_tls_configuration(ext_site_id)

Get website TLS configuration

Retrieve the TLS configuration for a given website.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
ext_site_id = 789 # int | The Imperva ID of the website to operate on.

try:
    # Get website TLS configuration
    api_response = api_instance.get_tls_configuration(ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_tls_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ext_site_id** | **int**| The Imperva ID of the website to operate on. | 

### Return type

[**TLSConfigurationDto**](TLSConfigurationDto.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_xray_link**
> InlineResponse20028 get_xray_link(site_id)

Get XRay access link

Use this operation to get a URL that enables debug headers on the specific site. For more details see <a href=\"https://docs.imperva.com/bundle/cloud-application-security/page/settings/xray-debug-headers.htm\">XRAY Debug Headers Guide</a>

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.

try:
    # Get XRay access link
    api_response = api_instance.get_xray_link(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->get_xray_link: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20028**](InlineResponse20028.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **is_cache_shield_enabled**
> InlineResponse20029 is_cache_shield_enabled(site_id)

Is cache shield enabled

Get the enablement state of the Cache Shield feature for a given site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.

try:
    # Is cache shield enabled
    api_response = api_instance.is_cache_shield_enabled(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->is_cache_shield_enabled: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20029**](InlineResponse20029.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_account_custom_rules**
> ListCustomRulesResponse list_account_custom_rules(account_id, include_incap_rules=include_incap_rules, include_ad_rules=include_ad_rules)

List account rules

Use this operation to list rules (Delivery, Security or Rate) for all sites under a given account.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
account_id = 789 # int | Numeric identifier of the account to operate on
include_incap_rules = true # bool | Whether or not security rules be included. Defaults to \"Yes\". (optional)
include_ad_rules = true # bool | Whether or not delivery rules should be included. Defaults to \"Yes\". (optional)

try:
    # List account rules
    api_response = api_instance.list_account_custom_rules(account_id, include_incap_rules=include_incap_rules, include_ad_rules=include_ad_rules)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_account_custom_rules: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **account_id** | **int**| Numeric identifier of the account to operate on | 
 **include_incap_rules** | **bool**| Whether or not security rules be included. Defaults to \&quot;Yes\&quot;. | [optional] 
 **include_ad_rules** | **bool**| Whether or not delivery rules should be included. Defaults to \&quot;Yes\&quot;. | [optional] 

### Return type

[**ListCustomRulesResponse**](ListCustomRulesResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_cache_rules**
> InlineResponse2004 list_cache_rules(site_id, page_size=page_size, page_num=page_num)

List cache rules for a given site

Use this operation for representing cache rules for a given site

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
page_size = 'page_size_example' # str | The number of objects to return in the response.<br/>Default is 50.<br/>Maximum: 100 (optional)
page_num = 'page_num_example' # str | The page to return starting from 0. Default is 0. (optional)

try:
    # List cache rules for a given site
    api_response = api_instance.list_cache_rules(site_id, page_size=page_size, page_num=page_num)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_cache_rules: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **page_size** | **str**| The number of objects to return in the response.&lt;br/&gt;Default is 50.&lt;br/&gt;Maximum: 100 | [optional] 
 **page_num** | **str**| The page to return starting from 0. Default is 0. | [optional] 

### Return type

[**InlineResponse2004**](InlineResponse2004.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_custom_rules**
> ListCustomRulesResponse list_custom_rules(site_id, include_incap_rules=include_incap_rules, include_ad_rules=include_ad_rules, page_size=page_size, page_num=page_num)

List rules

Use this operation to list security, delivery, and rate rules for a given site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
include_incap_rules = 'include_incap_rules_example' # str | Whether or not security rules be included. Defaults to \"Yes\". (optional)
include_ad_rules = 'include_ad_rules_example' # str | Whether or not delivery rules should be included. Defaults to Yes (optional)
page_size = 'page_size_example' # str | The number of objects to return in the response. Defaults to 50. Maximum is 100 (optional)
page_num = 'page_num_example' # str | The page to return starting from 0. Default to 0 (optional)

try:
    # List rules
    api_response = api_instance.list_custom_rules(site_id, include_incap_rules=include_incap_rules, include_ad_rules=include_ad_rules, page_size=page_size, page_num=page_num)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_custom_rules: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **include_incap_rules** | **str**| Whether or not security rules be included. Defaults to \&quot;Yes\&quot;. | [optional] 
 **include_ad_rules** | **str**| Whether or not delivery rules should be included. Defaults to Yes | [optional] 
 **page_size** | **str**| The number of objects to return in the response. Defaults to 50. Maximum is 100 | [optional] 
 **page_num** | **str**| The page to return starting from 0. Default to 0 | [optional] 

### Return type

[**ListCustomRulesResponse**](ListCustomRulesResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_data_centers**
> InlineResponse20019 list_data_centers(site_id)

List data centers

Use this operation to list a site's data centers including the data centers' servers.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.

try:
    # List data centers
    api_response = api_instance.list_data_centers(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_data_centers: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 

### Return type

[**InlineResponse20019**](InlineResponse20019.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_data_centers_configuration**
> DataCentersConfigurationDTO list_data_centers_configuration(ext_site_id)

get site's data centers' configuration

Use this operation to get configured data centers and all their servers

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
ext_site_id = 789 # int | 

try:
    # get site's data centers' configuration
    api_response = api_instance.list_data_centers_configuration(ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_data_centers_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ext_site_id** | **int**|  | 

### Return type

[**DataCentersConfigurationDTO**](DataCentersConfigurationDTO.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_sites**
> ApiResultListSites list_sites(account_id=account_id, page_size=page_size, page_num=page_num)

List sites

List sites for an account

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters.<br/>If the account has sub accounts, the operation returns results for the sites in the account and in all of its sub accounts. (optional)
page_size = 'page_size_example' # str | The number of objects to return in the response. Default is 50. Maximum: 100 (optional)
page_num = 'page_num_example' # str | The page to return starting from 0. Default is 0 (optional)

try:
    # List sites
    api_response = api_instance.list_sites(account_id=account_id, page_size=page_size, page_num=page_num)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->list_sites: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **account_id** | **str**| Numeric identifier of the account to operate on.&lt;br/&gt;If not specified, operation will be performed on the account identified by the authentication parameters.&lt;br/&gt;If the account has sub accounts, the operation returns results for the sites in the account and in all of its sub accounts. | [optional] 
 **page_size** | **str**| The number of objects to return in the response. Default is 50. Maximum: 100 | [optional] 
 **page_num** | **str**| The page to return starting from 0. Default is 0 | [optional] 

### Return type

[**ApiResultListSites**](ApiResultListSites.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_advanced_caching_settings**
> ApiResult modify_advanced_caching_settings(site_id, param, value)

Advanced caching settings

Use this operation to modify advanced caching settings.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
param = 'param_example' # str | Name of configuration parameter to set.<br/>Possible values for param and value parameters:<br/><ul><li><b>async_validation</b> Sets Async validation. Pass \"true\" or \"false\" in the value parameter.</li><li><b>minify_javascript</b> Sets the Minify JS. Pass \"true\" or \"false\" in the value parameter.</li><li><b>minify_css</b> Sets the Minify CSS. Pass \"true\" or \"false\" in the value parameter</li><li><b>minify_static_html</b> Sets Minify static HTML. Pass \"true\" or \"false\" in the value parameter</li><li><b>compress_jpeg</b> Sets the Compress JPEG. Pass \"true\" or \"false\" in the value parameter.</li><li><b>progressive_image_rendering</b> Sets the Progressive Image rendering flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>aggressive_compression</b> Sets the Aggressive compression rendering flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>compress_png</b> Sets the Compress PNG flag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>on_the_fly_compression</b> \"On the fly\" Compression. Pass \"true\" or \"false\" in the value parameter.</li><li><b>tcp_pre_pooling</b> TCP Pre-Pooling. Pass \"true\" or \"false\" in the value parameter.</li><li><b>comply_no_cache</b> Comply with no-cache and max-age directives in client requests. Pass \"true\" or \"false\" in the value parameter.</li><li><b>comply_vary</b> Comply with the <b>Vary</b> header. Pass \"true\" or \"false\" in the value parameter.</li><li><b>use_shortest_caching</b> Use shortest caching duration in case of conflicts. Pass \"true\" or \"false\" in the value parameter.</li><li><b>prefer_last_modified</b> Prefer 'last modified' over eTag. Pass \"true\" or \"false\" in the value parameter.</li><li><b>disable_client_side_caching</b> Disable client side caching. Pass \"true\" or \"false\" in the value parameter.</li><li><b>cache_300x</b> Cache 300X responses. Pass \"true\" or \"false\" in the value parameter.</li><li><b>unite_naked_full_cache</b> Use the same cache for full and naked domains. For example, use the same cached resource for <a href=\"https://www.example.com/a\"></a> and <a href=\"https://example.com/\"></a>a.</li><li><b>cache_empty_responses</b> Cache responses that don’t have a message body.</li><li><b>cache_http_10_responses</b> Cache HTTP 1.0 type responses that don’t include the Content-Length header or chunking. Pass \"true\" or \"false\" in the value parameter.</li><li><b>send_age_header</b> Send <b>Cache-Control: max-age</b> and <b>Age</b> headers. Pass \"true\" or \"false\" in the value parameter.</li><li><b>support_non_sni_clients</b> By default, non-SNI clients are supported. Disable this option to block non-SNI clients. Pass \"true\" or \"false\" in the value parameter.</li><li><b>origin_connection_reuse</b> By default, TCP connections that are opened for a client request remain open for a short time to handle additional requests that may arrive. This option disables that behavior.. Pass \"true\" or \"false\" in the value parameter.</li><li><b>redirect_http_to_https</b> Redirect HTTP requests to HTTPS requests by sending an HTTP 301 response.</li><li><b>redirect_naked_domain_to_full</b> Redirect requests from your website's naked domain to its full domain by sending and HTTP 301 response.</li><li><b>http_2</b> Enables supporting browsers to take advantage of the performance enhancements provided by HTTP/2 for your website. Non-supporting browsers can connect via HTTP/1.0 or HTTP/1.1. HTTP/2 support requires that SSL is configured for your website. Pass \"true\" or \"false\" in the value parameter</li></ul>
value = 'value_example' # str | According to the param value.

try:
    # Advanced caching settings
    api_response = api_instance.modify_advanced_caching_settings(site_id, param, value)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_advanced_caching_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **param** | **str**| Name of configuration parameter to set.&lt;br/&gt;Possible values for param and value parameters:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;async_validation&lt;/b&gt; Sets Async validation. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_javascript&lt;/b&gt; Sets the Minify JS. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_css&lt;/b&gt; Sets the Minify CSS. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;li&gt;&lt;b&gt;minify_static_html&lt;/b&gt; Sets Minify static HTML. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;li&gt;&lt;b&gt;compress_jpeg&lt;/b&gt; Sets the Compress JPEG. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;progressive_image_rendering&lt;/b&gt; Sets the Progressive Image rendering flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;aggressive_compression&lt;/b&gt; Sets the Aggressive compression rendering flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;compress_png&lt;/b&gt; Sets the Compress PNG flag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;on_the_fly_compression&lt;/b&gt; \&quot;On the fly\&quot; Compression. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;tcp_pre_pooling&lt;/b&gt; TCP Pre-Pooling. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;comply_no_cache&lt;/b&gt; Comply with no-cache and max-age directives in client requests. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;comply_vary&lt;/b&gt; Comply with the &lt;b&gt;Vary&lt;/b&gt; header. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;use_shortest_caching&lt;/b&gt; Use shortest caching duration in case of conflicts. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;prefer_last_modified&lt;/b&gt; Prefer &#x27;last modified&#x27; over eTag. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;disable_client_side_caching&lt;/b&gt; Disable client side caching. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_300x&lt;/b&gt; Cache 300X responses. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;unite_naked_full_cache&lt;/b&gt; Use the same cache for full and naked domains. For example, use the same cached resource for &lt;a href&#x3D;\&quot;https://www.example.com/a\&quot;&gt;&lt;/a&gt; and &lt;a href&#x3D;\&quot;https://example.com/\&quot;&gt;&lt;/a&gt;a.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_empty_responses&lt;/b&gt; Cache responses that don’t have a message body.&lt;/li&gt;&lt;li&gt;&lt;b&gt;cache_http_10_responses&lt;/b&gt; Cache HTTP 1.0 type responses that don’t include the Content-Length header or chunking. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;send_age_header&lt;/b&gt; Send &lt;b&gt;Cache-Control: max-age&lt;/b&gt; and &lt;b&gt;Age&lt;/b&gt; headers. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;support_non_sni_clients&lt;/b&gt; By default, non-SNI clients are supported. Disable this option to block non-SNI clients. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;origin_connection_reuse&lt;/b&gt; By default, TCP connections that are opened for a client request remain open for a short time to handle additional requests that may arrive. This option disables that behavior.. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;redirect_http_to_https&lt;/b&gt; Redirect HTTP requests to HTTPS requests by sending an HTTP 301 response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;redirect_naked_domain_to_full&lt;/b&gt; Redirect requests from your website&#x27;s naked domain to its full domain by sending and HTTP 301 response.&lt;/li&gt;&lt;li&gt;&lt;b&gt;http_2&lt;/b&gt; Enables supporting browsers to take advantage of the performance enhancements provided by HTTP/2 for your website. Non-supporting browsers can connect via HTTP/1.0 or HTTP/1.1. HTTP/2 support requires that SSL is configured for your website. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter&lt;/li&gt;&lt;/ul&gt; | 
 **value** | **str**| According to the param value. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_cache404_settings**
> ApiResult modify_cache404_settings(site_id, enable, time=time, time_unit=time_unit)

Modify cache 404 settings

Use this operation to modify the caching settings of 404 responses for a site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
enable = 'enable_example' # str | Pass 'true' to cache 404 responses, 'false' to disable the option.
time = 'time_example' # str | A positive number representing the amount of time to cache 404 responses. Default value: 10 (optional)
time_unit = 'time_unit_example' # str | Unit of time for caching 404 responses. One of MINUTES, HOURS, DAYS, WEEKS. Default value: HOURS (optional)

try:
    # Modify cache 404 settings
    api_response = api_instance.modify_cache404_settings(site_id, enable, time=time, time_unit=time_unit)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_cache404_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **enable** | **str**| Pass &#x27;true&#x27; to cache 404 responses, &#x27;false&#x27; to disable the option. | 
 **time** | **str**| A positive number representing the amount of time to cache 404 responses. Default value: 10 | [optional] 
 **time_unit** | **str**| Unit of time for caching 404 responses. One of MINUTES, HOURS, DAYS, WEEKS. Default value: HOURS | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_purge_settings**
> ApiResult modify_purge_settings(site_id, resource_url, resource_pattern, should_purge_all_site_resources=should_purge_all_site_resources)

Purge resources

Use this operation to purge site resources.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
resource_url = 'resource_url_example' # str | Comma separated list of URLs where the resource is located.
resource_pattern = 'resource_pattern_example' # str | Comma separated list of pattern. One of: contains | equals | prefix | suffix | not_equals | not_contains | not_prefix | not_suffix
should_purge_all_site_resources = 'should_purge_all_site_resources_example' # str | Should purge all cached resources on site.</br>Possible values:</br>If the parameter does not exist, is null, or an empty string, it is ignored and only specific resources defined by the resource_pattern and resource_url parameters are purged.</br><b>true</b> or <b>TRUE</b>: All site resources are purged.</br><b>false</b> or <b>FALSE</b>: Nothing is done.</br>Any other string: An error is returned. (optional)

try:
    # Purge resources
    api_response = api_instance.modify_purge_settings(site_id, resource_url, resource_pattern, should_purge_all_site_resources=should_purge_all_site_resources)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_purge_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **resource_url** | **str**| Comma separated list of URLs where the resource is located. | 
 **resource_pattern** | **str**| Comma separated list of pattern. One of: contains | equals | prefix | suffix | not_equals | not_contains | not_prefix | not_suffix | 
 **should_purge_all_site_resources** | **str**| Should purge all cached resources on site.&lt;/br&gt;Possible values:&lt;/br&gt;If the parameter does not exist, is null, or an empty string, it is ignored and only specific resources defined by the resource_pattern and resource_url parameters are purged.&lt;/br&gt;&lt;b&gt;true&lt;/b&gt; or &lt;b&gt;TRUE&lt;/b&gt;: All site resources are purged.&lt;/br&gt;&lt;b&gt;false&lt;/b&gt; or &lt;b&gt;FALSE&lt;/b&gt;: Nothing is done.&lt;/br&gt;Any other string: An error is returned. | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_response_header_settings**
> ApiResult modify_response_header_settings(site_id, cache_headers=cache_headers, cache_all_headers=cache_all_headers)

Modify cached response headers

Use this operation to modify cached response headers.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
cache_headers = 'cache_headers_example' # str | Comma separated list of header names to be cached (optional)
cache_all_headers = 'cache_all_headers_example' # str | Cache all response headers. Pass \"true\" or \"false\" in the value parameter. Cannot be selected together with cache_headers. Default:false (optional)

try:
    # Modify cached response headers
    api_response = api_instance.modify_response_header_settings(site_id, cache_headers=cache_headers, cache_all_headers=cache_all_headers)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_response_header_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **cache_headers** | **str**| Comma separated list of header names to be cached | [optional] 
 **cache_all_headers** | **str**| Cache all response headers. Pass \&quot;true\&quot; or \&quot;false\&quot; in the value parameter. Cannot be selected together with cache_headers. Default:false | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_rewrite_ports**
> ApiResult modify_rewrite_ports(site_id, rewrite_port_enabled, rewrite_ssl_port_enabled, port=port, ssl_port=ssl_port)

Modify rewrite port

Use this operation to rewrite the port number used to access the origin server.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
rewrite_port_enabled = true # bool | Boolean value to indicate whether the default non-SSL port should be rewritten or not
rewrite_ssl_port_enabled = true # bool | Boolean value to indicate whether the default SSL port should be rewritten or not
port = 'port_example' # str | The port number. If empty, rewrite port will be removed (optional)
ssl_port = 'ssl_port_example' # str | The port number to rewrite default SSL port to (optional)

try:
    # Modify rewrite port
    api_response = api_instance.modify_rewrite_ports(site_id, rewrite_port_enabled, rewrite_ssl_port_enabled, port=port, ssl_port=ssl_port)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_rewrite_ports: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **rewrite_port_enabled** | **bool**| Boolean value to indicate whether the default non-SSL port should be rewritten or not | 
 **rewrite_ssl_port_enabled** | **bool**| Boolean value to indicate whether the default SSL port should be rewritten or not | 
 **port** | **str**| The port number. If empty, rewrite port will be removed | [optional] 
 **ssl_port** | **str**| The port number to rewrite default SSL port to | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_site_configuration**
> InlineResponse20014 modify_site_configuration(site_id, param, value)

Modify site configuration

Use this operation to change one of the basic configuration settings of the site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
param = 'param_example' # str | Name of configuration parameter to set.<br/>Parameter values:<br/><ul><li><b>active</b> Whether the site is active or bypassed by the Imperva network. One of: active | bypass.</li><li><b>site_ip</b> Comma separated list of IPs. For example: 8.8.8.8,1.2.2.2</li><li><b>domain_validation</b> Sets the domain validation method that will be used to generate an SSL certificate. One of: email | html | dns | cname<br/><b>One-step onboarding:</b> After adding a site and configuring your traffic to point to Imperva, use the html option to automatically add SSL support. Certificate creation takes approximately 5 minutes. During this time no traffic will reach the origin server.<br/><b>Note</b>: When running domain validation on a site, you may see the following error message in the API response: Internal error - \"Add site operation hasn't finished\".<br/>After running the add site process, it may take several minutes for the database to finish updating. During this time, attempts to further configure the site are blocked.<br/>In some cases, the database is not updated even after the add site process is complete.<br/>If the issue does not resolve after a few minutes, contact Support.</li><li><b>approver</b> Sets the approver e-mail address that will be used to perform SSL domain validation.</li><li><b>ignore_ssl</b> Sets the ignore SSL flag (if the site is in pending-select-approver state). Pass \"true\" in the value parameter.</li><li><b>acceleration_level</b> Sets the acceleration level of the site, one of: none | standard | aggressive. It is advised to use the newer Modify caching mode API call instead, as it provides enhanced functionality.</li><li><b>seal_location</b> Sets the seal location, e.g. \"api.seal_location.bottom_right\".</li><li><b>domain_redirect_to_full</b> Sets the redirect naked to full flag. Pass \"true\" in the value parameter.</li><li><b>remove_ssl</b> Sets the remove SSL from site flag. Pass \"true\" in the value parameter.</li><li><b>ref_id</b> Sets the Reference ID, a free-text field that enables you to add a unique identifier to correlate an object in our service, such as a protected website, with an object on the customer side.</li><li><b>naked_domain_san</b> Use this option to determine if the naked domain SAN will be added to the SSL certificate for www site. Will take effect in the next renewal.</li><li><b>wildcard_san</b> Use this option to determine if the wildcard SAN or the full domain SAN is added to the Imperva SSL certificate for site. Will take effect in the next renewal.</li><li><b>set_cookies_without_domain</b> Use this option to determine if to set site cookies without domain.</li><li><b>restricted_cname_reuse</b> Use this option to determine if legitimate traffic for all verified domains in the table is automatically allowed.</li><li><b>request_body_timeouts</b> Use this option to override default mitigation settings for slow HTTP attacks.</li><b>Note</b>: Send value in the format of {“methods”: [method name,method name,…],“interval”: integer,“byteCount”: integer}. For example: {“methods”: [HTTP_POST, HTTP_GET],“interval”:30,“byteCount”:20}. Each post of the API overwrites the custom configuration. To delete the whole custom configuration, send {} as the value. Possible values for method: HTTP_POST, HTTP_GET, HTTP_PUT, HTTP_RPC_IN_DATA, HTTP_RPC_OUT_DATA</ul>
value = 'value_example' # str | According to the param value.

try:
    # Modify site configuration
    api_response = api_instance.modify_site_configuration(site_id, param, value)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_site_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **param** | **str**| Name of configuration parameter to set.&lt;br/&gt;Parameter values:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;active&lt;/b&gt; Whether the site is active or bypassed by the Imperva network. One of: active | bypass.&lt;/li&gt;&lt;li&gt;&lt;b&gt;site_ip&lt;/b&gt; Comma separated list of IPs. For example: 8.8.8.8,1.2.2.2&lt;/li&gt;&lt;li&gt;&lt;b&gt;domain_validation&lt;/b&gt; Sets the domain validation method that will be used to generate an SSL certificate. One of: email | html | dns | cname&lt;br/&gt;&lt;b&gt;One-step onboarding:&lt;/b&gt; After adding a site and configuring your traffic to point to Imperva, use the html option to automatically add SSL support. Certificate creation takes approximately 5 minutes. During this time no traffic will reach the origin server.&lt;br/&gt;&lt;b&gt;Note&lt;/b&gt;: When running domain validation on a site, you may see the following error message in the API response: Internal error - \&quot;Add site operation hasn&#x27;t finished\&quot;.&lt;br/&gt;After running the add site process, it may take several minutes for the database to finish updating. During this time, attempts to further configure the site are blocked.&lt;br/&gt;In some cases, the database is not updated even after the add site process is complete.&lt;br/&gt;If the issue does not resolve after a few minutes, contact Support.&lt;/li&gt;&lt;li&gt;&lt;b&gt;approver&lt;/b&gt; Sets the approver e-mail address that will be used to perform SSL domain validation.&lt;/li&gt;&lt;li&gt;&lt;b&gt;ignore_ssl&lt;/b&gt; Sets the ignore SSL flag (if the site is in pending-select-approver state). Pass \&quot;true\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;acceleration_level&lt;/b&gt; Sets the acceleration level of the site, one of: none | standard | aggressive. It is advised to use the newer Modify caching mode API call instead, as it provides enhanced functionality.&lt;/li&gt;&lt;li&gt;&lt;b&gt;seal_location&lt;/b&gt; Sets the seal location, e.g. \&quot;api.seal_location.bottom_right\&quot;.&lt;/li&gt;&lt;li&gt;&lt;b&gt;domain_redirect_to_full&lt;/b&gt; Sets the redirect naked to full flag. Pass \&quot;true\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;remove_ssl&lt;/b&gt; Sets the remove SSL from site flag. Pass \&quot;true\&quot; in the value parameter.&lt;/li&gt;&lt;li&gt;&lt;b&gt;ref_id&lt;/b&gt; Sets the Reference ID, a free-text field that enables you to add a unique identifier to correlate an object in our service, such as a protected website, with an object on the customer side.&lt;/li&gt;&lt;li&gt;&lt;b&gt;naked_domain_san&lt;/b&gt; Use this option to determine if the naked domain SAN will be added to the SSL certificate for www site. Will take effect in the next renewal.&lt;/li&gt;&lt;li&gt;&lt;b&gt;wildcard_san&lt;/b&gt; Use this option to determine if the wildcard SAN or the full domain SAN is added to the Imperva SSL certificate for site. Will take effect in the next renewal.&lt;/li&gt;&lt;li&gt;&lt;b&gt;set_cookies_without_domain&lt;/b&gt; Use this option to determine if to set site cookies without domain.&lt;/li&gt;&lt;li&gt;&lt;b&gt;restricted_cname_reuse&lt;/b&gt; Use this option to determine if legitimate traffic for all verified domains in the table is automatically allowed.&lt;/li&gt;&lt;li&gt;&lt;b&gt;request_body_timeouts&lt;/b&gt; Use this option to override default mitigation settings for slow HTTP attacks.&lt;/li&gt;&lt;b&gt;Note&lt;/b&gt;: Send value in the format of {“methods”: [method name,method name,…],“interval”: integer,“byteCount”: integer}. For example: {“methods”: [HTTP_POST, HTTP_GET],“interval”:30,“byteCount”:20}. Each post of the API overwrites the custom configuration. To delete the whole custom configuration, send {} as the value. Possible values for method: HTTP_POST, HTTP_GET, HTTP_PUT, HTTP_RPC_IN_DATA, HTTP_RPC_OUT_DATA&lt;/ul&gt; | 
 **value** | **str**| According to the param value. | 

### Return type

[**InlineResponse20014**](InlineResponse20014.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_site_error_page_template**
> ApiResult modify_site_error_page_template(site_id, error_page_template)

Modify error page

Use this operation to set a custom error page for a given site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
error_page_template = 'error_page_template_example' # str | The error page html template. $TITLE$ and $BODY$ placeholders are required.

try:
    # Modify error page
    api_response = api_instance.modify_site_error_page_template(site_id, error_page_template)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_site_error_page_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **error_page_template** | **str**| The error page html template. $TITLE$ and $BODY$ placeholders are required. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_site_log_level**
> ApiResult modify_site_log_level(site_id, log_level, logs_account_id=logs_account_id)

Modify site logs level

Use this operation to change the site log configuration.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
log_level = 'log_level_example' # str | Available only for customers that purchased the Logs Integration SKU. Sets the log reporting level for the site.<br/>Possible values: full, security, none, default
logs_account_id = 'logs_account_id_example' # str | Available only for customers that purchased the Logs Integration SKU. Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.<br/>If not specified, operation will be performed on the account identified by the authentication parameters (optional)

try:
    # Modify site logs level
    api_response = api_instance.modify_site_log_level(site_id, log_level, logs_account_id=logs_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_site_log_level: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **log_level** | **str**| Available only for customers that purchased the Logs Integration SKU. Sets the log reporting level for the site.&lt;br/&gt;Possible values: full, security, none, default | 
 **logs_account_id** | **str**| Available only for customers that purchased the Logs Integration SKU. Numeric identifier of the account that purchased the logs integration SKU and which collects the logs.&lt;br/&gt;If not specified, operation will be performed on the account identified by the authentication parameters | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_site_security_configuration**
> InlineResponse20014 modify_site_security_configuration(site_id, rule_id, block_bad_bots=block_bad_bots, challenge_suspected_bots=challenge_suspected_bots, activation_mode=activation_mode, security_rule_action=security_rule_action, quarantined_urls=quarantined_urls, ddos_traffic_threshold=ddos_traffic_threshold)

Modify site security configuration

Use this operation to change the security configuration of a site. To modify the configuration for a specific rule, additional parameters may be required, as documented below.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
rule_id = 'rule_id_example' # str | ID of the security rule to change.<br/>Values for the rule_id parameter:<br/><ul><li>api.threats.bot_access_control</li><li>api.threats.sql_injection</li><li>api.threats.cross_site_scripting</li><li>api.threats.backdoor</li><li>api.threats.ddos</li><li>api.threats.remote_file_inclusion</li></ul>
block_bad_bots = 'block_bad_bots_example' # str | Whether or not to block bad bots. Possible values: true, false (optional)
challenge_suspected_bots = 'challenge_suspected_bots_example' # str | Whether or not to send a challenge to clients that are suspected to be bad bots (CAPTCHA for example). Possible values: true, false (optional)
activation_mode = 'activation_mode_example' # str | Possible values: api.threats.ddos.activation_mode.off, api.threats.ddos.activation_mode.auto, api.threats.ddos.activation_mode.on<br/><ul><li><b>api.threats.ddos.activation_mode.off</b> security measures are disabled even if site is under a DDoS attack</li><li><b>api.threats.ddos.activation_mode.auto</b> security measures will be activated automatically when the system suspects site is under a DDoS attack</li><li><b>api.threats.ddos.activation_mode.on</b> security measures are enabled even if site is not under a DDoS attack</li></ul>The syntax is as follows:<rule_id>.activation_mode.<value> For example, for 'off', use 'activation_mode=api.threats.ddos.activation_mode.off.<br/><b>Note:</b> This parameter is relevant and required for a DDoS rule only -- where rule_id=api.threats.ddos. (optional)
security_rule_action = 'security_rule_action_example' # str | The action that should be taken when a threat is detected, for example:<br/>api.threats.action.block_ip. Different actions are allowed per different threats, e.g. backdoors may only be quarantined, ignored, or trigger an alert.<br/>Values for the security_rule_action parameter:<br/><ul><li><b>api.threats.action.disabled</b> Threat is not blocked, site owner is not notified.</li><li><b>api.threats.action.alert</b> Threat is not blocked, site owner is notified.</li><li><b>api.threats.action.block_request</b> Threat blocked by stopping the request, site owner is notified.</li><li><b>api.threats.action.block_user</b> Threat blocked by stopping the request. Additional requests by the client application will be automatically blocked for a duration of several minutes. Site owner is notified.</li><li><b>api.threats.action.block_ip</b> Threat blocked by stopping the request. Additional requests from the same IP addresses will be automatically blocked for a duration of several minutes. Site owner is notified.</li><li><b>api.threats.action.quarantine_url</b> Relevant only for Backdoor Protect. When detecting a backdoor, additional requests to the URL of the backdoor will be automatically blocked. Site owner is notified.</li></ul> (optional)
quarantined_urls = 'quarantined_urls_example' # str | Removes quarantined URLs from the backdoor protection list, as defined in the Cloud Security Console Website Settings > WAF Settings > Backdoor Protect.<br/>To remove a URL from the backdoor protection list, use the following parameters with the specified values:<br/>quarantined_urls: <URL full path><br/>rule_id: api.threats.backdoor<br/>security_rule_action: api.threats.action.quarantine_url (optional)
ddos_traffic_threshold = 789 # int | Consider site to be under DDoS if the request rate is above this threshold.<br/><b>Allowed values:</b> 10-10000 requests per second. (optional)

try:
    # Modify site security configuration
    api_response = api_instance.modify_site_security_configuration(site_id, rule_id, block_bad_bots=block_bad_bots, challenge_suspected_bots=challenge_suspected_bots, activation_mode=activation_mode, security_rule_action=security_rule_action, quarantined_urls=quarantined_urls, ddos_traffic_threshold=ddos_traffic_threshold)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_site_security_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **rule_id** | **str**| ID of the security rule to change.&lt;br/&gt;Values for the rule_id parameter:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;api.threats.bot_access_control&lt;/li&gt;&lt;li&gt;api.threats.sql_injection&lt;/li&gt;&lt;li&gt;api.threats.cross_site_scripting&lt;/li&gt;&lt;li&gt;api.threats.backdoor&lt;/li&gt;&lt;li&gt;api.threats.ddos&lt;/li&gt;&lt;li&gt;api.threats.remote_file_inclusion&lt;/li&gt;&lt;/ul&gt; | 
 **block_bad_bots** | **str**| Whether or not to block bad bots. Possible values: true, false | [optional] 
 **challenge_suspected_bots** | **str**| Whether or not to send a challenge to clients that are suspected to be bad bots (CAPTCHA for example). Possible values: true, false | [optional] 
 **activation_mode** | **str**| Possible values: api.threats.ddos.activation_mode.off, api.threats.ddos.activation_mode.auto, api.threats.ddos.activation_mode.on&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;api.threats.ddos.activation_mode.off&lt;/b&gt; security measures are disabled even if site is under a DDoS attack&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.ddos.activation_mode.auto&lt;/b&gt; security measures will be activated automatically when the system suspects site is under a DDoS attack&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.ddos.activation_mode.on&lt;/b&gt; security measures are enabled even if site is not under a DDoS attack&lt;/li&gt;&lt;/ul&gt;The syntax is as follows:&lt;rule_id&gt;.activation_mode.&lt;value&gt; For example, for &#x27;off&#x27;, use &#x27;activation_mode&#x3D;api.threats.ddos.activation_mode.off.&lt;br/&gt;&lt;b&gt;Note:&lt;/b&gt; This parameter is relevant and required for a DDoS rule only -- where rule_id&#x3D;api.threats.ddos. | [optional] 
 **security_rule_action** | **str**| The action that should be taken when a threat is detected, for example:&lt;br/&gt;api.threats.action.block_ip. Different actions are allowed per different threats, e.g. backdoors may only be quarantined, ignored, or trigger an alert.&lt;br/&gt;Values for the security_rule_action parameter:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;api.threats.action.disabled&lt;/b&gt; Threat is not blocked, site owner is not notified.&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.action.alert&lt;/b&gt; Threat is not blocked, site owner is notified.&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.action.block_request&lt;/b&gt; Threat blocked by stopping the request, site owner is notified.&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.action.block_user&lt;/b&gt; Threat blocked by stopping the request. Additional requests by the client application will be automatically blocked for a duration of several minutes. Site owner is notified.&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.action.block_ip&lt;/b&gt; Threat blocked by stopping the request. Additional requests from the same IP addresses will be automatically blocked for a duration of several minutes. Site owner is notified.&lt;/li&gt;&lt;li&gt;&lt;b&gt;api.threats.action.quarantine_url&lt;/b&gt; Relevant only for Backdoor Protect. When detecting a backdoor, additional requests to the URL of the backdoor will be automatically blocked. Site owner is notified.&lt;/li&gt;&lt;/ul&gt; | [optional] 
 **quarantined_urls** | **str**| Removes quarantined URLs from the backdoor protection list, as defined in the Cloud Security Console Website Settings &gt; WAF Settings &gt; Backdoor Protect.&lt;br/&gt;To remove a URL from the backdoor protection list, use the following parameters with the specified values:&lt;br/&gt;quarantined_urls: &lt;URL full path&gt;&lt;br/&gt;rule_id: api.threats.backdoor&lt;br/&gt;security_rule_action: api.threats.action.quarantine_url | [optional] 
 **ddos_traffic_threshold** | **int**| Consider site to be under DDoS if the request rate is above this threshold.&lt;br/&gt;&lt;b&gt;Allowed values:&lt;/b&gt; 10-10000 requests per second. | [optional] 

### Return type

[**InlineResponse20014**](InlineResponse20014.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_site_support_deprecated_tls**
> InlineResponse20034 modify_site_support_deprecated_tls(site_id, support_all_tls_versions)

Set support for all TLS versions

Use this operation to support all TLS versions for the site for connectivity between clients (visitors) and the Imperva service. To remain PCI-compliant, do not enable this option.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
support_all_tls_versions = true # bool | Support all TLS versions. Default value: false

try:
    # Set support for all TLS versions
    api_response = api_instance.modify_site_support_deprecated_tls(site_id, support_all_tls_versions)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_site_support_deprecated_tls: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **support_all_tls_versions** | **bool**| Support all TLS versions. Default value: false | 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_stale_content**
> ApiResult modify_stale_content(site_id, serve_stale_content, stale_content_mode, time=time, time_unit=time_unit)

Modify stale content settings

When Imperva can't connect to the origin server, serve stale content instead of displaying an error to end users for the specified amount of time. Expired resources are returned from cache, and refreshed asynchronously in the background.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
serve_stale_content = 'serve_stale_content_example' # str | Pass <b>true</b> to serve stale content, <b>false</b> to disable the option.
stale_content_mode = 'stale_content_mode_example' # str | Pass <b>ADAPTIVE</b> to use Imperva's algorithm, or <b>CUSTOM</b> to specify an amount of time. When using <b>CUSTOM</b>, you must specify the time and time_unit parameters.
time = 'time_example' # str | A positive number representing the amount of time to serve stale content. (optional)
time_unit = 'time_unit_example' # str | Stale content time unit. One of SECONDS, MINUTES, HOURS. (optional)

try:
    # Modify stale content settings
    api_response = api_instance.modify_stale_content(site_id, serve_stale_content, stale_content_mode, time=time, time_unit=time_unit)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_stale_content: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **serve_stale_content** | **str**| Pass &lt;b&gt;true&lt;/b&gt; to serve stale content, &lt;b&gt;false&lt;/b&gt; to disable the option. | 
 **stale_content_mode** | **str**| Pass &lt;b&gt;ADAPTIVE&lt;/b&gt; to use Imperva&#x27;s algorithm, or &lt;b&gt;CUSTOM&lt;/b&gt; to specify an amount of time. When using &lt;b&gt;CUSTOM&lt;/b&gt;, you must specify the time and time_unit parameters. | 
 **time** | **str**| A positive number representing the amount of time to serve stale content. | [optional] 
 **time_unit** | **str**| Stale content time unit. One of SECONDS, MINUTES, HOURS. | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_tag_response_header**
> ApiResult modify_tag_response_header(site_id, header)

Tag the response according to the value of a header

Specify which origin response header contains the cache tags in your resources.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
header = 'header_example' # str | Specify which origin response header contains the cache tags in your resources. default: \"\".

try:
    # Tag the response according to the value of a header
    api_response = api_instance.modify_tag_response_header(site_id, header)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->modify_tag_response_header: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **header** | **str**| Specify which origin response header contains the cache tags in your resources. default: \&quot;\&quot;. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **move_site**
> InlineResponse20035 move_site(site_id, destination_account_id)

Move site

Use this operation to move a site from its account to another account.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to move
destination_account_id = 789 # int | The numeric identifier of the account which the site will be moved to

try:
    # Move site
    api_response = api_instance.move_site(site_id, destination_account_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->move_site: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to move | 
 **destination_account_id** | **int**| The numeric identifier of the account which the site will be moved to | 

### Return type

[**InlineResponse20035**](InlineResponse20035.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **purge_hostname**
> ApiResult purge_hostname(host_name=host_name)

Purge hostname from cache

Use this operation to purge the hostname from the cache. This API is for customers who use the same CNAME provided by Imperva for multiple hostnames and would like to change the CNAME for a particular hostname. Purging the hostname is required for the CNAME change to take effect.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
host_name = 'host_name_example' # str | The hostname to purge from the cache (optional)

try:
    # Purge hostname from cache
    api_response = api_instance.purge_hostname(host_name=host_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->purge_hostname: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **host_name** | **str**| The hostname to purge from the cache | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **purge_site_cache**
> ApiResult purge_site_cache(site_id, purge_pattern=purge_pattern, purge_tag_names=purge_tag_names)

Purge site cache

Use this operation to purge all cached content on our proxy servers for a specific site.<br/>Our Proxy servers keep cached content of your sites in order to accelerate page load times for your users.<br/>When you want this cached content to be refreshed (for example, after making adjustments in your site) you can use this API call.<br/>In order to purge the entire cached content for this site just use the API call with no parameters.<br/>If you want to purge a specific resource add the resource name as parameter.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
purge_pattern = 'purge_pattern_example' # str | The pattern of the resource to be purged from the cache. For example:</br><ul/><li><b>Resource_name</b> - Resources that contain Resource_name will be purged</li><li><b>^Resource_name</b> - Resources that start with Resource_name will be purged</li><li><b>Resource_name$</b> - Resources that end with Resource_name will be purged.</li></ul> (optional)
purge_tag_names = 'purge_tag_names_example' # str | A comma separated list of tag names to purge. (optional)

try:
    # Purge site cache
    api_response = api_instance.purge_site_cache(site_id, purge_pattern=purge_pattern, purge_tag_names=purge_tag_names)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->purge_site_cache: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **purge_pattern** | **str**| The pattern of the resource to be purged from the cache. For example:&lt;/br&gt;&lt;ul/&gt;&lt;li&gt;&lt;b&gt;Resource_name&lt;/b&gt; - Resources that contain Resource_name will be purged&lt;/li&gt;&lt;li&gt;&lt;b&gt;^Resource_name&lt;/b&gt; - Resources that start with Resource_name will be purged&lt;/li&gt;&lt;li&gt;&lt;b&gt;Resource_name$&lt;/b&gt; - Resources that end with Resource_name will be purged.&lt;/li&gt;&lt;/ul&gt; | [optional] 
 **purge_tag_names** | **str**| A comma separated list of tag names to purge. | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **put_data_centers_configuration**
> DataCentersConfigurationDTO put_data_centers_configuration(body, ext_site_id)

set site's data centers' configuration

Use this operation to configure site's data centers and all their servers

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.DataCentersConfigurationDTO() # DataCentersConfigurationDTO | JSON body. Schema is identical to the response.
ext_site_id = 789 # int | 

try:
    # set site's data centers' configuration
    api_response = api_instance.put_data_centers_configuration(body, ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->put_data_centers_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DataCentersConfigurationDTO**](DataCentersConfigurationDTO.md)| JSON body. Schema is identical to the response. | 
 **ext_site_id** | **int**|  | 

### Return type

[**DataCentersConfigurationDTO**](DataCentersConfigurationDTO.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_custom_certificate**
> ApiResult remove_custom_certificate(site_id=site_id, auth_type=auth_type)

Remove custom certificate

Use this operation to remove a custom certificate.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on (optional)
auth_type = 'auth_type_example' # str | The authentication type of the certificate (RSA or ECC). Optional. If not provided, then RSA will be assume  (optional)

try:
    # Remove custom certificate
    api_response = api_instance.remove_custom_certificate(site_id=site_id, auth_type=auth_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->remove_custom_certificate: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on | [optional] 
 **auth_type** | **str**| The authentication type of the certificate (RSA or ECC). Optional. If not provided, then RSA will be assume  | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **resume_traffic_to_active_dcs**
> ApiResult resume_traffic_to_active_dcs(site_id)

Resume traffic to your active data centers

When at least one active data center is back up, you have to manually reroute your traffic back to the active data center.<br/>Traffic does not revert automatically to your active data centers.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.

try:
    # Resume traffic to your active data centers
    api_response = api_instance.resume_traffic_to_active_dcs(site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->resume_traffic_to_active_dcs: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_caching_mode**
> ApiResult set_caching_mode(cache_mode, site_id, dynamic_cache_duration=dynamic_cache_duration, aggressive_cache_duration=aggressive_cache_duration)

Modify caching mode

Use this operation to edit basic site caching settings.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
cache_mode = 'cache_mode_example' # str | Possible values:<br/><ul/><li>disable</li><li>custom_cache_rules_only</li><li>static_only</li><li>static_and_dynamic</li><li>aggressive</li>Default value: static_only</ul>
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on.
dynamic_cache_duration = 'dynamic_cache_duration_example' # str | Profile dynamic pages and cache duration. Pass a number followed by '_' and one of: hr | min | sec | days | weeks.</br>Default: 5_min (optional)
aggressive_cache_duration = 'aggressive_cache_duration_example' # str | Cache resource duration. Pass a number followed by '_' and one of: hr | min | sec | days | weeks</br>Default: 1_hr (optional)

try:
    # Modify caching mode
    api_response = api_instance.set_caching_mode(cache_mode, site_id, dynamic_cache_duration=dynamic_cache_duration, aggressive_cache_duration=aggressive_cache_duration)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_caching_mode: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cache_mode** | **str**| Possible values:&lt;br/&gt;&lt;ul/&gt;&lt;li&gt;disable&lt;/li&gt;&lt;li&gt;custom_cache_rules_only&lt;/li&gt;&lt;li&gt;static_only&lt;/li&gt;&lt;li&gt;static_and_dynamic&lt;/li&gt;&lt;li&gt;aggressive&lt;/li&gt;Default value: static_only&lt;/ul&gt; | 
 **site_id** | **str**| Numeric identifier of the site to operate on. | 
 **dynamic_cache_duration** | **str**| Profile dynamic pages and cache duration. Pass a number followed by &#x27;_&#x27; and one of: hr | min | sec | days | weeks.&lt;/br&gt;Default: 5_min | [optional] 
 **aggressive_cache_duration** | **str**| Cache resource duration. Pass a number followed by &#x27;_&#x27; and one of: hr | min | sec | days | weeks&lt;/br&gt;Default: 1_hr | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_data_center_origin_po_p**
> ApiResult set_data_center_origin_po_p(dc_id, origin_pop=origin_pop)

Set data center origin PoP

Set an origin PoP for a given data center.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
dc_id = 789 # int | Numeric identifier of the data center to operate on.
origin_pop = 'origin_pop_example' # str | The ID of the PoP that serves as an access point between Imperva and the customer’s origin server. For example: “lax”, for Los Angeles. (optional)

try:
    # Set data center origin PoP
    api_response = api_instance.set_data_center_origin_po_p(dc_id, origin_pop=origin_pop)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_data_center_origin_po_p: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dc_id** | **int**| Numeric identifier of the data center to operate on. | 
 **origin_pop** | **str**| The ID of the PoP that serves as an access point between Imperva and the customer’s origin server. For example: “lax”, for Los Angeles. | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_data_region**
> InlineResponse20031 set_data_region(site_id, data_storage_region)

Set site data storage region

Use this operation to set the site data region.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 789 # int | Numeric identifier of the site to operate on.
data_storage_region = 'data_storage_region_example' # str | The data region to use.

try:
    # Set site data storage region
    api_response = api_instance.set_data_region(site_id, data_storage_region)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_data_region: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **int**| Numeric identifier of the site to operate on. | 
 **data_storage_region** | **str**| The data region to use. | 

### Return type

[**InlineResponse20031**](InlineResponse20031.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_html_injection_rule**
> InlineResponse20032 set_html_injection_rule(site_id, url, url_pattern, location, content=content, delete_content=delete_content)

Add, replace or remove a HTML injection rule

Use this operation to add a new HTML injection rule, or to replace or remove an existing rule.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
url = 'url_example' # str | The URL where the content is injected
url_pattern = 'url_pattern_example' # str | The url pattern. One of: contains | not_contains | equals | not_equals | prefix | suffix | not_prefix | not_suffix
location = 'location_example' # str | The location of the injection inside the URL ('head' or 'body_end')
content = 'content_example' # str | The injected HTML snippet, Base64-encoded (optional)
delete_content = true # bool | Whether or not to delete existing HTML content.<br/>Possible values: true/false (optional)

try:
    # Add, replace or remove a HTML injection rule
    api_response = api_instance.set_html_injection_rule(site_id, url, url_pattern, location, content=content, delete_content=delete_content)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_html_injection_rule: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **url** | **str**| The URL where the content is injected | 
 **url_pattern** | **str**| The url pattern. One of: contains | not_contains | equals | not_equals | prefix | suffix | not_prefix | not_suffix | 
 **location** | **str**| The location of the injection inside the URL (&#x27;head&#x27; or &#x27;body_end&#x27;) | 
 **content** | **str**| The injected HTML snippet, Base64-encoded | [optional] 
 **delete_content** | **bool**| Whether or not to delete existing HTML content.&lt;br/&gt;Possible values: true/false | [optional] 

### Return type

[**InlineResponse20032**](InlineResponse20032.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_override_site_regions_by_geo**
> ApiResult set_override_site_regions_by_geo(account_id, override_site_regions_by_geo)

Set site regions by origin geolocation

Use this operation to set the data storage region for each new site based on the geolocation of the origin server.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
account_id = 'account_id_example' # str | Numeric identifier of the account to operate on.<br/>If not specified, operation will be performed on the account identified by the authentication parameters.
override_site_regions_by_geo = true # bool | A boolean parameter. If it is set to \"true\", the data storage region for each new site will be based on the geolocation of the origin server.

try:
    # Set site regions by origin geolocation
    api_response = api_instance.set_override_site_regions_by_geo(account_id, override_site_regions_by_geo)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_override_site_regions_by_geo: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **account_id** | **str**| Numeric identifier of the account to operate on.&lt;br/&gt;If not specified, operation will be performed on the account identified by the authentication parameters. | 
 **override_site_regions_by_geo** | **bool**| A boolean parameter. If it is set to \&quot;true\&quot;, the data storage region for each new site will be based on the geolocation of the origin server. | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_priority**
> SetPriorityResponse set_priority(rule_id, priority)

Set rule priority

Use this operation to change delivery rule's priority.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
rule_id = 789 # int | Rule ID
priority = 56 # int | New priority for the selected rule

try:
    # Set rule priority
    api_response = api_instance.set_priority(rule_id, priority)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_priority: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rule_id** | **int**| Rule ID | 
 **priority** | **int**| New priority for the selected rule | 

### Return type

[**SetPriorityResponse**](SetPriorityResponse.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **set_secure_resources_mode**
> ApiResult set_secure_resources_mode(site_id, secured_resources_mode)

Modify secure resources mode

Use this operation to modify the Secure Resources mode for a site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
secured_resources_mode = 'secured_resources_mode_example' # str | <b>do_not_cache</b> - Do not cache HTTPS resources<br/><b>defaults</b> - Use default HTTPS caching. Do not cache HTML pages<br/><b>defaults_with_html</b> - Use default HTTPS caching. Also cache HTML pages<br/><b>general</b> - Cache HTTPS according to general caching settings

try:
    # Modify secure resources mode
    api_response = api_instance.set_secure_resources_mode(site_id, secured_resources_mode)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->set_secure_resources_mode: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **secured_resources_mode** | **str**| &lt;b&gt;do_not_cache&lt;/b&gt; - Do not cache HTTPS resources&lt;br/&gt;&lt;b&gt;defaults&lt;/b&gt; - Use default HTTPS caching. Do not cache HTML pages&lt;br/&gt;&lt;b&gt;defaults_with_html&lt;/b&gt; - Use default HTTPS caching. Also cache HTML pages&lt;br/&gt;&lt;b&gt;general&lt;/b&gt; - Cache HTTPS according to general caching settings | 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **site_status**
> InlineResponse20014 site_status(site_id, tests=tests)

Get site status

Use this operation to get the status of a site.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
site_id = 'site_id_example' # str | Numeric identifier of the site to operate on
tests = 'tests_example' # str | List of tests to run on site before returning its status.<br/>A comma separated list of one of: domain_validation, services, dns<br/>Values for the stats parameters:<br/><ul><li><b>domain_validation</b> Runs the domain validation test on the specified site. This test will check for HTML meta tag or DNS records, according to the selected domain validation method.</li><li><b>services</b> Runs the services test on the specified site. This test will check the availability of HTTP and HTTPS connections on the site.</li><li><b>dns</b> Runs the DNS test on the specified site. This test will check whether the site owner performed the DNS changes required in order to protect the site.</li></ul> (optional)

try:
    # Get site status
    api_response = api_instance.site_status(site_id, tests=tests)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->site_status: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **site_id** | **str**| Numeric identifier of the site to operate on | 
 **tests** | **str**| List of tests to run on site before returning its status.&lt;br/&gt;A comma separated list of one of: domain_validation, services, dns&lt;br/&gt;Values for the stats parameters:&lt;br/&gt;&lt;ul&gt;&lt;li&gt;&lt;b&gt;domain_validation&lt;/b&gt; Runs the domain validation test on the specified site. This test will check for HTML meta tag or DNS records, according to the selected domain validation method.&lt;/li&gt;&lt;li&gt;&lt;b&gt;services&lt;/b&gt; Runs the services test on the specified site. This test will check the availability of HTTP and HTTPS connections on the site.&lt;/li&gt;&lt;li&gt;&lt;b&gt;dns&lt;/b&gt; Runs the DNS test on the specified site. This test will check whether the site owner performed the DNS changes required in order to protect the site.&lt;/li&gt;&lt;/ul&gt; | [optional] 

### Return type

[**InlineResponse20014**](InlineResponse20014.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_tls_configuration**
> TLSConfigurationDto update_tls_configuration(body, ext_site_id)

Update website TLS configuration

Update the TLS configuration for a given website.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
body = swagger_client.TLSConfigurationDto() # TLSConfigurationDto | JSON body. Schema is identical or semi identical to the response.
ext_site_id = 789 # int | The Imperva ID of the website to operate on.

try:
    # Update website TLS configuration
    api_response = api_instance.update_tls_configuration(body, ext_site_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->update_tls_configuration: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TLSConfigurationDto**](TLSConfigurationDto.md)| JSON body. Schema is identical or semi identical to the response. | 
 **ext_site_id** | **int**| The Imperva ID of the website to operate on. | 

### Return type

[**TLSConfigurationDto**](TLSConfigurationDto.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upload_custom_certificate**
> ApiResult upload_custom_certificate(certificate, private_key, site_id=site_id, passphrase=passphrase, auth_type=auth_type, input_hash=input_hash)

Upload custom certificate

Use this operation to upload a custom certificate for your site. The following SSL certificate file formats are supported: PFX, PEM, CER.

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: api_id
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Id'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Id'] = 'Bearer'
# Configure API key authorization: api_key
configuration = swagger_client.Configuration()
configuration.api_key['x-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.SiteManagementApi(swagger_client.ApiClient(configuration))
certificate = 'certificate_example' # str | The certificate file in base64 format
private_key = 'private_key_example' # str | The private key of the certificate in base64 format. Optional in case of PFX certificate file format
site_id = 789 # int | Numeric identifier of the site to operate on (optional)
passphrase = 'passphrase_example' # str | The passphrase used to protect your SSL certificate  (optional)
auth_type = 'auth_type_example' # str | The authentication type of the certificate (RSA or ECC). Optional. If not provided, then RSA will be assume  (optional)
input_hash = 'input_hash_example' # str | optional parameter. usually a hash representation for the concatenation of all inputs (optional)

try:
    # Upload custom certificate
    api_response = api_instance.upload_custom_certificate(certificate, private_key, site_id=site_id, passphrase=passphrase, auth_type=auth_type, input_hash=input_hash)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling SiteManagementApi->upload_custom_certificate: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **certificate** | **str**| The certificate file in base64 format | 
 **private_key** | **str**| The private key of the certificate in base64 format. Optional in case of PFX certificate file format | 
 **site_id** | **int**| Numeric identifier of the site to operate on | [optional] 
 **passphrase** | **str**| The passphrase used to protect your SSL certificate  | [optional] 
 **auth_type** | **str**| The authentication type of the certificate (RSA or ECC). Optional. If not provided, then RSA will be assume  | [optional] 
 **input_hash** | **str**| optional parameter. usually a hash representation for the concatenation of all inputs | [optional] 

### Return type

[**ApiResult**](ApiResult.md)

### Authorization

[api_id](../README.md#api_id), [api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

